/**
 * JS Object to manipulate and reorder a grid
 * @param {int} maxWidth max column width
 * @since 2.0.0
 */
function IndexedGrid(i){i="undefined"!=typeof i?i:12,this.grid=[],this.maxWidth=i}IndexedGrid.prototype.insertionSort=function(){for(var i,r=this.grid.length,t=1;t<r;t++){for(var d=this.grid[t],i=t-1;i>=0&&this.grid[i]>d;i--)this.grid[i+1]=this.grid[i];this.grid[i+1]=d}},IndexedGrid.prototype.setGrid=function(i,r,t,d){for(var h=0;h<d;h++)for(var e=0;e<t;e++)this.grid.push(i+e+(r+h)*this.maxWidth);this.insertionSort()},IndexedGrid.prototype.checkGrid=function(i){for(var r=0;this.grid[r]<i;){var t=this.grid[r];if(t+1!==this.grid[r+1])for(var d=t+1;d<this.grid[r+1];d++)this.grid.push(d);r++}this.insertionSort()},IndexedGrid.prototype.willFit=function(i,r){if(0==this.grid.length)return 0;for(var t=this.findHoles(),d=0,h=t.length;d<h;d++){var e=t[d],o=t[d]+1;if("undefined"!=typeof e&&"undefined"!=typeof o)for(var n=this.grid[e]+1;n<this.grid[o];n++){var s=this.searchFreeSpace(n,i,r);if(s)return n}}for(var f=this.grid[this.grid.length-1]+1,a=Math.floor(f/this.maxWidth),g=Math.floor((f+(i-1))/this.maxWidth);a!==g;)f+=1,a=Math.floor(f/this.maxWidth),g=Math.floor((f+(i-1))/this.maxWidth);return f},IndexedGrid.prototype.findHoles=function(){for(var i=[],r=0,t=this.grid.length;r<t;r++)"undefined"!=typeof this.grid[r+1]&&this.grid[r]+1===this.grid[r+1]||i.push(r);return i},IndexedGrid.prototype.searchFreeSpace=function(i,r,t){var d=Math.floor(i/this.maxWidth),h=Math.floor((i+r-1)/this.maxWidth);if(d!==h)return!1;for(var e=0;e<t;e++)for(var o=0;o<r;o++){var n=i+o+e*this.maxWidth;if(-1!==this.grid.indexOf(n))return!1}return!0},IndexedGrid.prototype.negativeGrid=function(){for(var i=[],r=0,t=this.grid.length;r<t;r++)if(this.grid[r]+1!==this.grid[r+1])for(var d=this.grid[r]+1;d<this.grid[r+1];d++)i.push(d);return i};
/**
 * Copyright 2016 Google Inc. All Rights Reserved.
 *
 * Licensed under the W3C SOFTWARE AND DOCUMENT NOTICE AND LICENSE.
 *
 *  https://www.w3.org/Consortium/Legal/2015/copyright-software-and-document
 *
 */
!function(){"use strict";function t(t){this.time=t.time,this.target=t.target,this.rootBounds=t.rootBounds,this.boundingClientRect=t.boundingClientRect,this.intersectionRect=t.intersectionRect||c(),this.isIntersecting=!!t.intersectionRect;var e=this.boundingClientRect,n=e.width*e.height,o=this.intersectionRect,i=o.width*o.height;n?this.intersectionRatio=Number((i/n).toFixed(4)):this.intersectionRatio=this.isIntersecting?1:0}function e(t,e){var n=e||{};if("function"!=typeof t)throw new Error("callback must be a function");if(n.root&&1!=n.root.nodeType)throw new Error("root must be an Element");this._checkForIntersections=o(this._checkForIntersections.bind(this),this.THROTTLE_TIMEOUT),this._callback=t,this._observationTargets=[],this._queuedEntries=[],this._rootMarginValues=this._parseRootMargin(n.rootMargin),this.thresholds=this._initThresholds(n.threshold),this.root=n.root||null,this.rootMargin=this._rootMarginValues.map(function(t){return t.value+t.unit}).join(" ")}function n(){return window.performance&&performance.now&&performance.now()}function o(t,e){var n=null;return function(){n||(n=setTimeout(function(){t(),n=null},e))}}function i(t,e,n,o){"function"==typeof t.addEventListener?t.addEventListener(e,n,o||!1):"function"==typeof t.attachEvent&&t.attachEvent("on"+e,n)}function r(t,e,n,o){"function"==typeof t.removeEventListener?t.removeEventListener(e,n,o||!1):"function"==typeof t.detatchEvent&&t.detatchEvent("on"+e,n)}function s(t,e){var n=Math.max(t.top,e.top),o=Math.min(t.bottom,e.bottom),i=Math.max(t.left,e.left),r=Math.min(t.right,e.right),s=r-i,h=o-n;return s>=0&&h>=0&&{top:n,bottom:o,left:i,right:r,width:s,height:h}}function h(t){var e;try{e=t.getBoundingClientRect()}catch(n){}return e?(e.width&&e.height||(e={top:e.top,right:e.right,bottom:e.bottom,left:e.left,width:e.right-e.left,height:e.bottom-e.top}),e):c()}function c(){return{top:0,bottom:0,left:0,right:0,width:0,height:0}}function u(t,e){for(var n=e;n;){if(n==t)return!0;n=a(n)}return!1}function a(t){var e=t.parentNode;return e&&11==e.nodeType&&e.host?e.host:e&&e.assignedSlot?e.assignedSlot.parentNode:e}if("object"==typeof window){if("IntersectionObserver"in window&&"IntersectionObserverEntry"in window&&"intersectionRatio"in window.IntersectionObserverEntry.prototype)return void("isIntersecting"in window.IntersectionObserverEntry.prototype||Object.defineProperty(window.IntersectionObserverEntry.prototype,"isIntersecting",{get:function(){return this.intersectionRatio>0}}));var l=window.document,d=[];e.prototype.THROTTLE_TIMEOUT=100,e.prototype.POLL_INTERVAL=null,e.prototype.USE_MUTATION_OBSERVER=!0,e.prototype.observe=function(t){var e=this._observationTargets.some(function(e){return e.element==t});if(!e){if(!t||1!=t.nodeType)throw new Error("target must be an Element");this._registerInstance(),this._observationTargets.push({element:t,entry:null}),this._monitorIntersections(),this._checkForIntersections()}},e.prototype.unobserve=function(t){this._observationTargets=this._observationTargets.filter(function(e){return e.element!=t}),this._observationTargets.length||(this._unmonitorIntersections(),this._unregisterInstance())},e.prototype.disconnect=function(){this._observationTargets=[],this._unmonitorIntersections(),this._unregisterInstance()},e.prototype.takeRecords=function(){var t=this._queuedEntries.slice();return this._queuedEntries=[],t},e.prototype._initThresholds=function(t){var e=t||[0];return Array.isArray(e)||(e=[e]),e.sort().filter(function(t,e,n){if("number"!=typeof t||isNaN(t)||t<0||t>1)throw new Error("threshold must be a number between 0 and 1 inclusively");return t!==n[e-1]})},e.prototype._parseRootMargin=function(t){var e=t||"0px",n=e.split(/\s+/).map(function(t){var e=/^(-?\d*\.?\d+)(px|%)$/.exec(t);if(!e)throw new Error("rootMargin must be specified in pixels or percent");return{value:parseFloat(e[1]),unit:e[2]}});return n[1]=n[1]||n[0],n[2]=n[2]||n[0],n[3]=n[3]||n[1],n},e.prototype._monitorIntersections=function(){this._monitoringIntersections||(this._monitoringIntersections=!0,this.POLL_INTERVAL?this._monitoringInterval=setInterval(this._checkForIntersections,this.POLL_INTERVAL):(i(window,"resize",this._checkForIntersections,!0),i(l,"scroll",this._checkForIntersections,!0),this.USE_MUTATION_OBSERVER&&"MutationObserver"in window&&(this._domObserver=new MutationObserver(this._checkForIntersections),this._domObserver.observe(l,{attributes:!0,childList:!0,characterData:!0,subtree:!0}))))},e.prototype._unmonitorIntersections=function(){this._monitoringIntersections&&(this._monitoringIntersections=!1,clearInterval(this._monitoringInterval),this._monitoringInterval=null,r(window,"resize",this._checkForIntersections,!0),r(l,"scroll",this._checkForIntersections,!0),this._domObserver&&(this._domObserver.disconnect(),this._domObserver=null))},e.prototype._checkForIntersections=function(){var e=this._rootIsInDom(),o=e?this._getRootRect():c();this._observationTargets.forEach(function(i){var r=i.element,s=h(r),c=this._rootContainsTarget(r),u=i.entry,a=e&&c&&this._computeTargetAndRootIntersection(r,o),l=i.entry=new t({time:n(),target:r,boundingClientRect:s,rootBounds:o,intersectionRect:a});u?e&&c?this._hasCrossedThreshold(u,l)&&this._queuedEntries.push(l):u&&u.isIntersecting&&this._queuedEntries.push(l):this._queuedEntries.push(l)},this),this._queuedEntries.length&&this._callback(this.takeRecords(),this)},e.prototype._computeTargetAndRootIntersection=function(t,e){if("none"!=window.getComputedStyle(t).display){for(var n=h(t),o=n,i=a(t),r=!1;!r;){var c=null,u=1==i.nodeType?window.getComputedStyle(i):{};if("none"==u.display)return;if(i==this.root||i==l?(r=!0,c=e):i!=l.body&&i!=l.documentElement&&"visible"!=u.overflow&&(c=h(i)),c&&(o=s(c,o),!o))break;i=a(i)}return o}},e.prototype._getRootRect=function(){var t;if(this.root)t=h(this.root);else{var e=l.documentElement,n=l.body;t={top:0,left:0,right:e.clientWidth||n.clientWidth,width:e.clientWidth||n.clientWidth,bottom:e.clientHeight||n.clientHeight,height:e.clientHeight||n.clientHeight}}return this._expandRectByRootMargin(t)},e.prototype._expandRectByRootMargin=function(t){var e=this._rootMarginValues.map(function(e,n){return"px"==e.unit?e.value:e.value*(n%2?t.width:t.height)/100}),n={top:t.top-e[0],right:t.right+e[1],bottom:t.bottom+e[2],left:t.left-e[3]};return n.width=n.right-n.left,n.height=n.bottom-n.top,n},e.prototype._hasCrossedThreshold=function(t,e){var n=t&&t.isIntersecting?t.intersectionRatio||0:-1,o=e.isIntersecting?e.intersectionRatio||0:-1;if(n!==o)for(var i=0;i<this.thresholds.length;i++){var r=this.thresholds[i];if(r==n||r==o||r<n!=r<o)return!0}},e.prototype._rootIsInDom=function(){return!this.root||u(l,this.root)},e.prototype._rootContainsTarget=function(t){return u(this.root||l,t)},e.prototype._registerInstance=function(){d.indexOf(this)<0&&d.push(this)},e.prototype._unregisterInstance=function(){var t=d.indexOf(this);t!=-1&&d.splice(t,1)},window.IntersectionObserver=e,window.IntersectionObserverEntry=t}}();
!function(e){"use strict";var n=function(e,t){var r=/[^\w\-.:]/.test(e)?new Function(n.arg+",tmpl","var _e=tmpl.encode"+n.helper+",_s='"+e.replace(n.regexp,n.func)+"';return _s;"):n.cache[e]=n.cache[e]||n(n.load(e));return t?r(t,n):function(e){return r(e,n)}};n.cache={},n.load=function(e){return document.getElementById(e).innerHTML},n.regexp=/([\s'\\])(?!(?:[^{]|\{(?!%))*%\})|(?:\{%(=|#)([\s\S]+?)%\})|(\{%)|(%\})/g,n.func=function(e,n,t,r,c,u){return n?{"\n":"\\n","\r":"\\r","\t":"\\t"," ":" "}[n]||"\\"+n:t?"="===t?"'+_e("+r+")+'":"'+("+r+"==null?'':"+r+")+'":c?"';":u?"_s+='":void 0},n.encReg=/[<>&"'\x00]/g,n.encMap={"<":"&lt;",">":"&gt;","&":"&amp;",'"':"&quot;","'":"&#39;"},n.encode=function(e){return(null==e?"":""+e).replace(n.encReg,function(e){return n.encMap[e]||""})},n.arg="o",n.helper=",print=function(s,e){_s+=e?(s==null?'':s):_e(s);},include=function(s,d){_s+=tmpl(s,d);}","function"==typeof define&&define.amd?define(function(){return n}):"object"==typeof module&&module.exports?module.exports=n:e.tmpl=n}(this);
/*! PhotoSwipe - v4.1.3 - 2019-01-08
* http://photoswipe.com
* Copyright (c) 2019 Dmitry Semenov; */
!function(e,t){"function"==typeof define&&define.amd?define(t):"object"==typeof exports?module.exports=t():e.PhotoSwipe=t()}(this,function(){"use strict";var e=function(e,t,n,i){var o={features:null,bind:function(e,t,n,i){var o=(i?"remove":"add")+"EventListener";t=t.split(" ");for(var a=0;a<t.length;a++)t[a]&&e[o](t[a],n,!1)},isArray:function(e){return e instanceof Array},createEl:function(e,t){var n=document.createElement(t||"div");return e&&(n.className=e),n},getScrollY:function(){var e=window.pageYOffset;return void 0!==e?e:document.documentElement.scrollTop},unbind:function(e,t,n){o.bind(e,t,n,!0)},removeClass:function(e,t){var n=new RegExp("(\\s|^)"+t+"(\\s|$)");e.className=e.className.replace(n," ").replace(/^\s\s*/,"").replace(/\s\s*$/,"")},addClass:function(e,t){o.hasClass(e,t)||(e.className+=(e.className?" ":"")+t)},hasClass:function(e,t){return e.className&&new RegExp("(^|\\s)"+t+"(\\s|$)").test(e.className)},getChildByClass:function(e,t){for(var n=e.firstChild;n;){if(o.hasClass(n,t))return n;n=n.nextSibling}},arraySearch:function(e,t,n){for(var i=e.length;i--;)if(e[i][n]===t)return i;return-1},extend:function(e,t,n){for(var i in t)if(t.hasOwnProperty(i)){if(n&&e.hasOwnProperty(i))continue;e[i]=t[i]}},easing:{sine:{out:function(e){return Math.sin(e*(Math.PI/2))},inOut:function(e){return-(Math.cos(Math.PI*e)-1)/2}},cubic:{out:function(e){return--e*e*e+1}}},detectFeatures:function(){if(o.features)return o.features;var e=o.createEl(),t=e.style,n="",i={};if(i.oldIE=document.all&&!document.addEventListener,i.touch="ontouchstart"in window,window.requestAnimationFrame&&(i.raf=window.requestAnimationFrame,i.caf=window.cancelAnimationFrame),i.pointerEvent=!!window.PointerEvent||navigator.msPointerEnabled,!i.pointerEvent){var a=navigator.userAgent;if(/iP(hone|od)/.test(navigator.platform)){var r=navigator.appVersion.match(/OS (\d+)_(\d+)_?(\d+)?/);r&&r.length>0&&(r=parseInt(r[1],10),r>=1&&r<8&&(i.isOldIOSPhone=!0))}var l=a.match(/Android\s([0-9\.]*)/),s=l?l[1]:0;s=parseFloat(s),s>=1&&(s<4.4&&(i.isOldAndroid=!0),i.androidVersion=s),i.isMobileOpera=/opera mini|opera mobi/i.test(a)}for(var u,c,d=["transform","perspective","animationName"],p=["","webkit","Moz","ms","O"],m=0;m<4;m++){n=p[m];for(var f=0;f<3;f++)u=d[f],c=n+(n?u.charAt(0).toUpperCase()+u.slice(1):u),!i[u]&&c in t&&(i[u]=c);n&&!i.raf&&(n=n.toLowerCase(),i.raf=window[n+"RequestAnimationFrame"],i.raf&&(i.caf=window[n+"CancelAnimationFrame"]||window[n+"CancelRequestAnimationFrame"]))}if(!i.raf){var h=0;i.raf=function(e){var t=(new Date).getTime(),n=Math.max(0,16-(t-h)),i=window.setTimeout(function(){e(t+n)},n);return h=t+n,i},i.caf=function(e){clearTimeout(e)}}return i.svg=!!document.createElementNS&&!!document.createElementNS("http://www.w3.org/2000/svg","svg").createSVGRect,o.features=i,i}};o.detectFeatures(),o.features.oldIE&&(o.bind=function(e,t,n,i){t=t.split(" ");for(var o,a=(i?"detach":"attach")+"Event",r=function(){n.handleEvent.call(n)},l=0;l<t.length;l++)if(o=t[l])if("object"==typeof n&&n.handleEvent){if(i){if(!n["oldIE"+o])return!1}else n["oldIE"+o]=r;e[a]("on"+o,n["oldIE"+o])}else e[a]("on"+o,n)});var a=this,r=25,l=3,s={allowPanToNext:!0,spacing:.12,bgOpacity:1,mouseUsed:!1,loop:!0,pinchToClose:!0,closeOnScroll:!0,closeOnVerticalDrag:!0,verticalDragRange:.75,hideAnimationDuration:333,showAnimationDuration:333,showHideOpacity:!1,focus:!0,escKey:!0,arrowKeys:!0,mainScrollEndFriction:.35,panEndFriction:.35,isClickableElement:function(e){return"A"===e.tagName},getDoubleTapZoom:function(e,t){return e?1:t.initialZoomLevel<.7?1:1.33},maxSpreadZoom:1.33,modal:!0,scaleMode:"fit"};o.extend(s,i);var u,c,d,p,m,f,h,y,v,x,g,w,b,I,C,D,T,M,S,A,E,O,k,R,P,Z,F,L,z,_,N,U,H,Y,W,B,G,X,V,K,q,$,j,J,Q,ee,te,ne,ie,oe,ae,re,le,se,ue,ce,de,pe=function(){return{x:0,y:0}},me=pe(),fe=pe(),he=pe(),ye={},ve=0,xe={},ge=pe(),we=0,be=!0,Ie=[],Ce={},De=!1,Te=function(e,t){o.extend(a,t.publicMethods),Ie.push(e)},Me=function(e){var t=en();return e>t-1?e-t:e<0?t+e:e},Se={},Ae=function(e,t){return Se[e]||(Se[e]=[]),Se[e].push(t)},Ee=function(e){var t=Se[e];if(t){var n=Array.prototype.slice.call(arguments);n.shift();for(var i=0;i<t.length;i++)t[i].apply(a,n)}},Oe=function(){return(new Date).getTime()},ke=function(e){ue=e,a.bg.style.opacity=e*s.bgOpacity},Re=function(e,t,n,i,o){(!De||o&&o!==a.currItem)&&(i/=o?o.fitRatio:a.currItem.fitRatio),e[O]=w+t+"px, "+n+"px"+b+" scale("+i+")"},Pe=function(e){oe&&(e&&(x>a.currItem.fitRatio?De||(mn(a.currItem,!1,!0),De=!0):De&&(mn(a.currItem),De=!1)),Re(oe,he.x,he.y,x))},Ze=function(e){e.container&&Re(e.container.style,e.initialPosition.x,e.initialPosition.y,e.initialZoomLevel,e)},Fe=function(e,t){t[O]=w+e+"px, 0px"+b},Le=function(e,t){if(!s.loop&&t){var n=p+(ge.x*ve-e)/ge.x,i=Math.round(e-gt.x);(n<0&&i>0||n>=en()-1&&i<0)&&(e=gt.x+i*s.mainScrollEndFriction)}gt.x=e,Fe(e,m)},ze=function(e,t){var n=wt[e]-xe[e];return fe[e]+me[e]+n-n*(t/g)},_e=function(e,t){e.x=t.x,e.y=t.y,t.id&&(e.id=t.id)},Ne=function(e){e.x=Math.round(e.x),e.y=Math.round(e.y)},Ue=null,He=function(){Ue&&(o.unbind(document,"mousemove",He),o.addClass(e,"pswp--has_mouse"),s.mouseUsed=!0,Ee("mouseUsed")),Ue=setTimeout(function(){Ue=null},100)},Ye=function(){o.bind(document,"keydown",a),N.transform&&o.bind(a.scrollWrap,"click",a),s.mouseUsed||o.bind(document,"mousemove",He),o.bind(window,"resize scroll orientationchange",a),Ee("bindEvents")},We=function(){o.unbind(window,"resize scroll orientationchange",a),o.unbind(window,"scroll",v.scroll),o.unbind(document,"keydown",a),o.unbind(document,"mousemove",He),N.transform&&o.unbind(a.scrollWrap,"click",a),V&&o.unbind(window,h,a),clearTimeout(U),Ee("unbindEvents")},Be=function(e,t){var n=un(a.currItem,ye,e);return t&&(ie=n),n},Ge=function(e){return e||(e=a.currItem),e.initialZoomLevel},Xe=function(e){return e||(e=a.currItem),e.w>0?s.maxSpreadZoom:1},Ve=function(e,t,n,i){return i===a.currItem.initialZoomLevel?(n[e]=a.currItem.initialPosition[e],!0):(n[e]=ze(e,i),n[e]>t.min[e]?(n[e]=t.min[e],!0):n[e]<t.max[e]&&(n[e]=t.max[e],!0))},Ke=function(){if(O){var t=N.perspective&&!R;return w="translate"+(t?"3d(":"("),void(b=N.perspective?", 0px)":")")}O="left",o.addClass(e,"pswp--ie"),Fe=function(e,t){t.left=e+"px"},Ze=function(e){var t=e.fitRatio>1?1:e.fitRatio,n=e.container.style,i=t*e.w,o=t*e.h;n.width=i+"px",n.height=o+"px",n.left=e.initialPosition.x+"px",n.top=e.initialPosition.y+"px"},Pe=function(){if(oe){var e=oe,t=a.currItem,n=t.fitRatio>1?1:t.fitRatio,i=n*t.w,o=n*t.h;e.width=i+"px",e.height=o+"px",e.left=he.x+"px",e.top=he.y+"px"}}},qe=function(e){var t="";s.escKey&&27===e.keyCode?t="close":s.arrowKeys&&(37===e.keyCode?t="prev":39===e.keyCode&&(t="next")),t&&(e.ctrlKey||e.altKey||e.shiftKey||e.metaKey||(e.preventDefault?e.preventDefault():e.returnValue=!1,a[t]()))},$e=function(e){e&&($||q||ae||G)&&(e.preventDefault(),e.stopPropagation())},je=function(){a.setScrollOffset(0,o.getScrollY())},Je={},Qe=0,et=function(e){Je[e]&&(Je[e].raf&&Z(Je[e].raf),Qe--,delete Je[e])},tt=function(e){Je[e]&&et(e),Je[e]||(Qe++,Je[e]={})},nt=function(){for(var e in Je)Je.hasOwnProperty(e)&&et(e)},it=function(e,t,n,i,o,a,r){var l,s=Oe();tt(e);var u=function(){if(Je[e]){if(l=Oe()-s,l>=i)return et(e),a(n),void(r&&r());a((n-t)*o(l/i)+t),Je[e].raf=P(u)}};u()},ot={shout:Ee,listen:Ae,viewportSize:ye,options:s,isMainScrollAnimating:function(){return ae},getZoomLevel:function(){return x},getCurrentIndex:function(){return p},isDragging:function(){return V},isZooming:function(){return ee},setScrollOffset:function(e,t){xe.x=e,_=xe.y=t,Ee("updateScrollOffset",xe)},applyZoomPan:function(e,t,n,i){he.x=t,he.y=n,x=e,Pe(i)},init:function(){if(!u&&!c){var n;a.framework=o,a.template=e,a.bg=o.getChildByClass(e,"pswp__bg"),F=e.className,u=!0,N=o.detectFeatures(),P=N.raf,Z=N.caf,O=N.transform,z=N.oldIE,a.scrollWrap=o.getChildByClass(e,"pswp__scroll-wrap"),a.container=o.getChildByClass(a.scrollWrap,"pswp__container"),m=a.container.style,a.itemHolders=D=[{el:a.container.children[0],wrap:0,index:-1},{el:a.container.children[1],wrap:0,index:-1},{el:a.container.children[2],wrap:0,index:-1}],D[0].el.style.display=D[2].el.style.display="none",Ke(),v={resize:a.updateSize,orientationchange:function(){clearTimeout(U),U=setTimeout(function(){ye.x!==a.scrollWrap.clientWidth&&a.updateSize()},500)},scroll:je,keydown:qe,click:$e};var i=N.isOldIOSPhone||N.isOldAndroid||N.isMobileOpera;for(N.animationName&&N.transform&&!i||(s.showAnimationDuration=s.hideAnimationDuration=0),n=0;n<Ie.length;n++)a["init"+Ie[n]]();if(t){var r=a.ui=new t(a,o);r.init()}Ee("firstUpdate"),p=p||s.index||0,(isNaN(p)||p<0||p>=en())&&(p=0),a.currItem=Qt(p),(N.isOldIOSPhone||N.isOldAndroid)&&(be=!1),e.setAttribute("aria-hidden","false"),s.modal&&(be?e.style.position="fixed":(e.style.position="absolute",e.style.top=o.getScrollY()+"px")),void 0===_&&(Ee("initialLayout"),_=L=o.getScrollY());var d="pswp--open ";for(s.mainClass&&(d+=s.mainClass+" "),s.showHideOpacity&&(d+="pswp--animate_opacity "),d+=R?"pswp--touch":"pswp--notouch",d+=N.animationName?" pswp--css_animation":"",d+=N.svg?" pswp--svg":"",o.addClass(e,d),a.updateSize(),f=-1,we=null,n=0;n<l;n++)Fe((n+f)*ge.x,D[n].el.style);z||o.bind(a.scrollWrap,y,a),Ae("initialZoomInEnd",function(){a.setContent(D[0],p-1),a.setContent(D[2],p+1),D[0].el.style.display=D[2].el.style.display="block",s.focus&&e.focus(),Ye()}),a.setContent(D[1],p),a.updateCurrItem(),Ee("afterInit"),be||(I=setInterval(function(){Qe||V||ee||x!==a.currItem.initialZoomLevel||a.updateSize()},1e3)),o.addClass(e,"pswp--visible")}},close:function(){u&&(u=!1,c=!0,Ee("close"),We(),nn(a.currItem,null,!0,a.destroy))},destroy:function(){Ee("destroy"),qt&&clearTimeout(qt),e.setAttribute("aria-hidden","true"),e.className=F,I&&clearInterval(I),o.unbind(a.scrollWrap,y,a),o.unbind(window,"scroll",a),Tt(),nt(),Se=null},panTo:function(e,t,n){n||(e>ie.min.x?e=ie.min.x:e<ie.max.x&&(e=ie.max.x),t>ie.min.y?t=ie.min.y:t<ie.max.y&&(t=ie.max.y)),he.x=e,he.y=t,Pe()},handleEvent:function(e){e=e||window.event,v[e.type]&&v[e.type](e)},goTo:function(e){e=Me(e);var t=e-p;we=t,p=e,a.currItem=Qt(p),ve-=t,Le(ge.x*ve),nt(),ae=!1,a.updateCurrItem()},next:function(){a.goTo(p+1)},prev:function(){a.goTo(p-1)},updateCurrZoomItem:function(e){if(e&&Ee("beforeChange",0),D[1].el.children.length){var t=D[1].el.children[0];oe=o.hasClass(t,"pswp__zoom-wrap")?t.style:null}else oe=null;ie=a.currItem.bounds,g=x=a.currItem.initialZoomLevel,he.x=ie.center.x,he.y=ie.center.y,e&&Ee("afterChange")},invalidateCurrItems:function(){C=!0;for(var e=0;e<l;e++)D[e].item&&(D[e].item.needsUpdate=!0)},updateCurrItem:function(e){if(0!==we){var t,n=Math.abs(we);if(!(e&&n<2)){a.currItem=Qt(p),De=!1,Ee("beforeChange",we),n>=l&&(f+=we+(we>0?-l:l),n=l);for(var i=0;i<n;i++)we>0?(t=D.shift(),D[l-1]=t,f++,Fe((f+2)*ge.x,t.el.style),a.setContent(t,p-n+i+1+1)):(t=D.pop(),D.unshift(t),f--,Fe(f*ge.x,t.el.style),a.setContent(t,p+n-i-1-1));if(oe&&1===Math.abs(we)){var o=Qt(T);o.initialZoomLevel!==x&&(un(o,ye),mn(o),Ze(o))}we=0,a.updateCurrZoomItem(),T=p,Ee("afterChange")}}},updateSize:function(t){if(!be&&s.modal){var n=o.getScrollY();if(_!==n&&(e.style.top=n+"px",_=n),!t&&Ce.x===window.innerWidth&&Ce.y===window.innerHeight)return;Ce.x=window.innerWidth,Ce.y=window.innerHeight,e.style.height=Ce.y+"px"}if(ye.x=a.scrollWrap.clientWidth,ye.y=a.scrollWrap.clientHeight,je(),ge.x=ye.x+Math.round(ye.x*s.spacing),ge.y=ye.y,Le(ge.x*ve),Ee("beforeResize"),void 0!==f){for(var i,r,u,c=0;c<l;c++)i=D[c],Fe((c+f)*ge.x,i.el.style),u=p+c-1,s.loop&&en()>2&&(u=Me(u)),r=Qt(u),r&&(C||r.needsUpdate||!r.bounds)?(a.cleanSlide(r),a.setContent(i,u),1===c&&(a.currItem=r,a.updateCurrZoomItem(!0)),r.needsUpdate=!1):i.index===-1&&u>=0&&a.setContent(i,u),r&&r.container&&(un(r,ye),mn(r),Ze(r));C=!1}g=x=a.currItem.initialZoomLevel,ie=a.currItem.bounds,ie&&(he.x=ie.center.x,he.y=ie.center.y,Pe(!0)),Ee("resize")},zoomTo:function(e,t,n,i,a){t&&(g=x,wt.x=Math.abs(t.x)-he.x,wt.y=Math.abs(t.y)-he.y,_e(fe,he));var r=Be(e,!1),l={};Ve("x",r,l,e),Ve("y",r,l,e);var s=x,u={x:he.x,y:he.y};Ne(l);var c=function(t){1===t?(x=e,he.x=l.x,he.y=l.y):(x=(e-s)*t+s,he.x=(l.x-u.x)*t+u.x,he.y=(l.y-u.y)*t+u.y),a&&a(t),Pe(1===t)};n?it("customZoomTo",0,1,n,i||o.easing.sine.inOut,c):c(1)}},at=30,rt=10,lt={},st={},ut={},ct={},dt={},pt=[],mt={},ft=[],ht={},yt=0,vt=pe(),xt=0,gt=pe(),wt=pe(),bt=pe(),It=function(e,t){return e.x===t.x&&e.y===t.y},Ct=function(e,t){return Math.abs(e.x-t.x)<r&&Math.abs(e.y-t.y)<r},Dt=function(e,t){return ht.x=Math.abs(e.x-t.x),ht.y=Math.abs(e.y-t.y),Math.sqrt(ht.x*ht.x+ht.y*ht.y)},Tt=function(){j&&(Z(j),j=null)},Mt=function(){V&&(j=P(Mt),Yt())},St=function(){return!("fit"===s.scaleMode&&x===a.currItem.initialZoomLevel)},At=function(e,t){return!(!e||e===document)&&!(e.getAttribute("class")&&e.getAttribute("class").indexOf("pswp__scroll-wrap")>-1)&&(t(e)?e:At(e.parentNode,t))},Et={},Ot=function(e,t){return Et.prevent=!At(e.target,s.isClickableElement),Ee("preventDragEvent",e,t,Et),Et.prevent},kt=function(e,t){return t.x=e.pageX,t.y=e.pageY,t.id=e.identifier,t},Rt=function(e,t,n){n.x=.5*(e.x+t.x),n.y=.5*(e.y+t.y)},Pt=function(e,t,n){if(e-Y>50){var i=ft.length>2?ft.shift():{};i.x=t,i.y=n,ft.push(i),Y=e}},Zt=function(){var e=he.y-a.currItem.initialPosition.y;return 1-Math.abs(e/(ye.y/2))},Ft={},Lt={},zt=[],_t=function(e){for(;zt.length>0;)zt.pop();return k?(de=0,pt.forEach(function(e){0===de?zt[0]=e:1===de&&(zt[1]=e),de++})):e.type.indexOf("touch")>-1?e.touches&&e.touches.length>0&&(zt[0]=kt(e.touches[0],Ft),e.touches.length>1&&(zt[1]=kt(e.touches[1],Lt))):(Ft.x=e.pageX,Ft.y=e.pageY,Ft.id="",zt[0]=Ft),zt},Nt=function(e,t){var n,i,o,r,l=0,u=he[e]+t[e],c=t[e]>0,d=gt.x+t.x,p=gt.x-mt.x;return n=u>ie.min[e]||u<ie.max[e]?s.panEndFriction:1,u=he[e]+t[e]*n,!s.allowPanToNext&&x!==a.currItem.initialZoomLevel||(oe?"h"!==re||"x"!==e||q||(c?(u>ie.min[e]&&(n=s.panEndFriction,l=ie.min[e]-u,i=ie.min[e]-fe[e]),(i<=0||p<0)&&en()>1?(r=d,p<0&&d>mt.x&&(r=mt.x)):ie.min.x!==ie.max.x&&(o=u)):(u<ie.max[e]&&(n=s.panEndFriction,l=u-ie.max[e],i=fe[e]-ie.max[e]),(i<=0||p>0)&&en()>1?(r=d,p>0&&d<mt.x&&(r=mt.x)):ie.min.x!==ie.max.x&&(o=u))):r=d,"x"!==e)?void(ae||J||x>a.currItem.fitRatio&&(he[e]+=t[e]*n)):(void 0!==r&&(Le(r,!0),J=r!==mt.x),ie.min.x!==ie.max.x&&(void 0!==o?he.x=o:J||(he.x+=t.x*n)),void 0!==r)},Ut=function(e){if(!("mousedown"===e.type&&e.button>0)){if(Jt)return void e.preventDefault();if(!X||"mousedown"!==e.type){if(Ot(e,!0)&&e.preventDefault(),Ee("pointerDown"),k){var t=o.arraySearch(pt,e.pointerId,"id");t<0&&(t=pt.length),pt[t]={x:e.pageX,y:e.pageY,id:e.pointerId}}var n=_t(e),i=n.length;Q=null,nt(),V&&1!==i||(V=le=!0,o.bind(window,h,a),B=ce=se=G=J=$=K=q=!1,re=null,Ee("firstTouchStart",n),_e(fe,he),me.x=me.y=0,_e(ct,n[0]),_e(dt,ct),mt.x=ge.x*ve,ft=[{x:ct.x,y:ct.y}],Y=H=Oe(),Be(x,!0),Tt(),Mt()),!ee&&i>1&&!ae&&!J&&(g=x,q=!1,ee=K=!0,me.y=me.x=0,_e(fe,he),_e(lt,n[0]),_e(st,n[1]),Rt(lt,st,bt),wt.x=Math.abs(bt.x)-he.x,wt.y=Math.abs(bt.y)-he.y,te=ne=Dt(lt,st))}}},Ht=function(e){if(e.preventDefault(),k){var t=o.arraySearch(pt,e.pointerId,"id");if(t>-1){var n=pt[t];n.x=e.pageX,n.y=e.pageY}}if(V){var i=_t(e);if(re||$||ee)Q=i;else if(gt.x!==ge.x*ve)re="h";else{var a=Math.abs(i[0].x-ct.x)-Math.abs(i[0].y-ct.y);Math.abs(a)>=rt&&(re=a>0?"h":"v",Q=i)}}},Yt=function(){if(Q){var e=Q.length;if(0!==e)if(_e(lt,Q[0]),ut.x=lt.x-ct.x,ut.y=lt.y-ct.y,ee&&e>1){if(ct.x=lt.x,ct.y=lt.y,!ut.x&&!ut.y&&It(Q[1],st))return;_e(st,Q[1]),q||(q=!0,Ee("zoomGestureStarted"));var t=Dt(lt,st),n=Vt(t);n>a.currItem.initialZoomLevel+a.currItem.initialZoomLevel/15&&(ce=!0);var i=1,o=Ge(),r=Xe();if(n<o)if(s.pinchToClose&&!ce&&g<=a.currItem.initialZoomLevel){var l=o-n,u=1-l/(o/1.2);ke(u),Ee("onPinchClose",u),se=!0}else i=(o-n)/o,i>1&&(i=1),n=o-i*(o/3);else n>r&&(i=(n-r)/(6*o),i>1&&(i=1),n=r+i*o);i<0&&(i=0),te=t,Rt(lt,st,vt),me.x+=vt.x-bt.x,me.y+=vt.y-bt.y,_e(bt,vt),he.x=ze("x",n),he.y=ze("y",n),B=n>x,x=n,Pe()}else{if(!re)return;if(le&&(le=!1,Math.abs(ut.x)>=rt&&(ut.x-=Q[0].x-dt.x),Math.abs(ut.y)>=rt&&(ut.y-=Q[0].y-dt.y)),ct.x=lt.x,ct.y=lt.y,0===ut.x&&0===ut.y)return;if("v"===re&&s.closeOnVerticalDrag&&!St()){me.y+=ut.y,he.y+=ut.y;var c=Zt();return G=!0,Ee("onVerticalDrag",c),ke(c),void Pe()}Pt(Oe(),lt.x,lt.y),$=!0,ie=a.currItem.bounds;var d=Nt("x",ut);d||(Nt("y",ut),Ne(he),Pe())}}},Wt=function(e){if(N.isOldAndroid){if(X&&"mouseup"===e.type)return;e.type.indexOf("touch")>-1&&(clearTimeout(X),X=setTimeout(function(){X=0},600))}Ee("pointerUp"),Ot(e,!1)&&e.preventDefault();var t;if(k){var n=o.arraySearch(pt,e.pointerId,"id");if(n>-1)if(t=pt.splice(n,1)[0],navigator.msPointerEnabled){var i={4:"mouse",2:"touch",3:"pen"};t.type=i[e.pointerType],t.type||(t.type=e.pointerType||"mouse")}else t.type=e.pointerType||"mouse"}var r,l=_t(e),u=l.length;if("mouseup"===e.type&&(u=0),2===u)return Q=null,!0;1===u&&_e(dt,l[0]),0!==u||re||ae||(t||("mouseup"===e.type?t={x:e.pageX,y:e.pageY,type:"mouse"}:e.changedTouches&&e.changedTouches[0]&&(t={x:e.changedTouches[0].pageX,y:e.changedTouches[0].pageY,type:"touch"})),Ee("touchRelease",e,t));var c=-1;if(0===u&&(V=!1,o.unbind(window,h,a),Tt(),ee?c=0:xt!==-1&&(c=Oe()-xt)),xt=1===u?Oe():-1,r=c!==-1&&c<150?"zoom":"swipe",ee&&u<2&&(ee=!1,1===u&&(r="zoomPointerUp"),Ee("zoomGestureEnded")),Q=null,$||q||ae||G)if(nt(),W||(W=Bt()),W.calculateSwipeSpeed("x"),G){var d=Zt();if(d<s.verticalDragRange)a.close();else{var p=he.y,m=ue;it("verticalDrag",0,1,300,o.easing.cubic.out,function(e){he.y=(a.currItem.initialPosition.y-p)*e+p,ke((1-m)*e+m),Pe()}),Ee("onVerticalDrag",1)}}else{if((J||ae)&&0===u){var f=Xt(r,W);if(f)return;r="zoomPointerUp"}if(!ae)return"swipe"!==r?void Kt():void(!J&&x>a.currItem.fitRatio&&Gt(W))}},Bt=function(){var e,t,n={lastFlickOffset:{},lastFlickDist:{},lastFlickSpeed:{},slowDownRatio:{},slowDownRatioReverse:{},speedDecelerationRatio:{},speedDecelerationRatioAbs:{},distanceOffset:{},backAnimDestination:{},backAnimStarted:{},calculateSwipeSpeed:function(i){ft.length>1?(e=Oe()-Y+50,t=ft[ft.length-2][i]):(e=Oe()-H,t=dt[i]),n.lastFlickOffset[i]=ct[i]-t,n.lastFlickDist[i]=Math.abs(n.lastFlickOffset[i]),n.lastFlickDist[i]>20?n.lastFlickSpeed[i]=n.lastFlickOffset[i]/e:n.lastFlickSpeed[i]=0,Math.abs(n.lastFlickSpeed[i])<.1&&(n.lastFlickSpeed[i]=0),n.slowDownRatio[i]=.95,n.slowDownRatioReverse[i]=1-n.slowDownRatio[i],n.speedDecelerationRatio[i]=1},calculateOverBoundsAnimOffset:function(e,t){n.backAnimStarted[e]||(he[e]>ie.min[e]?n.backAnimDestination[e]=ie.min[e]:he[e]<ie.max[e]&&(n.backAnimDestination[e]=ie.max[e]),void 0!==n.backAnimDestination[e]&&(n.slowDownRatio[e]=.7,n.slowDownRatioReverse[e]=1-n.slowDownRatio[e],n.speedDecelerationRatioAbs[e]<.05&&(n.lastFlickSpeed[e]=0,n.backAnimStarted[e]=!0,it("bounceZoomPan"+e,he[e],n.backAnimDestination[e],t||300,o.easing.sine.out,function(t){he[e]=t,Pe()}))))},calculateAnimOffset:function(e){n.backAnimStarted[e]||(n.speedDecelerationRatio[e]=n.speedDecelerationRatio[e]*(n.slowDownRatio[e]+n.slowDownRatioReverse[e]-n.slowDownRatioReverse[e]*n.timeDiff/10),n.speedDecelerationRatioAbs[e]=Math.abs(n.lastFlickSpeed[e]*n.speedDecelerationRatio[e]),n.distanceOffset[e]=n.lastFlickSpeed[e]*n.speedDecelerationRatio[e]*n.timeDiff,he[e]+=n.distanceOffset[e])},panAnimLoop:function(){if(Je.zoomPan&&(Je.zoomPan.raf=P(n.panAnimLoop),n.now=Oe(),n.timeDiff=n.now-n.lastNow,n.lastNow=n.now,n.calculateAnimOffset("x"),n.calculateAnimOffset("y"),Pe(),n.calculateOverBoundsAnimOffset("x"),n.calculateOverBoundsAnimOffset("y"),n.speedDecelerationRatioAbs.x<.05&&n.speedDecelerationRatioAbs.y<.05))return he.x=Math.round(he.x),he.y=Math.round(he.y),Pe(),void et("zoomPan")}};return n},Gt=function(e){return e.calculateSwipeSpeed("y"),ie=a.currItem.bounds,e.backAnimDestination={},e.backAnimStarted={},Math.abs(e.lastFlickSpeed.x)<=.05&&Math.abs(e.lastFlickSpeed.y)<=.05?(e.speedDecelerationRatioAbs.x=e.speedDecelerationRatioAbs.y=0,e.calculateOverBoundsAnimOffset("x"),e.calculateOverBoundsAnimOffset("y"),!0):(tt("zoomPan"),e.lastNow=Oe(),void e.panAnimLoop())},Xt=function(e,t){var n;ae||(yt=p);var i;if("swipe"===e){var r=ct.x-dt.x,l=t.lastFlickDist.x<10;r>at&&(l||t.lastFlickOffset.x>20)?i=-1:r<-at&&(l||t.lastFlickOffset.x<-20)&&(i=1)}var u;i&&(p+=i,p<0?(p=s.loop?en()-1:0,u=!0):p>=en()&&(p=s.loop?0:en()-1,u=!0),u&&!s.loop||(we+=i,ve-=i,n=!0));var c,d=ge.x*ve,m=Math.abs(d-gt.x);return n||d>gt.x==t.lastFlickSpeed.x>0?(c=Math.abs(t.lastFlickSpeed.x)>0?m/Math.abs(t.lastFlickSpeed.x):333,c=Math.min(c,400),c=Math.max(c,250)):c=333,yt===p&&(n=!1),ae=!0,Ee("mainScrollAnimStart"),it("mainScroll",gt.x,d,c,o.easing.cubic.out,Le,function(){nt(),ae=!1,yt=-1,(n||yt!==p)&&a.updateCurrItem(),Ee("mainScrollAnimComplete")}),n&&a.updateCurrItem(!0),n},Vt=function(e){return 1/ne*e*g},Kt=function(){var e=x,t=Ge(),n=Xe();x<t?e=t:x>n&&(e=n);var i,r=1,l=ue;return se&&!B&&!ce&&x<t?(a.close(),!0):(se&&(i=function(e){ke((r-l)*e+l)}),a.zoomTo(e,0,200,o.easing.cubic.out,i),!0)};Te("Gestures",{publicMethods:{initGestures:function(){var e=function(e,t,n,i,o){M=e+t,S=e+n,A=e+i,E=o?e+o:""};k=N.pointerEvent,k&&N.touch&&(N.touch=!1),k?navigator.msPointerEnabled?e("MSPointer","Down","Move","Up","Cancel"):e("pointer","down","move","up","cancel"):N.touch?(e("touch","start","move","end","cancel"),R=!0):e("mouse","down","move","up"),h=S+" "+A+" "+E,y=M,k&&!R&&(R=navigator.maxTouchPoints>1||navigator.msMaxTouchPoints>1),a.likelyTouchDevice=R,v[M]=Ut,v[S]=Ht,v[A]=Wt,E&&(v[E]=v[A]),N.touch&&(y+=" mousedown",h+=" mousemove mouseup",v.mousedown=v[M],v.mousemove=v[S],v.mouseup=v[A]),R||(s.allowPanToNext=!1)}}});var qt,$t,jt,Jt,Qt,en,tn,nn=function(t,n,i,r){qt&&clearTimeout(qt),Jt=!0,jt=!0;var l;t.initialLayout?(l=t.initialLayout,t.initialLayout=null):l=s.getThumbBoundsFn&&s.getThumbBoundsFn(p);var u=i?s.hideAnimationDuration:s.showAnimationDuration,c=function(){et("initialZoom"),i?(a.template.removeAttribute("style"),a.bg.removeAttribute("style")):(ke(1),n&&(n.style.display="block"),o.addClass(e,"pswp--animated-in"),Ee("initialZoom"+(i?"OutEnd":"InEnd"))),r&&r(),Jt=!1};if(!u||!l||void 0===l.x)return Ee("initialZoom"+(i?"Out":"In")),x=t.initialZoomLevel,_e(he,t.initialPosition),Pe(),e.style.opacity=i?0:1,ke(1),void(u?setTimeout(function(){c()},u):c());var m=function(){var n=d,r=!a.currItem.src||a.currItem.loadError||s.showHideOpacity;t.miniImg&&(t.miniImg.style.webkitBackfaceVisibility="hidden"),i||(x=l.w/t.w,he.x=l.x,he.y=l.y-L,a[r?"template":"bg"].style.opacity=.001,Pe()),tt("initialZoom"),i&&!n&&o.removeClass(e,"pswp--animated-in"),r&&(i?o[(n?"remove":"add")+"Class"](e,"pswp--animate_opacity"):setTimeout(function(){o.addClass(e,"pswp--animate_opacity")},30)),qt=setTimeout(function(){if(Ee("initialZoom"+(i?"Out":"In")),i){var a=l.w/t.w,s={x:he.x,y:he.y},d=x,p=ue,m=function(t){1===t?(x=a,he.x=l.x,he.y=l.y-_):(x=(a-d)*t+d,he.x=(l.x-s.x)*t+s.x,he.y=(l.y-_-s.y)*t+s.y),Pe(),r?e.style.opacity=1-t:ke(p-t*p)};n?it("initialZoom",0,1,u,o.easing.cubic.out,m,c):(m(1),qt=setTimeout(c,u+20))}else x=t.initialZoomLevel,_e(he,t.initialPosition),Pe(),ke(1),r?e.style.opacity=1:ke(1),qt=setTimeout(c,u+20)},i?25:90)};m()},on={},an=[],rn={index:0,errorMsg:'<div class="pswp__error-msg"><a href="%url%" target="_blank">The image</a> could not be loaded.</div>',forceProgressiveLoading:!1,preload:[1,1],getNumItemsFn:function(){return $t.length}},ln=function(){return{center:{x:0,y:0},max:{x:0,y:0},min:{x:0,y:0}}},sn=function(e,t,n){var i=e.bounds;i.center.x=Math.round((on.x-t)/2),i.center.y=Math.round((on.y-n)/2)+e.vGap.top,i.max.x=t>on.x?Math.round(on.x-t):i.center.x,i.max.y=n>on.y?Math.round(on.y-n)+e.vGap.top:i.center.y,i.min.x=t>on.x?0:i.center.x,i.min.y=n>on.y?e.vGap.top:i.center.y},un=function(e,t,n){if(e.src&&!e.loadError){var i=!n;if(i&&(e.vGap||(e.vGap={top:0,bottom:0}),Ee("parseVerticalMargin",e)),on.x=t.x,on.y=t.y-e.vGap.top-e.vGap.bottom,i){var o=on.x/e.w,a=on.y/e.h;e.fitRatio=o<a?o:a;var r=s.scaleMode;"orig"===r?n=1:"fit"===r&&(n=e.fitRatio),n>1&&(n=1),e.initialZoomLevel=n,e.bounds||(e.bounds=ln())}if(!n)return;return sn(e,e.w*n,e.h*n),i&&n===e.initialZoomLevel&&(e.initialPosition=e.bounds.center),e.bounds}return e.w=e.h=0,e.initialZoomLevel=e.fitRatio=1,e.bounds=ln(),e.initialPosition=e.bounds.center,e.bounds},cn=function(e,t,n,i,o,r){t.loadError||i&&(t.imageAppended=!0,mn(t,i,t===a.currItem&&De),n.appendChild(i),r&&setTimeout(function(){t&&t.loaded&&t.placeholder&&(t.placeholder.style.display="none",t.placeholder=null)},500))},dn=function(e){e.loading=!0,e.loaded=!1;var t=e.img=o.createEl("pswp__img","img"),n=function(){e.loading=!1,e.loaded=!0,e.loadComplete?e.loadComplete(e):e.img=null,t.onload=t.onerror=null,t=null};return t.onload=n,t.onerror=function(){e.loadError=!0,n()},t.src=e.src,t},pn=function(e,t){if(e.src&&e.loadError&&e.container)return t&&(e.container.innerHTML=""),e.container.innerHTML=s.errorMsg.replace("%url%",e.src),!0},mn=function(e,t,n){if(e.src){t||(t=e.container.lastChild);var i=n?e.w:Math.round(e.w*e.fitRatio),o=n?e.h:Math.round(e.h*e.fitRatio);e.placeholder&&!e.loaded&&(e.placeholder.style.width=i+"px",e.placeholder.style.height=o+"px"),t.style.width=i+"px",t.style.height=o+"px"}},fn=function(){if(an.length){for(var e,t=0;t<an.length;t++)e=an[t],e.holder.index===e.index&&cn(e.index,e.item,e.baseDiv,e.img,!1,e.clearPlaceholder);an=[]}};Te("Controller",{publicMethods:{lazyLoadItem:function(e){e=Me(e);var t=Qt(e);t&&(!t.loaded&&!t.loading||C)&&(Ee("gettingData",e,t),t.src&&dn(t))},initController:function(){o.extend(s,rn,!0),a.items=$t=n,Qt=a.getItemAt,en=s.getNumItemsFn,tn=s.loop,en()<3&&(s.loop=!1),Ae("beforeChange",function(e){var t,n=s.preload,i=null===e||e>=0,o=Math.min(n[0],en()),r=Math.min(n[1],en());for(t=1;t<=(i?r:o);t++)a.lazyLoadItem(p+t);for(t=1;t<=(i?o:r);t++)a.lazyLoadItem(p-t)}),Ae("initialLayout",function(){a.currItem.initialLayout=s.getThumbBoundsFn&&s.getThumbBoundsFn(p)}),Ae("mainScrollAnimComplete",fn),Ae("initialZoomInEnd",fn),Ae("destroy",function(){for(var e,t=0;t<$t.length;t++)e=$t[t],e.container&&(e.container=null),e.placeholder&&(e.placeholder=null),e.img&&(e.img=null),e.preloader&&(e.preloader=null),e.loadError&&(e.loaded=e.loadError=!1);an=null})},getItemAt:function(e){return e>=0&&void 0!==$t[e]&&$t[e]},allowProgressiveImg:function(){return s.forceProgressiveLoading||!R||s.mouseUsed||screen.width>1200},setContent:function(e,t){s.loop&&(t=Me(t));var n=a.getItemAt(e.index);n&&(n.container=null);var i,r=a.getItemAt(t);if(!r)return void(e.el.innerHTML="");Ee("gettingData",t,r),e.index=t,e.item=r;var l=r.container=o.createEl("pswp__zoom-wrap");if(!r.src&&r.html&&(r.html.tagName?l.appendChild(r.html):l.innerHTML=r.html),pn(r),un(r,ye),!r.src||r.loadError||r.loaded)r.src&&!r.loadError&&(i=o.createEl("pswp__img","img"),i.style.opacity=1,i.src=r.src,mn(r,i),cn(t,r,l,i,!0));else{if(r.loadComplete=function(n){if(u){if(e&&e.index===t){if(pn(n,!0))return n.loadComplete=n.img=null,un(n,ye),Ze(n),void(e.index===p&&a.updateCurrZoomItem());n.imageAppended?!Jt&&n.placeholder&&(n.placeholder.style.display="none",n.placeholder=null):N.transform&&(ae||Jt)?an.push({item:n,baseDiv:l,img:n.img,index:t,holder:e,clearPlaceholder:!0}):cn(t,n,l,n.img,ae||Jt,!0)}n.loadComplete=null,n.img=null,Ee("imageLoadComplete",t,n)}},o.features.transform){var c="pswp__img pswp__img--placeholder";c+=r.msrc?"":" pswp__img--placeholder--blank";var d=o.createEl(c,r.msrc?"img":"");r.msrc&&(d.src=r.msrc),mn(r,d),l.appendChild(d),r.placeholder=d}r.loading||dn(r),a.allowProgressiveImg()&&(!jt&&N.transform?an.push({item:r,baseDiv:l,img:r.img,index:t,holder:e}):cn(t,r,l,r.img,!0,!0))}jt||t!==p?Ze(r):(oe=l.style,nn(r,i||r.img)),e.el.innerHTML="",e.el.appendChild(l)},cleanSlide:function(e){e.img&&(e.img.onload=e.img.onerror=null),e.loaded=e.loading=e.img=e.imageAppended=!1}}});var hn,yn={},vn=function(e,t,n){var i=document.createEvent("CustomEvent"),o={origEvent:e,target:e.target,releasePoint:t,pointerType:n||"touch"};i.initCustomEvent("pswpTap",!0,!0,o),e.target.dispatchEvent(i)};Te("Tap",{publicMethods:{initTap:function(){Ae("firstTouchStart",a.onTapStart),Ae("touchRelease",a.onTapRelease),Ae("destroy",function(){yn={},hn=null})},onTapStart:function(e){e.length>1&&(clearTimeout(hn),hn=null)},onTapRelease:function(e,t){if(t&&!$&&!K&&!Qe){var n=t;if(hn&&(clearTimeout(hn),hn=null,Ct(n,yn)))return void Ee("doubleTap",n);if("mouse"===t.type)return void vn(e,t,"mouse");var i=e.target.tagName.toUpperCase();if("BUTTON"===i||o.hasClass(e.target,"pswp__single-tap"))return void vn(e,t);_e(yn,n),hn=setTimeout(function(){vn(e,t),hn=null},300)}}}});var xn;Te("DesktopZoom",{publicMethods:{initDesktopZoom:function(){z||(R?Ae("mouseUsed",function(){a.setupDesktopZoom()}):a.setupDesktopZoom(!0))},setupDesktopZoom:function(t){xn={};var n="wheel mousewheel DOMMouseScroll";Ae("bindEvents",function(){o.bind(e,n,a.handleMouseWheel)}),Ae("unbindEvents",function(){xn&&o.unbind(e,n,a.handleMouseWheel)}),a.mouseZoomedIn=!1;var i,r=function(){a.mouseZoomedIn&&(o.removeClass(e,"pswp--zoomed-in"),a.mouseZoomedIn=!1),x<1?o.addClass(e,"pswp--zoom-allowed"):o.removeClass(e,"pswp--zoom-allowed"),l()},l=function(){i&&(o.removeClass(e,"pswp--dragging"),i=!1)};Ae("resize",r),Ae("afterChange",r),Ae("pointerDown",function(){a.mouseZoomedIn&&(i=!0,o.addClass(e,"pswp--dragging"))}),Ae("pointerUp",l),t||r()},handleMouseWheel:function(e){if(x<=a.currItem.fitRatio)return s.modal&&(!s.closeOnScroll||Qe||V?e.preventDefault():O&&Math.abs(e.deltaY)>2&&(d=!0,a.close())),!0;if(e.stopPropagation(),xn.x=0,"deltaX"in e)1===e.deltaMode?(xn.x=18*e.deltaX,xn.y=18*e.deltaY):(xn.x=e.deltaX,xn.y=e.deltaY);else if("wheelDelta"in e)e.wheelDeltaX&&(xn.x=-.16*e.wheelDeltaX),e.wheelDeltaY?xn.y=-.16*e.wheelDeltaY:xn.y=-.16*e.wheelDelta;else{if(!("detail"in e))return;xn.y=e.detail}Be(x,!0);var t=he.x-xn.x,n=he.y-xn.y;(s.modal||t<=ie.min.x&&t>=ie.max.x&&n<=ie.min.y&&n>=ie.max.y)&&e.preventDefault(),a.panTo(t,n)},toggleDesktopZoom:function(t){t=t||{x:ye.x/2+xe.x,y:ye.y/2+xe.y};var n=s.getDoubleTapZoom(!0,a.currItem),i=x===n;a.mouseZoomedIn=!i,a.zoomTo(i?a.currItem.initialZoomLevel:n,t,333),o[(i?"remove":"add")+"Class"](e,"pswp--zoomed-in")}}});var gn,wn,bn,In,Cn,Dn,Tn,Mn,Sn,An,En,On,kn={history:!0,galleryUID:1},Rn=function(){return En.hash.substring(1)},Pn=function(){gn&&clearTimeout(gn),bn&&clearTimeout(bn)},Zn=function(){var e=Rn(),t={};if(e.length<5)return t;var n,i=e.split("&");for(n=0;n<i.length;n++)if(i[n]){var o=i[n].split("=");o.length<2||(t[o[0]]=o[1])}if(s.galleryPIDs){var a=t.pid;for(t.pid=0,n=0;n<$t.length;n++)if($t[n].pid===a){t.pid=n;break}}else t.pid=parseInt(t.pid,10)-1;return t.pid<0&&(t.pid=0),t},Fn=function(){if(bn&&clearTimeout(bn),Qe||V)return void(bn=setTimeout(Fn,500));In?clearTimeout(wn):In=!0;var e=p+1,t=Qt(p);t.hasOwnProperty("pid")&&(e=t.pid);var n=Tn+"&gid="+s.galleryUID+"&pid="+e;Mn||En.hash.indexOf(n)===-1&&(An=!0);var i=En.href.split("#")[0]+"#"+n;On?"#"+n!==window.location.hash&&history[Mn?"replaceState":"pushState"]("",document.title,i):Mn?En.replace(i):En.hash=n,Mn=!0,wn=setTimeout(function(){In=!1},60)};Te("History",{publicMethods:{initHistory:function(){if(o.extend(s,kn,!0),s.history){En=window.location,An=!1,Sn=!1,Mn=!1,Tn=Rn(),On="pushState"in history,Tn.indexOf("gid=")>-1&&(Tn=Tn.split("&gid=")[0],Tn=Tn.split("?gid=")[0]),Ae("afterChange",a.updateURL),Ae("unbindEvents",function(){o.unbind(window,"hashchange",a.onHashChange)});var e=function(){Dn=!0,Sn||(An?history.back():Tn?En.hash=Tn:On?history.pushState("",document.title,En.pathname+En.search):En.hash=""),Pn()};Ae("unbindEvents",function(){d&&e()}),Ae("destroy",function(){Dn||e()}),Ae("firstUpdate",function(){p=Zn().pid});var t=Tn.indexOf("pid=");t>-1&&(Tn=Tn.substring(0,t),"&"===Tn.slice(-1)&&(Tn=Tn.slice(0,-1))),setTimeout(function(){u&&o.bind(window,"hashchange",a.onHashChange)},40)}},onHashChange:function(){return Rn()===Tn?(Sn=!0,void a.close()):void(In||(Cn=!0,a.goTo(Zn().pid),Cn=!1))},updateURL:function(){Pn(),Cn||(Mn?gn=setTimeout(Fn,800):Fn())}}}),o.extend(a,ot)};return e});
/*! PhotoSwipe Default UI - 4.1.3 - 2019-01-08
* http://photoswipe.com
* Copyright (c) 2019 Dmitry Semenov; */
!function(e,t){"function"==typeof define&&define.amd?define(t):"object"==typeof exports?module.exports=t():e.PhotoSwipeUI_Default=t()}(this,function(){"use strict";var e=function(e,t){var n,o,l,r,i,s,a,u,c,p,d,m,f,h,w,v,g,b,_,C=this,T=!1,I=!0,E=!0,F={barsSize:{top:44,bottom:"auto"},closeElClasses:["item","caption","zoom-wrap","ui","top-bar"],timeToIdle:4e3,timeToIdleOutside:1e3,loadingIndicatorDelay:1e3,addCaptionHTMLFn:function(e,t){return e.title?(t.children[0].innerHTML=e.title,!0):(t.children[0].innerHTML="",!1)},closeEl:!0,captionEl:!0,fullscreenEl:!0,zoomEl:!0,shareEl:!0,counterEl:!0,arrowEl:!0,preloaderEl:!0,tapToClose:!1,tapToToggleControls:!0,clickToCloseNonZoomable:!0,shareButtons:[{id:"facebook",label:"Share on Facebook",url:"https://www.facebook.com/sharer/sharer.php?u={{url}}"},{id:"twitter",label:"Tweet",url:"https://twitter.com/intent/tweet?text={{text}}&url={{url}}"},{id:"pinterest",label:"Pin it",url:"http://www.pinterest.com/pin/create/button/?url={{url}}&media={{image_url}}&description={{text}}"},{id:"download",label:"Download image",url:"{{raw_image_url}}",download:!0}],getImageURLForShare:function(){return e.currItem.src||""},getPageURLForShare:function(){return window.location.href},getTextForShare:function(){return e.currItem.title||""},indexIndicatorSep:" / ",fitControlsWidth:1200},x=function(e){if(v)return!0;e=e||window.event,w.timeToIdle&&w.mouseUsed&&!c&&D();for(var n,o,l=e.target||e.srcElement,r=l.getAttribute("class")||"",i=0;i<N.length;i++)n=N[i],n.onTap&&r.indexOf("pswp__"+n.name)>-1&&(n.onTap(),o=!0);if(o){e.stopPropagation&&e.stopPropagation(),v=!0;var s=t.features.isOldAndroid?600:30;g=setTimeout(function(){v=!1},s)}},S=function(){return!e.likelyTouchDevice||w.mouseUsed||screen.width>w.fitControlsWidth},k=function(e,n,o){t[(o?"add":"remove")+"Class"](e,"pswp__"+n)},K=function(){var e=1===w.getNumItemsFn();e!==h&&(k(o,"ui--one-slide",e),h=e)},L=function(){k(a,"share-modal--hidden",E)},O=function(){return E=!E,E?(t.removeClass(a,"pswp__share-modal--fade-in"),setTimeout(function(){E&&L()},300)):(L(),setTimeout(function(){E||t.addClass(a,"pswp__share-modal--fade-in")},30)),E||y(),!1},R=function(t){t=t||window.event;var n=t.target||t.srcElement;return e.shout("shareLinkClick",t,n),!(!n.href||!n.hasAttribute("download")&&(window.open(n.href,"pswp_share","scrollbars=yes,resizable=yes,toolbar=no,location=yes,width=550,height=420,top=100,left="+(window.screen?Math.round(screen.width/2-275):100)),E||O(),1))},y=function(){for(var e,t,n,o,l,r="",i=0;i<w.shareButtons.length;i++)e=w.shareButtons[i],n=w.getImageURLForShare(e),o=w.getPageURLForShare(e),l=w.getTextForShare(e),t=e.url.replace("{{url}}",encodeURIComponent(o)).replace("{{image_url}}",encodeURIComponent(n)).replace("{{raw_image_url}}",n).replace("{{text}}",encodeURIComponent(l)),r+='<a href="'+t+'" target="_blank" class="pswp__share--'+e.id+'"'+(e.download?"download":"")+">"+e.label+"</a>",w.parseShareButtonOut&&(r=w.parseShareButtonOut(e,r));a.children[0].innerHTML=r,a.children[0].onclick=R},z=function(e){for(var n=0;n<w.closeElClasses.length;n++)if(t.hasClass(e,"pswp__"+w.closeElClasses[n]))return!0},M=0,D=function(){clearTimeout(_),M=0,c&&C.setIdle(!1)},A=function(e){e=e?e:window.event;var t=e.relatedTarget||e.toElement;t&&"HTML"!==t.nodeName||(clearTimeout(_),_=setTimeout(function(){C.setIdle(!0)},w.timeToIdleOutside))},P=function(){w.fullscreenEl&&!t.features.isOldAndroid&&(n||(n=C.getFullscreenAPI()),n?(t.bind(document,n.eventK,C.updateFullscreen),C.updateFullscreen(),t.addClass(e.template,"pswp--supports-fs")):t.removeClass(e.template,"pswp--supports-fs"))},U=function(){w.preloaderEl&&(Z(!0),p("beforeChange",function(){clearTimeout(f),f=setTimeout(function(){e.currItem&&e.currItem.loading?(!e.allowProgressiveImg()||e.currItem.img&&!e.currItem.img.naturalWidth)&&Z(!1):Z(!0)},w.loadingIndicatorDelay)}),p("imageLoadComplete",function(t,n){e.currItem===n&&Z(!0)}))},Z=function(e){m!==e&&(k(d,"preloader--active",!e),m=e)},q=function(e){var n=e.vGap;if(S()){var i=w.barsSize;if(w.captionEl&&"auto"===i.bottom)if(r||(r=t.createEl("pswp__caption pswp__caption--fake"),r.appendChild(t.createEl("pswp__caption__center")),o.insertBefore(r,l),t.addClass(o,"pswp__ui--fit")),w.addCaptionHTMLFn(e,r,!0)){var s=r.clientHeight;n.bottom=parseInt(s,10)||44}else n.bottom=i.top;else n.bottom="auto"===i.bottom?0:i.bottom;n.top=i.top}else n.top=n.bottom=0},B=function(){w.timeToIdle&&p("mouseUsed",function(){t.bind(document,"mousemove",D),t.bind(document,"mouseout",A),b=setInterval(function(){M++,2===M&&C.setIdle(!0)},w.timeToIdle/2)})},H=function(){p("onVerticalDrag",function(e){I&&e<.95?C.hideControls():!I&&e>=.95&&C.showControls()});var e;p("onPinchClose",function(t){I&&t<.9?(C.hideControls(),e=!0):e&&!I&&t>.9&&C.showControls()}),p("zoomGestureEnded",function(){e=!1,e&&!I&&C.showControls()})},N=[{name:"caption",option:"captionEl",onInit:function(e){l=e}},{name:"share-modal",option:"shareEl",onInit:function(e){a=e},onTap:function(){O()}},{name:"button--share",option:"shareEl",onInit:function(e){s=e},onTap:function(){O()}},{name:"button--zoom",option:"zoomEl",onTap:e.toggleDesktopZoom},{name:"counter",option:"counterEl",onInit:function(e){i=e}},{name:"button--close",option:"closeEl",onTap:e.close},{name:"button--arrow--left",option:"arrowEl",onTap:e.prev},{name:"button--arrow--right",option:"arrowEl",onTap:e.next},{name:"button--fs",option:"fullscreenEl",onTap:function(){n.isFullscreen()?n.exit():n.enter()}},{name:"preloader",option:"preloaderEl",onInit:function(e){d=e}}],W=function(){var e,n,l,r=function(o){if(o)for(var r=o.length,i=0;i<r;i++){e=o[i],n=e.className;for(var s=0;s<N.length;s++)l=N[s],n.indexOf("pswp__"+l.name)>-1&&(w[l.option]?(t.removeClass(e,"pswp__element--disabled"),l.onInit&&l.onInit(e)):t.addClass(e,"pswp__element--disabled"))}};r(o.children);var i=t.getChildByClass(o,"pswp__top-bar");i&&r(i.children)};C.init=function(){t.extend(e.options,F,!0),w=e.options,o=t.getChildByClass(e.scrollWrap,"pswp__ui"),p=e.listen,H(),p("beforeChange",C.update),p("doubleTap",function(t){var n=e.currItem.initialZoomLevel;e.getZoomLevel()!==n?e.zoomTo(n,t,333):e.zoomTo(w.getDoubleTapZoom(!1,e.currItem),t,333)}),p("preventDragEvent",function(e,t,n){var o=e.target||e.srcElement;o&&o.getAttribute("class")&&e.type.indexOf("mouse")>-1&&(o.getAttribute("class").indexOf("__caption")>0||/(SMALL|STRONG|EM)/i.test(o.tagName))&&(n.prevent=!1)}),p("bindEvents",function(){t.bind(o,"pswpTap click",x),t.bind(e.scrollWrap,"pswpTap",C.onGlobalTap),e.likelyTouchDevice||t.bind(e.scrollWrap,"mouseover",C.onMouseOver)}),p("unbindEvents",function(){E||O(),b&&clearInterval(b),t.unbind(document,"mouseout",A),t.unbind(document,"mousemove",D),t.unbind(o,"pswpTap click",x),t.unbind(e.scrollWrap,"pswpTap",C.onGlobalTap),t.unbind(e.scrollWrap,"mouseover",C.onMouseOver),n&&(t.unbind(document,n.eventK,C.updateFullscreen),n.isFullscreen()&&(w.hideAnimationDuration=0,n.exit()),n=null)}),p("destroy",function(){w.captionEl&&(r&&o.removeChild(r),t.removeClass(l,"pswp__caption--empty")),a&&(a.children[0].onclick=null),t.removeClass(o,"pswp__ui--over-close"),t.addClass(o,"pswp__ui--hidden"),C.setIdle(!1)}),w.showAnimationDuration||t.removeClass(o,"pswp__ui--hidden"),p("initialZoomIn",function(){w.showAnimationDuration&&t.removeClass(o,"pswp__ui--hidden")}),p("initialZoomOut",function(){t.addClass(o,"pswp__ui--hidden")}),p("parseVerticalMargin",q),W(),w.shareEl&&s&&a&&(E=!0),K(),B(),P(),U()},C.setIdle=function(e){c=e,k(o,"ui--idle",e)},C.update=function(){I&&e.currItem?(C.updateIndexIndicator(),w.captionEl&&(w.addCaptionHTMLFn(e.currItem,l),k(l,"caption--empty",!e.currItem.title)),T=!0):T=!1,E||O(),K()},C.updateFullscreen=function(o){o&&setTimeout(function(){e.setScrollOffset(0,t.getScrollY())},50),t[(n.isFullscreen()?"add":"remove")+"Class"](e.template,"pswp--fs")},C.updateIndexIndicator=function(){w.counterEl&&(i.innerHTML=e.getCurrentIndex()+1+w.indexIndicatorSep+w.getNumItemsFn())},C.onGlobalTap=function(n){n=n||window.event;var o=n.target||n.srcElement;if(!v)if(n.detail&&"mouse"===n.detail.pointerType){if(z(o))return void e.close();t.hasClass(o,"pswp__img")&&(1===e.getZoomLevel()&&e.getZoomLevel()<=e.currItem.fitRatio?w.clickToCloseNonZoomable&&e.close():e.toggleDesktopZoom(n.detail.releasePoint))}else if(w.tapToToggleControls&&(I?C.hideControls():C.showControls()),w.tapToClose&&(t.hasClass(o,"pswp__img")||z(o)))return void e.close()},C.onMouseOver=function(e){e=e||window.event;var t=e.target||e.srcElement;k(o,"ui--over-close",z(t))},C.hideControls=function(){t.addClass(o,"pswp__ui--hidden"),I=!1},C.showControls=function(){I=!0,T||C.update(),t.removeClass(o,"pswp__ui--hidden")},C.supportsFullscreen=function(){var e=document;return!!(e.exitFullscreen||e.mozCancelFullScreen||e.webkitExitFullscreen||e.msExitFullscreen)},C.getFullscreenAPI=function(){var t,n=document.documentElement,o="fullscreenchange";return n.requestFullscreen?t={enterK:"requestFullscreen",exitK:"exitFullscreen",elementK:"fullscreenElement",eventK:o}:n.mozRequestFullScreen?t={enterK:"mozRequestFullScreen",exitK:"mozCancelFullScreen",elementK:"mozFullScreenElement",eventK:"moz"+o}:n.webkitRequestFullscreen?t={enterK:"webkitRequestFullscreen",exitK:"webkitExitFullscreen",elementK:"webkitFullscreenElement",eventK:"webkit"+o}:n.msRequestFullscreen&&(t={enterK:"msRequestFullscreen",exitK:"msExitFullscreen",elementK:"msFullscreenElement",eventK:"MSFullscreenChange"}),t&&(t.enter=function(){return u=w.closeOnScroll,w.closeOnScroll=!1,"webkitRequestFullscreen"!==this.enterK?e.template[this.enterK]():void e.template[this.enterK](Element.ALLOW_KEYBOARD_INPUT)},t.exit=function(){return w.closeOnScroll=u,document[this.exitK]()},t.isFullscreen=function(){return document[this.elementK]}),t}};return e});
/*jquery.mb.YTPlayer 02-02-2017
 _ jquery.mb.components 
 _ email: matteo@open-lab.com 
 _ Copyright (c) 2001-2017. Matteo Bicocchi (Pupunzi); 
 _ blog: http://pupunzi.open-lab.com 
 _ Open Lab s.r.l., Florence - Italy 
 */
function onYouTubeIframeAPIReady(){ytp.YTAPIReady||(ytp.YTAPIReady=!0,jQuery(document).trigger("YTAPIReady"))}function uncamel(e){return e.replace(/([A-Z])/g,function(e){return"-"+e.toLowerCase()})}function setUnit(e,r){return"string"!=typeof e||e.match(/^[\-0-9\.]+jQuery/)?""+e+r:e}function setFilter(e,r,t){var a=uncamel(r),o=jQuery.browser.mozilla?"":jQuery.CSS.sfx;e[o+"filter"]=e[o+"filter"]||"",t=setUnit(t>jQuery.CSS.filters[r].max?jQuery.CSS.filters[r].max:t,jQuery.CSS.filters[r].unit),e[o+"filter"]+=a+"("+t+") ",delete e[r]}var ytp=ytp||{},getYTPVideoID=function(e){var r,t;return e.indexOf("youtu.be")>0?(r=e.substr(e.lastIndexOf("/")+1,e.length),t=r.indexOf("?list=")>0?r.substr(r.lastIndexOf("="),r.length):null,r=t?r.substr(0,r.lastIndexOf("?")):r):e.indexOf("http")>-1?(r=e.match(/[\\?&]v=([^&#]*)/)[1],t=e.indexOf("list=")>0?e.match(/[\\?&]list=([^&#]*)/)[1]:null):(r=e.length>15?null:e,t=r?null:e),{videoID:r,playlistID:t}};!function(jQuery,ytp){jQuery.mbYTPlayer={name:"jquery.mb.YTPlayer",version:"3.0.11",build:"6092",author:"Matteo Bicocchi (pupunzi)",apiKey:"",defaults:{containment:"body",ratio:"auto",videoURL:null,playlistURL:null,startAt:0,stopAt:0,autoPlay:!0,vol:50,addRaster:!1,mask:!1,opacity:1,quality:"default",mute:!1,loop:!0,showControls:!0,showAnnotations:!1,showYTLogo:!0,stopMovieOnBlur:!0,realfullscreen:!0,mobileFallbackImage:null,gaTrack:!0,optimizeDisplay:!0,anchor:"center,center",onReady:function(e){},onError:function(e,r){}},controls:{play:"P",pause:"p",mute:"M",unmute:"A",onlyYT:"O",showSite:"R",ytLogo:"Y"},controlBar:null,loading:null,locationProtocol:"https:",filters:{grayscale:{value:0,unit:"%"},hue_rotate:{value:0,unit:"deg"},invert:{value:0,unit:"%"},opacity:{value:0,unit:"%"},saturate:{value:0,unit:"%"},sepia:{value:0,unit:"%"},brightness:{value:0,unit:"%"},contrast:{value:0,unit:"%"},blur:{value:0,unit:"px"}},buildPlayer:function(options){return this.each(function(){var YTPlayer=this,$YTPlayer=jQuery(YTPlayer);YTPlayer.loop=0,YTPlayer.opt={},YTPlayer.state={},YTPlayer.filters=jQuery.mbYTPlayer.filters,YTPlayer.filtersEnabled=!0,YTPlayer.id=YTPlayer.id||"YTP_"+(new Date).getTime(),$YTPlayer.addClass("mb_YTPlayer");var property=$YTPlayer.data("property")&&"string"==typeof $YTPlayer.data("property")?eval("("+$YTPlayer.data("property")+")"):$YTPlayer.data("property");"undefined"!=typeof property&&"undefined"!=typeof property.vol&&(property.vol=0===property.vol?property.vol=1:property.vol),jQuery.extend(YTPlayer.opt,jQuery.mbYTPlayer.defaults,options,property),YTPlayer.hasChanged||(YTPlayer.defaultOpt={},jQuery.extend(YTPlayer.defaultOpt,jQuery.mbYTPlayer.defaults,options)),"true"==YTPlayer.opt.loop&&(YTPlayer.opt.loop=9999),YTPlayer.isRetina=window.retina||window.devicePixelRatio>1;var isIframe=function(){var e=!1;try{self.location.href!=top.location.href&&(e=!0)}catch(r){e=!0}return e};YTPlayer.canGoFullScreen=!(jQuery.browser.msie||jQuery.browser.opera||isIframe()),YTPlayer.canGoFullScreen||(YTPlayer.opt.realfullscreen=!1),$YTPlayer.attr("id")||$YTPlayer.attr("id","ytp_"+(new Date).getTime());var playerID="mbYTP_"+YTPlayer.id;YTPlayer.isAlone=!1,YTPlayer.hasFocus=!0,YTPlayer.videoID=this.opt.videoURL?getYTPVideoID(this.opt.videoURL).videoID:!!$YTPlayer.attr("href")&&getYTPVideoID($YTPlayer.attr("href")).videoID,YTPlayer.playlistID=this.opt.videoURL?getYTPVideoID(this.opt.videoURL).playlistID:!!$YTPlayer.attr("href")&&getYTPVideoID($YTPlayer.attr("href")).playlistID,YTPlayer.opt.showAnnotations=YTPlayer.opt.showAnnotations?"0":"3";var playerVars={modestbranding:1,autoplay:0,controls:0,showinfo:0,rel:0,enablejsapi:1,version:3,playerapiid:playerID,origin:"*",allowfullscreen:!0,wmode:"transparent",iv_load_policy:YTPlayer.opt.showAnnotations};if(document.createElement("video").canPlayType&&jQuery.extend(playerVars,{html5:1}),jQuery.browser.msie&&jQuery.browser.version<9&&(this.opt.opacity=1),YTPlayer.isSelf="self"==YTPlayer.opt.containment,YTPlayer.defaultOpt.containment=YTPlayer.opt.containment=jQuery("self"==YTPlayer.opt.containment?this:YTPlayer.opt.containment),YTPlayer.isBackground=YTPlayer.opt.containment.is("body"),!YTPlayer.isBackground||!ytp.backgroundIsInited){var isPlayer=YTPlayer.opt.containment.is(jQuery(this));YTPlayer.canPlayOnMobile=isPlayer&&0===jQuery(this).children().length,YTPlayer.isPlayer=!1,isPlayer?YTPlayer.isPlayer=!0:$YTPlayer.hide();var overlay=jQuery("<div/>").css({position:"absolute",top:0,left:0,width:"100%",height:"100%"}).addClass("YTPOverlay");YTPlayer.isPlayer&&overlay.on("click",function(){$YTPlayer.YTPTogglePlay()});var wrapper=jQuery("<div/>").addClass("mbYTP_wrapper").attr("id","wrapper_"+playerID);wrapper.css({position:"absolute",zIndex:0,minWidth:"100%",minHeight:"100%",left:0,top:0,overflow:"hidden",opacity:0});var playerBox=jQuery("<div/>").attr("id",playerID).addClass("playerBox");if(playerBox.css({position:"absolute",zIndex:0,width:"100%",height:"100%",top:0,left:0,overflow:"hidden"}),wrapper.append(playerBox),YTPlayer.opt.containment.children().not("script, style").each(function(){"static"==jQuery(this).css("position")&&jQuery(this).css("position","relative")}),YTPlayer.isBackground?(jQuery("body").css({boxSizing:"border-box"}),wrapper.css({position:"fixed",top:0,left:0,zIndex:0}),$YTPlayer.hide()):"static"==YTPlayer.opt.containment.css("position")&&YTPlayer.opt.containment.css({position:"relative"}),YTPlayer.opt.containment.prepend(wrapper),YTPlayer.wrapper=wrapper,playerBox.css({opacity:1}),jQuery.browser.mobile||(playerBox.after(overlay),YTPlayer.overlay=overlay),YTPlayer.isBackground||overlay.on("mouseenter",function(){YTPlayer.controlBar&&YTPlayer.controlBar.length&&YTPlayer.controlBar.addClass("visible")}).on("mouseleave",function(){YTPlayer.controlBar&&YTPlayer.controlBar.length&&YTPlayer.controlBar.removeClass("visible")}),ytp.YTAPIReady)setTimeout(function(){jQuery(document).trigger("YTAPIReady")},100);else{jQuery("#YTAPI").remove();var tag=jQuery("<script></script>").attr({src:jQuery.mbYTPlayer.locationProtocol+"//www.youtube.com/iframe_api?v="+jQuery.mbYTPlayer.version,id:"YTAPI"});jQuery("head").prepend(tag)}if(jQuery.browser.mobile&&!YTPlayer.canPlayOnMobile)return YTPlayer.opt.mobileFallbackImage&&wrapper.css({backgroundImage:"url("+YTPlayer.opt.mobileFallbackImage+")",backgroundPosition:"center center",backgroundSize:"cover",backgroundRepeat:"no-repeat",opacity:1}),$YTPlayer.remove(),void jQuery(document).trigger("YTPUnavailable");jQuery(document).on("YTAPIReady",function(){YTPlayer.isBackground&&ytp.backgroundIsInited||YTPlayer.isInit||(YTPlayer.isBackground&&(ytp.backgroundIsInited=!0),YTPlayer.opt.autoPlay="undefined"==typeof YTPlayer.opt.autoPlay?!!YTPlayer.isBackground:YTPlayer.opt.autoPlay,YTPlayer.opt.vol=YTPlayer.opt.vol?YTPlayer.opt.vol:100,jQuery.mbYTPlayer.getDataFromAPI(YTPlayer),jQuery(YTPlayer).on("YTPChanged",function(){if(!YTPlayer.isInit){if(YTPlayer.isInit=!0,jQuery.browser.mobile&&YTPlayer.canPlayOnMobile){if(YTPlayer.opt.containment.outerWidth()>jQuery(window).width()){YTPlayer.opt.containment.css({maxWidth:"100%"});var h=.563*YTPlayer.opt.containment.outerWidth();YTPlayer.opt.containment.css({maxHeight:h})}return void new YT.Player(playerID,{videoId:YTPlayer.videoID.toString(),width:"100%",height:h,playerVars:playerVars,events:{onReady:function(e){YTPlayer.player=e.target,playerBox.css({opacity:1}),YTPlayer.wrapper.css({opacity:1})}}})}new YT.Player(playerID,{videoId:YTPlayer.videoID.toString(),playerVars:playerVars,events:{onReady:function(e){YTPlayer.player=e.target,YTPlayer.isReady||(YTPlayer.isReady=!(YTPlayer.isPlayer&&!YTPlayer.opt.autoPlay),YTPlayer.playerEl=YTPlayer.player.getIframe(),jQuery(YTPlayer.playerEl).unselectable(),$YTPlayer.optimizeDisplay(),jQuery(window).off("resize.YTP_"+YTPlayer.id).on("resize.YTP_"+YTPlayer.id,function(){$YTPlayer.optimizeDisplay()}),jQuery.mbYTPlayer.checkForState(YTPlayer))},onStateChange:function(event){if("function"==typeof event.target.getPlayerState){var state=event.target.getPlayerState();if(YTPlayer.preventTrigger)return void(YTPlayer.preventTrigger=!1);YTPlayer.state=state;var eventType;switch(state){case-1:eventType="YTPUnstarted";break;case 0:eventType="YTPEnd";break;case 1:eventType="YTPPlay",YTPlayer.controlBar.length&&YTPlayer.controlBar.find(".mb_YTPPlaypause").html(jQuery.mbYTPlayer.controls.pause),"undefined"!=typeof _gaq&&eval(YTPlayer.opt.gaTrack)&&_gaq.push(["_trackEvent","YTPlayer","Play",YTPlayer.hasData?YTPlayer.videoData.title:YTPlayer.videoID.toString()]),"undefined"!=typeof ga&&eval(YTPlayer.opt.gaTrack)&&ga("send","event","YTPlayer","play",YTPlayer.hasData?YTPlayer.videoData.title:YTPlayer.videoID.toString());break;case 2:eventType="YTPPause",YTPlayer.controlBar.length&&YTPlayer.controlBar.find(".mb_YTPPlaypause").html(jQuery.mbYTPlayer.controls.play);break;case 3:YTPlayer.player.setPlaybackQuality(YTPlayer.opt.quality),eventType="YTPBuffering",YTPlayer.controlBar.length&&YTPlayer.controlBar.find(".mb_YTPPlaypause").html(jQuery.mbYTPlayer.controls.play);break;case 5:eventType="YTPCued"}var YTPEvent=jQuery.Event(eventType);YTPEvent.time=YTPlayer.currentTime,YTPlayer.canTrigger&&jQuery(YTPlayer).trigger(YTPEvent)}},onPlaybackQualityChange:function(e){var r=e.target.getPlaybackQuality(),t=jQuery.Event("YTPQualityChange");t.quality=r,jQuery(YTPlayer).trigger(t)},onError:function(e){150==e.data&&(console.log("Embedding this video is restricted by Youtube."),YTPlayer.isPlayList&&jQuery(YTPlayer).playNext()),2==e.data&&YTPlayer.isPlayList&&jQuery(YTPlayer).playNext(),"function"==typeof YTPlayer.opt.onError&&YTPlayer.opt.onError($YTPlayer,e)}}})}}))}),$YTPlayer.off("YTPTime.mask"),jQuery.mbYTPlayer.applyMask(YTPlayer)}})},getDataFromAPI:function(e){if(e.videoData=jQuery.mbStorage.get("YTPlayer_data_"+e.videoID),jQuery(e).off("YTPData.YTPlayer").on("YTPData.YTPlayer",function(){if(e.hasData&&e.isPlayer&&!e.opt.autoPlay){var r=e.videoData.thumb_max||e.videoData.thumb_high||e.videoData.thumb_medium;e.opt.containment.css({background:"rgba(0,0,0,0.5) url("+r+") center center",backgroundSize:"cover"}),e.opt.backgroundUrl=r}}),e.videoData)setTimeout(function(){e.opt.ratio="auto"==e.opt.ratio?"16/9":e.opt.ratio,e.dataReceived=!0,jQuery(e).trigger("YTPChanged");var r=jQuery.Event("YTPData");r.prop={};for(var t in e.videoData)r.prop[t]=e.videoData[t];jQuery(e).trigger(r)},500),e.hasData=!0;else if(jQuery.mbYTPlayer.apiKey)jQuery.getJSON(jQuery.mbYTPlayer.locationProtocol+"//www.googleapis.com/youtube/v3/videos?id="+e.videoID+"&key="+jQuery.mbYTPlayer.apiKey+"&part=snippet",function(r){function t(r){e.videoData={},e.videoData.id=e.videoID,e.videoData.channelTitle=r.channelTitle,e.videoData.title=r.title,e.videoData.description=r.description.length<400?r.description:r.description.substring(0,400)+" ...",e.videoData.aspectratio="auto"==e.opt.ratio?"16/9":e.opt.ratio,e.opt.ratio=e.videoData.aspectratio,e.videoData.thumb_max=r.thumbnails.maxres?r.thumbnails.maxres.url:null,e.videoData.thumb_high=r.thumbnails.high?r.thumbnails.high.url:null,e.videoData.thumb_medium=r.thumbnails.medium?r.thumbnails.medium.url:null,jQuery.mbStorage.set("YTPlayer_data_"+e.videoID,e.videoData)}e.dataReceived=!0,jQuery(e).trigger("YTPChanged"),t(r.items[0].snippet),e.hasData=!0;var a=jQuery.Event("YTPData");a.prop={};for(var o in e.videoData)a.prop[o]=e.videoData[o];jQuery(e).trigger(a)});else{if(setTimeout(function(){jQuery(e).trigger("YTPChanged")},50),e.isPlayer&&!e.opt.autoPlay){var r=jQuery.mbYTPlayer.locationProtocol+"//i.ytimg.com/vi/"+e.videoID+"/hqdefault.jpg";e.opt.containment.css({background:"rgba(0,0,0,0.5) url("+r+") center center",backgroundSize:"cover"}),e.opt.backgroundUrl=r}e.videoData=null,e.opt.ratio="auto"==e.opt.ratio?"16/9":e.opt.ratio}!e.isPlayer||e.opt.autoPlay||jQuery.browser.mobile||(e.loading=jQuery("<div/>").addClass("loading").html("Loading").hide(),jQuery(e).append(e.loading),e.loading.fadeIn())},removeStoredData:function(){jQuery.mbStorage.remove()},getVideoData:function(){var e=this.get(0);return e.videoData},getVideoID:function(){var e=this.get(0);return e.videoID||!1},setVideoQuality:function(e){var r=this.get(0);r.player.setPlaybackQuality(e)},playlist:function(e,r,t,a){var o=this,i=o.get(0);return i.isPlayList=!0,r&&(e=jQuery.shuffle(e)),i.videoID||(i.videos=e,i.videoCounter=0,i.videoLength=e.length,jQuery(i).data("property",e[0]),jQuery(i).mb_YTPlayer()),"function"==typeof t&&jQuery(i).one("YTPChanged",function(){t(i)}),jQuery(i).on("YTPEnd",function(){a="undefined"==typeof a||a,jQuery(i).playNext(a)}),this},playNext:function(e){var r=this.get(0);return r.checkForStartAt&&(clearTimeout(r.checkForStartAt),clearInterval(r.getState)),r.videoCounter++,r.videoCounter>=r.videoLength&&e&&(r.videoCounter=0),r.videoCounter<r.videoLength?jQuery(r).YTPChangeMovie(r.videos[r.videoCounter]):r.videoCounter--,this},playPrev:function(){var e=this.get(0);return e.checkForStartAt&&(clearInterval(e.checkForStartAt),clearInterval(e.getState)),e.videoCounter--,e.videoCounter<0&&(e.videoCounter=e.videoLength-1),jQuery(e).YTPChangeMovie(e.videos[e.videoCounter]),this},playIndex:function(e){var r=this.get(0);return e-=1,r.checkForStartAt&&(clearInterval(r.checkForStartAt),clearInterval(r.getState)),r.videoCounter=e,r.videoCounter>=r.videoLength-1&&(r.videoCounter=r.videoLength-1),jQuery(r).YTPChangeMovie(r.videos[r.videoCounter]),this},changeMovie:function(e){var r=this,t=r.get(0);t.opt.startAt=0,t.opt.stopAt=0,t.opt.mask=!1,t.opt.mute=!0,t.hasData=!1,t.hasChanged=!0,t.player.loopTime=void 0,e&&jQuery.extend(t.opt,e),t.videoID=getYTPVideoID(t.opt.videoURL).videoID,"true"==t.opt.loop&&(t.opt.loop=9999),jQuery(t.playerEl).CSSAnimate({opacity:0},200,function(){var e=jQuery.Event("YTPChangeMovie");e.time=t.currentTime,e.videoId=t.videoID,jQuery(t).trigger(e),jQuery(t).YTPGetPlayer().cueVideoByUrl(encodeURI(jQuery.mbYTPlayer.locationProtocol+"//www.youtube.com/v/"+t.videoID),1,t.opt.quality),jQuery(t).optimizeDisplay(),jQuery.mbYTPlayer.checkForState(t),jQuery.mbYTPlayer.getDataFromAPI(t)}),jQuery.mbYTPlayer.applyMask(t)},getPlayer:function(){return jQuery(this).get(0).player},playerDestroy:function(){var e=this.get(0);ytp.YTAPIReady=!0,ytp.backgroundIsInited=!1,e.isInit=!1,e.videoID=null,e.isReady=!1;var r=e.wrapper;return r.remove(),jQuery("#controlBar_"+e.id).remove(),clearInterval(e.checkForStartAt),clearInterval(e.getState),this},fullscreen:function(real){function hideMouse(){YTPlayer.overlay.css({cursor:"none"})}function RunPrefixMethod(e,r){for(var t,a,o=["webkit","moz","ms","o",""],i=0;i<o.length&&!e[t];){if(t=r,""==o[i]&&(t=t.substr(0,1).toLowerCase()+t.substr(1)),t=o[i]+t,a=typeof e[t],"undefined"!=a)return o=[o[i]],"function"==a?e[t]():e[t];i++}}function launchFullscreen(e){RunPrefixMethod(e,"RequestFullScreen")}function cancelFullscreen(){(RunPrefixMethod(document,"FullScreen")||RunPrefixMethod(document,"IsFullScreen"))&&RunPrefixMethod(document,"CancelFullScreen")}var YTPlayer=this.get(0);"undefined"==typeof real&&(real=YTPlayer.opt.realfullscreen),real=eval(real);var controls=jQuery("#controlBar_"+YTPlayer.id),fullScreenBtn=controls.find(".mb_OnlyYT"),videoWrapper=YTPlayer.isSelf?YTPlayer.opt.containment:YTPlayer.wrapper;if(real){var fullscreenchange=jQuery.browser.mozilla?"mozfullscreenchange":jQuery.browser.webkit?"webkitfullscreenchange":"fullscreenchange";jQuery(document).off(fullscreenchange).on(fullscreenchange,function(){var e=RunPrefixMethod(document,"IsFullScreen")||RunPrefixMethod(document,"FullScreen");e?(jQuery(YTPlayer).YTPSetVideoQuality("default"),jQuery(YTPlayer).trigger("YTPFullScreenStart")):(YTPlayer.isAlone=!1,fullScreenBtn.html(jQuery.mbYTPlayer.controls.onlyYT),jQuery(YTPlayer).YTPSetVideoQuality(YTPlayer.opt.quality),videoWrapper.removeClass("YTPFullscreen"),videoWrapper.CSSAnimate({opacity:YTPlayer.opt.opacity},500),videoWrapper.css({zIndex:0}),YTPlayer.isBackground?jQuery("body").after(controls):YTPlayer.wrapper.before(controls),jQuery(window).resize(),jQuery(YTPlayer).trigger("YTPFullScreenEnd"))})}return YTPlayer.isAlone?(jQuery(document).off("mousemove.YTPlayer"),clearTimeout(YTPlayer.hideCursor),YTPlayer.overlay.css({cursor:"auto"}),real?cancelFullscreen():(videoWrapper.CSSAnimate({opacity:YTPlayer.opt.opacity},500),videoWrapper.css({zIndex:0})),fullScreenBtn.html(jQuery.mbYTPlayer.controls.onlyYT),YTPlayer.isAlone=!1):(jQuery(document).on("mousemove.YTPlayer",function(e){YTPlayer.overlay.css({cursor:"auto"}),clearTimeout(YTPlayer.hideCursor),jQuery(e.target).parents().is(".mb_YTPBar")||(YTPlayer.hideCursor=setTimeout(hideMouse,3e3))}),hideMouse(),real?(videoWrapper.css({opacity:0}),videoWrapper.addClass("YTPFullscreen"),launchFullscreen(videoWrapper.get(0)),setTimeout(function(){videoWrapper.CSSAnimate({opacity:1},1e3),YTPlayer.wrapper.append(controls),jQuery(YTPlayer).optimizeDisplay(),YTPlayer.player.seekTo(YTPlayer.player.getCurrentTime()+.1,!0)},500)):videoWrapper.css({zIndex:1e4}).CSSAnimate({opacity:1},1e3),fullScreenBtn.html(jQuery.mbYTPlayer.controls.showSite),YTPlayer.isAlone=!0),this},toggleLoops:function(){var e=this.get(0),r=e.opt;return 1==r.loop?r.loop=0:(r.startAt?e.player.seekTo(r.startAt):e.player.playVideo(),r.loop=1),this},play:function(){var e=this.get(0);if(!e.isReady)return this;e.player.playVideo(),e.wrapper.CSSAnimate({opacity:e.isAlone?1:e.opt.opacity},2e3),jQuery(e.playerEl).CSSAnimate({opacity:1},1e3);var r=jQuery("#controlBar_"+e.id),t=r.find(".mb_YTPPlaypause");return t.html(jQuery.mbYTPlayer.controls.pause),e.state=1,jQuery(e).css("background-image","none"),this},togglePlay:function(e){var r=this.get(0);return 1==r.state?this.YTPPause():this.YTPPlay(),"function"==typeof e&&e(r.state),this},stop:function(){var e=this.get(0),r=jQuery("#controlBar_"+e.id),t=r.find(".mb_YTPPlaypause");return t.html(jQuery.mbYTPlayer.controls.play),e.player.stopVideo(),this},pause:function(){var e=this.get(0);return e.player.pauseVideo(),e.state=2,this},seekTo:function(e){var r=this.get(0);return r.player.seekTo(e,!0),this},setVolume:function(e){var r=this.get(0);return e||r.opt.vol||0!=r.player.getVolume()?!e&&r.player.getVolume()>0||e&&r.opt.vol==e?r.isMute?jQuery(r).YTPUnmute():jQuery(r).YTPMute():(r.opt.vol=e,r.player.setVolume(r.opt.vol),r.volumeBar&&r.volumeBar.length&&r.volumeBar.updateSliderVal(e)):jQuery(r).YTPUnmute(),this},toggleVolume:function(){var e=this.get(0);if(e)return e.player.isMuted()?(jQuery(e).YTPUnmute(),!0):(jQuery(e).YTPMute(),!1)},mute:function(){var e=this.get(0);if(!e.isMute){e.player.mute(),e.isMute=!0,e.player.setVolume(0),e.volumeBar&&e.volumeBar.length&&e.volumeBar.width()>10&&e.volumeBar.updateSliderVal(0);var r=jQuery("#controlBar_"+e.id),t=r.find(".mb_YTPMuteUnmute");t.html(jQuery.mbYTPlayer.controls.unmute),jQuery(e).addClass("isMuted"),e.volumeBar&&e.volumeBar.length&&e.volumeBar.addClass("muted");var a=jQuery.Event("YTPMuted");return a.time=e.currentTime,e.canTrigger&&jQuery(e).trigger(a),this}},unmute:function(){var e=this.get(0);if(e.isMute){e.player.unMute(),e.isMute=!1,e.player.setVolume(e.opt.vol),e.volumeBar&&e.volumeBar.length&&e.volumeBar.updateSliderVal(e.opt.vol>10?e.opt.vol:10);var r=jQuery("#controlBar_"+e.id),t=r.find(".mb_YTPMuteUnmute");t.html(jQuery.mbYTPlayer.controls.mute),jQuery(e).removeClass("isMuted"),e.volumeBar&&e.volumeBar.length&&e.volumeBar.removeClass("muted");var a=jQuery.Event("YTPUnmuted");return a.time=e.currentTime,e.canTrigger&&jQuery(e).trigger(a),this}},applyFilter:function(e,r){return this.each(function(){var t=this;t.filters[e].value=r,t.filtersEnabled&&jQuery(t).YTPEnableFilters()})},applyFilters:function(e){return this.each(function(){var r=this;if(!r.isReady)return void jQuery(r).on("YTPReady",function(){jQuery(r).YTPApplyFilters(e)});for(var t in e)jQuery(r).YTPApplyFilter(t,e[t]);jQuery(r).trigger("YTPFiltersApplied")})},toggleFilter:function(e,r){return this.each(function(){var t=this;t.filters[e].value?t.filters[e].value=0:t.filters[e].value=r,t.filtersEnabled&&jQuery(this).YTPEnableFilters()})},toggleFilters:function(e){return this.each(function(){var r=this;r.filtersEnabled?(jQuery(r).trigger("YTPDisableFilters"),jQuery(r).YTPDisableFilters()):(jQuery(r).YTPEnableFilters(),jQuery(r).trigger("YTPEnableFilters")),"function"==typeof e&&e(r.filtersEnabled)})},disableFilters:function(){return this.each(function(){var e=this,r=jQuery(e.playerEl);r.css("-webkit-filter",""),r.css("filter",""),e.filtersEnabled=!1})},enableFilters:function(){return this.each(function(){var e=this,r=jQuery(e.playerEl),t="";for(var a in e.filters)e.filters[a].value&&(t+=a.replace("_","-")+"("+e.filters[a].value+e.filters[a].unit+") ");r.css("-webkit-filter",t),r.css("filter",t),e.filtersEnabled=!0})},removeFilter:function(e,r){return this.each(function(){var t=this;if("function"==typeof e&&(r=e,e=null),e)jQuery(this).YTPApplyFilter(e,0),"function"==typeof r&&r(e);else for(var a in t.filters)jQuery(this).YTPApplyFilter(a,0),"function"==typeof r&&r(a)})},getFilters:function(){var e=this.get(0);return e.filters},addMask:function(e){var r=this.get(0),t=r.overlay;e||(e=r.actualMask);var a=jQuery("<img/>").attr("src",e).on("load",function(){t.CSSAnimate({opacity:0},500,function(){r.hasMask=!0,a.remove(),t.css({backgroundImage:"url("+e+")",backgroundRepeat:"no-repeat",backgroundPosition:"center center",backgroundSize:"cover"}),t.CSSAnimate({opacity:1},500)})});return this},removeMask:function(){var e=this.get(0),r=e.overlay;return r.CSSAnimate({opacity:0},500,function(){e.hasMask=!1,r.css({backgroundImage:"",backgroundRepeat:"",backgroundPosition:"",backgroundSize:""}),r.CSSAnimate({opacity:1},500)}),this},applyMask:function(e){var r=jQuery(e);if(r.off("YTPTime.mask"),e.opt.mask)if("string"==typeof e.opt.mask)r.YTPAddMask(e.opt.mask),e.actualMask=e.opt.mask;else if("object"==typeof e.opt.mask){for(var t in e.opt.mask)e.opt.mask[t]&&jQuery("<img/>").attr("src",e.opt.mask[t]);e.opt.mask[0]&&r.YTPAddMask(e.opt.mask[0]),r.on("YTPTime.mask",function(t){for(var a in e.opt.mask)t.time==a&&(e.opt.mask[a]?(r.YTPAddMask(e.opt.mask[a]),e.actualMask=e.opt.mask[a]):r.YTPRemoveMask())})}},toggleMask:function(){var e=this.get(0),r=$(e);return e.hasMask?r.YTPRemoveMask():r.YTPAddMask(),this},manageProgress:function(){var e=this.get(0),r=jQuery("#controlBar_"+e.id),t=r.find(".mb_YTPProgress"),a=r.find(".mb_YTPLoaded"),o=r.find(".mb_YTPseekbar"),i=t.outerWidth(),n=Math.floor(e.player.getCurrentTime()),l=Math.floor(e.player.getDuration()),s=n*i/l,u=0,y=100*e.player.getVideoLoadedFraction();return a.css({left:u,width:y+"%"}),o.css({left:0,width:s}),{totalTime:l,currentTime:n}},buildControls:function(YTPlayer){var data=YTPlayer.opt;if(data.showYTLogo=data.showYTLogo||data.printUrl,!jQuery("#controlBar_"+YTPlayer.id).length){YTPlayer.controlBar=jQuery("<span/>").attr("id","controlBar_"+YTPlayer.id).addClass("mb_YTPBar").css({whiteSpace:"noWrap",position:YTPlayer.isBackground?"fixed":"absolute",zIndex:YTPlayer.isBackground?1e4:1e3}).hide();var buttonBar=jQuery("<div/>").addClass("buttonBar"),playpause=jQuery("<span>"+jQuery.mbYTPlayer.controls.play+"</span>").addClass("mb_YTPPlaypause ytpicon").click(function(){1==YTPlayer.player.getPlayerState()?jQuery(YTPlayer).YTPPause():jQuery(YTPlayer).YTPPlay()}),MuteUnmute=jQuery("<span>"+jQuery.mbYTPlayer.controls.mute+"</span>").addClass("mb_YTPMuteUnmute ytpicon").click(function(){0==YTPlayer.player.getVolume()?jQuery(YTPlayer).YTPUnmute():jQuery(YTPlayer).YTPMute()}),volumeBar=jQuery("<div/>").addClass("mb_YTPVolumeBar").css({display:"inline-block"});YTPlayer.volumeBar=volumeBar;var idx=jQuery("<span/>").addClass("mb_YTPTime"),vURL=data.videoURL?data.videoURL:"";vURL.indexOf("http")<0&&(vURL=jQuery.mbYTPlayer.locationProtocol+"//www.youtube.com/watch?v="+data.videoURL);var movieUrl=jQuery("<span/>").html(jQuery.mbYTPlayer.controls.ytLogo).addClass("mb_YTPUrl ytpicon").attr("title","view on YouTube").on("click",function(){window.open(vURL,"viewOnYT")}),onlyVideo=jQuery("<span/>").html(jQuery.mbYTPlayer.controls.onlyYT).addClass("mb_OnlyYT ytpicon").on("click",function(){jQuery(YTPlayer).YTPFullscreen(data.realfullscreen)}),progressBar=jQuery("<div/>").addClass("mb_YTPProgress").css("position","absolute").click(function(e){timeBar.css({width:e.clientX-timeBar.offset().left}),YTPlayer.timeW=e.clientX-timeBar.offset().left,YTPlayer.controlBar.find(".mb_YTPLoaded").css({width:0});var r=Math.floor(YTPlayer.player.getDuration());YTPlayer["goto"]=timeBar.outerWidth()*r/progressBar.outerWidth(),YTPlayer.player.seekTo(parseFloat(YTPlayer["goto"]),!0),YTPlayer.controlBar.find(".mb_YTPLoaded").css({width:0})}),loadedBar=jQuery("<div/>").addClass("mb_YTPLoaded").css("position","absolute"),timeBar=jQuery("<div/>").addClass("mb_YTPseekbar").css("position","absolute");progressBar.append(loadedBar).append(timeBar),buttonBar.append(playpause).append(MuteUnmute).append(volumeBar).append(idx),data.showYTLogo&&buttonBar.append(movieUrl),(YTPlayer.isBackground||eval(YTPlayer.opt.realfullscreen)&&!YTPlayer.isBackground)&&buttonBar.append(onlyVideo),YTPlayer.controlBar.append(buttonBar).append(progressBar),YTPlayer.isBackground?jQuery("body").after(YTPlayer.controlBar):(YTPlayer.controlBar.addClass("inlinePlayer"),YTPlayer.wrapper.before(YTPlayer.controlBar)),volumeBar.simpleSlider({initialval:YTPlayer.opt.vol,scale:100,orientation:"h",callback:function(e){0==e.value?jQuery(YTPlayer).YTPMute():jQuery(YTPlayer).YTPUnmute(),YTPlayer.player.setVolume(e.value),YTPlayer.isMute||(YTPlayer.opt.vol=e.value)}})}},checkForState:function(YTPlayer){var interval=YTPlayer.opt.showControls?100:400;return clearInterval(YTPlayer.getState),jQuery.contains(document,YTPlayer)?(jQuery.mbYTPlayer.checkForStart(YTPlayer),void(YTPlayer.getState=setInterval(function(){var prog=jQuery(YTPlayer).YTPManageProgress(),$YTPlayer=jQuery(YTPlayer),data=YTPlayer.opt,startAt=YTPlayer.opt.startAt?YTPlayer.opt.startAt:1,stopAt=YTPlayer.opt.stopAt>YTPlayer.opt.startAt?YTPlayer.opt.stopAt:0;if(stopAt=stopAt<YTPlayer.player.getDuration()?stopAt:0,YTPlayer.currentTime!=prog.currentTime){var YTPEvent=jQuery.Event("YTPTime");YTPEvent.time=YTPlayer.currentTime,jQuery(YTPlayer).trigger(YTPEvent)}if(YTPlayer.currentTime=prog.currentTime,YTPlayer.totalTime=YTPlayer.player.getDuration(),0==YTPlayer.player.getVolume()?$YTPlayer.addClass("isMuted"):$YTPlayer.removeClass("isMuted"),YTPlayer.opt.showControls&&(prog.totalTime?YTPlayer.controlBar.find(".mb_YTPTime").html(jQuery.mbYTPlayer.formatTime(prog.currentTime)+" / "+jQuery.mbYTPlayer.formatTime(prog.totalTime)):YTPlayer.controlBar.find(".mb_YTPTime").html("-- : -- / -- : --")),eval(YTPlayer.opt.stopMovieOnBlur)&&(document.hasFocus()?document.hasFocus()&&!YTPlayer.hasFocus&&-1!=YTPlayer.state&&0!=YTPlayer.state&&(YTPlayer.hasFocus=!0,$YTPlayer.YTPPlay()):1==YTPlayer.state&&(YTPlayer.hasFocus=!1,$YTPlayer.YTPPause())),YTPlayer.controlBar.length&&YTPlayer.controlBar.outerWidth()<=400&&!YTPlayer.isCompact?(YTPlayer.controlBar.addClass("compact"),YTPlayer.isCompact=!0,!YTPlayer.isMute&&YTPlayer.volumeBar&&YTPlayer.volumeBar.updateSliderVal(YTPlayer.opt.vol)):YTPlayer.controlBar.length&&YTPlayer.controlBar.outerWidth()>400&&YTPlayer.isCompact&&(YTPlayer.controlBar.removeClass("compact"),YTPlayer.isCompact=!1,!YTPlayer.isMute&&YTPlayer.volumeBar&&YTPlayer.volumeBar.updateSliderVal(YTPlayer.opt.vol)),1==YTPlayer.player.getPlayerState()&&(parseFloat(YTPlayer.player.getDuration()-1.5)<YTPlayer.player.getCurrentTime()||stopAt>0&&parseFloat(YTPlayer.player.getCurrentTime())>stopAt)){if(YTPlayer.isEnded)return;if(YTPlayer.isEnded=!0,setTimeout(function(){YTPlayer.isEnded=!1},1e3),YTPlayer.isPlayList){if(!data.loop||data.loop>0&&YTPlayer.player.loopTime===data.loop-1){YTPlayer.player.loopTime=void 0,clearInterval(YTPlayer.getState);var YTPEnd=jQuery.Event("YTPEnd");return YTPEnd.time=YTPlayer.currentTime,void jQuery(YTPlayer).trigger(YTPEnd)}}else if(!data.loop||data.loop>0&&YTPlayer.player.loopTime===data.loop-1)return YTPlayer.player.loopTime=void 0,YTPlayer.preventTrigger=!0,YTPlayer.state=2,jQuery(YTPlayer).YTPPause(),void YTPlayer.wrapper.CSSAnimate({opacity:0},500,function(){YTPlayer.controlBar.length&&YTPlayer.controlBar.find(".mb_YTPPlaypause").html(jQuery.mbYTPlayer.controls.play);var e=jQuery.Event("YTPEnd");e.time=YTPlayer.currentTime,jQuery(YTPlayer).trigger(e),YTPlayer.player.seekTo(startAt,!0),YTPlayer.isBackground||YTPlayer.opt.containment.css({background:"rgba(0,0,0,0.5) url("+YTPlayer.opt.backgroundUrl+") center center",backgroundSize:"cover"})});YTPlayer.player.loopTime=YTPlayer.player.loopTime?++YTPlayer.player.loopTime:1,startAt=startAt||1,YTPlayer.preventTrigger=!0,YTPlayer.state=2,jQuery(YTPlayer).YTPPause(),YTPlayer.player.seekTo(startAt,!0),$YTPlayer.YTPPlay()}},interval))):(jQuery(YTPlayer).YTPPlayerDestroy(),clearInterval(YTPlayer.getState),void clearInterval(YTPlayer.checkForStartAt))},getTime:function(){var e=this.get(0);return jQuery.mbYTPlayer.formatTime(e.currentTime)},getTotalTime:function(){var e=this.get(0);return jQuery.mbYTPlayer.formatTime(e.totalTime)},checkForStart:function(e){var r=jQuery(e);if(!jQuery.contains(document,e))return void jQuery(e).YTPPlayerDestroy();if(e.preventTrigger=!0,e.state=2,jQuery(e).YTPPause(),jQuery(e).muteYTPVolume(),jQuery("#controlBar_"+e.id).remove(),e.controlBar=!1,e.opt.showControls&&jQuery.mbYTPlayer.buildControls(e),e.opt.addRaster){var t="dot"==e.opt.addRaster?"raster-dot":"raster";e.overlay.addClass(e.isRetina?t+" retina":t)}else e.overlay.removeClass(function(e,r){var t=r.split(" "),a=[];return jQuery.each(t,function(e,r){/raster.*/.test(r)&&a.push(r)}),a.push("retina"),a.join(" ")});var a=e.opt.startAt?e.opt.startAt:1;e.player.playVideo(),e.player.seekTo(a,!0),e.checkForStartAt=setInterval(function(){jQuery(e).YTPMute();var t=e.player.getVideoLoadedFraction()>=a/e.player.getDuration();if(e.player.getDuration()>0&&e.player.getCurrentTime()>=a&&t){clearInterval(e.checkForStartAt),"function"==typeof e.opt.onReady&&e.opt.onReady(e),e.isReady=!0;var o=jQuery.Event("YTPReady");if(o.time=e.currentTime,jQuery(e).trigger(o),e.preventTrigger=!0,e.state=2,jQuery(e).YTPPause(),e.opt.mute||jQuery(e).YTPUnmute(),e.canTrigger=!0,e.opt.autoPlay){var i=jQuery.Event("YTPStart");i.time=e.currentTime,jQuery(e).trigger(i),r.css("background-image","none"),jQuery(e.playerEl).CSSAnimate({opacity:1},1e3),r.YTPPlay(),e.wrapper.CSSAnimate({opacity:e.isAlone?1:e.opt.opacity},1e3),jQuery.browser.safari&&(e.safariPlay=setInterval(function(){1!=e.state?r.YTPPlay():clearInterval(e.safariPlay)},10)),r.on("YTPReady",function(){r.YTPPlay()})}else e.player.pauseVideo(),e.isPlayer||(jQuery(e.playerEl).CSSAnimate({opacity:1},500),e.wrapper.CSSAnimate({opacity:e.isAlone?1:e.opt.opacity},500)),e.controlBar.length&&e.controlBar.find(".mb_YTPPlaypause").html(jQuery.mbYTPlayer.controls.play);e.isPlayer&&!e.opt.autoPlay&&e.loading&&e.loading.length&&(e.loading.html("Ready"),setTimeout(function(){e.loading.fadeOut()},100)),e.controlBar&&e.controlBar.length&&e.controlBar.slideDown(1e3)}else jQuery.browser.safari&&(e.player.playVideo(),a>=0&&e.player.seekTo(a,!0))},1)},setAnchor:function(e){var r=this;r.optimizeDisplay(e)},getAnchor:function(){var e=this.get(0);return e.opt.anchor},formatTime:function(e){var r=Math.floor(e/60),t=Math.floor(e-60*r);return(9>=r?"0"+r:r)+" : "+(9>=t?"0"+t:t)}},jQuery.fn.optimizeDisplay=function(e){var r=this.get(0),t=jQuery(r.playerEl),a={};r.opt.anchor=e||r.opt.anchor,r.opt.anchor="undefined "!=typeof r.opt.anchor?r.opt.anchor:"center,center";var o=r.opt.anchor.split(",");if(r.opt.optimizeDisplay){var i=r.isPlayer?0:80,n={},l=r.wrapper;n.width=l.outerWidth(),n.height=l.outerHeight()+i,a.width=n.width,a.height="16/9"==r.opt.ratio?Math.ceil(a.width*(9/16)):Math.ceil(.75*a.width),a.marginTop=-((a.height-n.height)/2),a.marginLeft=0;var s=a.height<n.height;s&&(a.height=n.height,a.width="16/9"==r.opt.ratio?Math.floor(a.height*(16/9)):Math.floor(a.height*(4/3)),a.marginTop=0,a.marginLeft=-((a.width-n.width)/2));for(var u in o)if(o.hasOwnProperty(u)){var y=o[u].replace(/ /g,"");switch(y){case"top":a.marginTop=s?-((a.height-n.height)/2):0;
break;case"bottom":a.marginTop=s?0:-(a.height-n.height);break;case"left":a.marginLeft=0;break;case"right":a.marginLeft=s?-(a.width-n.width):0;break;default:a.width>n.width&&(a.marginLeft=-((a.width-n.width)/2))}}}else a.width="100%",a.height="100%",a.marginTop=0,a.marginLeft=0;t.css({width:a.width,height:a.height,marginTop:a.marginTop,marginLeft:a.marginLeft,maxWidth:"initial"})},jQuery.shuffle=function(e){for(var r=e.slice(),t=r.length,a=t;a--;){var o=parseInt(Math.random()*t),i=r[a];r[a]=r[o],r[o]=i}return r},jQuery.fn.unselectable=function(){return this.each(function(){jQuery(this).css({"-moz-user-select":"none","-webkit-user-select":"none","user-select":"none"}).attr("unselectable","on")})},jQuery.fn.YTPlayer=jQuery.mbYTPlayer.buildPlayer,jQuery.fn.YTPGetPlayer=jQuery.mbYTPlayer.getPlayer,jQuery.fn.YTPGetVideoID=jQuery.mbYTPlayer.getVideoID,jQuery.fn.YTPChangeMovie=jQuery.mbYTPlayer.changeMovie,jQuery.fn.YTPPlayerDestroy=jQuery.mbYTPlayer.playerDestroy,jQuery.fn.YTPPlay=jQuery.mbYTPlayer.play,jQuery.fn.YTPTogglePlay=jQuery.mbYTPlayer.togglePlay,jQuery.fn.YTPStop=jQuery.mbYTPlayer.stop,jQuery.fn.YTPPause=jQuery.mbYTPlayer.pause,jQuery.fn.YTPSeekTo=jQuery.mbYTPlayer.seekTo,jQuery.fn.YTPlaylist=jQuery.mbYTPlayer.playlist,jQuery.fn.YTPPlayNext=jQuery.mbYTPlayer.playNext,jQuery.fn.YTPPlayPrev=jQuery.mbYTPlayer.playPrev,jQuery.fn.YTPPlayIndex=jQuery.mbYTPlayer.playIndex,jQuery.fn.YTPMute=jQuery.mbYTPlayer.mute,jQuery.fn.YTPUnmute=jQuery.mbYTPlayer.unmute,jQuery.fn.YTPToggleVolume=jQuery.mbYTPlayer.toggleVolume,jQuery.fn.YTPSetVolume=jQuery.mbYTPlayer.setVolume,jQuery.fn.YTPGetVideoData=jQuery.mbYTPlayer.getVideoData,jQuery.fn.YTPFullscreen=jQuery.mbYTPlayer.fullscreen,jQuery.fn.YTPToggleLoops=jQuery.mbYTPlayer.toggleLoops,jQuery.fn.YTPSetVideoQuality=jQuery.mbYTPlayer.setVideoQuality,jQuery.fn.YTPManageProgress=jQuery.mbYTPlayer.manageProgress,jQuery.fn.YTPApplyFilter=jQuery.mbYTPlayer.applyFilter,jQuery.fn.YTPApplyFilters=jQuery.mbYTPlayer.applyFilters,jQuery.fn.YTPToggleFilter=jQuery.mbYTPlayer.toggleFilter,jQuery.fn.YTPToggleFilters=jQuery.mbYTPlayer.toggleFilters,jQuery.fn.YTPRemoveFilter=jQuery.mbYTPlayer.removeFilter,jQuery.fn.YTPDisableFilters=jQuery.mbYTPlayer.disableFilters,jQuery.fn.YTPEnableFilters=jQuery.mbYTPlayer.enableFilters,jQuery.fn.YTPGetFilters=jQuery.mbYTPlayer.getFilters,jQuery.fn.YTPGetTime=jQuery.mbYTPlayer.getTime,jQuery.fn.YTPGetTotalTime=jQuery.mbYTPlayer.getTotalTime,jQuery.fn.YTPAddMask=jQuery.mbYTPlayer.addMask,jQuery.fn.YTPRemoveMask=jQuery.mbYTPlayer.removeMask,jQuery.fn.YTPToggleMask=jQuery.mbYTPlayer.toggleMask,jQuery.fn.YTPSetAnchor=jQuery.mbYTPlayer.setAnchor,jQuery.fn.YTPGetAnchor=jQuery.mbYTPlayer.getAnchor,jQuery.fn.mb_YTPlayer=jQuery.mbYTPlayer.buildPlayer,jQuery.fn.playNext=jQuery.mbYTPlayer.playNext,jQuery.fn.playPrev=jQuery.mbYTPlayer.playPrev,jQuery.fn.changeMovie=jQuery.mbYTPlayer.changeMovie,jQuery.fn.getVideoID=jQuery.mbYTPlayer.getVideoID,jQuery.fn.getPlayer=jQuery.mbYTPlayer.getPlayer,jQuery.fn.playerDestroy=jQuery.mbYTPlayer.playerDestroy,jQuery.fn.fullscreen=jQuery.mbYTPlayer.fullscreen,jQuery.fn.buildYTPControls=jQuery.mbYTPlayer.buildControls,jQuery.fn.playYTP=jQuery.mbYTPlayer.play,jQuery.fn.toggleLoops=jQuery.mbYTPlayer.toggleLoops,jQuery.fn.stopYTP=jQuery.mbYTPlayer.stop,jQuery.fn.pauseYTP=jQuery.mbYTPlayer.pause,jQuery.fn.seekToYTP=jQuery.mbYTPlayer.seekTo,jQuery.fn.muteYTPVolume=jQuery.mbYTPlayer.mute,jQuery.fn.unmuteYTPVolume=jQuery.mbYTPlayer.unmute,jQuery.fn.setYTPVolume=jQuery.mbYTPlayer.setVolume,jQuery.fn.setVideoQuality=jQuery.mbYTPlayer.setVideoQuality,jQuery.fn.manageYTPProgress=jQuery.mbYTPlayer.manageProgress,jQuery.fn.YTPGetDataFromFeed=jQuery.mbYTPlayer.getVideoData}(jQuery,ytp),jQuery.support.CSStransition=function(){var e=document.body||document.documentElement,r=e.style;return void 0!==r.transition||void 0!==r.WebkitTransition||void 0!==r.MozTransition||void 0!==r.MsTransition||void 0!==r.OTransition}(),jQuery.CSS={name:"mb.CSSAnimate",author:"Matteo Bicocchi",version:"2.0.0",transitionEnd:"transitionEnd",sfx:"",filters:{blur:{min:0,max:100,unit:"px"},brightness:{min:0,max:400,unit:"%"},contrast:{min:0,max:400,unit:"%"},grayscale:{min:0,max:100,unit:"%"},hueRotate:{min:0,max:360,unit:"deg"},invert:{min:0,max:100,unit:"%"},saturate:{min:0,max:400,unit:"%"},sepia:{min:0,max:100,unit:"%"}},normalizeCss:function(e){var r=jQuery.extend(!0,{},e);jQuery.browser.webkit||jQuery.browser.opera?jQuery.CSS.sfx="-webkit-":jQuery.browser.mozilla?jQuery.CSS.sfx="-moz-":jQuery.browser.msie&&(jQuery.CSS.sfx="-ms-");for(var t in r){"transform"===t&&(r[jQuery.CSS.sfx+"transform"]=r[t],delete r[t]),"transform-origin"===t&&(r[jQuery.CSS.sfx+"transform-origin"]=e[t],delete r[t]),"filter"!==t||jQuery.browser.mozilla||(r[jQuery.CSS.sfx+"filter"]=e[t],delete r[t]),"blur"===t&&setFilter(r,"blur",e[t]),"brightness"===t&&setFilter(r,"brightness",e[t]),"contrast"===t&&setFilter(r,"contrast",e[t]),"grayscale"===t&&setFilter(r,"grayscale",e[t]),"hueRotate"===t&&setFilter(r,"hueRotate",e[t]),"invert"===t&&setFilter(r,"invert",e[t]),"saturate"===t&&setFilter(r,"saturate",e[t]),"sepia"===t&&setFilter(r,"sepia",e[t]);var a="";"x"===t&&(a=jQuery.CSS.sfx+"transform",r[a]=r[a]||"",r[a]+=" translateX("+setUnit(e[t],"px")+")",delete r[t]),"y"===t&&(a=jQuery.CSS.sfx+"transform",r[a]=r[a]||"",r[a]+=" translateY("+setUnit(e[t],"px")+")",delete r[t]),"z"===t&&(a=jQuery.CSS.sfx+"transform",r[a]=r[a]||"",r[a]+=" translateZ("+setUnit(e[t],"px")+")",delete r[t]),"rotate"===t&&(a=jQuery.CSS.sfx+"transform",r[a]=r[a]||"",r[a]+=" rotate("+setUnit(e[t],"deg")+")",delete r[t]),"rotateX"===t&&(a=jQuery.CSS.sfx+"transform",r[a]=r[a]||"",r[a]+=" rotateX("+setUnit(e[t],"deg")+")",delete r[t]),"rotateY"===t&&(a=jQuery.CSS.sfx+"transform",r[a]=r[a]||"",r[a]+=" rotateY("+setUnit(e[t],"deg")+")",delete r[t]),"rotateZ"===t&&(a=jQuery.CSS.sfx+"transform",r[a]=r[a]||"",r[a]+=" rotateZ("+setUnit(e[t],"deg")+")",delete r[t]),"scale"===t&&(a=jQuery.CSS.sfx+"transform",r[a]=r[a]||"",r[a]+=" scale("+setUnit(e[t],"")+")",delete r[t]),"scaleX"===t&&(a=jQuery.CSS.sfx+"transform",r[a]=r[a]||"",r[a]+=" scaleX("+setUnit(e[t],"")+")",delete r[t]),"scaleY"===t&&(a=jQuery.CSS.sfx+"transform",r[a]=r[a]||"",r[a]+=" scaleY("+setUnit(e[t],"")+")",delete r[t]),"scaleZ"===t&&(a=jQuery.CSS.sfx+"transform",r[a]=r[a]||"",r[a]+=" scaleZ("+setUnit(e[t],"")+")",delete r[t]),"skew"===t&&(a=jQuery.CSS.sfx+"transform",r[a]=r[a]||"",r[a]+=" skew("+setUnit(e[t],"deg")+")",delete r[t]),"skewX"===t&&(a=jQuery.CSS.sfx+"transform",r[a]=r[a]||"",r[a]+=" skewX("+setUnit(e[t],"deg")+")",delete r[t]),"skewY"===t&&(a=jQuery.CSS.sfx+"transform",r[a]=r[a]||"",r[a]+=" skewY("+setUnit(e[t],"deg")+")",delete r[t]),"perspective"===t&&(a=jQuery.CSS.sfx+"transform",r[a]=r[a]||"",r[a]+=" perspective("+setUnit(e[t],"px")+")",delete r[t])}return r},getProp:function(e){var r=[];for(var t in e)r.indexOf(t)<0&&r.push(uncamel(t));return r.join(",")},animate:function(e,r,t,a,o){return this.each(function(){function i(){n.called=!0,n.CSSAIsRunning=!1,l.off(jQuery.CSS.transitionEnd+"."+n.id),clearTimeout(n.timeout),l.css(jQuery.CSS.sfx+"transition",""),"function"==typeof o&&o.apply(n),"function"==typeof n.CSSqueue&&(n.CSSqueue(),n.CSSqueue=null)}var n=this,l=jQuery(this);n.id=n.id||"CSSA_"+(new Date).getTime();var s=s||{type:"noEvent"};if(n.CSSAIsRunning&&n.eventType==s.type&&!jQuery.browser.msie&&jQuery.browser.version<=9)return void(n.CSSqueue=function(){l.CSSAnimate(e,r,t,a,o)});if(n.CSSqueue=null,n.eventType=s.type,0!==l.length&&e){if(e=jQuery.normalizeCss(e),n.CSSAIsRunning=!0,"function"==typeof r&&(o=r,r=jQuery.fx.speeds._default),"function"==typeof t&&(a=t,t=0),"string"==typeof t&&(o=t,t=0),"function"==typeof a&&(o=a,a="cubic-bezier(0.65,0.03,0.36,0.72)"),"string"==typeof r)for(var u in jQuery.fx.speeds){if(r==u){r=jQuery.fx.speeds[u];break}r=jQuery.fx.speeds._default}if(r||(r=jQuery.fx.speeds._default),"string"==typeof o&&(a=o,o=null),!jQuery.support.CSStransition){for(var y in e){if("transform"===y&&delete e[y],"filter"===y&&delete e[y],"transform-origin"===y&&delete e[y],"auto"===e[y]&&delete e[y],"x"===y){var c=e[y],p="left";e[p]=c,delete e[y]}if("y"===y){var c=e[y],p="top";e[p]=c,delete e[y]}("-ms-transform"===y||"-ms-filter"===y)&&delete e[y]}return void l.delay(t).animate(e,r,o)}var d={"default":"ease","in":"ease-in",out:"ease-out","in-out":"ease-in-out",snap:"cubic-bezier(0,1,.5,1)",easeOutCubic:"cubic-bezier(.215,.61,.355,1)",easeInOutCubic:"cubic-bezier(.645,.045,.355,1)",easeInCirc:"cubic-bezier(.6,.04,.98,.335)",easeOutCirc:"cubic-bezier(.075,.82,.165,1)",easeInOutCirc:"cubic-bezier(.785,.135,.15,.86)",easeInExpo:"cubic-bezier(.95,.05,.795,.035)",easeOutExpo:"cubic-bezier(.19,1,.22,1)",easeInOutExpo:"cubic-bezier(1,0,0,1)",easeInQuad:"cubic-bezier(.55,.085,.68,.53)",easeOutQuad:"cubic-bezier(.25,.46,.45,.94)",easeInOutQuad:"cubic-bezier(.455,.03,.515,.955)",easeInQuart:"cubic-bezier(.895,.03,.685,.22)",easeOutQuart:"cubic-bezier(.165,.84,.44,1)",easeInOutQuart:"cubic-bezier(.77,0,.175,1)",easeInQuint:"cubic-bezier(.755,.05,.855,.06)",easeOutQuint:"cubic-bezier(.23,1,.32,1)",easeInOutQuint:"cubic-bezier(.86,0,.07,1)",easeInSine:"cubic-bezier(.47,0,.745,.715)",easeOutSine:"cubic-bezier(.39,.575,.565,1)",easeInOutSine:"cubic-bezier(.445,.05,.55,.95)",easeInBack:"cubic-bezier(.6,-.28,.735,.045)",easeOutBack:"cubic-bezier(.175, .885,.32,1.275)",easeInOutBack:"cubic-bezier(.68,-.55,.265,1.55)"};d[a]&&(a=d[a]),l.off(jQuery.CSS.transitionEnd+"."+n.id);var f=jQuery.CSS.getProp(e),T={};jQuery.extend(T,e),T[jQuery.CSS.sfx+"transition-property"]=f,T[jQuery.CSS.sfx+"transition-duration"]=r+"ms",T[jQuery.CSS.sfx+"transition-delay"]=t+"ms",T[jQuery.CSS.sfx+"transition-timing-function"]=a,setTimeout(function(){l.one(jQuery.CSS.transitionEnd+"."+n.id,i),l.css(T)},1),n.timeout=setTimeout(function(){return n.called||!o?(n.called=!1,void(n.CSSAIsRunning=!1)):(l.css(jQuery.CSS.sfx+"transition",""),o.apply(n),n.CSSAIsRunning=!1,void("function"==typeof n.CSSqueue&&(n.CSSqueue(),n.CSSqueue=null)))},r+t+10)}})}},jQuery.fn.CSSAnimate=jQuery.CSS.animate,jQuery.normalizeCss=jQuery.CSS.normalizeCss,jQuery.fn.css3=function(e){return this.each(function(){var r=jQuery(this),t=jQuery.normalizeCss(e);r.css(t)})};var nAgt=navigator.userAgent;if(!jQuery.browser){jQuery.browser={},jQuery.browser.mozilla=!1,jQuery.browser.webkit=!1,jQuery.browser.opera=!1,jQuery.browser.safari=!1,jQuery.browser.chrome=!1,jQuery.browser.androidStock=!1,jQuery.browser.msie=!1,jQuery.browser.ua=nAgt,jQuery.browser.name=navigator.appName,jQuery.browser.fullVersion=""+parseFloat(navigator.appVersion),jQuery.browser.majorVersion=parseInt(navigator.appVersion,10);var nameOffset,verOffset,ix;if(-1!=(verOffset=nAgt.indexOf("Opera")))jQuery.browser.opera=!0,jQuery.browser.name="Opera",jQuery.browser.fullVersion=nAgt.substring(verOffset+6),-1!=(verOffset=nAgt.indexOf("Version"))&&(jQuery.browser.fullVersion=nAgt.substring(verOffset+8));else if(-1!=(verOffset=nAgt.indexOf("OPR")))jQuery.browser.opera=!0,jQuery.browser.name="Opera",jQuery.browser.fullVersion=nAgt.substring(verOffset+4);else if(-1!=(verOffset=nAgt.indexOf("MSIE")))jQuery.browser.msie=!0,jQuery.browser.name="Microsoft Internet Explorer",jQuery.browser.fullVersion=nAgt.substring(verOffset+5);else if(-1!=nAgt.indexOf("Trident")||-1!=nAgt.indexOf("Edge")){jQuery.browser.msie=!0,jQuery.browser.name="Microsoft Internet Explorer";var start=nAgt.indexOf("rv:")+3,end=start+4;jQuery.browser.fullVersion=nAgt.substring(start,end)}else-1!=(verOffset=nAgt.indexOf("Chrome"))?(jQuery.browser.webkit=!0,jQuery.browser.chrome=!0,jQuery.browser.name="Chrome",jQuery.browser.fullVersion=nAgt.substring(verOffset+7)):nAgt.indexOf("mozilla/5.0")>-1&&nAgt.indexOf("android ")>-1&&nAgt.indexOf("applewebkit")>-1&&!(nAgt.indexOf("chrome")>-1)?(verOffset=nAgt.indexOf("Chrome"),jQuery.browser.webkit=!0,jQuery.browser.androidStock=!0,jQuery.browser.name="androidStock",jQuery.browser.fullVersion=nAgt.substring(verOffset+7)):-1!=(verOffset=nAgt.indexOf("Safari"))?(jQuery.browser.webkit=!0,jQuery.browser.safari=!0,jQuery.browser.name="Safari",jQuery.browser.fullVersion=nAgt.substring(verOffset+7),-1!=(verOffset=nAgt.indexOf("Version"))&&(jQuery.browser.fullVersion=nAgt.substring(verOffset+8))):-1!=(verOffset=nAgt.indexOf("AppleWebkit"))?(jQuery.browser.webkit=!0,jQuery.browser.safari=!0,jQuery.browser.name="Safari",jQuery.browser.fullVersion=nAgt.substring(verOffset+7),-1!=(verOffset=nAgt.indexOf("Version"))&&(jQuery.browser.fullVersion=nAgt.substring(verOffset+8))):-1!=(verOffset=nAgt.indexOf("Firefox"))?(jQuery.browser.mozilla=!0,jQuery.browser.name="Firefox",jQuery.browser.fullVersion=nAgt.substring(verOffset+8)):(nameOffset=nAgt.lastIndexOf(" ")+1)<(verOffset=nAgt.lastIndexOf("/"))&&(jQuery.browser.name=nAgt.substring(nameOffset,verOffset),jQuery.browser.fullVersion=nAgt.substring(verOffset+1),jQuery.browser.name.toLowerCase()==jQuery.browser.name.toUpperCase()&&(jQuery.browser.name=navigator.appName));-1!=(ix=jQuery.browser.fullVersion.indexOf(";"))&&(jQuery.browser.fullVersion=jQuery.browser.fullVersion.substring(0,ix)),-1!=(ix=jQuery.browser.fullVersion.indexOf(" "))&&(jQuery.browser.fullVersion=jQuery.browser.fullVersion.substring(0,ix)),jQuery.browser.majorVersion=parseInt(""+jQuery.browser.fullVersion,10),isNaN(jQuery.browser.majorVersion)&&(jQuery.browser.fullVersion=""+parseFloat(navigator.appVersion),jQuery.browser.majorVersion=parseInt(navigator.appVersion,10)),jQuery.browser.version=jQuery.browser.majorVersion}jQuery.browser.android=/Android/i.test(nAgt),jQuery.browser.blackberry=/BlackBerry|BB|PlayBook/i.test(nAgt),jQuery.browser.ios=/iPhone|iPad|iPod|webOS/i.test(nAgt),jQuery.browser.operaMobile=/Opera Mini/i.test(nAgt),jQuery.browser.windowsMobile=/IEMobile|Windows Phone/i.test(nAgt),jQuery.browser.kindle=/Kindle|Silk/i.test(nAgt),jQuery.browser.mobile=jQuery.browser.android||jQuery.browser.blackberry||jQuery.browser.ios||jQuery.browser.windowsMobile||jQuery.browser.operaMobile||jQuery.browser.kindle,jQuery.isMobile=jQuery.browser.mobile,jQuery.isTablet=jQuery.browser.mobile&&jQuery(window).width()>765,jQuery.isAndroidDefault=jQuery.browser.android&&!/chrome/i.test(nAgt);var nAgt=navigator.userAgent;if(!jQuery.browser){jQuery.browser={},jQuery.browser.mozilla=!1,jQuery.browser.webkit=!1,jQuery.browser.opera=!1,jQuery.browser.safari=!1,jQuery.browser.chrome=!1,jQuery.browser.androidStock=!1,jQuery.browser.msie=!1,jQuery.browser.ua=nAgt,jQuery.browser.name=navigator.appName,jQuery.browser.fullVersion=""+parseFloat(navigator.appVersion),jQuery.browser.majorVersion=parseInt(navigator.appVersion,10);var nameOffset,verOffset,ix;if(-1!=(verOffset=nAgt.indexOf("Opera")))jQuery.browser.opera=!0,jQuery.browser.name="Opera",jQuery.browser.fullVersion=nAgt.substring(verOffset+6),-1!=(verOffset=nAgt.indexOf("Version"))&&(jQuery.browser.fullVersion=nAgt.substring(verOffset+8));else if(-1!=(verOffset=nAgt.indexOf("OPR")))jQuery.browser.opera=!0,jQuery.browser.name="Opera",jQuery.browser.fullVersion=nAgt.substring(verOffset+4);else if(-1!=(verOffset=nAgt.indexOf("MSIE")))jQuery.browser.msie=!0,jQuery.browser.name="Microsoft Internet Explorer",jQuery.browser.fullVersion=nAgt.substring(verOffset+5);else if(-1!=nAgt.indexOf("Trident")||-1!=nAgt.indexOf("Edge")){jQuery.browser.msie=!0,jQuery.browser.name="Microsoft Internet Explorer";var start=nAgt.indexOf("rv:")+3,end=start+4;jQuery.browser.fullVersion=nAgt.substring(start,end)}else-1!=(verOffset=nAgt.indexOf("Chrome"))?(jQuery.browser.webkit=!0,jQuery.browser.chrome=!0,jQuery.browser.name="Chrome",jQuery.browser.fullVersion=nAgt.substring(verOffset+7)):nAgt.indexOf("mozilla/5.0")>-1&&nAgt.indexOf("android ")>-1&&nAgt.indexOf("applewebkit")>-1&&!(nAgt.indexOf("chrome")>-1)?(verOffset=nAgt.indexOf("Chrome"),jQuery.browser.webkit=!0,jQuery.browser.androidStock=!0,jQuery.browser.name="androidStock",jQuery.browser.fullVersion=nAgt.substring(verOffset+7)):-1!=(verOffset=nAgt.indexOf("Safari"))?(jQuery.browser.webkit=!0,jQuery.browser.safari=!0,jQuery.browser.name="Safari",jQuery.browser.fullVersion=nAgt.substring(verOffset+7),-1!=(verOffset=nAgt.indexOf("Version"))&&(jQuery.browser.fullVersion=nAgt.substring(verOffset+8))):-1!=(verOffset=nAgt.indexOf("AppleWebkit"))?(jQuery.browser.webkit=!0,jQuery.browser.safari=!0,jQuery.browser.name="Safari",jQuery.browser.fullVersion=nAgt.substring(verOffset+7),-1!=(verOffset=nAgt.indexOf("Version"))&&(jQuery.browser.fullVersion=nAgt.substring(verOffset+8))):-1!=(verOffset=nAgt.indexOf("Firefox"))?(jQuery.browser.mozilla=!0,jQuery.browser.name="Firefox",jQuery.browser.fullVersion=nAgt.substring(verOffset+8)):(nameOffset=nAgt.lastIndexOf(" ")+1)<(verOffset=nAgt.lastIndexOf("/"))&&(jQuery.browser.name=nAgt.substring(nameOffset,verOffset),jQuery.browser.fullVersion=nAgt.substring(verOffset+1),jQuery.browser.name.toLowerCase()==jQuery.browser.name.toUpperCase()&&(jQuery.browser.name=navigator.appName));-1!=(ix=jQuery.browser.fullVersion.indexOf(";"))&&(jQuery.browser.fullVersion=jQuery.browser.fullVersion.substring(0,ix)),-1!=(ix=jQuery.browser.fullVersion.indexOf(" "))&&(jQuery.browser.fullVersion=jQuery.browser.fullVersion.substring(0,ix)),jQuery.browser.majorVersion=parseInt(""+jQuery.browser.fullVersion,10),isNaN(jQuery.browser.majorVersion)&&(jQuery.browser.fullVersion=""+parseFloat(navigator.appVersion),jQuery.browser.majorVersion=parseInt(navigator.appVersion,10)),jQuery.browser.version=jQuery.browser.majorVersion}jQuery.browser.android=/Android/i.test(nAgt),jQuery.browser.blackberry=/BlackBerry|BB|PlayBook/i.test(nAgt),jQuery.browser.ios=/iPhone|iPad|iPod|webOS/i.test(nAgt),jQuery.browser.operaMobile=/Opera Mini/i.test(nAgt),jQuery.browser.windowsMobile=/IEMobile|Windows Phone/i.test(nAgt),jQuery.browser.kindle=/Kindle|Silk/i.test(nAgt),jQuery.browser.mobile=jQuery.browser.android||jQuery.browser.blackberry||jQuery.browser.ios||jQuery.browser.windowsMobile||jQuery.browser.operaMobile||jQuery.browser.kindle,jQuery.isMobile=jQuery.browser.mobile,jQuery.isTablet=jQuery.browser.mobile&&jQuery(window).width()>765,jQuery.isAndroidDefault=jQuery.browser.android&&!/chrome/i.test(nAgt),function(e){e.simpleSlider={defaults:{initialval:0,scale:100,orientation:"h",readonly:!1,callback:!1},events:{start:e.browser.mobile?"touchstart":"mousedown",end:e.browser.mobile?"touchend":"mouseup",move:e.browser.mobile?"touchmove":"mousemove"},init:function(r){return this.each(function(){var t=this,a=e(t);a.addClass("simpleSlider"),t.opt={},e.extend(t.opt,e.simpleSlider.defaults,r),e.extend(t.opt,a.data());var o="h"==t.opt.orientation?"horizontal":"vertical",o=e("<div/>").addClass("level").addClass(o);a.prepend(o),t.level=o,a.css({cursor:"default"}),"auto"==t.opt.scale&&(t.opt.scale=e(t).outerWidth()),a.updateSliderVal(),t.opt.readonly||(a.on(e.simpleSlider.events.start,function(r){e.browser.mobile&&(r=r.changedTouches[0]),t.canSlide=!0,a.updateSliderVal(r),"h"==t.opt.orientation?a.css({cursor:"col-resize"}):a.css({cursor:"row-resize"}),r.preventDefault(),r.stopPropagation()}),e(document).on(e.simpleSlider.events.move,function(r){e.browser.mobile&&(r=r.changedTouches[0]),t.canSlide&&(e(document).css({cursor:"default"}),a.updateSliderVal(r),r.preventDefault(),r.stopPropagation())}).on(e.simpleSlider.events.end,function(){e(document).css({cursor:"auto"}),t.canSlide=!1,a.css({cursor:"auto"})}))})},updateSliderVal:function(r){var t=this.get(0);if(t.opt){t.opt.initialval="number"==typeof t.opt.initialval?t.opt.initialval:t.opt.initialval(t);var a=e(t).outerWidth(),o=e(t).outerHeight();t.x="object"==typeof r?r.clientX+document.body.scrollLeft-this.offset().left:"number"==typeof r?r*a/t.opt.scale:t.opt.initialval*a/t.opt.scale,t.y="object"==typeof r?r.clientY+document.body.scrollTop-this.offset().top:"number"==typeof r?(t.opt.scale-t.opt.initialval-r)*o/t.opt.scale:t.opt.initialval*o/t.opt.scale,t.y=this.outerHeight()-t.y,t.scaleX=t.x*t.opt.scale/a,t.scaleY=t.y*t.opt.scale/o,t.outOfRangeX=t.scaleX>t.opt.scale?t.scaleX-t.opt.scale:0>t.scaleX?t.scaleX:0,t.outOfRangeY=t.scaleY>t.opt.scale?t.scaleY-t.opt.scale:0>t.scaleY?t.scaleY:0,t.outOfRange="h"==t.opt.orientation?t.outOfRangeX:t.outOfRangeY,t.value="undefined"!=typeof r?"h"==t.opt.orientation?t.x>=this.outerWidth()?t.opt.scale:0>=t.x?0:t.scaleX:t.y>=this.outerHeight()?t.opt.scale:0>=t.y?0:t.scaleY:"h"==t.opt.orientation?t.scaleX:t.scaleY,"h"==t.opt.orientation?t.level.width(Math.floor(100*t.x/a)+"%"):t.level.height(Math.floor(100*t.y/o)),"function"==typeof t.opt.callback&&t.opt.callback(t)}}},e.fn.simpleSlider=e.simpleSlider.init,e.fn.updateSliderVal=e.simpleSlider.updateSliderVal}(jQuery),!function(e){e.mbCookie={set:function(e,r,t,a){r=JSON.stringify(r),t||(t=7),a=a?"; domain="+a:"";var o,i=new Date;i.setTime(i.getTime()+864e5*t),o="; expires="+i.toGMTString(),document.cookie=e+"="+r+o+"; path=/"+a},get:function(e){for(var r=e+"=",t=document.cookie.split(";"),a=0;a<t.length;a++){for(var o=t[a];" "==o.charAt(0);)o=o.substring(1,o.length);if(0==o.indexOf(r))return JSON.parse(o.substring(r.length,o.length))}return null},remove:function(r){e.mbCookie.set(r,"",-1)}},e.mbStorage={set:function(e,r){r=JSON.stringify(r),localStorage.setItem(e,r)},get:function(e){return localStorage[e]?JSON.parse(localStorage[e]):null},remove:function(e){e?localStorage.removeItem(e):localStorage.clear()}}}(jQuery);
/* store.js - Copyright (c) 2010-2017 Marcus Westin */
!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{var t;t="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this,t.store=e()}}(function(){var define,module,exports;return function e(t,n,r){function o(u,a){if(!n[u]){if(!t[u]){var c="function"==typeof require&&require;if(!a&&c)return c(u,!0);if(i)return i(u,!0);var f=new Error("Cannot find module '"+u+"'");throw f.code="MODULE_NOT_FOUND",f}var s=n[u]={exports:{}};t[u][0].call(s.exports,function(e){var n=t[u][1][e];return o(n?n:e)},s,s.exports,e,t,n,r)}return n[u].exports}for(var i="function"==typeof require&&require,u=0;u<r.length;u++)o(r[u]);return o}({1:[function(e,t,n){"use strict";var r=e("../src/store-engine"),o=e("../storages/all"),i=[e("../plugins/json2")];t.exports=r.createStore(o,i)},{"../plugins/json2":2,"../src/store-engine":4,"../storages/all":6}],2:[function(e,t,n){"use strict";function r(){return e("./lib/json2"),{}}t.exports=r},{"./lib/json2":3}],3:[function(require,module,exports){"use strict";var _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e};"object"!==("undefined"==typeof JSON?"undefined":_typeof(JSON))&&(JSON={}),function(){function f(e){return e<10?"0"+e:e}function this_value(){return this.valueOf()}function quote(e){return rx_escapable.lastIndex=0,rx_escapable.test(e)?'"'+e.replace(rx_escapable,function(e){var t=meta[e];return"string"==typeof t?t:"\\u"+("0000"+e.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+e+'"'}function str(e,t){var n,r,o,i,u,a=gap,c=t[e];switch(c&&"object"===("undefined"==typeof c?"undefined":_typeof(c))&&"function"==typeof c.toJSON&&(c=c.toJSON(e)),"function"==typeof rep&&(c=rep.call(t,e,c)),"undefined"==typeof c?"undefined":_typeof(c)){case"string":return quote(c);case"number":return isFinite(c)?String(c):"null";case"boolean":case"null":return String(c);case"object":if(!c)return"null";if(gap+=indent,u=[],"[object Array]"===Object.prototype.toString.apply(c)){for(i=c.length,n=0;n<i;n+=1)u[n]=str(n,c)||"null";return o=0===u.length?"[]":gap?"[\n"+gap+u.join(",\n"+gap)+"\n"+a+"]":"["+u.join(",")+"]",gap=a,o}if(rep&&"object"===("undefined"==typeof rep?"undefined":_typeof(rep)))for(i=rep.length,n=0;n<i;n+=1)"string"==typeof rep[n]&&(r=rep[n],o=str(r,c),o&&u.push(quote(r)+(gap?": ":":")+o));else for(r in c)Object.prototype.hasOwnProperty.call(c,r)&&(o=str(r,c),o&&u.push(quote(r)+(gap?": ":":")+o));return o=0===u.length?"{}":gap?"{\n"+gap+u.join(",\n"+gap)+"\n"+a+"}":"{"+u.join(",")+"}",gap=a,o}}var rx_one=/^[\],:{}\s]*$/,rx_two=/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,rx_three=/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,rx_four=/(?:^|:|,)(?:\s*\[)+/g,rx_escapable=/[\\"\u0000-\u001f\u007f-\u009f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,rx_dangerous=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;"function"!=typeof Date.prototype.toJSON&&(Date.prototype.toJSON=function(){return isFinite(this.valueOf())?this.getUTCFullYear()+"-"+f(this.getUTCMonth()+1)+"-"+f(this.getUTCDate())+"T"+f(this.getUTCHours())+":"+f(this.getUTCMinutes())+":"+f(this.getUTCSeconds())+"Z":null},Boolean.prototype.toJSON=this_value,Number.prototype.toJSON=this_value,String.prototype.toJSON=this_value);var gap,indent,meta,rep;"function"!=typeof JSON.stringify&&(meta={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"},JSON.stringify=function(e,t,n){var r;if(gap="",indent="","number"==typeof n)for(r=0;r<n;r+=1)indent+=" ";else"string"==typeof n&&(indent=n);if(rep=t,t&&"function"!=typeof t&&("object"!==("undefined"==typeof t?"undefined":_typeof(t))||"number"!=typeof t.length))throw new Error("JSON.stringify");return str("",{"":e})}),"function"!=typeof JSON.parse&&(JSON.parse=function(text,reviver){function walk(e,t){var n,r,o=e[t];if(o&&"object"===("undefined"==typeof o?"undefined":_typeof(o)))for(n in o)Object.prototype.hasOwnProperty.call(o,n)&&(r=walk(o,n),void 0!==r?o[n]=r:delete o[n]);return reviver.call(e,t,o)}var j;if(text=String(text),rx_dangerous.lastIndex=0,rx_dangerous.test(text)&&(text=text.replace(rx_dangerous,function(e){return"\\u"+("0000"+e.charCodeAt(0).toString(16)).slice(-4)})),rx_one.test(text.replace(rx_two,"@").replace(rx_three,"]").replace(rx_four,"")))return j=eval("("+text+")"),"function"==typeof reviver?walk({"":j},""):j;throw new SyntaxError("JSON.parse")})}()},{}],4:[function(e,t,n){"use strict";function r(){var e="undefined"==typeof console?null:console;if(e){var t=e.warn?e.warn:e.log;t.apply(e,arguments)}}function o(e,t,n){n||(n=""),e&&!l(e)&&(e=[e]),t&&!l(t)&&(t=[t]);var o=n?"__storejs_"+n+"_":"",i=n?new RegExp("^"+o):null,v=/^[a-zA-Z0-9_\-]*$/;if(!v.test(n))throw new Error("store.js namespaces can only have alphanumerics + underscores and dashes");var h={_namespacePrefix:o,_namespaceRegexp:i,_testStorage:function(e){try{var t="__storejs__test__";e.write(t,t);var n=e.read(t)===t;return e.remove(t),n}catch(r){return!1}},_assignPluginFnProp:function(e,t){var n=this[t];this[t]=function(){function t(){if(n)return c(arguments,function(e,t){r[t]=e}),n.apply(o,r)}var r=u(arguments,0),o=this,i=[t].concat(r);return e.apply(o,i)}},_serialize:function(e){return JSON.stringify(e)},_deserialize:function(e,t){if(!e)return t;var n="";try{n=JSON.parse(e)}catch(r){n=e}return void 0!==n?n:t},_addStorage:function(e){this.enabled||this._testStorage(e)&&(this.storage=e,this.enabled=!0)},_addPlugin:function(e){var t=this;if(l(e))return void c(e,function(e){t._addPlugin(e)});var n=a(this.plugins,function(t){return e===t});if(!n){if(this.plugins.push(e),!p(e))throw new Error("Plugins must be function values that return objects");var r=e.call(this);if(!d(r))throw new Error("Plugins must return an object of function properties");c(r,function(n,r){if(!p(n))throw new Error("Bad plugin property: "+r+" from plugin "+e.name+". Plugins should only return functions.");t._assignPluginFnProp(n,r)})}},addStorage:function(e){r("store.addStorage(storage) is deprecated. Use createStore([storages])"),this._addStorage(e)}},m=s(h,g,{plugins:[]});return m.raw={},c(m,function(e,t){p(e)&&(m.raw[t]=f(m,e))}),c(e,function(e){m._addStorage(e)}),c(t,function(e){m._addPlugin(e)}),m}var i=e("./util"),u=i.slice,a=i.pluck,c=i.each,f=i.bind,s=i.create,l=i.isList,p=i.isFunction,d=i.isObject;t.exports={createStore:o};var g={version:"2.0.12",enabled:!1,get:function(e,t){var n=this.storage.read(this._namespacePrefix+e);return this._deserialize(n,t)},set:function(e,t){return void 0===t?this.remove(e):(this.storage.write(this._namespacePrefix+e,this._serialize(t)),t)},remove:function(e){this.storage.remove(this._namespacePrefix+e)},each:function(e){var t=this;this.storage.each(function(n,r){e.call(t,t._deserialize(n),(r||"").replace(t._namespaceRegexp,""))})},clearAll:function(){this.storage.clearAll()},hasNamespace:function(e){return this._namespacePrefix=="__storejs_"+e+"_"},createStore:function(){return o.apply(this,arguments)},addPlugin:function(e){this._addPlugin(e)},namespace:function(e){return o(this.storage,this.plugins,e)}}},{"./util":5}],5:[function(e,t,n){(function(e){"use strict";function n(){return Object.assign?Object.assign:function(e,t,n,r){for(var o=1;o<arguments.length;o++)a(Object(arguments[o]),function(t,n){e[n]=t});return e}}function r(){if(Object.create)return function(e,t,n,r){var o=u(arguments,1);return d.apply(this,[Object.create(e)].concat(o))};var e=function(){};return function(t,n,r,o){var i=u(arguments,1);return e.prototype=t,d.apply(this,[new e].concat(i))}}function o(){return String.prototype.trim?function(e){return String.prototype.trim.call(e)}:function(e){return e.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,"")}}function i(e,t){return function(){return t.apply(e,Array.prototype.slice.call(arguments,0))}}function u(e,t){return Array.prototype.slice.call(e,t||0)}function a(e,t){f(e,function(e,n){return t(e,n),!1})}function c(e,t){var n=s(e)?[]:{};return f(e,function(e,r){return n[r]=t(e,r),!1}),n}function f(e,t){if(s(e)){for(var n=0;n<e.length;n++)if(t(e[n],n))return e[n]}else for(var r in e)if(e.hasOwnProperty(r)&&t(e[r],r))return e[r]}function s(e){return null!=e&&"function"!=typeof e&&"number"==typeof e.length}function l(e){return e&&"[object Function]"==={}.toString.call(e)}function p(e){return e&&"[object Object]"==={}.toString.call(e)}var d=n(),g=r(),v=o(),h="undefined"!=typeof window?window:e;t.exports={assign:d,create:g,trim:v,bind:i,slice:u,each:a,map:c,pluck:f,isList:s,isFunction:l,isObject:p,Global:h}}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{}],6:[function(e,t,n){"use strict";t.exports=[e("./localStorage"),e("./oldFF-globalStorage"),e("./oldIE-userDataStorage"),e("./cookieStorage"),e("./sessionStorage"),e("./memoryStorage")]},{"./cookieStorage":7,"./localStorage":8,"./memoryStorage":9,"./oldFF-globalStorage":10,"./oldIE-userDataStorage":11,"./sessionStorage":12}],7:[function(e,t,n){"use strict";function r(e){if(!e||!c(e))return null;var t="(?:^|.*;\\s*)"+escape(e).replace(/[\-\.\+\*]/g,"\\$&")+"\\s*\\=\\s*((?:[^;](?!;))*[^;]?).*";return unescape(p.cookie.replace(new RegExp(t),"$1"))}function o(e){for(var t=p.cookie.split(/; ?/g),n=t.length-1;n>=0;n--)if(l(t[n])){var r=t[n].split("="),o=unescape(r[0]),i=unescape(r[1]);e(i,o)}}function i(e,t){e&&(p.cookie=escape(e)+"="+escape(t)+"; expires=Tue, 19 Jan 2038 03:14:07 GMT; path=/")}function u(e){e&&c(e)&&(p.cookie=escape(e)+"=; expires=Thu, 01 Jan 1970 00:00:00 GMT; path=/")}function a(){o(function(e,t){u(t)})}function c(e){return new RegExp("(?:^|;\\s*)"+escape(e).replace(/[\-\.\+\*]/g,"\\$&")+"\\s*\\=").test(p.cookie)}var f=e("../src/util"),s=f.Global,l=f.trim;t.exports={name:"cookieStorage",read:r,write:i,each:o,remove:u,clearAll:a};var p=s.document},{"../src/util":5}],8:[function(e,t,n){"use strict";function r(){return s.localStorage}function o(e){return r().getItem(e)}function i(e,t){return r().setItem(e,t)}function u(e){for(var t=r().length-1;t>=0;t--){var n=r().key(t);e(o(n),n)}}function a(e){return r().removeItem(e)}function c(){return r().clear()}var f=e("../src/util"),s=f.Global;t.exports={name:"localStorage",read:o,write:i,each:u,remove:a,clearAll:c}},{"../src/util":5}],9:[function(e,t,n){"use strict";function r(e){return c[e]}function o(e,t){c[e]=t}function i(e){for(var t in c)c.hasOwnProperty(t)&&e(c[t],t)}function u(e){delete c[e]}function a(e){c={}}t.exports={name:"memoryStorage",read:r,write:o,each:i,remove:u,clearAll:a};var c={}},{}],10:[function(e,t,n){"use strict";function r(e){return s[e]}function o(e,t){s[e]=t}function i(e){for(var t=s.length-1;t>=0;t--){var n=s.key(t);e(s[n],n)}}function u(e){return s.removeItem(e)}function a(){i(function(e,t){delete s[e]})}var c=e("../src/util"),f=c.Global;t.exports={name:"oldFF-globalStorage",read:r,write:o,each:i,remove:u,clearAll:a};var s=f.globalStorage},{"../src/util":5}],11:[function(e,t,n){"use strict";function r(e,t){if(!v){var n=c(e);g(function(e){e.setAttribute(n,t),e.save(p)})}}function o(e){if(!v){var t=c(e),n=null;return g(function(e){n=e.getAttribute(t)}),n}}function i(e){g(function(t){for(var n=t.XMLDocument.documentElement.attributes,r=n.length-1;r>=0;r--){var o=n[r];e(t.getAttribute(o.name),o.name)}})}function u(e){var t=c(e);g(function(e){e.removeAttribute(t),e.save(p)})}function a(){g(function(e){var t=e.XMLDocument.documentElement.attributes;e.load(p);for(var n=t.length-1;n>=0;n--)e.removeAttribute(t[n].name);e.save(p)})}function c(e){return e.replace(/^\d/,"___$&").replace(h,"___")}function f(){if(!d||!d.documentElement||!d.documentElement.addBehavior)return null;var e,t,n,r="script";try{t=new ActiveXObject("htmlfile"),t.open(),t.write("<"+r+">document.w=window</"+r+'><iframe src="/favicon.ico"></iframe>'),t.close(),e=t.w.frames[0].document,n=e.createElement("div")}catch(o){n=d.createElement("div"),e=d.body}return function(t){var r=[].slice.call(arguments,0);r.unshift(n),e.appendChild(n),n.addBehavior("#default#userData"),n.load(p),t.apply(this,r),e.removeChild(n)}}var s=e("../src/util"),l=s.Global;t.exports={name:"oldIE-userDataStorage",write:r,read:o,each:i,remove:u,clearAll:a};var p="storejs",d=l.document,g=f(),v=(l.navigator?l.navigator.userAgent:"").match(/ (MSIE 8|MSIE 9|MSIE 10)\./),h=new RegExp("[!\"#$%&'()*+,/\\\\:;<=>?@[\\]^`{|}~]","g")},{"../src/util":5}],12:[function(e,t,n){"use strict";function r(){return s.sessionStorage}function o(e){return r().getItem(e)}function i(e,t){return r().setItem(e,t)}function u(e){for(var t=r().length-1;t>=0;t--){var n=r().key(t);e(o(n),n)}}function a(e){return r().removeItem(e)}function c(){return r().clear()}var f=e("../src/util"),s=f.Global;t.exports={name:"sessionStorage",read:o,write:i,each:u,remove:a,clearAll:c}},{"../src/util":5}]},{},[1])(1)});
/**
 * HTML templates in string, much faster on Safari
 * @since  2.0.5
 */
var Rexbuilder_Public_Templates=function(){"use strict";function e(e,t){switch(e){case"label-text-paragraph":return'<div class="wpcf7-label-text__paragraph" contenteditable="false"></div>'}}function t(t,a){return $.parseHTML(e(t,a))}return{getTemplate:e,getParsedTemplate:t}}();
var Rexbuilder_Util=function($){"use strict";function rtimeOut(e,t){var i,a=Date.now,o=window.requestAnimationFrame,r=a(),n=function(){a()-r<t?i||o(n):e()};return o(n),{clear:function(){i=1}}}function rInterval(e,t){var i,a=Date.now,o=window.requestAnimationFrame,r=a(),n=function(){a()-r<t||(r+=t,e()),i||o(n)};return o(n),{clear:function(){i=1}}}function handlingRowReadyEnd(e){if(edlTimeouts[e]=null,""===edlTimeouts.join("")){Rexbuilder_Util.playAllVideos();var t=jQuery.Event("rexlive:editDomLayoutEnd");Rexbuilder_Util.$document.trigger(t),edlTimeouts=[]}}function _storeBlocksIDsUsed(){blocksIDsUsed=$usedBlocksIDsContainer.length>0?JSON.parse($usedBlocksIDsContainer.text()):[]}function saveBlocksIDsUsed(){$usedBlocksIDsContainer.text(JSON.stringify(blocksIDsUsed))}function updateBlocksIDsUsed(e){blocksIDsUsed=e,saveBlocksIDsUsed()}function getBlocksIDsUsed(){return blocksIDsUsed}function addBlockID(e){blocksIDsUsed.push(e),blocksIDsUsed=Rexbuilder_Util.removeArrayDuplicates(blocksIDsUsed)}function removeBlockID(e){for(var t=blocksIDsUsed.length-1;t>=0&&e!=blocksIDsUsed[t];t--);t>-1&&(blocksIDsUsed.splice(t,1),saveBlocksIDsUsed())}function createBlockID(){var e,t;do e=createRandomID(4),t="self"!==e&&-1===blocksIDsUsed.indexOf(e);while(!t);return addBlockID(e),e}function _updateBlocksIDs(){if(Rexbuilder_Util.rexContainer)for(var e,t,i=Array.prototype.slice.call(Rexbuilder_Util.rexContainer.getElementsByClassName("grid-stack-item")),a=0;a<i.length;a++)t=i[a].getAttribute("data-rexbuilder-block-id"),null!==t&&""!==t||(e=createBlockID(),i[a].setAttribute("data-rexbuilder-block-id",e))}function guessLayout(e){var t=document.getElementById("layout-avaiable-dimensions").textContent;t=""!==t?JSON.parse(t):[];var i=t.filter(function(t){return t.id===e});if(!i)return"default";if(i=i[0],"standard"===i.type)return"default";var a,o=$availableLayoutNames.text(),r=t.filter(function(e){return-1!==o.indexOf(e.id)}),n=r.length,s="";if(parseInt(i.min)<_plugin_frontend_settings.defaultSettings.collapseWidth){for(a=0;a<n;a++)if(parseInt(r[a].min)<_plugin_frontend_settings.defaultSettings.collapseWidth&&parseInt(i.min)>=parseInt(r[a].min)&&(""===r[a].max||parseInt(i.min)<=parseInt(r[a].max))){s=r[a].id;break}}else for(a=0;a<n;a++)if(parseInt(r[a].min)>=_plugin_frontend_settings.defaultSettings.collapseWidth&&parseInt(i.min)>=parseInt(r[a].min)&&(""===r[a].max||parseInt(i.min)<=parseInt(r[a].max))){s=r[a].id;break}return""===s&&(s="default"),s}function _isMobile(){return Rexbuilder_Util.globalViewport.width<_plugin_frontend_settings.defaultSettings.collapseWidth}function clearSectionsEdited(){var e,t=Array.prototype.slice.call(Rexbuilder_Util.rexContainer.getElementsByClassName("rexpansive_section")),i=t.length;for(e=0;e<i;e++){t[e].setAttribute("data-rexlive-section-edited",!1),t[e].querySelector(".grid-stack-row").setAttribute("data-rexlive-layout-changed",!1);var a,o=Array.prototype.slice.call(t[e].getElementsByClassName("grid-stack-item")),r=o.length;for(a=0;a<r;a++)o[a].setAttribute("data-rexlive-element-edited",!1)}}function handlingGridstackCommitEnd(e,t,i,a){Rexbuilder_Util.domUpdating=!0,e.properties.gridstackInstance&&e.properties.gridstackInstance.batchUpdate(),e.fixBlockDomOrder(),e.saveStateGrid(),"masonry"!=e.settings.galleryLayout||t?"fixed"==e.settings.galleryLayout&&"true"==e.settings.fullHeight.toString()&&e.updateFullHeight():e.updateBlocksHeight(),i[0].props.collapse_grid&&(e.collapseElements(),e.collapseElementsProperties()),e.properties.gridstackInstance&&e.properties.gridstackInstance.commit();var o=setTimeout(handlingRowReady.bind(null,e,a,i[0].props.collapse_grid),200);edlTimeouts.push(o)}function handlingRowReady(e,t,i){Rexbuilder_Util.domUpdating=!1,e.properties.dispositionBeforeCollapsing=e.createActionDataMoveBlocksGrid(),e._createFirstReverseStack(),e._fixImagesDimension(),Rexbuilder_Util.editorMode&&e._updateElementsSizeViewers(),handlingRowReadyEnd(t),i||setTimeout(Rexbuilder_Util.fixYoutube.bind(null,e.section),1500)}function updateDOMSingleElement(e){var t=e.$elem,i=t.get(0),a=e.targetProps,o=e.$itemData,r=o.get(0),n=e.$itemContent,s=e.gridstackInstance,l=e.positionAndSize||!1,d=e.collapseGrid||!1;if(l){d&&(i.setAttribute("data-gs-width",12),i.setAttribute("data-width",12),r.setAttribute("data-gs_width",12),r.setAttribute("data-size_x",12),a.gs_width="12",a.size_x="12",i.setAttribute("data-gs-x",0),i.setAttribute("data-row",1),r.setAttribute("data-gs_x",0),r.setAttribute("data-row",1),a.gs_x="0",a.row="1");var u={x:i.getAttribute("data-gs-x"),y:i.getAttribute("data-gs-y"),w:i.getAttribute("data-gs-width"),h:i.getAttribute("data-gs-height"),startH:r.getAttribute("data-gs_start_h"),realFluid:r.getAttribute("data-element_real_fluid")},c={x:"undefined"==typeof a.gs_x?u.x:a.gs_x,y:"undefined"==typeof a.gs_y?u.y:a.gs_y,w:"undefined"==typeof a.gs_width?u.w:a.gs_width,h:"undefined"==typeof a.gs_height?u.h:a.gs_height,startH:"undefined"==typeof a.gs_start_h?u.startH:a.gs_start_h,realFluid:"undefined"==typeof a.element_real_fluid?u.realFluid:a.element_real_fluid,gridstackInstance:s};updateElementDimensions(t[0],o[0],c)}var _=isNaN(parseInt(a.video_bg_id))?"":parseInt(a.video_bg_id),g="undefined"==typeof a.video_bg_url_youtube?"":a.video_bg_url_youtube,m="undefined"==typeof a.video_bg_url_vimeo?"":a.video_bg_url_vimeo,p="";""!=_?p="mp4":""!=m?p="vimeo":""!=g&&(p="youtube");var f={mp4Data:{idMp4:_,linkMp4:"undefined"==typeof a.video_mp4_url?"":a.video_mp4_url,width:isNaN(parseInt(a.video_bg_width))?"":parseInt(a.video_bg_width),height:isNaN(parseInt(a.video_bg_height))?"":parseInt(a.video_bg_height)},vimeoUrl:m,youtubeUrl:g,audio:"undefined"==typeof a.video_has_audio?"":"1"==a.video_has_audio||"true"==a.video_has_audio.toString(),typeVideo:p};Rexbuilder_Dom_Util.updateVideos(n,f);var b="undefined"==typeof a.image_bg_elem_active||"true"==a.image_bg_elem_active.toString(),h={active:b,idImage:b?isNaN(parseInt(a.id_image_bg))?"":parseInt(a.id_image_bg):"",urlImage:b?a.image_bg_url:"",width:b?isNaN(parseInt(a.image_width))?"":parseInt(a.image_width):"",height:b?isNaN(parseInt(a.image_height))?"":parseInt(a.image_height):"",typeBGimage:b?a.type_bg_image:"",photoswipe:b?a.photoswipe:""};Rexbuilder_Dom_Util.updateImageBG(n,h);var v={$elem:t,color:"undefined"!=typeof a.color_bg_block?a.color_bg_block:"",active:"undefined"==typeof a.color_bg_block_active||a.color_bg_block_active.toString()};-1===v.color.indexOf("gradient")?Rexbuilder_Dom_Util.updateBlockBackgroundColor(v):Rexbuilder_Dom_Util.updateBlockBackgroundGradient(v);var y={$elem:t,color:"undefined"!=typeof a.overlay_block_color?a.overlay_block_color:"",active:"undefined"!=typeof a.overlay_block_color_active&&a.overlay_block_color_active.toString()};-1===y.color.indexOf("gradient")?Rexbuilder_Dom_Util.updateBlockOverlay(y):Rexbuilder_Dom_Util.updateBlockOverlayGradient(y),Rexbuilder_Dom_Util.updateBlockPaddings(t,_getPaddingsDataString("undefined"!=typeof a.block_padding?a.block_padding:""));var x="undefined"==typeof a.block_custom_class?"":a.block_custom_class,D=[];""!=x&&(x=x.trim(),D=x.split(/\s+/)),Rexbuilder_Dom_Util.updateCustomClasses(t,D);var S="undefined"!=typeof a.block_flex_position?a.block_flex_position.split(" "):"",C={x:S[0],y:S[1]};Rexbuilder_Dom_Util.updateFlexPostition(t,C);var S="undefined"!=typeof a.block_flex_img_position?a.block_flex_img_position.split(" "):"",k={x:S[0],y:S[1]};Rexbuilder_Dom_Util.updateImageFlexPostition(t,k);var U="undefined"==typeof a.slider_dimension_ratio?"":a.slider_dimension_ratio;o.attr("data-slider_ratio",U);var I="undefined"==typeof a.block_ratio?"":a.block_ratio;o.attr("data-block_ratio",I);var R="undefined"==typeof a.block_dimensions_live_edited?"":a.block_dimensions_live_edited;o.attr("data-block_dimensions_live_edited",R);var w="undefined"!=typeof a.hide&&"true"==a.hide.toString();w?(t.hasClass("rex-hide-element")||t.addClass("rex-hide-element"),Rexbuilder_Util.stopBlockVideos(t)):(t.hasClass("rex-hide-element")&&t.removeClass("rex-hide-element"),Rexbuilder_Util.playBlockVideos(t));var A="undefined"!=typeof a.element_edited&&"true"==a.element_edited.toString();t.attr("data-rexlive-element-edited",A);for(var $ in a)switch($){case"type":o.attr("data-type",a.type);break;case"size_x":t.attr("data-width",a.size_x);break;case"size_y":t.attr("data-height",a.size_y);break;case"row":t.attr("data-row",a.row);break;case"col":t.attr("data-col",a.col);break;case"photoswipe":if(!Rexbuilder_Util.editorMode)if(""===a.linkurl&&"true"==a.photoswipe){Rexbuilder_Photoswipe.addElement(n,a.image_bg_url,parseInt(a.image_width),parseInt(a.image_height),a.image_size);var L=t.parents(".rexpansive_section");L.addClass("photoswipe-gallery")}else Rexbuilder_Photoswipe.removeElement(n);o.attr("data-photoswipe",a.photoswipe);break;case"linkurl":if(!Rexbuilder_Util.editorMode){var N=n.parents(".element-link");if(""!=a.linkurl)if(0!=N.length)N.attr("href",a.linkurl),N.attr("title",a.linkurl);else{var z=n.parent();tmpl.arg="link",z.append('<a class="element-link hovered" href="'+a.linkurl+'" title="'+a.linkurl+'"></a>');var E=z.children(".element-link");n.detach().appendTo(E)}else 0!=N.length&&N.children().unwrap()}Rexbuilder_Dom_Util.updateBlockUrl(t,a.linkurl);break;case"zak_background":case"zak_side":case"zak_title":case"zak_icon":case"zak_foreground":break;case"block_animation":break;case"block_has_scrollbar":}}function _smoothScroll(e){$bodyHtml.animate({scrollTop:e.offset().top+_plugin_frontend_settings.scroll_animation_offset},600)}function getGalleryInstance(e){var t=e.is(".rexpansive_section");t||(e=e.parents(".rexpansive_section"));var i=e.find(".grid-stack-row");return 0==i.length?null:i.data("plugin_perfectGridGalleryEditor")}function startVideoPlugin(e){if(e.hasClass("mp4-player")){var t=e.find(".rex-video-wrap"),i=t.children(".rex-video-container").get(0);t.removeClass("removing-video-mp4"),i.play()["catch"](function(e){Rexbuilder_Util.displayError("An error occurred while trying to play the video."),console.error(e)})}else if(e.hasClass("vimeo-player")){var a=e.children(".rex-video-vimeo-wrap").find("iframe")[0],o={autoplay:!0,background:!0,loop:!0};VimeoVideo.addPlayer("1",a,o)}else e.hasClass("youtube-player")&&void 0===e.children(".rex-youtube-wrap").YTPGetPlayer()&&e.children(".rex-youtube-wrap").YTPlayer()}function handleYtbVideoMobileClick(ev){ev.preventDefault();var data_yt=eval("("+this.getAttribute("data-property")+")"),url=data_yt.videoURL;window.location.href=url}function handleLayoutChange(e){var t=Array.prototype.slice.call(Rexbuilder_Util.rexContainer.querySelectorAll(".rexpansive_section:not(.removing_section)")),i=t.length;Rexbuilder_Util.rexContainer.setAttribute("data-rex-layout-selected",e),Rexbuilder_Util.activeLayout=e;var a,o,r=[],n=[];for(a=0;a<i;a++)Rexbuilder_Util.hasClass(t[a],"rex-model-section")&&r.push(parseInt(t[a].getAttribute("data-rexlive-model-id"))),o={rexID:t[a].getAttribute("data-rexlive-section-id"),modelID:isNaN(parseInt(t[a].getAttribute("data-rexlive-model-id")))?"":parseInt(t[a].getAttribute("data-rexlive-model-id"))},n.push(o);var s,l,d=Rexbuilder_Util.getPageCustomizations();"default"==Rexbuilder_Util.activeLayout&&Rexbuilder_Util.saveCustomizationDomOrder(jQuery.extend(!0,[],d));var u,c=Rexbuilder_Util.getModelsCustomizations();"true"==$defaultLayoutState.attr("data-empty-default-customization")?(u=Rexbuilder_Util.getDefaultPageLayout(d,c),_createDefaultLayoutState(u)):(Rexbuilder_Util.updateDefaultLayoutState({modelsData:c}),u=Rexbuilder_Util.getDefaultLayoutState());var _,g=Rexbuilder_Util.getCustomLayoutSections(d,c,u,e),m=[];for(s=0;s<g;s++)if("true"==g[s].section_is_model.toString()){for(_=!1,l=0;l<m.length;l++)if(m[l].id==g[s].section_model_id){m[l].number=m[l].number+1,g[s].section_model_number=m[l].number,_=!0;break}_||(g[s].section_model_number=1,m.push({id:g[s].section_model_id,number:1}))}Rexbuilder_Util.clearSectionsEdited();var p=_mergeSections(g,u);Rexbuilder_Util.domUpdating=!0;var f,b,h=!1,v=[];for(f in p)if(!p[f].notInSection||"default"==e){var y={rexID:p[f].section_rex_id,modelID:-1,modelNumber:-1};"true"==p[f].section_is_model.toString()?(y.modelID=p[f].section_model_id,y.modelNumber=p[f].section_model_number,b=Rexbuilder_Util.rexContainer.querySelector('section[data-rexlive-section-id="'+p[f].section_rex_id+'"][data-rexlive-model-number="'+y.modelNumber+'"]')):b=Rexbuilder_Util.rexContainer.querySelector('section[data-rexlive-section-id="'+p[f].section_rex_id+'"]'),b&&!Rexbuilder_Util.hasClass(b,"removing_section")&&("undefined"!=typeof p[f].section_hide&&"true"==p[f].section_hide.toString()?Rexbuilder_Util.addClass(b,"rex-hide-section"):(Rexbuilder_Util.removeClass(b,"rex-hide-section"),updateRexGrid(b,p[f].targets,h,f)),v.push(y))}Rexbuilder_Dom_Util.fixSectionDomOrder(v,!0),Rexbuilder_Util.domUpdating=!1}function updateRexGrid(e,t,i){var a=$(e),o=a.find(".grid-stack-row"),r=t[0].props.collapse_grid;-1!==t[0].props.custom_classes.indexOf("rex-block-grid")&&(r=!1),e.querySelector(".section-data").setAttribute("data-collapse-grid",r),t[0].props.gridEdited&&o.attr("data-rexlive-layout-changed",!0);var n,s=t.length;for(n=1;n<s;n++){var l=o.children('div[data-rexbuilder-block-id="'+t[n].name+'"]'),d="undefined"!=typeof t[n].props.hide&&"true"==t[n].props.hide.toString();d?l.hasClass("rex-hide-element")||l.addClass("rex-hide-element"):l.hasClass("rex-hide-element")&&l.removeClass("rex-hide-element")}var u,c,l,_,g,m,p,f;for(n=1;n<s;n++)if((!t[n].notDisplay||"default"==Rexbuilder_Util.activeLayout)&&(u=t[n].name,c=t[n].props,l=o.find('.perfect-grid-item[data-rexbuilder-block-id="'+u+'"]'),m=l[0],_=l.children(".rexbuilder-block-data"),g=l.find(".grid-item-content"),l.length>0)){if(p=[].slice.call(m.getElementsByTagName("img")),f=p.length,!Rexbuilder_Util.editorMode&&0!==f){var b;for(b=0;b<f;b++)"true"===p[b].getAttribute("inline-photoswipe")&&Rexbuilder_Photoswipe.addElementFromInline($(p[b]))}var h={$elem:l,targetProps:c,$itemData:_,$itemContent:g,gridstackInstance:null,positionAndSize:!0,collapseGrid:r};Rexbuilder_Util.updateDOMSingleElement(h)}updateSection(a,o,t[0].props,i)}function removeArrayDuplicates(e){return e.filter(function(e,t,i){return i.indexOf(e)===t})}function isOrIsChild(e,t){return!!e.matches(t)||0!==$(e).parents(t).length}function displayError(e,t){"string"!=typeof e&&(e=e.toString()),/^\[Rexpansive\]/.test(e)||(e="[Rexpansive] "+e),console.error(e),t&&"string"==typeof t&&alert(t)}function displayAjaxError(e,t,i){"string"!=typeof t&&(t=t.toString()),/^\[Rexpansive\]/.test(t)||(t="[Rexpansive] "+t),console.error(t,{status:e.response.status,message:e.textStatus,errorThrown:e.errorThrown}),i&&"string"==typeof i&&alert(i)}var hasClass,addClass,removeClass,toggleClass;"classList"in document.documentElement?(hasClass=function(e,t){return e.classList.contains(t)},addClass=function(e,t){e.classList.add(t)},removeClass=function(e,t){e.classList.remove(t)}):(hasClass=function(e,t){return new RegExp("\\b"+t+"\\b").test(e.className)},addClass=function(e,t){hasClass(e,t)||(e.className+=" "+t)},removeClass=function(e,t){e.className=e.className.replace(new RegExp("\\b"+t+"\\b","g"),"")}),toggleClass=function(e,t){hasClass(e,t)?removeClass(e,t):addClass(e,t)};var editorMode=!1,windowIsResizing=!1,responsiveLayouts,defaultLayoutSections,$modelsCustomizationsDataDiv,$pageCustomizationsDataDiv,$liveDataContainer,$layoutsDomOrder,$defaultLayoutState,frontAvailableLayouts,startFrontLayout,changedFrontLayout,layoutSavedInfo,$usedIDSContainer,sectionIDSused,$usedBlocksIDsContainer,blocksIDsUsed,$rexbuilderLayoutData,$rexbuilderModelData,$availableLayoutNames,edlTimeouts=[],$bodyHtml,createRandomID=function(e){for(var t="",i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",a=0;a<e;a++)t+=i.charAt(Math.floor(Math.random()*i.length));return t},_createRandomNumericID=function(e){for(var t="",i="0123456789",a=0;a<e;a++)t+=i.charAt(Math.floor(Math.random()*i.length));return parseInt(t)},_storeNamesUsed=function(){sectionIDSused=$usedIDSContainer.length>0?JSON.parse($usedIDSContainer.text()):[]},_saveSectionNamesUsed=function(){$usedIDSContainer.text(JSON.stringify(sectionIDSused))},_getSectionNamesUsed=function(){return sectionIDSused},_addSectionID=function(e){var t;for(t=sectionIDSused.length-1;t>=0&&e!=sectionIDSused[t];t--);t==-1&&sectionIDSused.push(e)},_removeSectionID=function(e){var t=0;for(t=sectionIDSused.length-1;t>=0&&e!=sectionIDSused[t];t--);t>-1&&(sectionIDSused.splice(t,1),_saveSectionNamesUsed())},_createSectionID=function(){var e,t,i,a=4;do if(t=!0,e=createRandomID(a),"self"==e)t=!1;else for(i=0;i<sectionIDSused.length;i++)if(e==sectionIDSused[i]){t=!1;break}while(!t);return _addSectionID(e),e},_updateSectionsIDs=function(){if(Rexbuilder_Util.rexContainer){var e,t,i=[].slice.call(Rexbuilder_Util.rexContainer.getElementsByClassName("rexpansive_section")),a=i.length;for(t=0;t<a;t++){var o=i[t].getAttribute("data-rexlive-section-id");null!==o&&""!==o||(e=_createSectionID(),i[t].setAttribute("data-rexlive-section-id",e),_fix_tools_ids(i[t],e))}}},_fix_tools_ids=function(e,t){if(e){var i,a,o,r,n,s,l=[].slice.call(e.getElementsByClassName("tool-area--side tool-area--left")),d=l.length;for(i=0;i<d;i++){for(o=[].slice.call(l[i].getElementsByClassName("edit-row-width")),r=o.length,a=0;a<r;a++)o[a].setAttribute("id",o[a].getAttribute("id")+t),o[a].setAttribute("name",o[a].getAttribute("name")+t),o[a].nextElementSibling.setAttribute("for",o[a].nextElementSibling.getAttribute("for")+t);for(n=[].slice.call(l[i].getElementsByClassName("edit-row-layout")),s=n.length,a=0;a<s;a++)n[a].setAttribute("id",n[a].getAttribute("id")+t),n[a].setAttribute("name",n[a].getAttribute("name")+t),n[a].nextElementSibling.setAttribute("for",n[a].nextElementSibling.getAttribute("for")+t)}}},_updateSectionsNumber=function(){var e=-1;if(Rexbuilder_Util.rexContainer){var t,i=[].slice.call(Rexbuilder_Util.rexContainer.getElementsByClassName("rexpansive_section")),a=i.length;for(t=0;t<a;t++)i[t].setAttribute("data-rexlive-section-number",t),e=t;Rexbuilder_Util.lastSectionNumber=e}},_findLayoutType=function(e){return"default"==e||"tablet"==e||"mobile"==e?"standard":"custom"},_findFrontLayout=function(){for(var e=Rexbuilder_Util.globalViewport.width,t=frontAvailableLayouts.length-1;t>=0;t--)if(e>=parseInt(frontAvailableLayouts[t].min)&&(""==frontAvailableLayouts[t].max||e<=parseInt(frontAvailableLayouts[t].max)))return frontAvailableLayouts[t].id},_getModelsCustomizations=function(){var e=[];return $modelsCustomizationsDataDiv.children(".model-customizations-container").each(function(t,i){var a=$(i),o=parseInt(a.attr("data-model-id")),r=[];a.children(".model-customization-data").each(function(e,t){var i=$(t),a=i.attr("data-model-layout-name"),o=JSON.parse(i.text()),n={name:a,targets:o};r.push(n)});var n={id:o,customizations:r};e.push(n)}),e},_updateModelsCustomizationsData=function(e){var t,i,a=e.id,o=$modelsCustomizationsDataDiv.children('.model-customizations-container[data-model-id="'+a+'"]');for(0!=o.length?o.children(".model-customization-data").remove():(o=$(document.createElement("script")),o.addClass("model-customizations-container"),o.attr("data-model-id",a),o.appendTo($modelsCustomizationsDataDiv[0])),t=0,i=e.customizations.length;t<i;t++){var r=$(document.createElement("script"));r.addClass("model-customization-data"),r.attr("data-model-layout-name",e.customizations[t].name),r.text(JSON.stringify(e.customizations[t].targets)),r.appendTo(o[0])}$modelsCustomizationsDataDiv.attr("data-empty-models-customizations",!1)},_updateDivModelCustomizationsNames=function(e){var t,i,a=$rexbuilderModelData.find(".available-models-customizations-names"),o=JSON.parse(a.text()),r=[];for(t=0,i=o.length;t<i;t++){var n=o[t];n.id!=e.id&&r.push(n)}r.push(e),a.text(JSON.stringify(r))},_getPageCustomizations=function(){var e=[],t={name:"default",sections:[]},i=$pageCustomizationsDataDiv.children('.customization-wrap[data-customization-name="default"]');return i.children(".section-targets").each(function(e,i){var a=$(i),o=a.attr("data-section-rex-id"),r=isNaN(parseInt(a.attr("data-model-id")))?-1:parseInt(a.attr("data-model-id")),n=isNaN(parseInt(a.attr("data-model-number")))?-1:parseInt(a.attr("data-model-number")),s="undefined"!=typeof a.attr("data-section-hide")&&"1"==a.attr("data-section-hide").toString(),l=""!=a.text()?JSON.parse(a.text()):[];t.sections.push({section_rex_id:o,section_model_id:r!=-1?r:"",section_model_number:n!=-1?n:"",section_is_model:r!=-1,section_hide:s,targets:l})}),e.push(t),$pageCustomizationsDataDiv.children('.customization-wrap:not([data-customization-name="default"])').each(function(t,i){var a=$(i),o=a.attr("data-customization-name"),r={name:o,sections:[]};a.children(".section-targets").each(function(e,t){var i=$(t),a=i.attr("data-section-rex-id"),o=isNaN(parseInt(i.attr("data-model-id")))?-1:parseInt(i.attr("data-model-id")),n=isNaN(parseInt(i.attr("data-model-number")))?-1:parseInt(i.attr("data-model-number")),s="undefined"!=typeof i.attr("data-section-hide")&&"1"==i.attr("data-section-hide").toString(),l=""!=i.text()?JSON.parse(i.text()):[],d="undefined"!=typeof i.attr("data-section-created-live")&&"1"==i.attr("data-section-created-live").toString();r.sections.push({section_rex_id:a,section_model_id:o!=-1?o:"",section_model_number:n!=-1?n:"",section_is_model:o!=-1,section_hide:s,section_created_live:d,targets:l})}),e.push(r)}),e},_createPageCustomizationsDataLive=function(e){$liveDataContainer.children().remove();var t,i;for(t=0,i=e.length;t<i;t++){var a=$(document.createElement("script"));a.addClass("section-targets"),a.attr("data-section-rex-id",e[t].section_rex_id),a.attr("data-model-id",e[t].section_model_id),a.attr("data-model-number",e[t].section_model_number),a.attr("data-section-hide",e[t].section_hide),a.text(JSON.stringify(e[t].targets)),a.appendTo($liveDataContainer[0])}},_updatePageCustomizationsData=function(e){var t,i,a=e.name,o=$pageCustomizationsDataDiv.children('.customization-wrap[data-customization-name="'+a+'"]');for(0!=o.length?o.children(".section-targets").remove():(o=$(document.createElement("script")),o.addClass("customization-wrap"),o.attr("data-customization-name",a),o.appendTo($pageCustomizationsDataDiv[0])),t=0,i=e.sections.length;t<i;t++){var r=$(document.createElement("script"));r.addClass("section-targets"),r.attr("data-section-rex-id",e.sections[t].section_rex_id),r.attr("data-model-id",e.sections[t].section_model_id),r.attr("data-model-number",e.sections[t].section_model_number),r.attr("data-section-hide",e.sections[t].section_hide),r.attr("data-section-created-live","true"==e.sections[t].section_created_live.toString()&&"1"),""==e.sections[t].section_model_id&&r.text(JSON.stringify(e.sections[t].targets)),r.appendTo(o[0])}$pageCustomizationsDataDiv.removeAttr("data-empty-customizations")},_updatePageAvaiableLayoutsNames=function(e){$availableLayoutNames.text(JSON.stringify(e))},_getSectionCustomLayouts=function(e){var t,i,a,o,r=[],n=Rexbuilder_Util.getPageCustomizations();for(t=0,a=n.length;t<a;t++){var s=n[t].name;if(null!=n[t].sections)for(i=0,o=n[t].sections.length;i<o;i++)if(n[t].sections[i].section_rex_id==e){var l=jQuery.extend(!0,[],n[t].sections[i].targets),d={name:s,targets:l};r.push(d)}}return r},chooseLayout=function(){var e=$rexbuilderLayoutData,t=$rexbuilderModelData;if(Rexbuilder_Util.chosenLayoutData={min:0,max:"",id:"default",label:"My Desktop",type:"standard"},"true"==e.children(".layouts-data").attr("data-empty-customizations")||Rexbuilder_Util.editorMode&&Rexbuilder_Util.firstStart)return"default";var i,a,o,r,n,s,l,d,u,c,_=Rexbuilder_Util.globalViewport.width,g=document.getElementById("layout-avaiable-dimensions"),m=g?JSON.parse(g.textContent):[],p=t.children(".available-models-customizations-names"),f=p.length>0?JSON.parse(p.text()):[],b=e.children("#available-layouts-names"),h=b.length>0?JSON.parse(b.text()):[],v=[];for(i=0,r=m.length;i<r;i++){for(c=!1,a=0,n=f.length;a<n;a++)for(o=0,s=f[a].names.length;o<s;o++)if(m[i].id==f[a].names[o]){var y=m[i];y.model=!0,c=!0,v.push(y)}if(!c)for(o=0,l=h.length;o<l;o++)if(m[i].id==h[o]){var y=m[i];y.model=!1,c=!0,v.push(y)}}for(i=0,d=v.length;i<d;i++)""==v[i].min&&(v[i].min=0);var x="",D=function(e){return function(t,i){return t[e]>i[e]?1:i[e]>t[e]?-1:0}},S=v.concat();for(S.sort(D("min")),i=0,u=S.length;i<u;i++)_>=S[i].min&&(""!=S[i].max?_<=S[i].max&&(x=S[i].id,Rexbuilder_Util.chosenLayoutData=S[i]):(x=S[i].id,Rexbuilder_Util.chosenLayoutData=S[i]));return""===x&&(x="default"),x},predictLayout=function(){var e=Rexbuilder_Util.globalViewport.width;return e<=767?"mobile":e<=1024?"tablet":"default"},_createEmptyTargets=function(e){var t,i,a=[];for(t=0,i=e.length;t<i;t++){var o={name:e[t].name,props:{}};"self"==e[t].name&&_isMobile()&&(o.props.collapse_grid=!0),a.push(o)}return a},_getDefaultPageLayout=function(e,t){var i,a,o,r,n,s,l,d,u,c=[];for(i=0,n=e.length;i<n;i++)if("default"==e[i].name){for(a=0,s=e[i].sections.length;a<s;a++)c.push(jQuery.extend(!0,{},e[i].sections[a]));break}for(i=0,l=c.length;i<l;i++)if("true"==c[i].section_is_model.toString())for(o=0,d=t.length;o<d;o++)if(t[o].id==c[i].section_model_id){for(r=0,u=t[o].customizations.length;r<u;r++)if("default"==t[o].customizations[r].name){c[i].targets=jQuery.extend(!0,[],t[o].customizations[r].targets);break}break}return c},_getDefaultModelsLayout=function(e){var t,i,a,o,r=[];for(t=0,a=e.length;t<a;t++)for(i=0,o=e[t].customizations.length;i<o;i++)if("default"==e[t].customizations[i].name){r.push({id:e[t].id,targets:e[t].customizations[i].targets});break}return r},_getCustomLayoutSections=function(e,t,i,a){if("default"==a)return i;var o,r,n,s,l,d,u,c,_,g,m,p,f=[],b=!1,h=_getDefaultModelsLayout(t);for(o=0,l=e.length;o<l;o++)if(e[o].name==a){for(b=!0,r=0,d=e[o].sections.length;r<d;r++)f.push(jQuery.extend(!0,{},e[o].sections[r]));break}if(!b)for(o=0,u=i.length;o<u;o++){var v=jQuery.extend(!0,{},i[o]);v.targets=_createEmptyTargets(i[o].targets),v.sectionCleared=!0,f.push(v)}for(o=0,c=f.length;o<c;o++)if("true"==f[o].section_is_model.toString()){for(n=0,_=t.length;n<_;n++)if(t[n].id==f[o].section_model_id){for(p=!1,s=0,g=t[n].customizations.length;s<g;s++)if(t[n].customizations[s].name==a){p=!0,f[o].targets=jQuery.extend(!0,[],t[n].customizations[s].targets),f[o].defaultSection=!1,f[o].sectionCleared=!1;break}if(!p)for(s=0,m=h.length;s<m;s++)if(f[o].section_model_id==h[s].id){f[o].targets=_createEmptyTargets(h[s].targets),f[o].sectionCleared=!0;break}break}}else if(0==f[o].targets.length)for(r=0,u=i.length;r<u;r++)if(f[o].section_rex_id==i[r].section_rex_id){f[o].targets=_createEmptyTargets(i[r].targets),f[o].sectionCleared=!0;break}return f},_mergeSections=function(e,t){var i,a,o,r,n,s,l,d,u;if("default"!=Rexbuilder_Util.activeLayout){for(i=0,n=e.length;i<n;i++)for(e[i].sectionFounded=!1,e[i].defaultSection=!1,a=0,s=t.length;a<s;a++)if(e[i].section_rex_id==t[a].section_rex_id){e[i].sectionFounded=!0;var c=e[i],_=t[a];for(("undefined"==typeof c.targets[0]||jQuery.isEmptyObject(c.targets[0].props)||"undefined"!=typeof c.sectionCleared&&c.sectionCleared)&&(c.defaultSection=!0,c.targets=jQuery.extend(!0,[],_.targets)),o=0,l=c.targets.length;o<l;o++){for(u=!1,r=0,d=_.targets.length;r<d;r++)if(c.targets[o].name==_.targets[r].name){if(c.targets[o].notDisplay=!1,u=!0,_.targets[r].oldElement=!0,o>=1&&jQuery.isEmptyObject(c.targets[o].props)&&"default"!=Rexbuilder_Util.activeLayout&&_.targets[0].props.layout!=c.targets[0].props.layout){var g=parseFloat(_.targets[0].props.grid_cell_width),m=5;"masonry"==_.targets[0].props.layout?(c.targets[o].props.gs_y=Math.round(_.targets[r].props.gs_y*m/g),c.targets[o].props.gs_height=Math.round(_.targets[r].props.gs_height*m/g),c.targets[o].props.gs_start_h=Math.round(_.targets[r].props.gs_start_h*m/g)):(c.targets[o].props.gs_y=Math.round(_.targets[r].props.gs_y*g/m),c.targets[o].props.gs_height=Math.round(_.targets[r].props.gs_height*g/m),c.targets[o].props.gs_start_h=Math.round(_.targets[r].props.gs_start_h*g/m))}c.targets[o].props=Rexbuilder_Util.merge(_.targets[r].props,c.targets[o].props);break}u||(c.targets[o].notDisplay=!0)}for(r=0,d=_.targets.length;r<d;r++)if("undefined"==typeof _.targets[r].oldElement){var p=jQuery.extend(!0,{},_.targets[r]);if("default"!=Rexbuilder_Util.activeLayout&&_.targets[0].props.layout!=c.targets[0].props.layout){var g=parseFloat(_.targets[0].props.grid_cell_width),m=5;"masonry"==_.targets[0].props.layout?(p.props.gs_y=Math.round(p.props.gs_y*m/g),p.props.gs_height=Math.round(p.props.gs_height*m/g),p.props.gs_start_h=Math.round(p.props.gs_start_h*m/g)):(p.props.gs_y=Math.round(p.props.gs_y*g/m),p.props.gs_height=Math.round(p.props.gs_height*g/m),p.props.gs_start_h=Math.round(p.props.gs_start_h*g/m))}c.targets.splice(1,0,p)}break}if(0==e.length)for(e=t,i=0,n=e.length;i<n;i++)e[i].defaultSection=!0}for(_createPageCustomizationsDataLive(e),i=0,n=e.length;i<n;i++)(e[i].sectionFounded||"default"==Rexbuilder_Util.activeLayout)&&("default"!=Rexbuilder_Util.activeLayout&&e[i].defaultSection||"default"==Rexbuilder_Util.activeLayout)&&_isMobile()&&(e[i].targets[0].props.collapse_grid=!0,e[i].targets[0].props.noMobileLayoutSaved=!0,e[i].targets[0].props.layout="masonry",e[i].targets[0].props.fullHeight=!1);return jQuery.extend(!0,{},e)},_cssPropertyValueSupported=function(e,t){var i=document.createElement("div");return i.style[e]=t,i.style[e]===t},launchEditDomLayout=function(){var e=Rexbuilder_Util.chooseLayout();Rexbuilder_Util.edit_dom_layout(e)},edit_dom_layout=function(e){var t={collapse_needed:!1};if(e==Rexbuilder_Util.activeLayout&&"default"==e)return _isMobile()?Rexbuilder_Util.blockGridUnder768||(Rexbuilder_Util.collapseAllGrids(),t.collapse_needed=!0):Rexbuilder_Util.removeCollapsedGrids(),t;if(Rexbuilder_Util.rexContainer.setAttribute("data-rex-layout-selected",e),Rexbuilder_Util.activeLayout=e,"true"==$rexbuilderLayoutData.children(".layouts-customizations").attr("data-empty-customizations")&&"true"==$rexbuilderModelData.children(".models-customizations").attr("data-empty-models-customizations")){_isMobile()?Rexbuilder_Util.blockGridUnder768||(Rexbuilder_Util.collapseAllGrids(),t.collapse_needed=!0):Rexbuilder_Util.removeCollapsedGrids();var i=document.querySelector(".rexpansive_section.empty-section");if(i){var a=[{section_rex_id:i.getAttribute("data-rexlive-section-id"),targets:[{name:"self",props:{}}]}];Rexbuilder_Util.editedDataInfo=new RexEditedData(a)}else{var o,r=Array.prototype.slice.call(document.getElementsByClassName("rexpansive_section")),n=r.length,s=[];for(o=0;o<n;o++){var l={},d=r[o].querySelector(".section-data");l.section_rex_id=r[o].getAttribute("data-rexlive-section-id"),l.targets=[];var u={name:"",props:{}};u.name="self",u.props.section_name=d.getAttribute("data-section_name"),u.props.section_nav_label=d.getAttribute("data-section_nav_label"),u.props.color_bg_section=d.getAttribute("data-color_bg_section"),u.props.color_bg_section_active=""!==u.props.color_bg_section,u.props.image_bg_section_active=d.getAttribute("data-image_bg_section_active"),u.props.image_bg_section=d.getAttribute("data-image_bg_section"),u.props.image_width=d.getAttribute("data-image_width"),u.props.image_height=d.getAttribute("data-image_height"),u.props.id_image_bg_section=d.getAttribute("data-id_image_bg_section"),u.props.image_size=d.getAttribute("data-image_size"),u.props.video_bg_id=d.getAttribute("data-video_bg_id_section"),u.props.video_mp4_url=d.getAttribute("data-video_mp4_url"),u.props.video_bg_width_section=d.getAttribute("data-video_bg_width_section"),u.props.video_bg_height_section=d.getAttribute("data-video_bg_height_section"),u.props.video_bg_url_section=d.getAttribute("data-video_bg_url_section"),u.props.video_bg_url_vimeo_section=d.getAttribute("data-video_bg_url_vimeo_section"),u.props.block_distance=d.getAttribute("data-block_distance"),u.props.row_separator_top=d.getAttribute("data-row_separator_top"),u.props.row_separator_bottom=d.getAttribute("data-row_separator_bottom"),u.props.row_separator_right=d.getAttribute("data-row_separator_right"),
u.props.row_separator_left=d.getAttribute("data-row_separator_left"),u.props.margin=d.getAttribute("data-margin"),u.props.row_margin_top=d.getAttribute("data-row_margin_top"),u.props.row_margin_bottom=d.getAttribute("data-row_margin_bottom"),u.props.row_margin_right=d.getAttribute("data-row_margin_right"),u.props.row_margin_left=d.getAttribute("data-row_margin_left"),u.props.custom_classes=d.getAttribute("data-custom_classes"),u.props.row_overlay_color=d.getAttribute("data-row_overlay_color"),u.props.row_overlay_active=d.getAttribute("data-row_overlay_active"),l.targets.push(u);var c,g=Array.prototype.slice.call(r[o].getElementsByClassName("rexbuilder-block-data")),m=g.length;for(c=0;c<m;c++){var p={name:g[c].getAttribute("data-rexbuilder_block_id"),props:{color_bg_block:g[c].getAttribute("data-color_bg_block"),color_bg_block_active:g[c].getAttribute("data-color_bg_block_active"),image_bg_url:g[c].getAttribute("data-image_bg_url"),image_width:g[c].getAttribute("data-image_width"),image_height:g[c].getAttribute("data-image_height"),id_image_bg:g[c].getAttribute("data-id_image_bg"),image_size:g[c].getAttribute("data-image_size"),image_bg_elem_active:g[c].getAttribute("data-image_bg_elem_active"),type_bg_image:g[c].getAttribute("data-type_bg_image"),video_bg_id:g[c].getAttribute("data-video_bg_id"),video_bg_width:g[c].getAttribute("data-video_bg_width"),video_bg_height:g[c].getAttribute("data-video_bg_height"),video_mp4_url:g[c].getAttribute("data-video_mp4_url"),video_bg_url_youtube:g[c].getAttribute("data-video_bg_url_youtube"),video_bg_url_vimeo:g[c].getAttribute("data-video_bg_url_vimeo"),photoswipe:g[c].getAttribute("data-photoswipe"),block_custom_class:g[c].getAttribute("data-block_custom_class"),block_padding:g[c].getAttribute("data-block_padding"),overlay_block_color:g[c].getAttribute("data-overlay_block_color"),overlay_block_color_active:g[c].getAttribute("data-overlay_block_color_active"),linkurl:g[c].getAttribute("data-linkurl"),block_flex_position:g[c].getAttribute("data-block_flex_position"),block_flex_img_position:g[c].getAttribute("data-block_flex_img_position")}};l.targets.push(p)}s.push(l)}Rexbuilder_Util.editedDataInfo=new RexEditedData(s)}return t}var f,b,h=[],v=[],y=[].slice.call(Rexbuilder_Util.rexContainer.querySelectorAll(".rexpansive_section:not(.removing_section)")),x=y.length;for(f=0;f<x;f++)Rexbuilder_Util.hasClass(y[f],"rex-model-section")&&h.push(parseInt(y[f].getAttribute("data-rexlive-model-id"))),b={rexID:y[f].getAttribute("data-rexlive-section-id"),modelID:isNaN(parseInt(y[f].getAttribute("data-rexlive-model-id")))?"":parseInt(y[f].getAttribute("data-rexlive-model-id"))},v.push(b);var D,S,C=_getPageCustomizations();"default"==Rexbuilder_Util.activeLayout&&_saveCustomizationDomOrder(jQuery.extend(!0,[],C));var k,U=_getModelsCustomizations();"true"==$defaultLayoutState.attr("data-empty-default-customization")?(k=Rexbuilder_Util.getDefaultPageLayout(C,U),_createDefaultLayoutState(k)):(_updateDefaultLayoutState({modelsData:U}),k=_getDefaultLayoutState());var I,R=Rexbuilder_Util.getCustomLayoutSections(C,U,k,e),w=[];for(D=0;D<R;D++)if("true"==R[D].section_is_model.toString()){for(I=!1,S=0;S<w.length;S++)if(w[S].id==R[D].section_model_id){w[S].number=w[S].number+1,R[D].section_model_number=w[S].number,I=!0;break}I||(R[D].section_model_number=1,w.push({id:R[D].section_model_id,number:1}))}Rexbuilder_Util.clearSectionsEdited();var A=!1;if("default"!==e&&"tablet"!==e&&"mobile"!==e&&null===document.querySelector('.customization-wrap[data-customization-name="'+e+'"]')){var L,N=guessLayout(e);e!==N?(L=C.filter(function(e){return N===e.name}),L=L[0].sections,A=!0):L=R}var z=null;A&&(z=R.map(function(e){var t=e.targets.map(function(e){return{name:e.name,props:{}}});return _.merge(_.omit(e,"targets"),{targets:t})})),Rexbuilder_Util.editedDataInfo=new RexEditedData(z?z:R);var E=_mergeSections("undefined"==typeof N?R:L,k);Rexbuilder_Util.removeCollapsedGrids(),Rexbuilder_Util.domUpdating=!0;var P,V,B,M=!1,O=[];for(P in E){var T=E[P],G=T.section_rex_id;if(!T.notInSection||"default"==e){var J={rexID:G,modelID:-1,modelNumber:-1},F="true"==T.section_is_model.toString();if(F){var H=T.section_model_id,j=T.section_model_number;J.modelID=H,J.modelNumber=j,V=Rexbuilder_Util.rexContainer.querySelector('section[data-rexlive-section-id="'+G+'"][data-rexlive-model-number="'+J.modelNumber+'"]')}else V=Rexbuilder_Util.rexContainer.querySelector('section[data-rexlive-section-id="'+G+'"]');var Y=V&&!Rexbuilder_Util.hasClass(V,"removing_section");if(Y){var q="undefined"!=typeof T.section_hide&&"true"==T.section_hide.toString();if(q)Rexbuilder_Util.addClass(V,"rex-hide-section");else{Rexbuilder_Util.removeClass(V,"rex-hide-section"),B=$(V);var Q=_updateDOMelements(B,T.targets,M,P);t.collapse_needed+=Q}O.push(J)}}}return Rexbuilder_Dom_Util.fixSectionDomOrder(O,!0),Rexbuilder_Util.domUpdating=!1,t},_updateDOMelements=function(e,t,i,a){var o=e.find(".grid-stack-row"),r=o.get(0),n=o.data(),s=n.plugin_perfectGridGalleryEditor;t[0].props.gridEdited&&r.setAttribute("data-rexlive-layout-changed",!0),e.removeClass("empty-section");var l=!0;if("undefined"!=typeof n&&"undefined"!=typeof s){for(var d=1,u=t.length;d<u;d++){var c=r.querySelector('div[data-rexbuilder-block-id="'+t[d].name+'"]');if(null!==c){var _="undefined"!=typeof t[d].props.hide&&"true"==t[d].props.hide.toString();l*=_,_?Rexbuilder_Util.hasClass(c,"rex-hide-element")||(Rexbuilder_Util.addClass(c,"rex-hide-element"),s.removeBlock(c)):Rexbuilder_Util.hasClass(c,"rex-hide-element")&&(Rexbuilder_Util.removeClass(c,"rex-hide-element"),s.reAddBlock($(c)))}}s.properties.gridstackInstance.batchUpdate()}l&&e.addClass("empty-section");var d,g,m,p,f,b,c,h,v,y=t.length;for(d=1;d<y;d++)if((!t[d].notDisplay||"default"==Rexbuilder_Util.activeLayout)&&(g=t[d].name,m=t[d].props,p=o.find('.perfect-grid-item[data-rexbuilder-block-id="'+g+'"]'),c=p[0],f=p.children(".rexbuilder-block-data"),b=p.find(".grid-item-content"),p.length>0)){if(h=[].slice.call(c.getElementsByTagName("img")),v=h.length,!Rexbuilder_Util.editorMode&&0!==v){var x;for(x=0;x<v;x++)"true"===h[x].getAttribute("inline-photoswipe")&&Rexbuilder_Photoswipe.addElementFromInline($(h[x]))}var D={$elem:p,targetProps:m,$itemData:f,$itemContent:b,gridstackInstance:Rexbuilder_Util.editorMode?s.properties.gridstackInstance:null,positionAndSize:!0};Rexbuilder_Util.updateDOMSingleElement(D)}updateSection(e,o,t[0].props,i),Rexbuilder_Util.editorMode&&updateSectionTools(e,o,t[0].props,i);var S="undefined"!=typeof t[0].props.collapse_grid&&("true"==t[0].props.collapse_grid.toString()||i);return"undefined"!=typeof n&&"undefined"!=typeof s&&"undefined"!=typeof s.properties.gridstackInstance&&s.properties.gridstackInstance&&(Rexbuilder_Util.domUpdating=!0,s.properties.gridstackInstance.commit(),handlingGridstackCommitEnd(s,S,t,a)),S},_getDefaultBlockMeasure=function(e){e="undefined"!=typeof e?e:"";var t={defDefaultWidth:3,defDefaultHeight:4,defMobileWidth:12,defMobileHeight:null};if(""!==e){var i=$pageCustomizationsDataDiv.find(".customization-wrap");i.each(function(i,a){for(var o=$(a),r=a.getAttribute("data-customization-name"),n=JSON.parse(o.find(".section-targets[data-section-rex-id="+e+"]").text()),s=0,l=n.length;s<l;s++)if("self"===n[s].name){switch(n[s].props.layout){case"masonry":"mobile"==r?t.defMobileHeight=52:t.defDefaultHeight=Math.ceil(4*n[s].props.grid_cell_width/5);break;case"fixed":"mobile"==r?t.defMobileHeight=4:t.defDefaultHeight=4}break}})}return t.defMobileHeight||(t.defMobileHeight=52),t},_updateModelsLive=function(e,t,i){Rexbuilder_Util.domUpdating=!0;var a,o,r=[].slice.call(Rexbuilder_Util.rexContainer.getElementsByClassName("rexpansive_section")),n=r.length;for(a=0;a<n;a++)r[a].getAttribute("data-rexlive-model-id")==e&&r[a].getAttribute("data-rexlive-model-number")!=i&&(o=$(r[a]),_updateDOMelements(o,t,!1));Rexbuilder_Util.domUpdating=!1},_saveCustomizationDomOrder=function(e){var t,i,a,o;$layoutsDomOrder.children().remove();var r=[];for(t=0,a=e.length;t<a;t++){var n=document.createElement("script");for(Rexbuilder_Util.addClass(n,"layout-sections"),n.setAttribute("data-rex-layout-name",e[t].name),r=[],i=0,o=e[t].sections.length;i<o;i++)r.push(e[t].sections[i]);n.textContent=JSON.stringify(r),$(n).appendTo($layoutsDomOrder[0])}},_getPageDefaultDom=function(){var e=$layoutsDomOrder.children('.layout-sections[data-rex-layout-name="default"]');return{name:"default",sections:JSON.parse(e.text())}},_getPageCustomizationsDom=function(){var e=[];return $layoutsDomOrder.children('.layout-sections:not([data-rex-layout-name="default"])').each(function(t,i){var a=$(i);e.push({name:a.attr("data-rex-layout-name"),sections:JSON.parse(a.text())})}),e},_updatePageCustomizationsDomOrder=function(e){for(var t=0,i=e.length;t<i;t++)$layoutsDomOrder.children('.layout-sections[data-rex-layout-name="'+e[t].name+'"]').text(JSON.stringify(e[t].sections))},_getPageAvaiableLayoutsNames=function(){return JSON.parse($availableLayoutNames.text())},_getLayoutLiveSectionTargets=function(e){var t=[];if(e.hasClass("rex-model-section")){var i=e.attr("data-rexlive-model-id");$liveDataContainer.children().each(function(e,a){var o=$(a);if(i==o.attr("data-model-id"))return t=JSON.parse(o.text()),!1})}else{var a=e.attr("data-rexlive-section-id");$liveDataContainer.children().each(function(e,i){var o=$(i);if(a==o.attr("data-section-rex-id"))return t=JSON.parse(o.text()),!1})}return t},_applyDefaultBlocksDimentions=function(e,t,i){for(var a=_getDefaultLayoutState(),o=e.attr("data-rexlive-section-id"),r=0,n=a.length;r<n;r++)if(o==a[r].section_rex_id){var s=a[r],l=s.targets;i.layout=l[0].props.layout,i.fullHeight=l[0].props.full_height,i.collapsed="undefined"!=typeof l[0].props.collapsed&&l[0].props.collapsed;for(var d=1,u=t.length;d<u;d++)for(var c=0,_=l.length;c<_;c++){var g=t[d];g.name==l[c].name&&(g.props.gs_x=l[c].props.gs_x,g.props.gs_y=l[c].props.gs_y,g.props.gs_width=l[c].props.gs_width,g.props.gs_height=l[c].props.gs_height,g.props.gs_start_h=l[c].props.gs_start_h)}break}},_createDefaultLayoutState=function(e){$defaultLayoutState.children().remove();var t,i;for(t=0,i=e.length;t<i;t++){var a=$(document.createElement("script"));a.addClass("section-targets"),a.attr("data-section-rex-id",e[t].section_rex_id),a.attr("data-model-id",e[t].section_model_id),a.attr("data-model-number",e[t].section_model_number),a.attr("data-section-hide",e[t].section_hide),a.text(JSON.stringify(e[t].targets)),a.appendTo($defaultLayoutState[0])}$defaultLayoutState.removeAttr("data-empty-default-customization")},_updateDefaultLayoutState=function(e){var t,i,a,o,r,n,s="undefined"==typeof e.pageData?[]:e.pageData,l="undefined"==typeof e.modelsData?[]:e.modelsData;if(0==s.length)$defaultLayoutState.children(".section-targets").each(function(e,t){var r=$(t),n=isNaN(parseInt(r.attr("data-model-id")))?-1:parseInt(r.attr("data-model-id"));if(n!=-1)for(i=0;i<l.length;i++)if(n==l[i].id){for(a=0,o=l[i].customizations.length;a<o;a++)if("default"==l[i].customizations[a].name){r.text(JSON.stringify(l[i].customizations[a].targets));break}break}});else for($defaultLayoutState.children(".section-targets").remove(),t=0,r=s.length;t<r;t++){var d=$(document.createElement("script"));if(d.addClass("section-targets"),d.attr("data-section-rex-id",s[t].section_rex_id),d.attr("data-model-id",s[t].section_model_id),d.attr("data-model-number",s[t].section_model_number),d.attr("data-section-hide",s[t].section_hide),""==s[t].section_model_id||s[t].section_model_id==-1)d.text(JSON.stringify(s[t].targets));else if(s[t].section_model_id!=-1)for(i=0,n=l.length;i<n;i++)if(s[t].section_model_id==l[i].id){for(a=0,o=l[i].customizations.length;a<o;a++)if("default"==l[i].customizations[a].name){d.text(JSON.stringify(l[i].customizations[a].targets));break}break}d.appendTo($defaultLayoutState[0])}},_updateDefaultLayoutStateDOMOrder=function(e){var t=_getDefaultLayoutState();e=jQuery.extend(!0,[],e);var i,a,o,r,n,s,l=[];for(i=0,o=e.length;i<o;i++)if(e[i].modelID!=-1){for(s=!1,a=0,r=l.length;a<r;a++)if(l[a].id==e[i].modelID){l[a].number=l[a].number+1,e[i].modelNumber=l[a].number,s=!0;break}s||(l.push({id:e[i].modelID,number:1}),e[i].modelNumber=1)}var d,u=[];for(i=0,o=e.length;i<e;i++){for(a=0,n=t.length;a<n;a++)e[i].modelID!=-1?e[i].modelID==t[a].section_model_id&&e[i].modelNumber==t[a].section_model_number&&(d=t.splice(a,1)):e[i].rexID==t[a].section_rex_id&&(d=t.splice(a,1));u.push(d[0])}_updateDefaultLayoutState({pageData:u})},_updateDefaultLayoutStateSection=function(e,t){var i=e[0];t="undefined"==typeof t?-1:t,Rexbuilder_Dom_Util.fixModelNumbers();var a=Rex_Save_Listeners.createTargets(e,Rexbuilder_Util.activeLayout),o=!1;if(hasClass(i,"rex-model-section")){var r,n=i.getAttribute("data-rexlive-model-id"),s=i.getAttribute("data-rexlive-section-number"),l=[].slice.call($defaultLayoutState[0].getElementsByClassName("section-targets")),d=l.length;for(r=0;r<d;r++)n==l[r].getAttribute("data-model-id")&&(l[r].textContent=JSON.stringify(a),s==l[r].getAttribute("data-model-number")&&(o=!0))}else{var r,u=i.getAttribute("data-rexlive-section-id"),l=[].slice.call($defaultLayoutState[0].getElementsByClassName("section-targets")),d=l.length;for(r=0;r<d;r++)u==l[r].getAttribute("data-section-rex-id")&&(l[r].textContent=JSON.stringify(a),o=!0)}if(!o){var c={section_rex_id:i.getAttribute("data-rexlive-section-id"),section_is_model:!1,section_model_id:"",section_model_number:-1,section_hide:!1};c.section_hide=hasClass(i,"rex-hide-section"),hasClass(i,"rex-model-section")&&(c.section_is_model=!0,c.section_model_id=i.getAttribute("data-rexlive-model-id"),c.section_model_number=i.getAttribute("data-rexlive-model-number"));var _=document.createElement("script");addClass(_,"section-targets"),_.setAttribute("data-section-rex-id",c.section_rex_id),_.setAttribute("data-model-id",c.section_model_id),_.setAttribute("data-model-number",c.section_model_number),_.setAttribute("data-section-hide",c.section_hide),_.textContent=JSON.stringify(a);var g=$(_);if(t==-1)g.appendTo($defaultLayoutState[0]);else{var m;t-=1,$defaultLayoutState.children(".section-targets").each(function(e,i){if(e==t)return m=$(i),!1}),m.after(g[0])}}},_getDefaultLayoutState=function(){var e=[];return $defaultLayoutState.children(".section-targets").each(function(t,i){var a=$(i),o=a.attr("data-section-rex-id"),r=isNaN(parseInt(a.attr("data-model-id")))?-1:parseInt(a.attr("data-model-id")),n=isNaN(parseInt(a.attr("data-model-number")))?-1:parseInt(a.attr("data-model-number")),s="undefined"!=typeof a.attr("data-section-hide")&&"1"==a.attr("data-section-hide").toString(),l=""!=a.text()?JSON.parse(a.text()):[];e.push({section_rex_id:o,section_model_id:r!=-1?r:"",section_model_number:n!=-1?n:"",section_is_model:r!=-1,section_hide:s,targets:l})}),e},_updateSectionOrderCustomLayouts=function(e,t){var i,a,o,r,n,s,l,d=Rexbuilder_Util.getPageCustomizationsDom();for(o=0,n=t.length;o<n;o++)if(t[o].rexID==e.rexID&&t[o].modelNumber==e.modelNumber&&t[o].modelID==e.modelID){a=o;break}for(o=0,s=d.length;o<s;o++){for(i=!1,r=0,l=d[o].sections.length;r<l;r++)if(d[o].sections[r].section_is_model){if(d[o].sections[r].section_model_id==e.modelID&&d[o].sections[r].section_model_number==e.modelNumber){"undefined"!=typeof d[o].sections[r].section_created_live&&"true"==d[o].sections[r].section_created_live.toString()&&(i=!0);break}}else if(e.rexID==d[o].sections[r].section_rex_id){"undefined"!=typeof d[o].sections[r].section_created_live&&"true"==d[o].sections[r].section_created_live.toString()&&(i=!0);break}if(i){var u=d[o].sections.splice(r,1)[0];d[o].sections.splice(a,0,u)}}Rexbuilder_Util.updatePageCustomizationsDomOrder(d)},_updateSectionStateLive=function(e){Rexbuilder_Dom_Util.fixModelNumbers();var t=Rex_Save_Listeners.createTargets(e,Rexbuilder_Util.activeLayout),i=!1;if(e.hasClass("rex-model-section")){var a=e.attr("data-rexlive-model-id");$liveDataContainer.children().each(function(e,o){var r=$(o);a==r.attr("data-model-id")&&(r.text(JSON.stringify(t)),i=!0)})}else{var o=e.attr("data-rexlive-section-id");$liveDataContainer.children().each(function(e,a){var r=$(a);o==r.attr("data-section-rex-id")&&(r.text(JSON.stringify(t)),i=!0)})}if(!i){var r={section_rex_id:e.attr("data-rexlive-section-id"),section_is_model:!1,section_model_id:"",section_model_number:-1,section_hide:!1};r.section_hide=e.hasClass("rex-hide-section"),e.hasClass("rex-model-section")&&(r.section_is_model=!0,r.section_model_id=e.attr("data-rexlive-model-id"),r.section_model_number=e.attr("data-rexlive-model-number"));var n=$(document.createElement("script"));n.addClass("section-targets"),n.attr("data-section-rex-id",r.section_rex_id),n.attr("data-model-id",r.section_model_id),n.attr("data-model-number",r.section_model_number),n.attr("data-section-hide",r.section_hide),n.text(JSON.stringify(t)),n.appendTo($liveDataContainer[0])}},_getGridLayoutLive=function(e){var t,i={layout:"fixed",fullHeight:!1,collapsed:!1};if(e.hasClass("rex-model-section")){var a=e.attr("data-rexlive-model-id");$liveDataContainer.children(".section-targets").each(function(e,i){var o=$(i);a==o.attr("data-model-id")&&(t=JSON.parse(o.text()))})}else{var o=e.attr("data-rexlive-section-id");$liveDataContainer.children(".section-targets").each(function(e,i){var a=$(i);o==a.attr("data-section-rex-id")&&(t=JSON.parse(a.text()))})}return i.layout=t[0].props.layout,i.fullHeight=t[0].props.full_height,i.collapsed=t[0].props.collapse_grid,i},_getLayoutSectionTargets=function(e,t){t="undefined"==typeof t?"default":t;var i,a,o,r,n,s,l=[];if(e.hasClass("rex-model-section")){var d=e.attr("data-rexlive-model-id"),u=_getModelsCustomizations();for(i=0,o=u.length;i<o;i++)if(u[i].id==d){for(a=0,r=u[i].customizations.length;a<r;a++)if(u[i].customizations[a].name==t){l=jQuery.extend(!0,[],u[i].customizations[a].targets);break}break}}else{var c=e.attr("data-rexlive-section-id"),_=_getPageCustomizations();for(i=0,n=_.length;i<n;i++)if(_[i].name==t&&"undefined"!=typeof _[i].sections){for(a=0,s=_[i].sections.length;a<s;a++)if(_[i].sections[a].section_rex_id==c){l=jQuery.extend(!0,[],_[i].sections[a].targets);break}break}}return l},_getDefaultBlockProps=function(e,t){var i,a,o=_getLayoutSectionTargets(e,"default"),r={};for(i=1,a=o.length;i<a;i++)if(o[i].name==t){r=jQuery.extend(!0,{},o[i].props);break}return r},_getGridLayout=function(e,t){t="undefined"==typeof t?"default":t;var i,a,o,r,n,s,l={layout:"fixed",fullHeight:!1,collapsed:!1};if(e.hasClass("rex-model-section")){var d=e.attr("data-rexlive-model-id"),u=_getModelsCustomizations();for(i=0,o=u.length;i<o;i++)if(u[i].id==d){for(a=0,r=u[i].customizations.length;a<r;a++)if(u[i].customizations[a].name==t){l.layout=u[i].customizations[a].targets[0].props.layout,l.fullHeight=u[i].customizations[a].targets[0].props.full_height,l.collapsed=u[i].customizations[a].targets[0].props.collapse_grid;break}break}}else{var c=e.attr("data-rexlive-section-id"),_=_getPageCustomizations();for(i=0,n=_.length;i<n;i++)if(_[i].name==t&&"undefined"!=typeof _[i].sections&&null!==typeof _[i].sections){for(a=0,s=_[i].sections.length;a<s;a++)if(_[i].sections[a].section_rex_id==c){0!=_[i].sections[a].targets.length&&(l.layout=_[i].sections[a].targets[0].props.layout,l.fullHeight=_[i].sections[a].targets[0].props.full_height,l.collapsed=_[i].sections[a].targets[0].props.collapse_grid);break}break}}return l},_customizationExists=function(e){var t,i,a=!1,o=[];for(""!=$availableLayoutNames.text()&&(o=JSON.parse($availableLayoutNames.text())),t=0,i=o.length;t<i;t++)if(o[t]==e){a=!0;break}return a},updateSection=function(e,t,i,a){var o=e.children(".section-data"),r=isNaN(parseInt(i.video_bg_id))?"":parseInt(i.video_bg_id),n="undefined"==typeof i.video_bg_url_section?"":i.video_bg_url_section,s="undefined"==typeof i.video_bg_url_vimeo_section?"":i.video_bg_url_vimeo_section,l="";""!=r?l="mp4":""!=s?l="vimeo":""!=n&&(l="youtube");var d="undefined"!==i.custom_classes&&-1!==i.custom_classes.indexOf("rex-video--with-audio"),u={mp4Data:{idMp4:r,linkMp4:"undefined"==typeof i.video_mp4_url?"":i.video_mp4_url,width:"undefined"==typeof i.video_bg_width_section?"":i.video_bg_width_section,height:"undefined"==typeof i.video_bg_height_section?"":i.video_bg_height_section},vimeoUrl:s,youtubeUrl:n,audio:d,typeVideo:l};Rexbuilder_Dom_Util.updateSectionVideoBackground(e,u);var c={active:"undefined"==typeof i.image_bg_section_active||i.image_bg_section_active.toString(),idImage:isNaN(parseInt(i.id_image_bg_section))?"":parseInt(i.id_image_bg_section),urlImage:i.image_bg_section,width:parseInt(i.image_width),height:parseInt(i.image_height)},_={color:i.row_overlay_color,active:"undefined"!=typeof i.row_overlay_active&&i.row_overlay_active.toString()};Rexbuilder_Dom_Util.updateImageBG(e,c);var g={color:"undefined"!=typeof i.color_bg_section?i.color_bg_section:"",active:"undefined"==typeof i.color_bg_section_active||i.color_bg_section_active.toString()};-1===g.color.indexOf("gradient")?Rexbuilder_Dom_Util.updateSectionBackgroundColor(e,g):Rexbuilder_Dom_Util.updateSectionBackgroundGradient(e,g),-1===_.color.indexOf("gradient")?Rexbuilder_Dom_Util.updateSectionOverlay(e,_):Rexbuilder_Dom_Util.updateSectionOverlayGradient(e,_);var m={top:isNaN(parseInt(i.row_margin_top))?0:parseInt(i.row_margin_top),right:isNaN(parseInt(i.row_margin_right))?0:parseInt(i.row_margin_right),bottom:isNaN(parseInt(i.row_margin_bottom))?0:parseInt(i.row_margin_bottom),left:isNaN(parseInt(i.row_margin_left))?0:parseInt(i.row_margin_left)};Rexbuilder_Dom_Util.updateSectionMarginsData(e,m),-1!==i.custom_classes.indexOf("rex-block-grid")&&(i.collapse_grid=!1,i.layout=o.attr("data-layout"));var p={gutter:i.block_distance,top:i.row_separator_top,bottom:i.row_separator_bottom,right:i.row_separator_right,left:i.row_separator_left,full_height:i.full_height,layout:i.layout,section_width:i.section_width,dimension:i.dimension,collapse_grid:"undefined"!=typeof i.collapse_grid&&("true"==i.collapse_grid.toString()||a),noMobileLayoutSaved:!!i.noMobileLayoutSaved};Rexbuilder_Dom_Util.updateRow(e,o,t,p);var f="undefined"==typeof i.section_name?"":i.section_name;Rexbuilder_Dom_Util.updateSectionName(e,f),e.attr("data-type",i.type);var b="undefined"==typeof i.custom_classes?"":i.custom_classes,h=[];""!=b&&(b=b.trim(),h=b.split(/\s+/)),Rexbuilder_Dom_Util.updateCustomClasses(e,h);var v="undefined"!=typeof i.section_edited&&"true"==i.section_edited.toString();e.attr("data-rexlive-section-edited",v)},updateSectionTools=function(e,t,i,a){var o={top:isNaN(parseInt(i.row_margin_top))?0:parseInt(i.row_margin_top),right:isNaN(parseInt(i.row_margin_right))?0:parseInt(i.row_margin_right),bottom:isNaN(parseInt(i.row_margin_bottom))?0:parseInt(i.row_margin_bottom),left:isNaN(parseInt(i.row_margin_left))?0:parseInt(i.row_margin_left)};Rexbuilder_Section.fixSectionToolbox(e,o),-1!==i.custom_classes.indexOf("rex-block-grid")&&(i.collapse_grid=!1);var r={gutter:i.block_distance,top:i.row_separator_top,bottom:i.row_separator_bottom,right:i.row_separator_right,left:i.row_separator_left,full_height:i.full_height,layout:i.layout,section_width:i.section_width,dimension:i.dimension,collapse_grid:"undefined"!=typeof i.collapse_grid&&("true"==i.collapse_grid.toString()||a)};Rexbuilder_Section.fixBlockToolsAccordingToSeparator(e,r)},updateElementDimensions=function(e,t,i){var a=parseInt(i.x),o=parseInt(i.y),r=parseInt(i.w),n=parseInt(i.h),s=parseInt(i.startH),l=(parseInt(i.increaseHeight),parseInt(i.realFluid));"undefined"!=typeof i.gridstackInstance&&i.gridstackInstance?i.gridstackInstance.update(e,a,o,r,n):(e.setAttribute("data-gs-height",n),e.setAttribute("data-gs-width",r),e.setAttribute("data-gs-y",o),e.setAttribute("data-gs-x",a)),t.setAttribute("data-gs_start_h",s),t.setAttribute("data-gs_width",r),t.setAttribute("data-gs_height",n),t.setAttribute("data-gs_y",o),t.setAttribute("data-gs_x",a),t.setAttribute("data-element_real_fluid",l)},_detect_mobile=function(){"ontouchstart"in document.documentElement?Rexbuilder_Util.addClass(document.body,"touch"):Rexbuilder_Util.addClass(document.body,"no-touch")},_viewport=function(){var e=window,t="inner";return"innerWidth"in window||(t="client",e=document.documentElement||document.body),{width:e[t+"Width"],height:e[t+"Height"]}},_merge=function(e,t){var i={},a=function(e){for(var t in e)e.hasOwnProperty(t)&&("[object Object]"===Object.prototype.toString.call(e[t])?i[t]=merge(i[t],e[t]):i[t]=e[t])};return a(e),a(t),i},getYoutubeID=function(e){var t;return t=e.indexOf("youtu.be")>0?e.substr(e.lastIndexOf("/")+1,e.length):e.indexOf("http")>-1?e.match(/[\\?&]v=([^&#]*)/)[1]:e.length>15?null:e},_checkPresentationPage=function(){return 0!==$(".rexpansive_portfolio_presentation").length},_checkStaticPresentationPage=function(){return 0!==$(".rexpansive-static-portfolio").length},_checkPost=function(){return 0!==$("#rex-article").length},_whichTransitionEvent=function(){var e,t=document.createElement("fakeelement"),i={transition:"transitionend",OTransition:"oTransitionEnd",MozTransition:"transitionend",WebkitTransition:"webkitTransitionEnd"};for(e in i)if(void 0!==t.style[e])return i[e]},_whichAnimationEvent=function(){var e,t=document.createElement("fakeelement"),i={animation:"animationend",OAnimation:"oAnimationEnd",MozAnimation:"animationend",WebkitAnimation:"webkitAnimationEnd"};for(e in i)if(void 0!==t.style[e])return i[e]},doneResizing=function(){if(Rexbuilder_Util.windowIsResizing=!0,Rexbuilder_Util.editorMode){if(!Rexbuilder_Util_Editor.changedLayout)return"default"===Rexbuilder_Util.chosenLayoutData.id&&_updateGridsHeights(),void(Rexbuilder_Util.windowIsResizing=!1);Rexbuilder_Util_Editor.changedLayout=!1;var e=edit_dom_layout(Rexbuilder_Util_Editor.clickedLayoutID);0===e.collapse_needed?Rexbuilder_Util_Editor.endLoading():Rexbuilder_Util.$document.one("rexlive:collapsingElementsEnded",function(e){Rexbuilder_Util_Editor.endLoading()})}Rexbuilder_Util.windowIsResizing=!1,Rexbuilder_Util.loadWidth=Rexbuilder_Util.globalViewport.width},_set_initial_grids_state=function(e){if(e="undefined"!=typeof e?e:"default",Rexbuilder_Util.rexContainer){var t,i=[].slice.call(Rexbuilder_Util.rexContainer.getElementsByClassName("rexpansive_section")),a=i.length;for(t=0;t<a;t++){for(var o=$(i[t]),r=o.find(".grid-stack-row"),n=r.data().plugin_perfectGridGalleryEditor,s=Rexbuilder_Util.getSectionCustomLayouts(i[t].getAttribute("data-rexlive-section-id")),l=null,d=null,u=0;u<s.length;u++){if("default"===s[u].name&&(d=u),s[u].name===e){l=u;break}u==s.length-1&&(l=d)}for(var c=[],u=0,_=s[l].targets.length;u<_;u++)if("self"!==s[l].targets[u].name){var g={};g.el=o.find(".perfect-grid-item[data-rexbuilder-block-id="+s[l].targets[u].name+"]"),g.x=parseInt(s[l].targets[u].props.gs_x),g.y=parseInt(s[l].targets[u].props.gs_y),g.width=parseInt(s[l].targets[u].props.gs_width),g.height=parseInt(s[l].targets[u].props.gs_height),c.push(g)}n.set_grid_initial_state(c)}}},_updateGridsHeights=function(){if(Rexbuilder_Util.rexContainer){var e,t,i,a=[].slice.call(Rexbuilder_Util.rexContainer.getElementsByClassName("grid-stack-row")),o=a.length;for(e=0;e<o;e++){t=$(a[e]),i=t.data().plugin_perfectGridGalleryEditor,void 0!==i&&(i.batchGridstack(),i._defineDynamicPrivateProperties(),i.updateGridstackStyles(),i.setFullWidthNaturalBackground(),i.setNaturalBackground(),i.updateBlocksHeight(),i.commitGridstack());var r=jQuery.Event("rexlive:updateGridsHeights");r.settings={$row:t},Rexbuilder_Util.$document.trigger(r)}}},_stopBlockVideos=function(e){_stopVideo(e.find(".grid-item-content"))},_playBlockVideos=function(e){_playVideoFromBegin(e.find(".grid-item-content"))},_stopPluginsSection=function(e){var t=e.find(".mp4-player"),i=e.find(".vimeo-player"),a=e.find(".youtube-player");$.each(t,function(e,t){Rexbuilder_Util.stopVideo($(t))}),$.each(i,function(e,t){Rexbuilder_Util.stopVideo($(t))}),$.each(a,function(e,t){Rexbuilder_Util.stopVideo($(t))})},_playPluginsSection=function(e){var t=e.find(".mp4-player"),i=e.find(".vimeo-player"),a=e.find(".youtube-player");Rexbuilder_Util.editorMode&&$.each(t,function(e,t){Rexbuilder_Util.playVideoFromBegin($(t))}),$.each(i,function(e,t){Rexbuilder_Util.playVideoFromBegin($(t))}),$.each(a,function(e,t){Rexbuilder_Util.playVideoFromBegin($(t))})},_stopVideo=function(e){if(e.hasClass("mp4-player")){var t=e.children(".rex-video-wrap").find("video")[0];t.currentTime=0,t.pause()}else if(e.hasClass("vimeo-player")){var i=VimeoVideo.findVideo(e.children(".rex-video-vimeo-wrap").find("iframe")[0]);i&&i.unload()}else if(e.hasClass("youtube-player")){if(void 0===e.children(".rex-youtube-wrap").YTPGetPlayer())return;e.children(".rex-youtube-wrap").YTPStop()}},_fixVideosAudioSection=function(e){var t=e.find(".mp4-player"),i=e.find(".vimeo-player"),a=e.find(".youtube-player");Rexbuilder_Util.fixVideoAudio(e),$.each(t,function(e,t){Rexbuilder_Util.fixVideoAudio($(t))}),$.each(i,function(e,t){Rexbuilder_Util.fixVideoAudio($(t))}),$.each(a,function(e,t){Rexbuilder_Util.fixVideoAudio($(t))})},_fixYoutube=function(e){var t,i=[].slice.call(e.getElementsByClassName("rex-youtube-wrap")),a=i.length;for(t=0;t<a;t++){var o=$(i[t]),r=o.parents(".youtube-player").eq(0).children(".rex-video-toggle-audio"),n=o.YTPGetPlayer();void 0!==n&&(o.optimizeDisplay(),o.YTPPlay(),0==r.length||r.hasClass("user-has-muted")?(n.mute(),n.isMute=!0,n.setVolume(0)):o.YTPUnmute())}},_fixVideoAudio=function(e){var t=e.children("rex-video-toggle-audio");if(e.hasClass("mp4-player")){var i=e.children(".rex-video-wrap").find("video")[0];0==t.length||t.hasClass("user-has-muted")?$(i).prop("muted",!0):$(i).prop("muted",!1)}else if(e.hasClass("vimeo-player")){var a=VimeoVideo.findVideo(e.children(".rex-video-vimeo-wrap").find("iframe")[0]);0==t.length||t.hasClass("user-has-muted")?a&&a.setVolume(0):a.setVolume(1)}else if(e.hasClass("youtube-player")){var o=e.children(".rex-youtube-wrap"),r=o.YTPGetPlayer();void 0!==r&&(0==t.length||t.hasClass("user-has-muted")?(r.mute(),r.isMute=!0,r.setVolume(0)):o.YTPUnmute())}},_playVideoFromBegin=function(e){var t=!1;if(e.hasClass("mp4-player")){var i=e.children(".rex-video-wrap").find("video")[0];i.currentTime=0,i.play(),t=!0}else if(e.hasClass("vimeo-player")){var a=VimeoVideo.findVideo(e.children(".rex-video-vimeo-wrap").find("iframe")[0]);null!==a&&a.play(),t=!0}else if(e.hasClass("youtube-player")){var o=e.children(".rex-youtube-wrap");if(0==o.length)return;var r=o.YTPGetPlayer();if(void 0===r)return;o.YTPPlay(),t=!0}t&&setTimeout(Rexbuilder_Util.fixVideoAudio.bind(null,e),500)},setContainer=function(e){this.$rexContainer=e},_parents=function(e,t){for(;e.parentNode;){if(_matches(e,t))return e;e=e.parentNode}return null},_matches=function(e,t){return(e.matches||e.matchesSelector||e.msMatchesSelector||e.mozMatchesSelector||e.webkitMatchesSelector||e.oMatchesSelector).call(e,t)},_transitionEvent="",_animationEvent="",removeCollapsedGrids=function(){if(Rexbuilder_Util.rexContainer&&Rexbuilder_Util.galleryPluginActive){var e,t=[].slice.call(Rexbuilder_Util.rexContainer.getElementsByClassName("rexpansive_section")),i=t.length;for(e=0;e<i;e++){var a=getGalleryInstance($(t[e]));Rexbuilder_Dom_Util.collapseGrid(a,!1,a.properties.dispositionBeforeCollapsing,a.properties.layoutBeforeCollapsing)}}},collapseAllGrids=function(){if(Rexbuilder_Util.rexContainer&&Rexbuilder_Util.galleryPluginActive){var e,t=[].slice.call(Rexbuilder_Util.rexContainer.getElementsByClassName("rexpansive_section")),i=t.length;for(e=0;e<i;e++){var a=getGalleryInstance($(t[e]));a._defineDynamicPrivateProperties(),a.collapseElements()}}},_destroyVideo=function(e,t){var i="";return e.hasClass("mp4-player")?(i="mp4",Rexbuilder_Dom_Util.removeMp4Video(e,t)):e.hasClass("vimeo-player")?(i="vimeo",Rexbuilder_Dom_Util.removeVimeoVideo(e,t)):e.hasClass("youtube-player")&&(i="youtube",Rexbuilder_Dom_Util.removeYoutubeVideo(e,t)),i},_pauseVideo=function(e){if(e.hasClass("mp4-player"))e.children(".rex-video-wrap").find("video")[0].pause();else if(e.hasClass("vimeo-player")){var t=VimeoVideo.findVideo(e.find(".rex-video-vimeo-wrap").find("iframe")[0]);
t.pause()}else if(e.hasClass("youtube-player")){if(void 0===e.children(".rex-youtube-wrap").YTPGetPlayer())return;e.children(".rex-youtube-wrap").YTPPause()}},_launchVideoPlugins=function(){if(Rexbuilder_Util.rexContainer&&"undefined"!=typeof Rexbuilder_Util.rexContainer){var ytVideos=[].slice.call(Rexbuilder_Util.rexContainer.getElementsByClassName("rex-youtube-wrap")),i,tot_ytVideos=ytVideos.length,$ytVideo,data_yt,url,id;if(jQuery.browser.mobile)for(i=0;i<tot_ytVideos;i++)data_yt=eval("("+ytVideos[i].getAttribute("data-property")+")"),url=data_yt.videoURL,id=getYoutubeID(url),ytVideos[i].style.backgroundImage="url(https://img.youtube.com/vi/"+id+"/0.jpg)",ytVideos[i].addEventListener("click",handleYtbVideoMobileClick);else for(i=0;i<tot_ytVideos;i++){if($ytVideo=$(ytVideos[i]),void 0===$ytVideo.YTPGetPlayer()&&!Rexbuilder_Util.hasClass(ytVideos[i],"youtube-player-launching"))return void $ytVideo.YTPlayer();Rexbuilder_Util.removeClass(ytVideos[i],"youtube-player-launching")}VimeoVideo.init()}},_playAllVideos=function(){if(Rexbuilder_Util.rexContainer&&"undefined"!=typeof Rexbuilder_Util.rexContainer){var e,t=[].slice.call(Rexbuilder_Util.rexContainer.getElementsByClassName("mp4-player")),i=[].slice.call(Rexbuilder_Util.rexContainer.getElementsByClassName("vimeo-player")),a=[].slice.call(Rexbuilder_Util.rexContainer.getElementsByClassName("youtube-player")),o=t.length,r=i.length,n=a.length;if(Rexbuilder_Util.editorMode)for(e=0;e<o;e++)Rexbuilder_Util.playVideo($(t[e]));for(e=0;e<r;e++)Rexbuilder_Util.playVideo($(i[e]));for(e=0;e<n;e++)Rexbuilder_Util.playVideo($(a[e]))}},_playVideo=function(e){var t=e[0];if("undefined"!=typeof t)if(Rexbuilder_Util.hasClass(t,"mp4-player")){var i=t.querySelector("video");i&&i.play()}else if(Rexbuilder_Util.hasClass(t,"vimeo-player")){var a=VimeoVideo.findVideo(t.querySelector("iframe"));a&&a.play()}else if(Rexbuilder_Util.hasClass(t,"youtube-player")){var o=t.querySelector(".rex-youtube-wrap");if(!o)return;var r=$(o);if(void 0===r.YTPGetPlayer())return;r.YTPPlay()}},_getPaddingsDataString=function(e){var t={top:"5",right:"5",bottom:"5",left:"5",type:"px"};if(""!=e){var i=e.split(/;/gm);t.top=parseInt(i[0].split(/\D+/gm)[0]),t.right=parseInt(i[1].split(/\D+/gm)[0]),t.bottom=parseInt(i[2].split(/\D+/gm)[0]),t.left=parseInt(i[3].split(/\D+/gm)[0]);var a="";a=i[0].indexOf("%")!=-1?"%":"px",t.type=a}return t},_paddingsToString=function(e){var t="";return t+=""+e.top+e.type+";",t+=""+e.right+e.type+";",t+=""+e.bottom+e.type+";",t+=""+e.left+e.type+";"},getCoord=function(e,t){return t="undefined"!=typeof t?t:12,{x:e%t,y:Math.floor(e/t)}},_diffStrings=function(e,t){t="undefined"!=typeof t?t:" ";for(var i=e.join(" "),a=i.split(t),o={},r=[],n=0,s=a.length;n<s;n++)o[a[n]]="undefined"!=typeof o[a[n]]?o[a[n]]+1:1;for(var l in o)1===o[l]&&r.push(l);return r},init=function(){this.globalViewport=Rexbuilder_Util.viewport(),this.firstStart=!0,this.isIframe=window.location!==window.parent.location,_plugin_frontend_settings.scroll_animation_offset=0,Rexbuilder_Util.changedFrontLayout=!1,_plugin_frontend_settings.user.logged&&_plugin_frontend_settings.user.editing?this.editorMode=!0:this.editorMode=!1,this._transitionEvent=_whichTransitionEvent(),this._animationEvent=_whichAnimationEvent(),this.$window=$(window),this.$document=$(document),this.$body=$("body"),$bodyHtml=$("body, html"),this.galleryPluginActive=!1,_detect_mobile(),$rexbuilderLayoutData=$(document.getElementById("rexbuilder-layout-data")),$rexbuilderModelData=$(document.getElementById("rexbuilder-model-data")),$availableLayoutNames=$(document.getElementById("available-layouts-names"));var e=$(document.getElementById("layout-avaiable-dimensions"));frontAvailableLayouts=e.length>0?JSON.parse(e.text()):[];var t=$availableLayoutNames.text();layoutSavedInfo=frontAvailableLayouts.filter(function(e){return-1!==t.indexOf(e.id)}),this.editorMode||(Rexbuilder_Util.startFrontLayout=_findFrontLayout()),$modelsCustomizationsDataDiv=$("#rexbuilder-model-data").children(".models-customizations").eq(0),$pageCustomizationsDataDiv=$rexbuilderLayoutData.children(".layouts-customizations").eq(0),$liveDataContainer=$("#rexbuilder-layout-data-live"),$layoutsDomOrder=$("#rexbuilder-layouts-sections-order"),$defaultLayoutState=$("#rexbuilder-default-layout-state"),$usedIDSContainer=$("#sections-ids-used"),_storeNamesUsed(),$usedBlocksIDsContainer=$("#blocks-ids-used"),_storeBlocksIDsUsed(),this.$rexContainer=$(".rex-container"),this.rexContainer=this.$rexContainer[0],0===this.$rexContainer.length&&console.warn("[Rexpansive] No rexContainer detected! This may cause problems."),this.backendEdited=!1,Rexbuilder_Util.$rexContainer.length>0&&"true"==Rexbuilder_Util.$rexContainer.attr("data-backend-edited").toString()&&(Rexbuilder_Util.$rexContainer.addClass("backend-edited"),this.backendEdited=!0),this.lastSectionNumber=-1,this.activeLayout="",this.domUpdating=!1;var i=this.$rexContainer.children(".rexpansive_section").eq(0).attr("data-rex-collapse-grid");this.blockGridUnder768="undefined"!=typeof i&&"false"==i.toString(),this.chosenLayoutData=null,this.loadWidth=Rexbuilder_Util.globalViewport.width,_updateSectionsIDs(),_updateBlocksIDs(),Rexbuilder_Dom_Util.fixModelNumbers(),_updateSectionsNumber(),this.firstStart=!1};return{init:init,viewport:_viewport,getYoutubeID:getYoutubeID,transitionEvent:_transitionEvent,animationEvent:_animationEvent,checkPresentationPage:_checkPresentationPage,checkStaticPresentationPage:_checkStaticPresentationPage,editorMode:editorMode,windowIsResizing:windowIsResizing,launchVideoPlugins:_launchVideoPlugins,stopPluginsSection:_stopPluginsSection,playPluginsSection:_playPluginsSection,stopBlockVideos:_stopBlockVideos,playBlockVideos:_playBlockVideos,chooseLayout:chooseLayout,predictLayout:predictLayout,setContainer:setContainer,createRandomID:createRandomID,createRandomNumericID:_createRandomNumericID,responsiveLayouts:responsiveLayouts,defaultLayoutSections:defaultLayoutSections,launchEditDomLayout:launchEditDomLayout,edit_dom_layout:edit_dom_layout,smoothScroll:_smoothScroll,getGalleryInstance:getGalleryInstance,removeCollapsedGrids:removeCollapsedGrids,collapseAllGrids:collapseAllGrids,stopVideo:_stopVideo,playVideoFromBegin:_playVideoFromBegin,pauseVideo:_pauseVideo,playVideo:_playVideo,destroyVideo:_destroyVideo,startVideoPlugin:startVideoPlugin,getPaddingsDataString:_getPaddingsDataString,paddingsToString:_paddingsToString,playAllVideos:_playAllVideos,findLayoutType:_findLayoutType,updateModelsLive:_updateModelsLive,getLayoutSectionTargets:_getLayoutSectionTargets,updateElementDimensions:updateElementDimensions,getGridLayout:_getGridLayout,customizationExists:_customizationExists,getDefaultBlockProps:_getDefaultBlockProps,fixVideosAudioSection:_fixVideosAudioSection,fixVideoAudio:_fixVideoAudio,fixYoutube:_fixYoutube,saveCustomizationDomOrder:_saveCustomizationDomOrder,getDefaultPageLayout:_getDefaultPageLayout,getModelsCustomizations:_getModelsCustomizations,updateModelsCustomizationsData:_updateModelsCustomizationsData,getPageCustomizations:_getPageCustomizations,updatePageCustomizationsData:_updatePageCustomizationsData,updatePageAvaiableLayoutsNames:_updatePageAvaiableLayoutsNames,getPageAvaiableLayoutsNames:_getPageAvaiableLayoutsNames,updateDivModelCustomizationsNames:_updateDivModelCustomizationsNames,getSectionCustomLayouts:_getSectionCustomLayouts,getLayoutLiveSectionTargets:_getLayoutLiveSectionTargets,getGridLayoutLive:_getGridLayoutLive,getCustomLayoutSections:_getCustomLayoutSections,updateSectionStateLive:_updateSectionStateLive,updatePageCustomizationsDomOrder:_updatePageCustomizationsDomOrder,getPageDefaultDom:_getPageDefaultDom,getPageCustomizationsDom:_getPageCustomizationsDom,updateDefaultLayoutState:_updateDefaultLayoutState,updateDefaultLayoutStateSection:_updateDefaultLayoutStateSection,updateDefaultLayoutStateDOMOrder:_updateDefaultLayoutStateDOMOrder,getDefaultLayoutState:_getDefaultLayoutState,updateSectionOrderCustomLayouts:_updateSectionOrderCustomLayouts,updateGridsHeights:_updateGridsHeights,updateDOMSingleElement:updateDOMSingleElement,getDefaultBlockMeasure:_getDefaultBlockMeasure,doneResizing:doneResizing,getCoord:getCoord,diffStrings:_diffStrings,applyDefaultBlocksDimentions:_applyDefaultBlocksDimentions,isMobile:_isMobile,cssPropertyValueSupported:_cssPropertyValueSupported,changedFrontLayout:changedFrontLayout,startFrontLayout:startFrontLayout,findFrontLayout:_findFrontLayout,parents:_parents,rtimeOut:rtimeOut,rInterval:rInterval,merge:_merge,handleLayoutChange:handleLayoutChange,removeArrayDuplicates:removeArrayDuplicates,isOrIsChild:isOrIsChild,hasClass:hasClass,addClass:addClass,removeClass:removeClass,toggleClass:toggleClass,createSectionID:_createSectionID,addSectionID:_addSectionID,removeSectionID:_removeSectionID,saveSectionNamesUsed:_saveSectionNamesUsed,getSectionNamesUsed:_getSectionNamesUsed,createBlockID:createBlockID,addBlockID:addBlockID,removeBlockID:removeBlockID,saveBlocksIDsUsed:saveBlocksIDsUsed,updateBlocksIDsUsed:updateBlocksIDsUsed,getBlocksIDsUsed:getBlocksIDsUsed,clearSectionsEdited:clearSectionsEdited,displayError:displayError,displayAjaxError:displayAjaxError}}(jQuery);
var Rexbuilder_Photoswipe=function(e){"use strict";function t(e){for(var t,r,i,n,l=e.length,a=0,p=0;a<l;a++)for(t=Array.prototype.slice.call(e[a].querySelectorAll(".rex-slider-element")),r=t.length,p=0;p<r;p++)i=t[p].querySelector(".pswp-item"),n=t[p].querySelector(".slider-overlay"),i&&n&&i.appendChild(n)}var r="",i=function(e){var t=e.target,r=t.getAttribute("data-inline-pswp-info");if("undefined"!=typeof r&&""!==r){var i=document.querySelectorAll(".pswp")[0],n=!1,l=JSON.parse(r),a={galleryUID:t.getAttribute("data-pswp-uid"),closeOnScroll:!1,showHideOpacity:!0};n&&(a.showAnimationDuration=0);var p=new PhotoSwipe(i,PhotoSwipeUI_Default,l,a);p.init()}},n=function(e,t,r,i,n){if(!e.parents(".grid-stack-item").hasClass("block-has-slider")){tmpl.arg="image";var l=e.parents(".grid-stack-item-content");if(0==e.parents(".pswp-figure").length){e.parent().prepend(tmpl("tmpl-photoswipe-block",{link:t,width:r,height:i,type:n}));var a=l.find(".pswp-item");e.detach().appendTo(a)}}},l=function(t){var r=t.attr("class").split(" ")[1];tmpl.arg="image",t.before(tmpl("tmpl-photoswipe-block-inline",{link:t.attr("src"),width:t.css("width"),height:t.css("height"),type:"natural",align:r}));var i=t.parents(".text-wrap").find(".pswp-item"),n=i.filter(function(t){return 3==e(this).children().length});t.detach().appendTo(n)},a=function(e){var t=e.parents(".pswp-figure");if(0!=t.length){var r=t.parent();e.detach().appendTo(r),t.remove()}},p=function(t){for(var r,i,n,l,a=e(t).find(".pswp-figure").get(),p=a.length,s=[],o=0;o<p;o++)r=a[o],1===r.nodeType&&(i=r.children[0],n=i.getAttribute("data-size").replace("px","").split("x"),l={src:i.getAttribute("href"),w:parseInt(n[0],10),h:parseInt(n[1],10)},r.children.length>1&&(l.title=r.children[1].innerHTML),i.children.length>0&&(l.msrc=i.children[0].getAttribute("data-thumburl")),l.pid=o,l.el=r,s.push(l));return s},s=function h(e,t){return e&&(t(e)?e:h(e.parentNode,t))},o=function(t){if(t=t||window.event,!(e(t.target).parents(".perfect-grid-item").find(".element-link").length>0||"a"===t.target.tagName.toUpperCase())){var i=t.target,n=s(i,function(e){return e.tagName&&"FIGURE"===e.tagName.toUpperCase()});if(n){t.preventDefault?t.preventDefault():t.returnValue=!1;for(var l,a=e(n).parents(r)[0],p=Array.prototype.slice.call(a.getElementsByClassName("pswp-figure")),o=p.length,d=0,u=0;u<o;u++)if(1===p[u].nodeType){if(p[u]===n){l=d;break}d++}return l>=0&&f(l,a),!1}}},d=function(){var e=window.location.hash.substring(1),t={};if(e.length<5)return t;for(var r=e.split("&"),i=0;i<r.length;i++)if(r[i]){var n=r[i].split("=");n.length<2||(t[n[0]]=n[1])}return t.gid&&(t.gid=parseInt(t.gid,10)),t},u=function(){var e={eventName:"popUpContent:pswpOpened"};Rexbuilder_Util_Editor.sendParentIframeMessage(e)},c=function(){var e={eventName:"popUpContent:pswpClosed"};Rexbuilder_Util_Editor.sendParentIframeMessage(e)},f=function(t,r,i,n){var l,a,s,o=document.querySelectorAll(".pswp")[0];if(s=p(r),a={galleryUID:r.getAttribute("data-pswp-uid"),getThumbBoundsFn:function(e){var t=s[e].el.getElementsByClassName("pswp-item-thumb")[0],r=s[e].el.getElementsByClassName("rex-custom-scrollbar")[0],i=window.pageYOffset||document.documentElement.scrollTop,n=r.getBoundingClientRect(),l=t.getAttribute("data-thumb-image-type");return"natural"==l?{x:n.left,y:n.top+i,w:n.width}:null},galleryPIDs:!0,closeOnScroll:!1,showHideOpacity:!0},n)if(a.galleryPIDs){for(var d=0,f=s.length;d<f;d++)if(s[d].pid==t){a.index=d;break}}else a.index=parseInt(t,10)-1;else a.index=parseInt(t,10);if(Rexbuilder_Util.hasClass(r,"split-scrollable")){var g=e(r).find(".pswp-figure").eq(t).parents(".opacity-block").find(".pswp-figure").get(),h=e(r).find(".pswp-figure").eq(t).get(0);a.index=g.indexOf(h),s=s.filter(function(e){for(var t=0;t<g.length;t++)if(e.el===g[t])return!0;return!1})}else{var m=0!==Array.prototype.slice.call(r.getElementsByClassName("block-has-slider")).length;if(m){var w=Rexbuilder_Util.parents(s[t].el,".perfect-grid-item"),v=!1;w&&Rexbuilder_Util.hasClass(w,"block-has-slider")&&(v=!0),s=s.filter(function(e){var t=Rexbuilder_Util.parents(e.el,".perfect-grid-item");return!t||(Rexbuilder_Util.hasClass(t,"block-has-slider")?!!v:!v)})}}isNaN(a.index)||(i&&(a.showAnimationDuration=0),l=new PhotoSwipe(o,PhotoSwipeUI_Default,s,a),l.init(),Rexbuilder_Util.isIframe&&(u(),l.listen("close",c)))},g=function(e){r=e;for(var i=document.querySelectorAll(e),n=i.length,l=0;l<n;l++)i[l].setAttribute("data-pswp-uid",l+1),i[l].onclick=o;t(i);var a=d();a.pid&&a.gid&&f(a.pid,i[a.gid-1],!0,!0)};return{init:g,addElement:n,addElementFromInline:l,removeElement:a,init_inline_pswp:i}}(jQuery);
/**
 * Util functions on RexLive
 * @since 2.0.0
 */
var Rexbuilder_Util_Editor=function(e){function t(e,t,i){var r=Rexbuilder_Util.getGalleryInstance(e),n=e.parents(".grid-stack-item").get(0),o=TextEditor.getEditorInstance().getExtensionByName("insert-media"),l=e.parents(".grid-item-content-wrap");t=t||!0,this.needToSave=t,r.updateElementHeight(n,void 0,i),o&&o.placeMediaBtn(l),this.needToSave=!0}function i(e){var t=e.selected,i=Rexbuilder_Util.$rexContainer.hasClass("editing-model"),o="default"===t;i&&n(),o&&(r(),s("default"));var l={eventName:"rexlive:restoreStateEnded",buttonData:e.buttonData};Rexbuilder_Util_Editor.sendParentIframeMessage(l)}function r(){for(var e=Rexbuilder_Util_Editor.undoStackArray.length,t=0;t<e;t++)Rexbuilder_Util.$document.trigger("rexlive:undo")}function n(){var e=Rexbuilder_Util.$rexContainer.find(".rex-model-section .update-model-button.unlocked").eq(0);Rexbuilder_Dom_Util.updateLockEditModel(e,!0),Rexbuilder_Util.$rexContainer.removeClass("editing-model")}function o(e){e="undefined"!=typeof e&&e;var t={eventName:"rexlive:edited",modelEdited:e};Rexbuilder_Util_Editor.sendParentIframeMessage(t)}function l(){var t,i,r=e(window).height();t=.8*r,i=.3*r;var n=null;return Rexbuilder_Util.$rexContainer.find(".rexpansive_section").each(function(r,o){var l=e(o),a=l.offset().top,d=l.height(),s=e(window).scrollTop();if(a-t<s&&a+d-i>s)return n=o,!1}),n}function a(){var e,t=Rexbuilder_Util.$rexContainer.find(".rexpansive_section.highLightRow"),i=Rexbuilder_Util.$rexContainer.find(".rexpansive_section.focusedRow"),r=Rexbuilder_Util.$rexContainer.find(".rexpansive_section").first();t.length>0?L(t)?t.is(r)?e={eventName:"rexlive:hideTopFastTools"}:i.length>0?t.is(i)&&(e={eventName:"rexlive:hideTopFastTools"}):e={eventName:"rexlive:viewTopFastTools"}:i.length>0?t.is(i)&&(e={eventName:"rexlive:viewTopFastTools"}):e={eventName:"rexlive:viewTopFastTools"}:e={eventName:"rexlive:hideTopFastTools"},Rexbuilder_Util_Editor.sendParentIframeMessage(e)}function d(){var e=l();c&&(e=c),null!==e&&Rexbuilder_Util_Editor.visibleRow!==e&&F(e),a()}function s(t){var i=e("#rexbuilder-layout-data"),r=e("#rexbuilder-default-layout-state"),n=i.find('.customization-wrap[data-customization-name="'+t+'"] .section-targets').get(),o=n.map(function(e){return{sectionID:e.getAttribute("data-section-rex-id"),data:e.innerText}});o.forEach(function(e){var t=r.find('[data-section-rex-id="'+e.sectionID+'"]');t.text(e.data)})}function u(e){return e instanceof jQuery}var c=null,x=function(e){e="undefined"!=typeof e?e:null,Rexbuilder_Util.$rexContainer.parent().removeClass("add-new-section--hide"),e&&e.removeClass("activeRowTools")},v=function(e){var t=e.find(".text-wrap"),i=0,r=0;if(t.hasClass("medium-editor-element")){var n=t.clone(!1);n.children(".medium-insert-buttons").remove(),i=n.text().trim().length,0!=i&&(t.hasClass("medium-editor-element")&&!t.hasClass("medium-editor-placeholder")||0!=t.parents(".pswp-item").length)&&(r=t.innerHeight())}else i=t.text().trim().length,0!=i&&(r=t.innerHeight());return 0==r?0:i},m=function(){var e=Rexbuilder_Util_Editor.editedGallery;e&&clearTimeout(e.doubleDownTimer),Rexbuilder_Util_Editor.elementIsDragging=!1,Rexbuilder_Util_Editor.editedTextWrap&&Rexbuilder_Util_Editor.editedTextWrap.blur(),e&&e.focusElementEditing(Rexbuilder_Util_Editor.editedElement),Rexbuilder_Util_Editor.editingGallery=!1,Rexbuilder_Util_Editor.editedGallery=null,Rexbuilder_Util_Editor.editingElement=!1,Rexbuilder_Util_Editor.editedElement=null,Rexbuilder_Util_Editor.editedTextWrap=null},_=function(){if(Rexbuilder_Util_Editor.editingElement&&Rexbuilder_Util_Editor.editingGallery){var e=Rexbuilder_Util_Editor.editedGallery,t=Rexbuilder_Util_Editor.editedElement;e.unFocusElementEditing(t),e.properties.elementStartingH=parseInt(t.attr("data-gs-height"))}},b=function(e){var t=Rexbuilder_Util.$rexContainer.parents(".rexbuilder-live-content").eq(0);e.distances.vals.top>0?t.addClass("fix-tools-first-row"):t.removeClass("fix-tools-first-row"),t.css("margin-top",e.distances.vals.top)},f=function(e,t,i,r){if("document"!==e)var n=h(e);else var n={sectionID:"",targetID:"",modelNumber:-1};var o={sectionID:n.sectionID,targetID:n.targetID,modelNumber:n.modelNumber,actionName:t,performActionData:i,reverseActionData:r};Rexbuilder_Util_Editor.undoStackArray.push(o),Rexbuilder_Util_Editor.redoStackArray=[],g()},g=function(){var e={eventName:"rexlive:undoRedoStackChange",stacks:{undo:Rexbuilder_Util_Editor.undoStackArray.length,redo:Rexbuilder_Util_Editor.redoStackArray.length}};Rexbuilder_Util_Editor.sendParentIframeMessage(e)},h=function(e){var t={sectionID:"",targetID:"",modelNumber:""},i=e.is("section")?e:e.parents(".rexpansive_section"),r=e.parents(".grid-stack-item");return t.sectionID=i.attr("data-rexlive-section-id"),i.hasClass("rex-model-section")&&(t.modelNumber=i.attr("data-rexlive-model-number")),0!=r.length?t.targetID=r.attr("data-rexbuilder-block-id"):t.targetID="self",t},p=function(){var e={undo:Rexbuilder_Util_Editor.undoStackArray,redo:Rexbuilder_Util_Editor.redoStackArray};return e},R=function(e){var t={rexliveEvent:!0};jQuery.extend(t,e),window.parent.postMessage(t,"*")},E=function(e,t){if(""!=e){U(e,t);var i="";i=t.parent().is("section")?t.attr("data-custom_classes"):t.attr("data-block_custom_class"),i+=" "+e,i=i.trim(),t.parent().is("section")?t.attr("data-custom_classes",i):t.attr("data-block_custom_class",i)}},U=function(e,t){if(""!=e){var i="";i=t.parent().is("section")?t.attr("data-custom_classes"):t.attr("data-block_custom_class"),e=w(e);var r="(\\s"+e+"\\s|^"+e+"\\s|\\s"+e+"$|^"+e+"$)",n=new RegExp(r,"g");i=i.replace(n," "),i=i.trim(),t.parent().is("section")?t.attr("data-custom_classes",i):t.attr("data-block_custom_class",i)}},w=function(e){return e.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g,"\\$&")},C=function(){if(0==Rexbuilder_Util_Editor.$styleElement.length){var e="",t=document.head||document.getElementsByTagName("head")[0],i=document.createElement("style");i.type="text/css",i.id="rexpansive-builder-style-inline-css",i.styleSheet?i.styleSheet.cssText=e:i.appendChild(document.createTextNode(e)),t.appendChild(i)}},y=function(e){e="undefined"==typeof e||e,e&&(Rexbuilder_Util.$rexContainer.parent().addClass("rexbuilder-live-content--loading"),Rexbuilder_Util.$rexContainer.addClass("fade-out").one(Rexbuilder_Util._animationEvent,function(){Rexbuilder_Util.$rexContainer.css("opacity","0").removeClass("fade-out");var e={eventName:"rexlive:animateContentsFadeOutEnd"};Rexbuilder_Util_Editor.sendParentIframeMessage(e)}))},k=function(e){e="undefined"==typeof e||e,e&&Rexbuilder_Util.$rexContainer.addClass("fade-in").one(Rexbuilder_Util._animationEvent,function(){Rexbuilder_Util.$rexContainer.css("opacity","").removeClass("fade-in"),Rexbuilder_Util.$rexContainer.parent().removeClass("rexbuilder-live-content--loading");var e={eventName:"rexlive:animateContentsEnd"};Rexbuilder_Util_Editor.sendParentIframeMessage(e)})},I=function(){Rexbuilder_Util.$rexContainer.children(".rexpansive_section").each(function(t,i){var r=e(i);r.wrap("<div></div>"),r.parent().attr("style","position:relative;"),r.parent().append('<div class="rexpansive-lock-section"></div>')})},T=function(){Rexbuilder_Util.$rexContainer.find(".rexpansive_section").each(function(t,i){var r=e(i);r.siblings().each(function(t,i){var r=e(i);r.hasClass("rexpansive-lock-section")&&r.remove()}),r.unwrap()})},$=function(e){e=void 0!==typeof e?e:null;var t=Rexbuilder_Util.$rexContainer.children(".rexpansive_section");null!==e&&t.not(e),t.addClass("rexpansive-lock-section--light")},A=function(){Rexbuilder_Util.$rexContainer.children(".rexpansive_section").removeClass("rexpansive-lock-section--light").removeClass("rexpansive-lock-section--overlay"),Rexbuilder_Util.$rexContainer.find(".grid-stack-item--drag-to-row").removeClass("grid-stack-item--drag-to-row"),Rexbuilder_Util.$rexContainer.find(".drag-to-section-simulator").remove()},D=function(e){for(var t,i=document.createElement("div"),r=i.style,n=Rexbuilder_Util_Editor.getPrefixedValues(e),o=0;o<n.length&&(t=n[o],r.backgroundImage=t,r.backgroundImage!=t);o++);return r.backgroundImage},N=function(e){for(var t=["-moz-","-webkit-","-o-","-ms-"],i=[],r=0;r<t.length;r++)i.push(t[r]+e);return i},P=function(){e(".text-gradient").each(function(t,i){var r=i.getAttribute("data-gradient");r=D(r);var n=e(i);n.css("background",r),n.css("-webkit-background-clip","text"),n.css("-webkit-text-fill-color","transparent")})},S=function(){Rexbuilder_Util_Editor.visibleRow=l();var t=null!==Rexbuilder_Util_Editor.visibleRow,i={};if(t){var r=e(Rexbuilder_Util_Editor.visibleRow).find(".section-data")[0];i=M(r),i.collapse=Rexbuilder_Util_Editor.visibleRow.getAttribute("data-rex-collapse-grid")}Rexbuilder_Util_Editor.visibleRowInfo={sectionID:t?Rexbuilder_Util_Editor.visibleRow.getAttribute("data-rexlive-section-id"):null,modelNumber:t?"undefined"!=typeof Rexbuilder_Util_Editor.visibleRow.getAttribute("data-rexlive-model-number")?Rexbuilder_Util_Editor.visibleRow.getAttribute("data-rexlive-model-number"):"":null,modelEditing:t?"undefined"!=typeof Rexbuilder_Util_Editor.visibleRow.getAttribute("data-rexlive-model-editing")?Rexbuilder_Util_Editor.visibleRow.getAttribute("data-rexlive-model-editing"):"":null};var n={eventName:"rexlive:traceVisibleRow",sectionTarget:Rexbuilder_Util_Editor.visibleRowInfo,rowInfo:i};Rexbuilder_Util_Editor.sendParentIframeMessage(n),e(Rexbuilder_Util_Editor.visibleRow).addClass("highLightRow"),Rexbuilder_Util.$rexContainer.on("mouseenter",".rexpansive_section",function(t){c=this;var i,r=e(this),n=r.hasClass("highLightRow");n||F(this),i=L(r)?{eventName:"rexlive:hideTopFastTools"}:{eventName:"rexlive:viewTopFastTools"},Rexbuilder_Util_Editor.sendParentIframeMessage(i)}),Rexbuilder_Util.$rexContainer.on("mouseleave",".rexpansive_section",function(t){var i=l();null!==i&&Rexbuilder_Util_Editor.visibleRow!==i&&F(i);var r=e(i),n=Rexbuilder_Util.$rexContainer.find(".rexpansive_section").first();if(c=null,!r.is(n)){var o={eventName:"rexlive:viewTopFastTools"};Rexbuilder_Util_Editor.sendParentIframeMessage(o)}})},M=function(e){var t={};if("undefined"!=typeof e)for(var i=e.attributes,r=0;r<i.length;r++)"class"!==i[r].name&&"style"!==i[r].name&&(t[i[r].name.replace("data-","")]=i[r].value);return t},F=function(t){var i=Rexbuilder_Util.$rexContainer.find(".rexpansive_section").removeClass("highLightRow"),r=i.filter(".focusedRow"),n=e(t);if(0==r.length||n.is(r)){n.addClass("highLightRow"),Rexbuilder_Util_Editor.visibleRow=t,Rexbuilder_Util_Editor.visibleRowInfo={sectionID:t.getAttribute("data-rexlive-section-id"),modelNumber:"undefined"!=typeof t.getAttribute("data-rexlive-model-number")?t.getAttribute("data-rexlive-model-number"):"",modelEditing:"undefined"!=typeof t.getAttribute("data-rexlive-model-editing")?t.getAttribute("data-rexlive-model-editing"):""};var o={},l=n.find(".section-data")[0];o=M(l),o.collapse=t.getAttribute("data-rex-collapse-grid");var a={eventName:"rexlive:traceVisibleRow",sectionTarget:Rexbuilder_Util_Editor.visibleRowInfo,rowInfo:o};Rexbuilder_Util_Editor.sendParentIframeMessage(a)}},L=function(t,i,r){i=void 0===typeof i?i:0,r=void 0===typeof r?r:0;var n=t.offset().top,o=t.height(),l=e(window).scrollTop();return!(n+i<l&&n+o+r>l)},G=function(e,t){var i={};if("undefined"!=typeof e.clientX&&"undefined"!=typeof e.clientY&&"undefined"!=typeof e.offsetX&&"undefined"!=typeof e.offsetY&&"undefined"!=typeof t){var r=e.target.getBoundingClientRect();i={x:r.left+t.offset.w/2,y:r.top+Rexbuilder_Util_Editor.mousePositionFrameYOffset}}else null!==Rexbuilder_Util_Editor.mousePosition&&null!==Rexbuilder_Util_Editor.mouseClickObject?(i={x:Rexbuilder_Util_Editor.mousePosition.client.x-Rexbuilder_Util_Editor.mousePosition.offset.x+Rexbuilder_Util_Editor.mouseClickObject.offset.w/2,y:Rexbuilder_Util_Editor.mousePosition.client.y-Rexbuilder_Util_Editor.mousePosition.offset.y+Rexbuilder_Util_Editor.mousePositionFrameYOffset},Rexbuilder_Util_Editor.mousePosition=null,Rexbuilder_Util_Editor.mouseClickObject=null):i={x:Rexbuilder_Util_Editor.viewportMeasurement.width/2,y:Rexbuilder_Util_Editor.viewportMeasurement.height/2};return i},O=function(){var e=Rexbuilder_Util.$rexContainer.find(".rexpansive_section:not(removing_section)");"1"==e.length&&e.hasClass("empty-section")?(Rexbuilder_Util.$rexContainer.parent().addClass("add-new-section--hide"),e.addClass("activeRowTools")):Rexbuilder_Util.$rexContainer.parent().removeClass("add-new-section--hide")},j=function(){this.elementIsResizing=!1,this.elementIsDragging=!1,this.sectionCopying=!1,this.blockCopying=!1,this.editingGallery=!1,this.editingElement=!1,this.editedElement=null,this.manageElement=!1,this.editedGallery=null,this.editedTextWrap=null,this.activateElementFocus=!1,this.mouseDownEvent=null,this.mouseUpEvent=null,this.mouseDown=!1,this.mouseUp=!1,this.mousePosition=null,this.mouseClickObject=null,this.mousePositionFrameYOffset=50,this.viewportMeasurement=Rexbuilder_Util.globalViewport,this.elementDraggingTriggered=!1,this.focusedElement=null,this.hasResized=!1,this.changedLayout=!1,this.clickedLayoutID="",this.undoActive=!1,this.redoActive=!1,this.updatingGridstack=!1,this.addingNewBlocks=!1,this.removingBlocks=!1,this.updatingImageBg=!1,this.updatingPaddingBlock=!1,this.updatingCollapsedGrid=!1,this.updatingSectionWidth=!1,this.updatingSectionLayout=!1,this.savingPage=!1,this.savingModel=!1,this.openingModel=!1,this.insertingModel=!1,this.visibleRow=null,this.visibleRowInfo={},this.scrollbarsActive=!1,this.dragAndDropFromParent=!1,this.undoStackArray=[],this.redoStackArray=[],this.needToSave=!0,this.$styleElement=e("#rexpansive-builder-style-inline-css")},B=function(){S(),Rexbuilder_Util.$window.on("scroll",d),O(),C()};return{init:j,load:B,activeAddSection:x,endEditingElement:m,startEditingElement:_,sendParentIframeMessage:R,addCustomClass:E,removeCustomClass:U,escapeRegExp:w,pushAction:f,getIDs:h,getStacks:p,getTextWrapLength:v,rowAttrsObj:M,blockAttrsObj:M,startLoading:y,endLoading:k,builderEdited:o,getMousePosition:G,lockRows:I,lockRowsLight:$,releaseRows:T,releaseRowsLight:A,getGradientSafeValue:D,getPrefixedValues:N,synchGradient:P,updateBlockContainerHeight:t,updateContainerMargins:b,sendUndoRedoInformation:g,restorePageStartingState:i,isJQuery:u}}(jQuery);
var Rexbuilder_Dom_Util=function($){"use strict";function _resetImageBlock(e,t,a){t.attr("data-id_image_bg_block",""),t.attr("data-type_bg_block",""),t.attr("data-image_bg_block",""),t.attr("data-image_size",""),e.parents(".grid-stack-item").hasClass("block-has-slider")?t.attr("data-photoswipe",a.photoswipe):t.attr("data-photoswipe",""),t.attr("data-image_bg_elem_active",""),_removeImageBlock(e),e.attr("data-background_image_width",""),e.attr("data-background_image_height","");var i=e.parents(".grid-stack-item").get(0);if(i&&Rexbuilder_Util.editorMode){var o=i.querySelector(".deactivate-block-image-background");$(o).parents(".tool-button--double-icon--wrap").addClass("tool-button--hide"),Rexbuilder_Util.addClass(i.querySelector(".rexlive-block-toolbox.bottom-tools .edit-block-image-position"),"tool-button--hide"),$(i).find(".rexlive-block-toolbox.top-tools .edit-block-image").parents(".tool-button--double-icon--wrap").removeClass("tool-button--hide")}}function _enablePhotoswipeAllBlocksSection(e){for(var t,a,i,o,r,d=e.get(0),l=d.querySelectorAll(".grid-stack-item:not(.removing_block)"),n=l.length,s=0;s<n;s++)t=l[s],a=t.querySelector(".rexbuilder-block-data"),i=Rexbuilder_Util.hasClass(t,"block-has-slider"),o=0!==Rexbuilder_Util_Editor.getTextWrapLength($(t)),r=""!==a.getAttribute("data-image_bg_block"),t.setAttribute("data-rexlive-element-edited",!0),(r&&!o||i)&&a.setAttribute("data-photoswipe",!0)}function _removePhotoswipeAllBlocksSection(e){for(var t,a=e.get(0),i=a.querySelectorAll(".grid-stack-item:not(.removing_block)"),o=i.length,r=0;r<o;r++)t=i[r].querySelector(".rexbuilder-block-data"),i[r].setAttribute("data-rexlive-element-edited",!0),t.setAttribute("data-photoswipe",!1)}function _updateSectionBackgroundColorLive(e,t){var a=""!=e.modelNumber,i=Rexbuilder_Util.$rexContainer.find('section[data-rexlive-section-id="'+e.sectionID+'"]');a&&(i=Rexbuilder_Util.$rexContainer.find('section[data-rexlive-section-id="'+e.sectionID+'"][data-rexlive-model-number="'+e.modelNumber+'"]')),_setBackgroundColor(i,t),"undefined"!=typeof Rexbuilder_Section_Editor&&Rexbuilder_Section_Editor.updateRowBackgroundColorTool(i,t)}function updateSectionBackgroundColor(e,t){var a=e.children(".section-data"),i=t.color,o=t.active;_setBackgroundColor(e,i),a.attr("data-color_bg_section",i),a.attr("data-color_bg_section_active",o),"undefined"!=typeof Rexbuilder_Section_Editor&&Rexbuilder_Section_Editor.updateRowBackgroundColorTool(e,i)}function updateSectionOverlayColorLive(e,t){var a,i=""!==e.modelNumber;a=i?Rexbuilder_Util.$rexContainer.find('.rexpansive_section[data-rexlive-section-id="'+e.sectionID+'"][data-rexlive-model-number="'+e.modelNumber+'"]'):Rexbuilder_Util.$rexContainer.find('.rexpansive_section[data-rexlive-section-id="'+e.sectionID+'"]');var o=a.children(".responsive-overlay");_setBackgroundColor(o,t),"undefined"!=typeof Rexbuilder_Section_Editor&&Rexbuilder_Section_Editor.updateRowOverlayColorToolLive(a,t)}function updateSectionFullHeight(e){e.galleryInstance.updateFullHeight("true"==e.fullHeight.toString())}function _updateBulkSection(e,t,a){var i;i=""!=e.modelNumber?Rexbuilder_Util.$rexContainer.find('section[data-rexlive-section-id="'+e.sectionID+'"][data-rexlive-model-number="'+e.modelNumber+'"]'):Rexbuilder_Util.$rexContainer.find('section[data-rexlive-section-id="'+e.sectionID+'"]');var o,r,d=a.length;for(r=0;r<d;r++)if("self"===a[r].name){o=a[r].props;break}var l=!1,n=!1,s=!1,c=!1,u=!1,p=!1,_=!1,g=i.find(".perfect-grid-gallery").data().plugin_perfectGridGalleryEditor;for(var m in t)if(t[m])switch(m){case"section_name":_updateSectionName(i,o.section_name);break;case"section_nav_label":_updateSectionNavLabel(i,o.section_nav_label);break;case"color_bg_section":case"color_bg_section_active":if(l)break;updateSectionBackgroundColor(i,{color:o.color_bg_section,active:o.color_bg_section_active}),l=!0;break;case"image_bg_section_active":case"image_bg_section":case"image_width":case"image_height":case"id_image_bg_section":case"image_size":if(n)break;_updateSectionBackgroundImage(i,{width:o.image_width,height:o.image_height,image_size:o.image_size,idImage:o.id_image_bg_section,urlImage:o.image_bg_section,active:o.image_bg_section_active}),n=!0;break;case"video_bg_id_section":case"video_mp4_url":case"video_bg_width_section":case"video_bg_height_section":if(s)break;_updateSectionVideoBackground(i,{typeVideo:"mp4",mp4Data:{linkMp4:o.video_mp4_url,idMp4:o.video_bg_id_section,width:o.video_bg_width_section,height:o.video_bg_height_section},youtubeUrl:"",vimeoUrl:""}),s=!0;break;case"video_bg_url_section":_updateSectionVideoBackground(i,{typeVideo:"youtube",mp4Data:{linkMp4:"",idMp4:"",width:"",height:""},youtubeUrl:o.video_bg_url_section,vimeoUrl:""});break;case"video_bg_url_vimeo_section":_updateSectionVideoBackground(i,{typeVideo:"vimeo",mp4Data:{linkMp4:"",idMp4:"",width:"",height:""},youtubeUrl:"",vimeoUrl:o.video_bg_url_vimeo_section});break;case"block_distance":case"row_separator_top":case"row_separator_bottom":case"row_separator_right":case"row_separator_left":if(c)break;_updateRowDistances(i,{rowDistances:{gutter:o.block_distance,top:o.row_separator_top,right:o.row_separator_right,bottom:o.row_separator_bottom,left:o.row_separator_left},galleryInstance:g,singleWidth:g.properties.singleWidth,singleHeight:g.properties.singleHeight,blocksDisposition:$.extend(!0,{},g.createActionDataMoveBlocksGrid())}),c=!0;break;case"margin":case"row_margin_top":case"row_margin_bottom":case"row_margin_right":case"row_margin_left":if(u)break;_updateSectionMargins(i,{marginsSection:{top:o.row_margin_top,bottom:o.row_margin_bottom,right:o.row_margin_right,left:o.row_margin_left},galleryInstance:g,singleWidth:g.properties.singleWidth,singleHeight:g.properties.singleHeight,blocksDisposition:$.extend(!0,{},g.createActionDataMoveBlocksGrid())}),u=!0;break;case"custom_classes":var v=o.custom_classes.trim().split(/\s+/);_updateCustomClasses(i,v),_=!0;break;case"row_overlay_color":case"row_overlay_active":if(p)break;updateSectionOverlay(i,{color:o.row_overlay_color,active:o.row_overlay_active}),p=!0}_&&"default"!==Rexbuilder_Util.activeLayout&&Rexbuilder_Util.globalViewport.width<768&&-1!==o.custom_classes.indexOf("rex-block-grid")&&i.find(".collapse-grid").trigger("click")}function updateBulkBlock(e,t,a){var i;i=""!=e.modelNumber?Rexbuilder_Util.$rexContainer.find('section[data-rexlive-section-id="'+e.sectionID+'"][data-rexlive-model-number="'+e.modelNumber+'"]').find('div [data-rexbuilder-block-id="'+e.rexID+'"]'):Rexbuilder_Util.$rexContainer.find('section[data-rexlive-section-id="'+e.sectionID+'"]').find('div [data-rexbuilder-block-id="'+e.rexID+'"]');var o,r,d=i.get(0),l=d.querySelector(".rexbuilder-block-data"),n=i.parents(".rexpansive_section"),s=n.children(".section-data"),c=n.find(".grid-stack-row"),u=c.data("plugin_perfectGridGalleryEditor"),p=a.length;for(r=0;r<p;r++)if(e.rexID===a[r].name){o=a[r].props;break}var g;for(r=0;r<p;r++)if("self"===a[r].name){g=a[r].props;break}var m=parseInt(o.gs_width),v=parseInt(o.gs_height),b=parseInt(o.gs_x),k=parseInt(o.gs_y);if(Rexbuilder_Util.isMobile()&&"fixed"===g.layout)v=Math.floor(o.gs_height*u.properties.singleWidth/5),k=Math.floor(o.gs_y*u.properties.singleWidth/5);else if(g.layout!==s.attr("data-layout"))switch(s.attr("data-layout")){case"fixed":v=Math.floor(5*o.gs_height/u.properties.singleWidth),k=Math.floor(5*o.gs_y/u.properties.singleWidth);break;case"masonry":v=Math.floor(o.gs_height*u.properties.singleWidth/5),k=Math.floor(o.gs_y*u.properties.singleWidth/5)}l.setAttribute("data-gs_width",m),l.setAttribute("data-gs_height",v),l.setAttribute("data-gs_start_h",v),l.setAttribute("data-gs_x",b),l.setAttribute("data-gs_y",k),l.setAttribute("data-element_real_fluid",o.element_real_fluid),u.properties.gridstackInstance.update(d,b,k,m,v);var x=!1,f=!1,h=!1,y=!1;for(var B in t)if(t[B])switch(B){case"color_bg_block":case"color_bg_block_active":if(x)break;_updateBlockBackgroundColor({$elem:i,color:o.color_bg_block,active:o.color_bg_block_active}),x=!0;break;case"image_bg_url":case"image_width":case"image_height":case"id_image_bg":case"image_size":case"image_bg_elem_active":case"type_bg_image":if(f)break;_updateImageBG(i.find(".grid-item-content"),{width:o.image_width,height:o.image_height,sizeImage:o.image_size,idImage:o.id_image_bg,urlImage:o.image_bg_url,active:o.image_bg_elem_active,typeBGimage:o.type_bg_image}),f=!0;break;case"video_bg_id":case"video_bg_width":case"video_bg_height":case"video_mp4_url":case"video_bg_url_youtube":case"video_bg_url_vimeo":case"video_has_audio":if(y)break;var S=null;if(""!==o.video_mp4_url?S="mp4":""!==o.video_bg_url_youtube?S="youtube":""!==o.video_bg_url_vimeo&&(S="vimeo"),!S)break;var w={typeVideo:S,mp4Data:{linkMp4:"",idMp4:"",width:"",height:""},youtubeUrl:"",vimeoUrl:"",audio:"true"===o.video_has_audio};switch(S){case"mp4":w=_.assign(w,{mp4Data:{linkMp4:o.video_mp4_url,idMp4:o.video_bg_id,width:o.video_bg_width,height:o.video_bg_height}});break;case"youtube":w=_.assign(w,{youtubeUrl:o.video_bg_url_youtube});break;case"vimeo":w=_.assign(w,{vimeoUrl:o.video_bg_url_vimeo})}_updateVideos(i.find(".grid-item-content"),w),y=!0;break;case"photoswipe":_updateBlockPhotoswipe({$elem:i,photoswipe:o.photoswipe});break;case"block_custom_class":var C=o.block_custom_class.trim().split(/\s+/);_updateCustomClasses(i,C);break;case"block_padding":var R=-1!==o.block_padding.indexOf("px")?"px":-1!==o.block_padding.indexOf("%")?"%":"",D=o.block_padding;D=D.replace(/px|%/g,"");var I=D.split(";");_updateBlockPaddings(i,{top:I[0],right:I[1],bottom:I[2],left:I[3],type:R});break;case"overlay_block_color":case"overlay_block_color_active":if(h)break;_updateBlockOverlay({$elem:i,color:o.overlay_block_color,active:o.overlay_block_color_active}),h=!0;break;case"linkurl":_updateBlockUrl(i,o.linkurl);break;case"block_flex_position":var U=o.block_flex_position.split(" ");_updateFlexPostition(i,{x:U[0],y:U[1]});break;case"block_flex_img_position":var U=o.block_flex_img_position.split(" ");_updateImageFlexPostition(i,{x:U[0],y:U[1]})}}function htmlToElement(e){var t=document.createElement("template");return e=e.trim(),t.innerHTML=e,t.content.firstChild}function _setBackgroundColor(e,t){var a=-1!==e.css("background").indexOf("linear-gradient");a&&e.css("background",""),e.css("background-color",t)}function _insertBlockVideoToDOM(e,t){var a=e.find(".rex-image-wrapper"),i=e.find(".rexlive-block-drag-handle"),o=0!==a.length,r=0!==i.length;o?a.after(t):r?i.after(t):e.prepend(t)}function _moveImageBeforeVideo(e){var t=e.find(".rex-image-wrapper"),a=e.find(".rex-youtube-wrap, .rex-video-vimeo-wrap, .rex-video-wrap");t.insertBefore(a)}var _updateSlider=function(e){var t=e.textWrap,a=e.sliderNumberToActive,i=t.children('.rex-slider-wrap:not([data-rex-slider-number="'+e.sliderNumberToActive+'"])');i.each(function(e,t){var a=$(t);t.style.display="none",t.setAttribute("data-rex-slider-active",!1),RexSlider.destroySliderPlugins(a)});var o=t.children('.rex-slider-wrap[data-rex-slider-number="'+a+'"]');if(0==o.length){var r=e.newSliderData;if("undefined"!=typeof r){var d=t.parents(".grid-stack-item");Rexbuilder_CreateBlocks.createSlider(e.newSliderData,d,a)}}else{var l=o[0];l.style.display="",RexSlider.initSlider(o)}},_updateSliderStack=function(e){var t;t=""!=e.target.modelNumber?Rexbuilder_Util.$rexContainer.find('section[data-rexlive-section-id="'+e.target.sectionID+'"][data-rexlive-model-number="'+e.target.modelNumber+'"]'):Rexbuilder_Util.$rexContainer.find('section[data-rexlive-section-id="'+e.target.sectionID+'"]');var a=t.find('div [data-rexbuilder-block-id="'+e.target.rexID+'"]'),i=a.find(".text-wrap"),o=i.find('.rex-slider-wrap[data-rex-slider-number="'+e.target.sliderNumber+'"]'),r={textWrap:i,sliderNumberToActive:parseInt(o.attr("data-rex-slider-number"))};Rexbuilder_Dom_Util.lastSliderNumber=Rexbuilder_Dom_Util.lastSliderNumber+1;var d={textWrap:i,sliderNumberToActive:Rexbuilder_Dom_Util.lastSliderNumber,newSliderData:e};_updateSlider(d),Rexbuilder_Util_Editor.pushAction(t,"updateSlider",d,r)},_updateRow=function(e,t,a,i){var o=parseInt(i.gutter),r=parseInt(i.top),d=parseInt(i.right),l=parseInt(i.bottom),n=parseInt(i.left),s=20,c={gutter:isNaN(o)?s:o,top:isNaN(r)?s:r,right:isNaN(d)?s:d,bottom:isNaN(l)?s:l,left:isNaN(n)?s:n},u=c.gutter,p=c.top,_=c.right,g=c.bottom,m=c.left,v="undefined"==typeof i.layout?"fixed":i.layout,b="undefined"!=typeof i.full_height&&"masonry"!=v&&i.full_height,k="undefined"==typeof i.section_width?"100%":""+i.section_width,x="undefined"==typeof i.dimension?"full":i.dimension,f=!Rexbuilder_Util.editorMode&&i.collapse_grid,h=a.parent(),y=h[0];"full"==x?(h.removeClass("center-disposition"),h.addClass("full-disposition"),y.style.maxWidth="100%"):(h.removeClass("full-disposition"),h.addClass("center-disposition"),y.style.maxWidth=k),a.attr("data-separator",u),a.attr("data-row-separator-top",p),a.attr("data-row-separator-right",_),a.attr("data-row-separator-bottom",g),a.attr("data-row-separator-left",m),a.attr("data-layout",v),a.attr("data-full-height",b),t.attr("data-section_width",k),t.attr("data-dimension",x),t.attr("data-no-mobile-layout",i.noMobileLayoutSaved),t.attr("data-responsive_collapse",f),t.attr("data-layout",v),e.attr("data-rex-collapse-grid",f);var B=a.data();if(void 0!==B){var S=B.plugin_perfectGridGalleryEditor;void 0!==S&&S.updateGridSettingsChangeLayout(i)}Rexbuilder_Util.editorMode&&(Rexbuilder_Section_Editor.updateSectionDimensionTool(e,i),Rexbuilder_Section_Editor.updateSectionLayoutTool(e,i))},_updateImageBG=function(e,t){if(e.hasClass("rexpansive_section")){var a=e.children(".section-data");""==t.idImage||"true"!=t.active.toString()?(_resetImageSection(e,a),Rexbuilder_Util.editorMode||e.removeClass("section-w-image")):(_updateImageSection(e,a,t),Rexbuilder_Util.editorMode||e.addClass("section-w-image"))}else if(e.hasClass("grid-item-content")){var i=e.parents(".grid-stack-item"),o=i.children(".rexbuilder-block-data");""==t.idImage||"true"!=t.active.toString()?(_resetImageBlock(e,o,t),Rexbuilder_Util.editorMode||i.removeClass("block-w-image")):(Rexbuilder_Util.editorMode||i.addClass("block-w-image"),_updateImageBlock(e,o,t))}},_updateImageSection=function(e,t,a){if("undefined"!=typeof Rexbuilder_Section_Editor&&Rexbuilder_Section_Editor.updateRowBackgroundImageTool(e,a),a.idImage!=parseInt(t.attr("data-id_image_bg_section"))){var i=e[0];Rexbuilder_Util.editorMode?i.style.backgroundImage="url("+a.urlImage+")":i.setAttribute("data-src",a.urlImage),i.setAttribute("data-background_image_width",a.width),i.setAttribute("data-background_image_height",a.height),t.attr("data-image_size",a.image_size),t.attr("data-id_image_bg_section",a.idImage),t.attr("data-image_bg_section",a.urlImage),t.attr("data-image_bg_section_active",a.active)}},_updateBlockPhotoswipe=function(e){var t=e.$elem.children(".rexbuilder-block-data");t.attr("data-photoswipe",e.photoswipe)},_updateImageBlock=function(e,t,a){t.attr("data-id_image_bg_block",a.idImage),t.attr("data-type_bg_block",a.typeBGimage),t.attr("data-image_bg_block",a.urlImage),t.attr("data-image_size",a.sizeImage),t.attr("data-image_bg_elem_active",a.active),"full"==a.typeBGimage?_addImageFullBgBlock(e,a):"natural"==a.typeBGimage&&_addImageNaturalBgBlock(e,a);var i=/(youtube|vimeo|mp4)-player/.test(e.get(0).className);i&&_moveImageBeforeVideo(e),e.attr("data-background_image_width",a.width),e.attr("data-background_image_height",a.height),"undefined"!=typeof Rexbuilder_Block_Editor&&(Rexbuilder_Block_Editor.updateBlockBackgroundImageTool(e,a),Rexbuilder_Block_Editor.updateBlockImagePositionTool(e,a))},_addImageNaturalBgBlock=function(e,t){var a=e.find(".rex-image-wrapper"),i=e.find(".responsive-block-overlay");if(0==a.length){var o=document.createElement("div");a=$(o),a.addClass("rex-image-wrapper"),a.insertBefore(i[0])}else a.hasClass("full-image-background")&&(a.detach().insertBefore(i[0]),a.removeClass("full-image-background"));var r=a[0];a.addClass("natural-image-background"),Rexbuilder_Util.editorMode?r.style.backgroundImage="url("+t.urlImage+")":r.setAttribute("data-src",t.urlImage);var d=e.parents(".grid-stack-item"),l=d[0];l&&(l.offsetWidth<t.width?a.addClass("small-width"):a.removeClass("small-width"))},_removeImageBlock=function(e){var t=e.find(".rex-image-wrapper");0!=t.length&&t.remove()},_addImageFullBgBlock=function(e,t){var a=e.find(".rex-image-wrapper"),i=e.find(".responsive-block-overlay");if(0==a.length){var o=document.createElement("div");a=$(o),a.addClass("rex-image-wrapper"),a.insertBefore(i[0])}else a.hasClass("natural-image-background")&&(a.detach().insertBefore(i[0]),a.removeClass("natural-image-background"),a.removeClass("small-width"));var r=a[0];a.addClass("full-image-background"),Rexbuilder_Util.editorMode?r.style.backgroundImage="url("+t.urlImage+")":r.setAttribute("data-src",t.urlImage)},_resetImageSection=function(e,t){var a=e[0];t.attr("data-image_bg_section",""),t.attr("data-id_image_bg_section",""),t.data("data-image_size",""),a.setAttribute("data-background_image_width",""),a.setAttribute("data-background_image_height",""),a.style.backgroundImage="","undefined"!=typeof Rexbuilder_Section_Editor&&Rexbuilder_Section_Editor.resetRowBackgroundImageTool(e)},_removeYoutubeVideo=function($target,removeFromDom){var $ytpWrapper=$target.children(".rex-youtube-wrap"),$toggleAudio=$target.children(".rex-video-toggle-audio");if(0!=$ytpWrapper.length)if(removeFromDom="undefined"==typeof removeFromDom||removeFromDom,$target.removeClass("youtube-player"),removeFromDom)void 0!==$ytpWrapper.YTPGetPlayer()&&$ytpWrapper.YTPPlayerDestroy(),$ytpWrapper.remove(),0!=$toggleAudio.length&&$toggleAudio.remove();else{var videoID;if(void 0!==$ytpWrapper.YTPGetPlayer())videoID=$ytpWrapper.YTPGetVideoID(),$ytpWrapper.YTPPlayerDestroy();else{var elemData=jQuery.extend(!0,{},eval("("+$ytpWrapper.attr("data-property")+")"));videoID=elemData.videoURL}var wasSlide=0!=$ytpWrapper.parents(".rex-slider-element").length,hadAudio=0!=$toggleAudio.length;wasSlide&&(hadAudio=0!=$ytpWrapper.children(".rex-video-toggle-audio").length),$ytpWrapper.remove(),tmpl.arg="video";var youTubeTemplate='<div class="rex-youtube-wrap" data-property="{videoURL:\''+videoID+"',containment:'self',startAt:0,mute:"+!1+',autoPlay:true,loop:true,opacity:1,showControls:false, showYTLogo:false}"></div>';if(_insertBlockVideoToDOM($target,youTubeTemplate),hadAudio&&wasSlide){var $toggle=$('<div class="rex-video-toggle-audio"><div class="rex-video-toggle-audio-shadow"></div></div>');$toggle.addClass("removing-toggle-audio"),$toggle.appendTo($target.children(".rex-youtube-wrap")[0])}}},_removeVimeoVideo=function(e,t){var a=e.children(".rex-video-vimeo-wrap"),i=e.children(".rex-video-toggle-audio");if(0!=a.length){var o=a.children("iframe")[0];if(t="undefined"==typeof t||t,e.removeClass("vimeo-player"),t)VimeoVideo.removePlayer(o),a.remove(),0!=i.length&&i.remove();else{var r=VimeoVideo.findVideo(o);r&&r.unload(),0!=i.length&&i.addClass("removing-toggle-audio")}}},_removeMp4Video=function(e,t){var a=e.children(".rex-video-wrap"),i=e.children(".rex-video-toggle-audio");if(0!=a.length){t="undefined"==typeof t||t;var o=a.find("video")[0];o.pause(),o.currentTime=0,e.removeClass("mp4-player"),t?(a.remove(),0!=i.length&&i.remove()):(a.addClass("removing-video-mp4"),0!=i.length&&i.addClass("removing-toggle-audio"))}},_addMp4Video=function(e,t,a){var i=e.children(".rex-video-wrap"),o=e.children(".rex-video-toggle-audio"),r=i.find("source"),d=Rexbuilder_Util.editorMode?r.attr("src"):r.attr("data-src");if(0!=i.length&&d!=t.linkMp4||0==i.length){_removeMp4Video(e,!0),e.addClass("mp4-player"),tmpl.arg="video";var l='<div class="rex-video-wrap intrinsic-ignore" data-rex-video-width="'+t.width+'" data-rex-video-height="'+t.height+'"><video width="'+t.width+'" height="'+t.height+'" class="rex-video-container" preload autoplay loop muted><source type="video/mp4" src="'+t.linkMp4+'"></video></div>';if(e.is("section")){var n="";n=Rexbuilder_Util.editorMode?".section-toolBox":".section-data",e.children(n).after(l)}else _insertBlockVideoToDOM(e,l)}else 0!=i.length&&(i.removeClass("removing-video-mp4"),Rexbuilder_Util.editorMode&&i.find("video")[0].play());0==o.length?a&&e.append('<div class="rex-video-toggle-audio"><div class="rex-video-toggle-audio-shadow"></div></div>'):a?o.removeClass("removing-toggle-audio"):o.remove()},_addYoutubeVideo=function($target,urlYoutube,hasAudio){var $ytpWrapper=$target.children(".rex-youtube-wrap"),$toggleAudio=$target.children(".rex-video-toggle-audio");if(0!=$ytpWrapper.length){var elemData=jQuery.extend(!0,{},eval("("+$ytpWrapper.attr("data-property")+")")),activeUrl=elemData.videoURL,videoID=Rexbuilder_Util.getYoutubeID(activeUrl),urlID=Rexbuilder_Util.getYoutubeID(urlYoutube);videoID!=urlID?void 0===$ytpWrapper.YTPGetPlayer()?($ytpWrapper.attr("data-property","{videoURL:'"+urlYoutube+"',containment:'self',startAt:0,mute:'"+!hasAudio+"',autoPlay:true,loop:true,opacity:1,showControls:false, showYTLogo:false}"),$ytpWrapper.addClass("youtube-player-launching"),$ytpWrapper.YTPlayer()):(_removeYoutubeVideo($target,!0),setTimeout(function(){tmpl.arg="video";var e='<div class="rex-youtube-wrap" data-property="{videoURL:\''+urlYoutube+"',containment:'self',startAt:0,mute:"+!hasAudio+',autoPlay:true,loop:true,opacity:1,showControls:false, showYTLogo:false}"></div>';_insertBlockVideoToDOM($target,e),$target.children(".rex-youtube-wrap").YTPlayer();var t=$target.children(".rex-video-toggle-audio");0==t.length?hasAudio&&$target.append('<div class="rex-video-toggle-audio"><div class="rex-video-toggle-audio-shadow"></div></div>'):hasAudio?t.removeClass("removing-toggle-audio"):t.remove()},1e3,$target,urlYoutube,hasAudio)):void 0===$ytpWrapper.YTPGetPlayer()&&($ytpWrapper.addClass("youtube-player-launching"),$ytpWrapper.YTPlayer())}else{tmpl.arg="video";var youTubeTemplate='<div class="rex-youtube-wrap" data-property="{videoURL:\''+urlYoutube+"',containment:'self',startAt:0,mute:"+!hasAudio+',autoPlay:true,loop:true,opacity:1,showControls:false, showYTLogo:false}"></div>';_insertBlockVideoToDOM($target,youTubeTemplate),$target.children(".rex-youtube-wrap").YTPlayer()}$target.addClass("youtube-player"),0==$toggleAudio.length?hasAudio&&$target.append('<div class="rex-video-toggle-audio"><div class="rex-video-toggle-audio-shadow"></div></div>'):hasAudio?$toggleAudio.removeClass("removing-toggle-audio"):$toggleAudio.remove()},_addVimeoVideo=function(e,t,a){var i=e.children(".rex-video-vimeo-wrap"),o=e.children(".rex-video-toggle-audio");if(e.addClass("vimeo-player"),""==t)_removeVimeoVideo(e,!0);else if(0!=i.length&&i.children("iframe").attr("src").split("?")[0]!=t||0==i.length){_removeVimeoVideo(e,!0),tmpl.arg="video",t+="?autoplay=1&loop=1&title=0&byline=0&portrait=0&autopause=0&muted="+("true"==a.toString()?"0":"1")+"&background=1";var r='<div class="rex-video-vimeo-wrap rex-video-vimeo-wrap--block"><iframe src="'+t+'" width="640" height="360" frameborder="0" allow="autoplay"  webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe></div>';_insertBlockVideoToDOM(e,r);var d=e.children(".rex-video-vimeo-wrap").find("iframe")[0];VimeoVideo.addPlayer("1",d)}else if(0!=i.length){var l=VimeoVideo.findVideo(i.find("iframe")[0]);null!=l&&l.play()}0==o.length?a&&e.append('<div class="rex-video-toggle-audio"><div class="rex-video-toggle-audio-shadow"></div></div>'):a?o.removeClass("removing-toggle-audio"):o.remove()},_updateBlockVideoTools=function(e,t){var a=e.find(".rexlive-block-toolbox.top-tools .edit-block-video-background"),i=e.find(".rexlive-block-toolbox.bottom-tools .edit-block-video-background");t?(a.parent().removeClass("tool-button--hide"),i.parent().addClass("tool-button--hide")):(a.parent().addClass("tool-button--hide"),i.parent().removeClass("tool-button--hide"))},_updateVideos=function(e,t){var a,i,o,r="";if(e.hasClass("rexpansive_section"))a=e.children(".section-data"),r="section";else if(e.hasClass("grid-item-content"))o=e.parents(".grid-stack-item"),i=o.children(".rexbuilder-block-data"),r="block";else{if(!e.hasClass("rex-slider-video-wrapper"))return;r="slide"}var d=t.typeVideo;""==d?(_removeMp4Video(e,!0),_removeYoutubeVideo(e,!0),_removeVimeoVideo(e,!0)):"mp4"==d?(_removeYoutubeVideo(e,!0),_removeVimeoVideo(e,!0),_addMp4Video(e,t.mp4Data,t.audio)):"vimeo"==d?(_removeYoutubeVideo(e,!0),_removeMp4Video(e,!0),_addVimeoVideo(e,t.vimeoUrl,t.audio)):"youtube"==d&&(_removeVimeoVideo(e,!0),_removeMp4Video(e,!0),_addYoutubeVideo(e,t.youtubeUrl,t.audio)),"section"==r?(a.attr("data-video_mp4_url",t.mp4Data.linkMp4),a.attr("data-video_bg_id_section",t.mp4Data.idMp4),a.attr("data-video_bg_width_section",t.mp4Data.width),a.attr("data-video_bg_height_section",t.mp4Data.height),a.attr("data-video_bg_url_section",t.youtubeUrl),a.attr("data-video_bg_url_vimeo_section",t.vimeoUrl),"undefined"!=typeof Rexbuilder_Section_Editor&&Rexbuilder_Section_Editor.updateRowBackgroundVideo(e,t),"mp4"==d?e.addClass("section-w-html-video"):e.removeClass("section-w-html-video")):"block"==r&&(i.attr("data-video_mp4_url",t.mp4Data.linkMp4),i.attr("data-video_bg_id",t.mp4Data.idMp4),i.attr("data-video_bg_width",t.mp4Data.width),i.attr("data-video_bg_height",t.mp4Data.height),i.attr("data-video_bg_url",t.youtubeUrl),i.attr("data-video_bg_url_vimeo",t.vimeoUrl),i.attr("data-video_has_audio",t.audio),"mp4"==d?o.addClass("block-w-html-video"):o.removeClass("block-w-html-video"),Rexbuilder_Util.editorMode&&_updateBlockVideoTools(o,""===d))},_updateBlockPaddings=function(e,t){var a=e.children(".rexbuilder-block-data");a.attr("data-block_padding",Rexbuilder_Util.paddingsToString(t));var i=e.find(".text-wrap");if(0!=i.length){var o=i[0];o.style.paddingTop=""+t.top+t.type,o.style.paddingRight=""+t.right+t.type,o.style.paddingBottom=""+t.bottom+t.type,o.style.paddingLeft=""+t.left+t.type}},_updateBlocksLayout=function(e){var t,a,i,o,r,d,l=e.blocks,n=e.gridstackInstance;if(!(l.length<=0)){var s=$(e.blocks[0].elem).parents(".rexpansive_section");for(Rexbuilder_Util_Editor.updatingGridstack||n.grid&&n.batchUpdate(),t=0;t<l.length;t++)a=l[t].x,i=l[t].y,o=l[t].w,r=l[t].h,d=l[t].elem,n.update(d,a,i,o,r);Rexbuilder_Util_Editor.updatingGridstack||n.grid&&n.commit(),setTimeout(Rexbuilder_Util.fixYoutube.bind(null,s[0]),1500)}},_collapseGrid=function(e,t,a,i){Rexbuilder_Util_Editor.updatingCollapsedGrid=!0,t?e.collapseElementsProperties():e.removeCollapseElementsProperties(),e.updateGridLayoutCollapse(i),_updateBlocksLayout(a),setTimeout(function(){Rexbuilder_Util_Editor.updatingCollapsedGrid=!1,e._fixImagesDimension(),e._createFirstReverseStack(),Rexbuilder_Util.editorMode&&e._updateElementsSizeViewers()},200)},updateRemovingBlock=function(e,t,a){if(t?(a.removeBlock(e.get(0)),Rexbuilder_Util.stopBlockVideos(e)):(a.reAddBlock(e),Rexbuilder_Util.playBlockVideos(e)),0==a.properties.numberBlocksVisibileOnGrid)e.parents(".rexpansive_section").addClass("empty-section");else{var i=e.parents(".rexpansive_section");i.removeClass("empty-section")}},_updateSectionName=function(e,t){if(null!==t&&(e.attr("data-rexlive-section-name",t),""!==t&&"undefined"!=typeof t)){var a=t.replace(/\s/gm,"");Rex_Navigator.updateNavigatorItem(e,a,t)}},_updateSectionNavLabel=function(e,t){e.children(".section-data").attr("data-section_nav_label",t)},_fixSectionDomOrder=function(e,t,a){var i,o,r,d,l=[];t="undefined"!=typeof t&&t;var n,s=[].slice.call(Rexbuilder_Util.rexContainer.getElementsByClassName("rexpansive_section")),c=s.length;for(n=0;n<c;n++){o=$(s[n]);var u={rexID:s[n].getAttribute("data-rexlive-section-id"),section_is_model:Rexbuilder_Util.hasClass(s[n],"rex-model-section"),section_model_id:s[n].getAttribute("data-rexlive-model-id"),section_model_number:s[n].getAttribute("data-rexlive-model-number"),$section:o.detach()};l.push(u)}for(r=0;r<e.length;r++){for(d=0;d<l.length;d++)if(l[d].rexID==e[r].rexID){if(!l[d].section_is_model){i=l[d].$section;break}if(l[d].section_model_number==e[r].modelNumber){i=l[d].$section;break}}Rexbuilder_Util.$rexContainer.append(i),l.splice(d,1)}for(d=0;d<l.length;d++)Rexbuilder_Util.$rexContainer.append(l[d].$section);"default"==Rexbuilder_Util.activeLayout&&(Rexbuilder_Util.updateDefaultLayoutStateDOMOrder(e),"undefined"!=typeof a&&Rexbuilder_Util.updateSectionOrderCustomLayouts(a,e))},_updateSectionPhotoswipe=function(e){for(var t=0;t<e.length;t++)e[t].$data.attr("data-photoswipe",e[t].photoswipe)},_updateCustomClasses=function(e,t){var a,i="";e.is("section")?(a=e.children(".section-data"),i=a.attr("data-custom_classes")):(a=e.children(".rexbuilder-block-data"),i=a.attr("data-block_custom_class")),"undefined"==typeof i&&(i=""),i=i.trim();for(var o=i.split(/\s+/),r=0;r<o.length;r++)Rexbuilder_Util_Editor.removeCustomClass(o[r],a),e.removeClass(o[r]);for(var r=0;r<t.length;r++)Rexbuilder_Util_Editor.addCustomClass(t[r],a),e.addClass(t[r])},_updateBlockUrl=function(e,t){var a=e.children(".rexbuilder-block-data");a.attr("data-linkurl",t)},_updateFlexPostition=function(e,t){if(!e.hasClass("block-has-slider")){var a="rex-flex-top rex-flex-middle rex-flex-bottom rex-flex-left rex-flex-center rex-flex-right";e.removeClass(a);var i=e.children(".rexbuilder-block-data");i.attr("data-block_flex_position",""),""!=t.x&&""!=t.y&&(e.addClass("rex-flex-"+t.x),e.addClass("rex-flex-"+t.y),i.attr("data-block_flex_position",t.x+" "+t.y))}},_updateImageFlexPostition=function(e,t){if(!e.hasClass("block-has-slider")){var a="rex-flex-img-top rex-flex-img-middle rex-flex-img-bottom rex-flex-img-left rex-flex-img-center rex-flex-img-right";e.removeClass(a);var i=e.children(".rexbuilder-block-data");i.attr("data-block_flex_img_position",""),""!=t.x&&""!=t.y&&(e.addClass("rex-flex-img-"+t.x),e.addClass("rex-flex-img-"+t.y),i.attr("data-block_flex_img_position",t.x+" "+t.y))}},_updateCustomCSS=function(e){var t=document.getElementById("rexpansive-builder-style-inline-css");t&&(t.textContent=e)},_updateSectionVideoBackground=function(e,t){_updateVideos(e,t)},_updateSectionBackgroundGradient=function(e,t){var a=e.children(".section-data"),i=Rexbuilder_Util_Editor.getGradientSafeValue(t.color),o=e[0];o.style.background=i,a.attr("data-color_bg_section",t.color),a.attr("data-color_bg_section_active",t.active),"undefined"!=typeof Rexbuilder_Section_Editor&&Rexbuilder_Section_Editor.updateRowBackgroundGradientTool(e,i)},_updateBlockBackgroundColorLive=function(e,t){var a,i;if(""!=e.modelNumber){var o='section[data-rexlive-section-id="'+e.sectionID+'"][data-rexlive-model-number="'+e.modelNumber+'"]',r='div[data-rexbuilder-block-id="'+e.rexID+'"] .grid-item-content';a=Rexbuilder_Util.$rexContainer.find(o).find(r),i=a[0],-1!==getComputedStyle(i).background.indexOf("linear-gradient")&&(i.style.background=""),i.style.backgroundColor=t}else a=Rexbuilder_Util.$rexContainer.find('section[data-rexlive-section-id="'+e.sectionID+'"]').find('div [data-rexbuilder-block-id="'+e.rexID+'"] .grid-item-content'),i=a[0],-1!==getComputedStyle(i).background.indexOf("linear-gradient")&&(i.style.background=""),i.style.backgroundColor=t;"undefined"!=typeof Rexbuilder_Block_Editor&&Rexbuilder_Block_Editor.updateBlockBackgroundColorToolLive(a,t)},_updateBlockBackgroundColor=function(e){var t=e.$elem,a=t.find(".grid-item-content"),i=a[0],o=t.children(".rexbuilder-block-data");-1!==getComputedStyle(i).background.indexOf("linear-gradient")&&(i.style.background=""),i.style.backgroundColor=e.color,o.attr("data-color_bg_block",e.color),o.attr("data-color_bg_elem_active",e.active),"undefined"!=typeof Rexbuilder_Block_Editor&&Rexbuilder_Block_Editor.updateBlockBackgroundColorTool(t,e.color,e.active)},_updateBlockBackgroundGradient=function(e){var t=e.$elem,a=t.find(".grid-item-content"),i=a[0],o=t.children(".rexbuilder-block-data"),r=Rexbuilder_Util_Editor.getGradientSafeValue(e.color);i.style.background=r,o.attr("data-color_bg_block",e.color),o.attr("data-color_bg_elem_active",e.active),"undefined"!=typeof Rexbuilder_Block_Editor&&Rexbuilder_Block_Editor.updateBlockBackgroundGradientTool(t,r)},updateSectionOverlay=function(e,t){var a=e.children(".responsive-overlay"),i=e.children(".section-data");
_setBackgroundColor(a,t.color),i.attr("data-row_overlay_color",t.color),i.attr("data-row_overlay_active",t.active),"true"==t.active.toString()?a.addClass("rex-active-overlay"):a.removeClass("rex-active-overlay"),"undefined"!=typeof Rexbuilder_Section_Editor&&Rexbuilder_Section_Editor.updateRowOverlayColorTool(e,t)},_updateSectionOverlayGradient=function(e,t){var a=e.children(".section-data"),i=e.children(".responsive-overlay"),o=i[0],r=Rexbuilder_Util_Editor.getGradientSafeValue(t.color);o.style.background=r,a.attr("data-row_overlay_color",t.color),a.attr("data-row_overlay_active",t.active),"true"==t.active.toString()?i.addClass("rex-active-overlay"):i.removeClass("rex-active-overlay"),"undefined"!=typeof Rexbuilder_Section_Editor&&Rexbuilder_Section_Editor.updateRowOverlayGradientTool(e,{active:t.active,color:r})},_updateBlockOverlayColorLive=function(e,t){var a;if(""!=e.modelNumber){var i='section[data-rexlive-section-id="'+e.sectionID+'"][data-rexlive-model-number="'+e.modelNumber+'"]',o='div [data-rexbuilder-block-id="'+e.rexID+'"] .responsive-block-overlay';a=Rexbuilder_Util.$rexContainer.find(i).find(o),-1!==a.css("background").indexOf("linear-gradient")&&a.css("background",""),a.css("background-color",t)}else{a=Rexbuilder_Util.$rexContainer.find('section[data-rexlive-section-id="'+e.sectionID+'"]').find('div [data-rexbuilder-block-id="'+e.rexID+'"] .responsive-block-overlay');var r=Rexbuilder_Util.$rexContainer.find('[data-rexbuilder-block-id="'+e.rexID+'"] .slider-overlay');if(-1!==a.css("background").indexOf("linear-gradient")&&a.css("background",""),a.css("background-color",t),0===r.length){var d=Rexbuilder_Util.$rexContainer.find('[data-rexbuilder-block-id="'+e.rexID+'"] .rex-slider-element');""!==t&&d.append('<div class="slider-overlay" style="background-color:'+t+'"></div>')}else r.css("background-color",t)}"undefined"!=typeof Rexbuilder_Block_Editor&&Rexbuilder_Block_Editor.updateBlockOverlayColorToolLive(a,t)},_updateBlockOverlay=function(e){var t=e.color,a=e.active,i=e.$elem,o=i.children(".rexbuilder-block-data"),r=i.find(".responsive-block-overlay"),d=r[0],l=r.find(".slider-overlay");if(-1!==getComputedStyle(d).background.indexOf("linear-gradient")&&(d.style.background=""),d.style.backgroundColor=t,0===l.length){var n=i.find(".rex-slider-element");""!==t&&n.append('<div class="slider-overlay" style="background-color:'+t+'"></div>')}else l.css("background-color",t);o.attr("data-overlay_block_color",t),o.attr("data-overlay_block_color_active",a),"true"==a.toString()?r.addClass("rex-active-overlay"):r.removeClass("rex-active-overlay"),"undefined"!=typeof Rexbuilder_Block_Editor&&Rexbuilder_Block_Editor.updateBlockOverlayColorTool(i,t,a)},_updateBlockOverlayGradient=function(e){var t=e.color,a=e.active,i=e.$elem,o=i.children(".rexbuilder-block-data"),r=i.find(".responsive-block-overlay"),d=Rexbuilder_Util_Editor.getGradientSafeValue(e.color),l=r[0];l.style.background=d,o.attr("data-overlay_block_color",t),o.attr("data-overlay_block_color_active",a),"true"==a.toString()?r.addClass("rex-active-overlay"):r.removeClass("rex-active-overlay"),"undefined"!=typeof Rexbuilder_Block_Editor&&Rexbuilder_Block_Editor.updateBlockOverlayGradientTool(i,d)},_updateSectionBackgroundImage=function(e,t){_updateImageBG(e,t)},_updateSectionVisibility=function(e,t,a,i){t?("default"==Rexbuilder_Util.activeLayout&&(e.removeClass("removing_section"),Rexbuilder_Util.addSectionID(e.attr("data-rexlive-section-id"))),e.removeClass("rex-hide-section"),Rexbuilder_Util.playPluginsSection(e)):(Rexbuilder_Util.stopPluginsSection(e),"default"==Rexbuilder_Util.activeLayout&&(e.addClass("removing_section"),Rexbuilder_Util.removeSectionID(e.attr("data-rexlive-section-id"))),e.addClass("rex-hide-section")),"undefined"!=typeof a&&null!=a&&Rexbuilder_Util.updatePageCustomizationsDomOrder(a),"undefined"!=typeof i&&null!=i&&Rexbuilder_Util.updateDefaultLayoutState({pageData:i})},_updateModelVisibility=function(e){var t=e.$sectionToHide,a=e.$sectionToShow,i=e.layoutsOrder,o=e.defaultStateSections;_updateSectionVisibility(t,!1),_updateSectionVisibility(a,!0),"undefined"!=typeof i&&null!=i&&Rexbuilder_Util.updatePageCustomizationsDomOrder(i),"undefined"!=typeof o&&null!=o&&Rexbuilder_Util.updateDefaultLayoutState({pageData:o})},_updateSectionBecameModel=function(e){var t=e.$section,a=e.layoutsOrder,i=e.defaultStateSections;e.isModel?(t.addClass("rex-model-section"),t.addClass("rexlive-block-grid-editing"),t.attr("data-rexlive-model-editing","false"),0==t.find(".grid-stack-row").parent().children(".rexpansive-block-grid").length&&t.find(".grid-stack-row").parent().prepend('<div class="rexpansive-block-grid"></div>'),0==t.find(".rexpansive-block-section-toolbox").length&&t.find(".section-toolBox").parent().prepend('<div class="rexpansive-block-section-toolbox"></div>')):(t.removeClass("rex-model-section"),t.removeClass("rexlive-block-grid-editing"),t.attr("data-rexlive-model-editing","false"),t.find(".grid-stack-row").parent().children(".rexpansive-block-grid").remove(),t.find(".rexpansive-block-section-toolbox").remove()),t.attr("data-rexlive-model-id",e.modelID),t.attr("data-rexlive-model-name",e.modelName),t.attr("data-rexlive-model-number",e.modelNumber),t.attr("data-rexlive-section-id",e.sectionID),"undefined"!=typeof a&&null!=a&&Rexbuilder_Util.updatePageCustomizationsDomOrder(a),"undefined"!=typeof i&&null!=i&&Rexbuilder_Util.updateDefaultLayoutState({pageData:i})},updateLockEditModel=function(e,t){var a=e.parents(".rexpansive_section");t?(a.addClass("rexlive-block-grid-editing"),a.attr("data-rexlive-model-editing","false"),0==a.find(".grid-stack-row").parent().children(".rexpansive-block-grid").length&&a.find(".grid-stack-row").parent().prepend('<div class="rexpansive-block-grid"></div>'),0==a.find(".rexpansive-block-section-toolbox").length&&a.find(".section-toolBox").parent().prepend('<div class="rexpansive-block-section-toolbox"></div>'),e.removeClass("unlocked"),e.addClass("locked")):(e.addClass("unlocked"),e.removeClass("locked"),a.removeClass("rexlive-block-grid-editing"),a.attr("data-rexlive-model-editing","true"),a.find(".grid-stack-row").parent().children(".rexpansive-block-grid").remove(),a.find(".rexpansive-block-section-toolbox").remove())},_fixModelNumbers=function(){var e,t,a=[];if(Rexbuilder_Util.rexContainer){var i,o=[].slice.call(Rexbuilder_Util.rexContainer.querySelectorAll(".rexpansive_section:not(.removing_section)")),r=o.length;for(i=0;i<r;i++)if(Rexbuilder_Util.hasClass(o[i],"rex-model-section")){var d=o[i].getAttribute("data-rexlive-model-id");for(t=!1,e=0;e<a.length;e++)a[e].id==d&&(a[e].number=a[e].number+1,o[i].setAttribute("data-rexlive-model-number",a[e].number),t=!0);if(!t){var l={id:d,number:1};a.push(l),o[i].setAttribute("data-rexlive-model-number",l.number)}}}},_updateSectionWidthData=function(e,t){var a=e.children(".section-data");a.attr("data-section_width",t.sectionWidth),a.attr("data-dimension",t.widthType)},_updateSectionWidth=function(e,t){var a=t.section_width,i=t.dimension,o=t.galleryInstance;_updateSectionWidthData(e,{sectionWidth:a,widthType:i}),o.updateSectionWidthWrap(a),Rexbuilder_Util_Editor.updatingGridstack=!0,o.batchGridstack(),o.updateGridstackGridSizes(t.singleWidth,t.singleHeight),_updateBlocksLayout(t.blocksDisposition),o.commitGridstack(),Rexbuilder_Util_Editor.updatingGridstack=!1},_updateRowDistancesData=function(e,t){var a=e.parents(".rexpansive_section").children(".section-data");e.attr("data-separator",t.gutter),e.attr("data-row-separator-top",t.top),e.attr("data-row-separator-right",t.right),e.attr("data-row-separator-bottom",t.bottom),e.attr("data-row-separator-left",t.left),a.attr("data-block_distance",t.gutter),a.attr("data-row_separator_top",t.top),a.attr("data-row_separator_right",t.right),a.attr("data-row_separator_bottom",t.bottom),a.attr("data-row_separator_left",t.left)},_updateRowDistances=function(e,t){var a=t.rowDistances,i=e.find(".grid-stack-row"),o=t.galleryInstance;_updateRowDistancesData(i,a),o.updateRowDistances(a),Rexbuilder_Util_Editor.updatingGridstack=!0,o.batchGridstack(),o.updateGridstackGridSizes(t.singleWidth,t.singleHeight),_updateBlocksLayout(t.blocksDisposition),o.commitGridstack(),Rexbuilder_Util_Editor.updatingGridstack=!1},_updateSectionMarginsData=function(e,t){var a=e[0];a.style.marginTop=t.top+"px",a.style.marginRight=t.right+"px",a.style.marginBottom=t.bottom+"px",a.style.marginLeft=t.left+"px"},_updateSectionMargins=function(e,t){_updateSectionMarginsData(e,t.marginsSection);var a=t.galleryInstance;Rexbuilder_Util_Editor.updatingGridstack=!0,a.batchGridstack(),a.updateGridstackGridSizes(t.singleWidth,t.singleHeight),_updateBlocksLayout(t.blocksDisposition),a.commitGridstack(),Rexbuilder_Util_Editor.updatingGridstack=!1},_updateGridLayoutDomProperties=function(e,t){var a=e.parents(".rexpansive_section").children(".section-data");e.attr("data-layout",t),e.attr("data-full-height",!1),a.attr("data-layout",t),a.attr("data-full_height",!1)},_updateSectionLayout=function(e,t){_updateGridLayoutDomProperties(e,t.gridLayout);var a=t.galleryInstance;Rexbuilder_Util_Editor.updatingGridstack=!0,a.settings.galleryLayout=t.gridLayout,a.batchGridstack(),a.updateFloatingElementsGridstack(),a.updateGridstackGridSizes(t.singleWidth,t.singleHeight),_updateBlocksLayout(t.blocksDisposition),a.commitGridstack(),a._updateElementsSizeViewers(),Rexbuilder_Section_Editor.updateSectionLayoutTool(a.$section,{layout:t.gridLayout}),Rexbuilder_Util_Editor.updatingGridstack=!1},_updateRexButton=function(e){Rexbuilder_Rexbutton.updateButton(e)},_performAction=function(e,t){var a;t?(a=e.performActionData,Rexbuilder_Util_Editor.undoActive=!1,Rexbuilder_Util_Editor.redoActive=!0):(a=e.reverseActionData,Rexbuilder_Util_Editor.redoActive=!1,Rexbuilder_Util_Editor.undoActive=!0);var i;i=""!=e.modelNumber?Rexbuilder_Util.$rexContainer.find('section[data-rexlive-section-id="'+e.sectionID+'"][data-rexlive-model-number="'+e.modelNumber+'"]'):Rexbuilder_Util.$rexContainer.find('section[data-rexlive-section-id="'+e.sectionID+'"]');var o=i.find(".grid-stack-row"),r=o.data();if(void 0!==r)var d=o.data().plugin_perfectGridGalleryEditor;switch(e.actionName){case"updateSectionLayout":_updateSectionLayout(o,a);break;case"updateSectionFullHeight":updateSectionFullHeight(a);break;case"updateSectionBlocksDisposition":void 0!==d&&(_updateBlocksLayout(a),setTimeout(d._updateElementsSizeViewers(),200));break;case"updateBlockVisibility":void 0!==d&&updateRemovingBlock(a.targetElement,a.hasToBeRemoved,a.galleryInstance);break;case"updateSlider":_updateSlider(a);break;case"updateSectionName":_updateSectionName(i,a.sectionName);break;case"updateSectionPhotoswipe":_updateSectionPhotoswipe(a.elements);break;case"collapseSection":_collapseGrid(a.gridInstance,a.collapse,a.blockDisposition,a.gridLayout);break;case"updateCustomClasses":_updateCustomClasses(a.$target,a.classes);break;case"updateCustomCSS":_updateCustomCSS(a.css);break;case"updateSectionBackgroundColor":updateSectionBackgroundColor(i,a);break;case"updateSectionOverlay":updateSectionOverlay(i,a);break;case"updateSectionImageBG":_updateImageBG(i,a);break;case"updateSectionVideoBG":Rexbuilder_Dom_Util.updateVideos(i,a);break;case"updateBlockBackgroundColor":_updateBlockBackgroundColor(a);break;case"updateBlockBackgroundGradient":_updateBlockBackgroundGradient(a);break;case"updateBlockOverlayGradient":_updateBlockOverlayGradient(a);break;case"updateBlockOverlay":_updateBlockOverlay(a);break;case"updateBlockImageBG":Rexbuilder_Util_Editor.updatingImageBg=!0,_updateImageBG(a.$itemContent,a.imageOpt),void 0!==d&&"masonry"==d.settings.galleryLayout&&d.updateElementHeight(a.$itemContent.parents(".grid-stack-item").get(0)),Rexbuilder_Util_Editor.updatingImageBg=!1;break;case"updateBlockPhotoswipe":_updateBlockPhotoswipe(a);break;case"updateBlockPadding":Rexbuilder_Util_Editor.updatingPaddingBlock=!0,_updateBlockPaddings(a.$elem,a.dataPadding),void 0!==d&&"masonry"==d.settings.galleryLayout&&d.updateElementHeight(a.$elem[0],!0),Rexbuilder_Util_Editor.updatingPaddingBlock=!1;break;case"updateBlockVideoBG":Rexbuilder_Dom_Util.updateVideos(a.$itemContent,a.videoOpt);break;case"updateBlockFlexPosition":_updateFlexPostition(a.$elem,a.dataPosition);break;case"updateBlockImageFlexPosition":_updateImageFlexPostition(a.$elem,a.dataPosition);break;case"updateBlockUrl":_updateBlockUrl(a.$elem,a.url);break;case"updateSectionVisibility":_updateSectionVisibility(i,a.show,a.layoutsOrder,a.stateDefault);break;case"updateSectionModel":_updateModelVisibility(a);break;case"sectionBecameModel":_updateSectionBecameModel(a);break;case"updateSectionOrder":_fixSectionDomOrder(a.sectionOrder,!1,a.sectionMoved);break;case"updateLockButton":updateLockEditModel(a.$button,a.lock);break;case"updateSectionWidth":_updateSectionWidth(i,a);break;case"updateGridDistances":_updateRowDistances(i,a);break;case"updateSectionMargins":_updateSectionMargins(i,a);break;case"updateRexButton":_updateRexButton(a)}Rexbuilder_Util_Editor.undoActive=!1,Rexbuilder_Util_Editor.redoActive=!1},init=function(){this.lastSliderNumber=0};return{init:init,updateRow:_updateRow,updateSectionMargins:_updateSectionMargins,updateSectionMarginsData:_updateSectionMarginsData,updateImageBG:_updateImageBG,updateBlockPhotoswipe:_updateBlockPhotoswipe,performAction:_performAction,addYoutubeVideo:_addYoutubeVideo,removeYoutubeVideo:_removeYoutubeVideo,addVimeoVideo:_addVimeoVideo,removeVimeoVideo:_removeVimeoVideo,addMp4Video:_addMp4Video,removeMp4Video:_removeMp4Video,updateSlider:_updateSlider,updateSliderStack:_updateSliderStack,updateSectionName:_updateSectionName,updateSectionNavLabel:_updateSectionNavLabel,enablePhotoswipeAllBlocksSection:_enablePhotoswipeAllBlocksSection,removePhotoswipeAllBlocksSection:_removePhotoswipeAllBlocksSection,updateCustomClasses:_updateCustomClasses,collapseGrid:_collapseGrid,updateCustomCSS:_updateCustomCSS,updateSectionVideoBackground:_updateSectionVideoBackground,updateSectionBackgroundImage:_updateSectionBackgroundImage,updateSectionBackgroundColor:updateSectionBackgroundColor,updateSectionBackgroundColorLive:_updateSectionBackgroundColorLive,updateSectionBackgroundGradient:_updateSectionBackgroundGradient,updateSectionOverlay:updateSectionOverlay,updateSectionOverlayColorLive:updateSectionOverlayColorLive,updateSectionOverlayGradient:_updateSectionOverlayGradient,updateBlockBackgroundColor:_updateBlockBackgroundColor,updateBlockBackgroundColorLive:_updateBlockBackgroundColorLive,updateBlockBackgroundGradient:_updateBlockBackgroundGradient,updateBlockOverlayColorLive:_updateBlockOverlayColorLive,updateBlockOverlay:_updateBlockOverlay,updateBlockOverlayGradient:_updateBlockOverlayGradient,updateVideos:_updateVideos,updateBlockPaddings:_updateBlockPaddings,updateFlexPostition:_updateFlexPostition,updateImageFlexPostition:_updateImageFlexPostition,updateBlockUrl:_updateBlockUrl,updateSectionVisibility:_updateSectionVisibility,fixSectionDomOrder:_fixSectionDomOrder,updateSectionBecameModel:_updateSectionBecameModel,updateLockEditModel:updateLockEditModel,fixModelNumbers:_fixModelNumbers,updateSectionWidthData:_updateSectionWidthData,updateSectionWidth:_updateSectionWidth,updateRowDistancesData:_updateRowDistancesData,updateGridLayoutDomProperties:_updateGridLayoutDomProperties,htmlToElement:htmlToElement,updateBulkSection:_updateBulkSection,updateBulkBlock:updateBulkBlock,updateRemovingBlock:updateRemovingBlock,updateSectionFullHeight:updateSectionFullHeight}}(jQuery);
/**
 Values to insert on "wp_options" to work with rexbuttons
 Data are in form
 "option_name"
 "option_value"


_rex_buttons_ids

[\"9UEc\"]


_rex_buttons_styles

[{\"rexID\":\"9UEc\",\"buttonName\":\"Rex Funny v23\",\"rules\":{\"element\":{\"text_color\":\"rgb(111, 115, 181)\",\"font_size\":\"px\",\"background_color\":\"rgb(0, 238, 255)\",\"button_height\":\"px\",\"button_width\":\"\",\"border_color\":\"rgb(165, 0, 255)\",\"border_width\":\"px\",\"border_radius\":\"px\",\"margin_top\":\"px\",\"margin_bottom\":\"px\",\"margin_right\":\"px\",\"margin_left\":\"px\",\"padding_top\":\"px\",\"padding_bottom\":\"px\",\"padding_right\":\"px\",\"padding_left\":\"px\"},\"hover\":{\"background_color\":\"rgb(165, 0, 146)\",\"text_color\":\"rgb(0, 60, 255)\",\"border_color\":\"rgb(0, 255, 15)\"}}}]


_rex_button_9UEc_css

.rex-button-wrapper[data-rex-button-id=\"9UEc\"] .rex-button-container{font-size: 12px;color: rgb(111, 115, 181);min-height: 70px;min-width: 100px;margin-top: 20px;margin-right: 20px;margin-bottom: 20px;margin-left: 20px;}.rex-button-wrapper[data-rex-button-id=\"9UEc\"] .rex-button-text{padding-top: 20px;padding-right: 20px;padding-bottom: 20px;padding-left: 20px;}.rex-button-wrapper[data-rex-button-id=\"9UEc\"] .rex-button-background{background-color: rgb(0, 238, 255);border-color: rgb(165, 0, 255);border-width: 5px;border-radius: 10px;border-style: solid;}.rex-button-wrapper[data-rex-button-id=\"9UEc\"] .rex-button-background:hover{background-color: rgb(165, 0, 146);border-color: rgb(0, 255, 15);}.rex-button-wrapper[data-rex-button-id=\"9UEc\"] .rex-button-container:hover{color: rgb(0, 60, 255);}

_rex_button_9UEc_html

<span class=\"rex-button-wrapper\" data-rex-button-id=\"9UEc\"><span class=\"rex-button-data\" style=\"display:none;\" data-text-color=\"rgb(111, 115, 181)\" data-text-size=\"px\" data-background-color=\"rgb(0, 238, 255)\" data-background-color-hover=\"rgb(165, 0, 146)\" data-border-color-hover=\"rgb(0, 255, 15)\" data-text-color-hover=\"rgb(0, 60, 255)\" data-border-width=\"px\" data-border-color=\"rgb(165, 0, 255)\" data-border-radius=\"px\" data-button-height=\"px\" data-button-width=\"\" data-margin-top=\"px\" data-margin-bottom=\"px\" data-margin-left=\"px\" data-margin-right=\"px\" data-padding-left=\"px\" data-padding-right=\"px\" data-padding-top=\"px\" data-padding-bottom=\"px\" data-link-target=\"#\" data-link-type=\"_blank\" data-button-name=\"Rex Funny v23\"></span><a href=\"#\" class=\"rex-button-container\" target=\"_blank\"><span class=\"rex-button-background\"><span class=\"rex-button-text\">Learn More</span></span></a></span>


 */
var Rexbuilder_Rexbutton=function(t){function e(t){for(var e=0;e<d.cssRules.length;e++)if(-1!==d.cssRules[e].selectorText.indexOf(t))return!0;return!1}function r(t){t=t||!1;var e=[];if(!Rexbuilder_Util.rexContainer||"undefined"==typeof Rexbuilder_Util.rexContainer)return e;for(var r,o,a,n,i,s=Array.prototype.slice.call(Rexbuilder_Util.rexContainer.querySelectorAll(".rexpansive_section")),d=s.length,l=0,u=0,b=0,c=0,p=0;b<d;b++)if(r=s[b],t||!Rexbuilder_Util.hasClass(r,"removing_section"))for(o=Array.prototype.slice.call(r.querySelectorAll(".perfect-grid-item")),l=o.length,c=0;c<l;c++)if(a=o[c],t||!Rexbuilder_Util.hasClass(a,"removing_block"))for(n=Array.prototype.slice.call(a.querySelectorAll(".rex-button-wrapper")),u=n.length,p=0;p<u;p++)i=n[p],e.push(i.getAttribute("data-rex-button-id"));return e=Rexbuilder_Util.removeArrayDuplicates(e)}function o(){var t=r(!0),e={};if(t.forEach(function(t){e[t]={occurrencies:0}}),Rexbuilder_Util.rexContainer&&"undefined"!=typeof Rexbuilder_Util.rexContainer)for(var o,a,n=Array.prototype.slice.call(Rexbuilder_Util.rexContainer.querySelectorAll(".rex-button-wrapper")),i=n.length,s=0;s<i;s++)o=n[s],a=o.getAttribute("data-rex-button-id"),e[a].occurrencies++,o.setAttribute("data-rex-button-number",e[a].occurrencies)}function a(){if(l=[],Rexbuilder_Util.rexContainer&&"undefined"!=typeof Rexbuilder_Util.rexContainer)for(var r,o,a,n=Array.prototype.slice.call(Rexbuilder_Util.rexContainer.querySelectorAll(".rex-button-wrapper")),i=0;i<n.length;i++)r=n[i],o=r.getAttribute("data-rex-button-id"),a=parseInt(r.getAttribute("data-rex-button-number")),l.push({id:o,number:a}),Rexbuilder_Util.hasClass(r,"rex-separate-button")&&(e(o)||N(t(r))),l[i].number<a&&(l[i].number=a)}function n(e){var r=Rexbuilder_Util_Editor.isJQuery(e);r||(e=t(e));var o=e.next("p"),a=0!==o.length;return a}function i(t){return t.next("p")}function s(t){var e=Rexbuilder_Util_Editor.isJQuery(t);e&&(t=t.get(0));var r=Rexbuilder_Live_Templates.getTemplate("empty-paragraph");t.insertAdjacentHTML("afterend",r)}var d,l,u,b=function(){if(0==Rexbuilder_Rexbutton.$buttonsStyle.length){var t="",e=document.head||document.getElementsByTagName("head")[0],r=document.createElement("style");r.type="text/css",r.id="rexpansive-builder-rexbutton-style-inline-css",r.dataset.rexName="buttons-style",r.styleSheet?r.styleSheet.cssText=t:r.appendChild(document.createTextNode(t)),e.appendChild(r)}for(var o=0;o<document.styleSheets.length;o++)"rexpansive-builder-rexbutton-style-inline-css"==document.styleSheets[o].ownerNode.id&&(d=document.styleSheets[o])},c=function(){return d},p=function(t,e){"insertRule"in d?d.insertRule('.rex-button-wrapper[data-rex-button-id="'+t+'"] .rex-button-container{'+e+"}",d.cssRules.length):"addRule"in d&&d.addRule('.rex-button-wrapper[data-rex-button-id="'+t+'"] .rex-button-container{'+e+"}",d.cssRules.length)},g=function(t,e){"insertRule"in d?d.insertRule('.rex-button-wrapper[data-rex-button-id="'+t+'"] .rex-button-background{'+e+"}",d.cssRules.length):"addRule"in d&&d.addRule('.rex-button-wrapper[data-rex-button-id="'+t+'"] .rex-button-background{'+e+"}",d.cssRules.length)},x=function(t,e){"insertRule"in d?d.insertRule('.rex-button-wrapper[data-rex-button-id="'+t+'"] .rex-button-text{'+e+"}",d.cssRules.length):"addRule"in d&&d.addRule('.rex-button-wrapper[data-rex-button-id="'+t+'"] .rex-button-text{'+e+"}",d.cssRules.length)},h=function(t,e){"insertRule"in d?d.insertRule('.rex-button-wrapper[data-rex-button-id="'+t+'"] .rex-button-background:hover{'+e+"}",d.cssRules.length):"addRule"in d&&d.addRule('.rex-button-wrapper[data-rex-button-id="'+t+'"] .rex-button-background:hover{'+e+"}",d.cssRules.length)},m=function(t,e){"insertRule"in d?d.insertRule('.rex-button-wrapper[data-rex-button-id="'+t+'"] .rex-button-container:hover{'+e+"}",d.cssRules.length):"addRule"in d&&d.addRule('.rex-button-wrapper[data-rex-button-id="'+t+'"] .rex-button-container:hover{'+e+"}",d.cssRules.length)},_=function(t,e,r){for(var o=0;o<d.cssRules.length;o++)if(d.cssRules[o].selectorText=='.rex-button-wrapper[data-rex-button-id="'+t+'"] .rex-button-container'||d.cssRules[o].selectorText=="[data-rex-button-id='"+t+"'].rex-button-wrapper .rex-button-container"){switch(e){case"font-size":d.cssRules[o].style.fontSize=r;break;case"color":d.cssRules[o].style.color=r;break;case"min-height":d.cssRules[o].style.minHeight=r;break;case"min-width":d.cssRules[o].style.minWidth=r;break;case"margin-top":d.cssRules[o].style.marginTop=r;break;case"margin-bottom":d.cssRules[o].style.marginBottom=r;break;case"margin-left":d.cssRules[o].style.marginLeft=r;break;case"margin-right":d.cssRules[o].style.marginRight=r}break}},R=function(t,e,r){for(var o=0;o<d.cssRules.length;o++)if(d.cssRules[o].selectorText=='.rex-button-wrapper[data-rex-button-id="'+t+'"] .rex-button-background'||d.cssRules[o].selectorText=="[data-rex-button-id='"+t+"'].rex-button-wrapper .rex-button-background"){switch(e){case"border-width":d.cssRules[o].style.borderWidth=r,d.cssRules[o].style.borderTopWidth=r,d.cssRules[o].style.borderLeftWidth=r,d.cssRules[o].style.borderRightWidth=r,d.cssRules[o].style.borderBottomWidth=r,d.cssRules[o].style.borderTop=r+" "+d.cssRules[o].style.borderTopStyle+" "+d.cssRules[o].style.borderTopColor,d.cssRules[o].style.borderLeft=r+" "+d.cssRules[o].style.borderLeftStyle+" "+d.cssRules[o].style.borderLeftColor,d.cssRules[o].style.borderRight=r+" "+d.cssRules[o].style.borderRightStyle+" "+d.cssRules[o].style.borderRightColor,d.cssRules[o].style.borderBottom=r+" "+d.cssRules[o].style.borderBottomStyle+" "+d.cssRules[o].style.borderBottomColor;break;case"border-color":d.cssRules[o].style.borderColor=r,d.cssRules[o].style.borderTopColor=r,d.cssRules[o].style.borderLeftColor=r,d.cssRules[o].style.borderRightColor=r,d.cssRules[o].style.borderBottomColor=r;break;case"border-style":d.cssRules[o].style.borderStyle=r,d.cssRules[o].style.borderTopStyle=r,d.cssRules[o].style.borderLeftStyle=r,d.cssRules[o].style.borderRightStyle=r,d.cssRules[o].style.borderBottomStyle=r,d.cssRules[o].style.borderTop=d.cssRules[o].style.borderTopWidth+" "+r+" "+d.cssRules[o].style.borderTopColor,d.cssRules[o].style.borderLeft=d.cssRules[o].style.borderLeftWidth+" "+r+" "+d.cssRules[o].style.borderLeftColor,d.cssRules[o].style.borderRight=d.cssRules[o].style.borderRightWidth+" "+r+" "+d.cssRules[o].style.borderRightColor,d.cssRules[o].style.borderBottom=d.cssRules[o].style.borderBottomWidth+" "+r+" "+d.cssRules[o].style.borderBottomColor;break;case"border-radius":d.cssRules[o].style.borderRadius=r,d.cssRules[o].style.borderTopLeftRadius=r,d.cssRules[o].style.borderTopRightRadius=r,d.cssRules[o].style.borderBottomLeftRadius=r,d.cssRules[o].style.borderBottomRightRadius=r,d.cssRules[o].style.webkitBorderRadius=r,d.cssRules[o].style.webkitBorderTopLeftRadius=r,d.cssRules[o].style.webkitBorderTopRightRadius=r,d.cssRules[o].style.webkitBorderBottomLeftRadius=r,d.cssRules[o].style.webkitBorderBottomRightRadius=r;break;case"background-color":d.cssRules[o].style.backgroundColor=r}break}},f=function(t,e,r){for(var o=0;o<d.cssRules.length;o++)if(d.cssRules[o].selectorText=='.rex-button-wrapper[data-rex-button-id="'+t+'"] .rex-button-text'||d.cssRules[o].selectorText=="[data-rex-button-id='"+t+"'].rex-button-wrapper .rex-button-text")switch(e){case"padding-left":d.cssRules[o].style.paddingLeft=r;break;case"padding-right":d.cssRules[o].style.paddingRight=r;break;case"padding-top":d.cssRules[o].style.paddingTop=r;break;case"padding-bottom":d.cssRules[o].style.paddingBottom=r}},y=function(t,e,r){for(var o=0;o<d.cssRules.length;o++)if(d.cssRules[o].selectorText=='.rex-button-wrapper[data-rex-button-id="'+t+'"] .rex-button-container:hover'||d.cssRules[o].selectorText=="[data-rex-button-id='"+t+"'].rex-button-wrapper .rex-button-container:hover"){switch(e){case"color":d.cssRules[o].style.color=r}break}},v=function(t,e,r){for(var o=0;o<d.cssRules.length;o++)if(d.cssRules[o].selectorText=='.rex-button-wrapper[data-rex-button-id="'+t+'"] .rex-button-background:hover'||d.cssRules[o].selectorText=="[data-rex-button-id='"+t+"'].rex-button-wrapper .rex-button-background:hover"){switch(e){case"background-color":d.cssRules[o].style.backgroundColor=r;break;case"border-color":d.cssRules[o].style.borderColor=r,d.cssRules[o].style.borderTopColor=r,d.cssRules[o].style.borderLeftColor=r,d.cssRules[o].style.borderRightColor=r,d.cssRules[o].style.borderBottomColor=r;break;case"border-style":d.cssRules[o].style.borderStyle=r,d.cssRules[o].style.borderTopStyle=r,d.cssRules[o].style.borderLeftStyle=r,d.cssRules[o].style.borderRightStyle=r,d.cssRules[o].style.borderBottomStyle=r,d.cssRules[o].style.borderTop=d.cssRules[o].style.borderTopWidth+" "+r+" "+d.cssRules[o].style.borderTopColor,d.cssRules[o].style.borderLeft=d.cssRules[o].style.borderLeftWidth+" "+r+" "+d.cssRules[o].style.borderLeftColor,d.cssRules[o].style.borderRight=d.cssRules[o].style.borderRightWidth+" "+r+" "+d.cssRules[o].style.borderRightColor,d.cssRules[o].style.borderBottom=d.cssRules[o].style.borderBottomWidth+" "+r+" "+d.cssRules[o].style.borderBottomColor}break}},w=function(t){var e=Rexbuilder_Util.$rexContainer.find(".rex-loading-button .rex-button-wrapper");e.unwrap();var r=e.parents(".rex-buttons-paragraph").eq(0),o=e.parents(".text-wrap").eq(0),a=e.parents(".grid-stack-row").eq(0),d=e.parents(".rexpansive_section").eq(0),l=jQuery.extend(!0,{},t.buttonDimensions);a.find(".button-list__element__tools").remove();var u=e.find(".rex-button-data").eq(0),b={top:parseInt(u.attr("data-margin-top").replace("px","")),bottom:parseInt(u.attr("data-margin-bottom").replace("px","")),left:parseInt(u.attr("data-margin-left").replace("px","")),right:parseInt(u.attr("data-margin-right").replace("px",""))};b.top=isNaN(b.top)?0:b.top,b.bottom=isNaN(b.bottom)?0:b.bottom,b.left=isNaN(b.left)?0:b.left,b.right=isNaN(b.right)?0:b.right;var c={top:parseInt(u.attr("data-padding-top").replace("px","")),bottom:parseInt(u.attr("data-padding-bottom").replace("px","")),left:parseInt(u.attr("data-padding-left").replace("px","")),right:parseInt(u.attr("data-padding-right").replace("px",""))};c.top=isNaN(c.top)?0:c.top,c.bottom=isNaN(c.bottom)?0:c.bottom,c.left=isNaN(c.left)?0:c.left,c.right=isNaN(c.right)?0:c.right,l.height=l.height+b.top+b.bottom+c.top+c.bottom,l.width=l.width+b.left+b.right+c.left+c.right;var p;switch(p=0==o.length?0!=a.length?"inside-row":"inside-new-row":0!=r.length?"inside-paragraph":"inside-block"){case"inside-block":e.wrap('<p class="rex-buttons-paragraph"></p>'),k(e);break;case"inside-paragraph":k(e);var g=n(r);g||s(r);var x=i(r);TextEditor.moveCursorToStart(x);break;case"inside-row":var h=jQuery.Event("rexlive:insert_new_text_block");h.settings={data_to_send:{$buttonWrapper:e,$section:d,addBlockButton:!0,mousePosition:t.mousePosition,blockDimensions:{w:l.width,h:l.height},sectionTarget:{sectionID:d.attr("data-rexlive-section-id"),modelNumber:"undefined"!=typeof d.attr("data-rexlive-model-number")?d.attr("data-rexlive-model-number"):""}}},Rexbuilder_Util.$document.trigger(h);break;case"inside-new-row":}},k=function(t){for(var e=t.attr("data-rex-button-id"),r=!1,n=0;n<l.length;n++)if(l[n].id==e){r=!0;break}r||N(t),o(),a(),B(t);var i=t.parents(".text-wrap");0!=i.length&&TextEditor.removePlaceholder(i.eq(0)),Rexbuilder_Util_Editor.updateBlockContainerHeight(i),Rexbuilder_Util_Editor.builderEdited(!1),TextEditor.focusTextWrap(i)},N=function(t){if(0!=t.find(".rex-button-data").eq(0).length){var e=U(t,!0),r=e.buttonInfo.buttonTarget.button_id;A(r,e.buttonInfo)}},A=function(t,e){var r="",o="",a="",n="",i="",s="";s+="color: "+e.text_color+";",i=isNaN(parseInt(e.font_size.replace("px","")))?u.font_size:e.font_size,s+="font-size: "+i+";",a=isNaN(parseInt(e.button_height.replace("px","")))?u.dimensions.height:e.button_height,s+="min-height: "+a+";",a=isNaN(parseInt(e.button_width.replace("px","")))?u.dimensions.width:e.button_width,s+="min-width: "+a+";",r=isNaN(parseInt(e.margin_top.replace("px","")))?u.margins.top:e.margin_top,s+="margin-top: "+r+";",r=isNaN(parseInt(e.margin_right.replace("px","")))?u.margins.right:e.margin_right,s+="margin-right: "+r+";",r=isNaN(parseInt(e.margin_bottom.replace("px","")))?u.margins.bottom:e.margin_bottom,s+="margin-bottom: "+r+";",r=isNaN(parseInt(e.margin_left.replace("px","")))?u.margins.left:e.margin_left,s+="margin-left: "+r+";",p(t,s);var d="";d+="border-color: "+e.border_color+";",d+="border-style: solid;",n=isNaN(parseInt(e.border_width.replace("px","")))?u.border.width:e.border_width,d+="border-width: "+n+";",n=isNaN(parseInt(e.border_radius.replace("px","")))?u.border.radius:e.border_radius,d+="border-radius: "+n+";",d+="background-color: "+e.background_color+";",g(t,d);var l="";o=isNaN(parseInt(e.padding_top.replace("px","")))?u.paddings.top:e.padding_top,l+="padding-top: "+o+";",o=isNaN(parseInt(e.padding_right.replace("px","")))?u.paddings.right:e.padding_right,l+="padding-right: "+o+";",o=isNaN(parseInt(e.padding_bottom.replace("px","")))?u.paddings.bottom:e.padding_bottom,l+="padding-bottom: "+o+";",o=isNaN(parseInt(e.padding_left.replace("px","")))?u.paddings.left:e.padding_left,l+="padding-left: "+o+";",x(t,l);var b="";b+="background-color: "+e.hover_color+";",b+="border-color: "+e.hover_border+";",h(t,b);var c="";c+="color: "+e.hover_text+";",m(t,c)},T=function(t){switch(t.propertyType){case"text":f(t.buttonTarget.button_id,t.propertyName,t.newValue);break;case"container":_(t.buttonTarget.button_id,t.propertyName,t.newValue);break;case"background":R(t.buttonTarget.button_id,t.propertyName,t.newValue);break;case"backgroundHover":case"borderHover":v(t.buttonTarget.button_id,t.propertyName,t.newValue);break;case"textHover":y(t.buttonTarget.button_id,t.propertyName,t.newValue);break;case"button":var e=Rexbuilder_Util.$rexContainer.find('.rex-button-wrapper[data-rex-button-id="'+t.buttonTarget.button_id+'"][data-rex-button-number="'+t.buttonTarget.button_number+'"]');switch(t.propertyName){case"link_target":e.find("a.rex-button-container").eq(0).attr("href",t.newValue);break;case"link_type":e.find("a.rex-button-container").eq(0).attr("target",t.newValue);break;case"button_label":e.find(".rex-button-text").eq(0).text(t.newValue);break;case"button_class":e.find("a.rex-button-container").eq(0).attr("class","").addClass("rex-button-container").addClass(t.newValue);break;case"button_name":e.find(".rex-button-data").eq(0).attr("data-button-name",t.newValue)}}},C=function(t){var e=t.buttonProperties,r=e.buttonTarget.button_id,o="",a="",n="",i="",s="";s=isNaN(parseInt(e.font_size.replace("px","")))?u.font_size:e.font_size,_(r,"font-size",s),_(r,"color",e.text_color),n=isNaN(parseInt(e.button_height.replace("px","")))?u.dimensions.height:e.button_height,_(r,"min-height",n),n=isNaN(parseInt(e.button_width.replace("px","")))?u.dimensions.width:e.button_width,_(r,"min-width",n),o=isNaN(parseInt(e.margin_top.replace("px","")))?u.margins.top:e.margin_top,_(r,"margin-top",o),o=isNaN(parseInt(e.margin_right.replace("px","")))?u.margins.right:e.margin_right,_(r,"margin-right",o),o=isNaN(parseInt(e.margin_bottom.replace("px","")))?u.margins.bottom:e.margin_bottom,_(r,"margin-bottom",o),o=isNaN(parseInt(e.margin_left.replace("px","")))?u.margins.left:e.margin_left,_(r,"margin-left",o),R(r,"border-color",e.border_color),i=isNaN(parseInt(e.border_width.replace("px","")))?u.border.width:e.border_width,R(r,"border-width",i),i=isNaN(parseInt(e.border_radius.replace("px","")))?u.border.radius:e.border_radius,R(r,"border-radius",i),R(r,"background-color",e.background_color),a=isNaN(parseInt(e.padding_top.replace("px","")))?u.paddings.top:e.padding_top,f(r,"padding-top",a),a=isNaN(parseInt(e.padding_right.replace("px","")))?u.paddings.right:e.padding_right,f(r,"padding-right",a),a=isNaN(parseInt(e.padding_bottom.replace("px","")))?u.paddings.bottom:e.padding_bottom,f(r,"padding-bottom",a),a=isNaN(parseInt(e.padding_left.replace("px","")))?u.paddings.left:e.padding_left,f(r,"padding-left",a),v(r,"background-color",e.hover_color),v(r,"border-color",e.hover_border),y(r,"color",e.hover_text);var d=Rexbuilder_Util.$rexContainer.find('.rex-button-wrapper[data-rex-button-id="'+r+'"][data-rex-button-number="'+e.buttonTarget.button_number+'"]'),l=d.find(".rex-button-data").eq(0);d.find(".rex-button-text").eq(0).text(e.text),d.find("a.rex-button-container").eq(0).attr("href",e.link_target),d.find("a.rex-button-container").eq(0).attr("target",e.link_type),l.attr("data-link-target",e.link_target),l.attr("data-link-type",e.link_type),d.hasClass("rex-separate-button")?q(d,e):B(d)},S=function(t){var e=t.buttonTarget.button_id,r=Rexbuilder_Util.$rexContainer.find('.rex-button-wrapper[data-rex-button-id="'+e+'"]');r.removeClass("rex-separate-button"),B(r)},I=function(t){var e=t.buttonData,r=t.newID,o=e.buttonTarget.button_id,a=Rexbuilder_Util.$rexContainer.find('.rex-button-wrapper[data-rex-button-id="'+o+'"][data-rex-button-number="'+e.buttonTarget.button_number+'"]');if(a.addClass("rex-separate-button"),a.attr("data-rex-button-id",r),a.attr("data-rex-button-number",1),l.push({id:r,number:1}),0==Rexbuilder_Util.$rexContainer.find('.rex-button-wrapper[data-rex-button-id="'+o+'"]').length){var n;for(n=0;n<l.length&&l[n].id!=o;n++);n!=l.length&&l.splice(n,1)}q(a,e),N(a)},B=function(t){var e=t.find(".rex-button-data").eq(0);e.removeAttr("data-text-color"),e.removeAttr("data-text-size"),e.removeAttr("data-background-color"),e.removeAttr("data-background-color-hover"),e.removeAttr("data-border-color-hover"),e.removeAttr("data-text-color-hover"),e.removeAttr("data-border-width"),e.removeAttr("data-border-color"),e.removeAttr("data-border-radius"),e.removeAttr("data-button-height"),e.removeAttr("data-button-width"),e.removeAttr("data-margin-top"),e.removeAttr("data-margin-bottom"),e.removeAttr("data-margin-left"),e.removeAttr("data-margin-right"),e.removeAttr("data-padding-top"),e.removeAttr("data-padding-bottom"),e.removeAttr("data-padding-left"),e.removeAttr("data-padding-right"),e.removeAttr("data-button-name")},q=function(t,e){var r=t.find(".rex-button-data").eq(0);r.attr("data-text-color",e.text_color),r.attr("data-text-size",e.font_size),r.attr("data-background-color",e.background_color),r.attr("data-background-color-hover",e.hover_color),r.attr("data-border-color-hover",e.hover_border),r.attr("data-text-color-hover",e.hover_text),r.attr("data-border-width",e.border_width),r.attr("data-border-color",e.border_color),r.attr("data-border-radius",e.border_radius),r.attr("data-button-height",e.button_height),r.attr("data-button-width",e.button_width),r.attr("data-margin-top",e.margin_top),r.attr("data-margin-bottom",e.margin_bottom),r.attr("data-margin-right",e.margin_right),r.attr("data-margin-left",e.margin_left),r.attr("data-padding-top",e.padding_top),r.attr("data-padding-bottom",e.padding_bottom),r.attr("data-padding-right",e.padding_right),r.attr("data-padding-left",e.padding_left),r.attr("data-button-name",e.buttonTarget.button_name)},U=function(t,e){e="undefined"!=typeof e&&"true"==e.toString();var r={text_color:"",text:"",font_size:"",background_color:"",button_height:"",button_width:"",hover_color:"",hover_border:"",hover_text:"",border_color:"",border_width:"",border_radius:"",margin_top:"",margin_bottom:"",margin_right:"",margin_left:"",padding_top:"",padding_bottom:"",padding_right:"",padding_left:"",link_target:"",link_type:"",classes:"",buttonTarget:{button_name:"",button_id:"",button_number:""}},o=t.find(".rex-button-data").eq(0);r.buttonTarget.button_id=t.attr("data-rex-button-id"),r.buttonTarget.button_number=parseInt(t.attr("data-rex-button-number"));var a=o[0],n=!1;t.hasClass("rex-separate-button")||e?(r.font_size=a.getAttribute("data-text-size")?a.getAttribute("data-text-size").toString():"",r.text_color=a.getAttribute("data-text-color")?a.getAttribute("data-text-color").toString():"",r.button_height=a.getAttribute("data-button-height")?a.getAttribute("data-button-height").toString():"",r.button_width=a.getAttribute("data-button-width")?a.getAttribute("data-button-width").toString():"",r.margin_top=a.getAttribute("data-margin-top")?a.getAttribute("data-margin-top").toString():"",r.margin_bottom=a.getAttribute("data-margin-bottom")?a.getAttribute("data-margin-bottom").toString():"",r.margin_right=a.getAttribute("data-margin-right")?a.getAttribute("data-margin-right").toString():"",r.margin_left=a.getAttribute("data-margin-left")?a.getAttribute("data-margin-left").toString():"",r.border_color=a.getAttribute("data-border-color")?a.getAttribute("data-border-color").toString():"",r.border_width=a.getAttribute("data-border-width")?a.getAttribute("data-border-width").toString():"",r.border_radius=a.getAttribute("data-border-radius")?a.getAttribute("data-border-radius").toString():"",r.background_color=a.getAttribute("data-background-color")?a.getAttribute("data-background-color").toString():"",r.padding_top=a.getAttribute("data-padding-top")?a.getAttribute("data-padding-top").toString():"",r.padding_bottom=a.getAttribute("data-padding-bottom")?a.getAttribute("data-padding-bottom").toString():"",r.padding_right=a.getAttribute("data-padding-right")?a.getAttribute("data-padding-right").toString():"",r.padding_left=a.getAttribute("data-padding-left")?a.getAttribute("data-padding-left").toString():"",r.hover_color=a.getAttribute("data-background-color-hover")?a.getAttribute("data-background-color-hover").toString():"",r.hover_border=a.getAttribute("data-border-color-hover")?a.getAttribute("data-border-color-hover").toString():"",r.hover_text=a.getAttribute("data-text-color-hover")?a.getAttribute("data-text-color-hover").toString():"",r.buttonTarget.button_name=a.getAttribute("data-button-name")?a.getAttribute("data-button-name").toString():"",n=!0):r.synchronize="undefined"!=typeof o.attr("data-synchronize")&&o.attr("data-synchronize").toString(),r.text=t.find(".rex-button-text").eq(0).text(),r.link_target=o.attr("data-link-target"),r.link_type=o.attr("data-link-type"),r.classes=t.find("a.rex-button-container").eq(0).attr("class").replace("rex-button-container","").replace(/\s/,"");var i={separateButton:n,buttonInfo:r};return i},L=function(t){var e=t.buttonTarget.button_id,r=Rexbuilder_Util.$rexContainer.find('.rex-button-wrapper[data-rex-button-id="'+e+'"][data-rex-button-number="'+t.buttonTarget.button_number+'"]');r.find(".rex-button-data").attr("data-synchronize",!0)},z=function(){Rexbuilder_Util.$document.on("rexlive:completeImportButton",function(t){var e=t.settings,r=e.$blockAdded,o=e.$buttonWrapper;o.detach().prependTo(r.find(".text-wrap").eq(0)),o.wrap('<p class="rex-buttons-paragraph"></p>'),k(o)})},W=function(){return l},$=function(){d=null,l=[],u={margins:{top:"20px",right:"20px",bottom:"20px",left:"20px"},paddings:{top:"20px",right:"20px",bottom:"20px",left:"20px"},dimensions:{height:"70px",width:"100px"},border:{width:"5px",radius:"10px"},font_size:"12px"},this.$buttonsStyle=t("#rexpansive-builder-rexbutton-style-inline-css"),b(),o(),a(),z()};return{init:$,getActiveStyleSheet:c,fixImportedButton:w,getButtonsInPage:W,updateButtonLive:T,lockSynchronize:L,updateButton:C,removeSeparateButton:S,separateRexButton:I,generateButtonData:U,endFixingButtonImported:k,updateButtonListInPage:a,findIDsInPage:r,refreshNumbers:o,updateButtonContainerRule:_,updateButtonBackgroundRule:R,updateButtonBackgroundHoverRule:v,updateContainerHoverRule:y}}(jQuery);
var Rexbuilder_Rexelement=function(e){"use strict";function t(){Rexbuilder_Util.$rexContainer.find(".rex-element-wrapper").each(function(t,o){var n=e(o);n.hasClass("rex-separate-element")?r(n):0!==t&&i[t].id==i[t-1].id||r(n)})}function r(t){var r=0!==t.find(".wpcf7-form").length;r&&(Rexbuilder_Rexwpcf7.refreshFormStyle(t.find(".wpcf7-form"),!0),t.find(".wpcf7-column").each(function(t,r){Rexbuilder_Rexwpcf7.refreshColumnContentStyle(e(r))}))}function o(e){var t=e.get(0),r={},o=t.querySelector(".rex-element-data").dataset,a={element_id:e.attr("data-rex-element-id"),element_number:parseInt(e.attr("data-rex-element-number")),is_separated:Rexbuilder_Util.hasClass(t,"rex-separate-form"),form_title:t.querySelector(".string-shortcode").getAttribute("shortcode").match(/title\=\"(.*)\"/)[1]},c=e.find(".wpcf7-form"),d={background_color:o.wpcf7BackgroundColor||c.css("background-color"),border_color:o.wpcf7BorderColor||c.css("border-color"),border_width:o.wpcf7BorderWidth||c.css("border-width"),margin_top:o.wpcf7MarginTop||c.css("margin-top"),margin_left:o.wpcf7MarginLeft||c.css("margin-left"),margin_right:o.wpcf7MarginRight||c.css("margin-right"),margin_bottom:o.wpcf7MarginBottom||c.css("margin-bottom"),error_message_color:o.wpcf7ErrorMessageColor||_.wpcf7_data.error_message_color,error_message_font_size:o.wpcf7ErrorMessageFontSize||_.wpcf7_data.error_message_font_size,send_message_color:o.wpcf7SendMessageColor||_.wpcf7_data.send_message_color,send_message_font_size:o.wpcf7SendMessageFontSize||_.wpcf7_data.send_message_font_size},i={width:o.wpcf7ContentWidth||_.wpcf7_data.content.width,height:o.wpcf7ContentHeight||_.wpcf7_data.content.height,font_size:o.wpcf7ContentFontSize||_.wpcf7_data.content.font_size,border_width:o.wpcf7ContentBorderWidth||_.wpcf7_data.content.border_width,border_radius:o.wpcf7ContentBorderRadius||_.wpcf7_data.content.border_radius,text_color:o.wpcf7ContentTextColor||_.wpcf7_data.content.text_color,background_color:o.wpcf7ContentBackgroundColor||_.wpcf7_data.content.background_color,border_color:o.wpcf7ContentBorderColor||_.wpcf7_data.content.border_color,text_color_hover:o.wpcf7ContentTextColorHover||_.wpcf7_data.content.text_color_hover,background_color_hover:o.wpcf7ContentBackgroundColorHover||_.wpcf7_data.content.background_color_hover,border_color_hover:o.wpcf7ContentBorderColorHover||_.wpcf7_data.content.border_color_hover},l={padding_top:o.wpcf7ColumnsPaddingTop||_.wpcf7_data.columns.padding_top,padding_left:o.wpcf7ColumnsPaddingLeft||_.wpcf7_data.columns.padding_left,padding_right:o.wpcf7ColumnsPaddingRight||_.wpcf7_data.columns.padding_right,padding_bottom:o.wpcf7ColumnsPaddingBottom||_.wpcf7_data.columns.padding_bottom};return d.content=i,d.columns=l,d.options_different=n(a.element_id),r.synchronize=o.synchronize||!1,r.synchronize=o.synchronize||!1,r.element_target=a,r.wpcf7_data=d,r}function n(e){function t(e,t,r){return e===r[0]}var r=Rexbuilder_Util.rexContainer.querySelector('.rex-element-wrapper[data-rex-element-id="'+e+'"]'),o=r.querySelector(".rex-element-data"),n=Array.prototype.slice.call(r.querySelectorAll(".rex-wpcf7-column-content-data")),a=new Array(o.getAttribute("data-wpcf7-content-width")),c=new Array(o.getAttribute("data-wpcf7-content-height")),d=new Array(o.getAttribute("data-wpcf7-content-text-color")),i=new Array(o.getAttribute("data-wpcf7-content-font-size"));n.forEach(function(e){a.push(e.getAttribute("data-wpcf7-input-width")),c.push(e.getAttribute("data-wpcf7-input-height")),d.push(e.getAttribute("data-text-color")),i.push(e.getAttribute("data-wpcf7-font-size"))});var _={};return _.width=!a.every(t),_.height=!c.every(t),_.text_color=!d.every(t),_.font_size=!i.every(t),_}function a(){var t,r=!1;Rexbuilder_Util.$rexContainer.find(".rex-element-wrapper").each(function(o,n){var a=e(n),c=a.attr("data-rex-element-id"),d=parseInt(a.attr("data-rex-element-number"));for(r=!1,t=0;t<i.length;t++)if(i[t].id==c){r=!0;break}r=!1,r||i.push({id:parseInt(c),number:d}),i[t].number<d&&(i[t].number=d)})}function c(){var t=Rexbuilder_Util.$document.find("form").get(),r=t.filter(function(t){return 0===e(t).parents(".rex-element-wrapper").length});r.forEach(function(e){Rexbuilder_Util.addClass(e,"no-builder-form")})}function d(){c(),a()}var i=[],_={synchronize:!1,wpcf7_data:{background_color:"rgb(0, 0, 0, 0)",border_color:"rgb(0, 0, 0, 1)",border_width:"2px",margin_top:"5px",margin_left:"5px",margin_right:"5px",margin_bottom:"5px",error_message_color:"rgb(0, 0, 0, 1)",error_message_font_size:"15px",send_message_color:"rgb(0, 0, 0, 1)",send_message_font_size:"15px",columns:{padding_top:"15px",padding_left:"15px",padding_right:"15px",padding_bottom:"15px"},content:{background_color:"rgb(255, 255, 255, 1)",background_color_hover:"rgb(255, 255, 255, 1)",text_color:"rgb(0, 0, 0, 1)",text_color_hover:"rgb(0, 0, 0, 1)",border_color:"rgb(0, 0, 0, 1)",border_color_hover:"rgb(0, 0, 0, 1)",width:"200px",height:"50px",font_size:"15px",border_width:"1px",border_radius:"0px"},options_different:{width:!0,height:!0,font_size:!0,text_color:!0}},element_target:{element_id:"",element_number:""}};return{init:d,addStyles:t,addElementStyle:r,generateElementData:o}}(jQuery);
var Rexbuilder_Rexwpcf7=function(t){"use strict";function e(){if(0===Rexbuilder_Rexwpcf7.$rexFormsStyle.length){var t="",e=document.head||document.getElementsByTagName("head")[0],r=document.createElement("style");r.type="text/css",r.id="rexpansive-builder-rexwpcf7-style-inline-css",r.dataset.rexName="rexwpcf7-style",r.styleSheet?r.styleSheet.cssText=t:r.appendChild(document.createTextNode(t)),e.appendChild(r)}for(var o=0;o<document.styleSheets.length;o++)"rexpansive-builder-rexwpcf7-style-inline-css"==document.styleSheets[o].ownerNode.id&&(j=document.styleSheets[o])}function r(t){for(var e=0;e<j.cssRules.length;e++)if(j.cssRules[e].selectorText==t)return!0;return!1}function o(t){var e={},r=t.split(";");return r.forEach(function(t){var r=t.split(":");2===r.length&&(e[r[0]]=r[1].trim())}),e}function a(t,e){var a='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-form',c=a+"{"+e+"}";if(r(a)){var l=o(e);for(var n in l)l.hasOwnProperty(n)&&f(t,n,l[n])}else"insertRule"in j?j.insertRule(c,j.cssRules.length):"addRule"in j&&j.addRule(c,j.cssRules.length)}function c(t,e,a){var c='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-form .'+e,l=c+"{"+a+"}";if(r(c)){var n=o(a);for(var i in n)n.hasOwnProperty(i)&&u(t,i,n[i])}else"insertRule"in j?j.insertRule(l,j.cssRules.length):"addRule"in j&&j.addRule(l,j.cssRules.length)}function l(t,e){var a='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-form .wpcf7-column',c=a+"{"+e+"}";if(r(a)){var l=o(e);for(var n in l)l.hasOwnProperty(n)&&b(t,n,l[n])}else"insertRule"in j?j.insertRule(c,j.cssRules.length):"addRule"in j&&j.addRule(c,j.cssRules.length)}function n(t,e,a,c,l){var n='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-row[wpcf7-row-number="'+e+'"] .wpcf7-column[wpcf7-column-number="'+a+'"] .'+c,i=n+"{"+l+"}";if(r(n)){var s=o(l);for(var d in s)s.hasOwnProperty(d)&&p(t,d,s[d])}else"insertRule"in j?j.insertRule(i,j.cssRules.length):"addRule"in j&&j.addRule(i,j.cssRules.length)}function i(t,e,a,c,l){var n='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-row[wpcf7-row-number="'+e+'"] .wpcf7-column[wpcf7-column-number="'+a+'"] .'+c+":focus",i=n+"{"+l+"}";if(r(n)){var s=o(l);for(var d in s)s.hasOwnProperty(d)&&_(t,d,s[d])}else"insertRule"in j?j.insertRule(i,j.cssRules.length):"addRule"in j&&j.addRule(i,j.cssRules.length)}function s(t,e,a,c,l){var n='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-row[wpcf7-row-number="'+e+'"] .wpcf7-column[wpcf7-column-number="'+a+'"] .'+c+":hover",i=n+"{"+l+"}";if(r(n)){var s=o(l);for(var d in s)s.hasOwnProperty(d)&&g(t,d,s[d])}else"insertRule"in j?j.insertRule(i,j.cssRules.length):"addRule"in j&&j.addRule(i,j.cssRules.length)}function d(t,e,a,c,l){var n='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-row[wpcf7-row-number="'+e+'"] .wpcf7-column[wpcf7-column-number="'+a+'"] .'+c+":hover::placeholder",i=n+"{"+l+"}";if(r(n)){var s=o(l);for(var d in s)s.hasOwnProperty(d)&&w(t,d,s[d])}else"insertRule"in j?j.insertRule(i,j.cssRules.length):"addRule"in j&&j.addRule(i,j.cssRules.length)}function f(t,e,r){for(var o=0;o<j.cssRules.length;o++)if(j.cssRules[o].selectorText=='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-form'||j.cssRules[o].selectorText=='[data-rex-element-id="'+t+'"].rex-element-wrapper .wpcf7-form'){switch(e){case"margin-top":j.cssRules[o].style.marginTop=r;break;case"margin-bottom":j.cssRules[o].style.marginBottom=r;break;case"margin-left":j.cssRules[o].style.marginLeft=r;break;case"margin-right":j.cssRules[o].style.marginRight=r;break;case"border-width":j.cssRules[o].style.borderWidth=r,j.cssRules[o].style.borderTopWidth=r,j.cssRules[o].style.borderLeftWidth=r,j.cssRules[o].style.borderRightWidth=r,j.cssRules[o].style.borderBottomWidth=r,j.cssRules[o].style.borderTop=r+" "+j.cssRules[o].style.borderTopStyle+" "+j.cssRules[o].style.borderTopColor,j.cssRules[o].style.borderLeft=r+" "+j.cssRules[o].style.borderLeftStyle+" "+j.cssRules[o].style.borderLeftColor,j.cssRules[o].style.borderRight=r+" "+j.cssRules[o].style.borderRightStyle+" "+j.cssRules[o].style.borderRightColor,j.cssRules[o].style.borderBottom=r+" "+j.cssRules[o].style.borderBottomStyle+" "+j.cssRules[o].style.borderBottomColor;break;case"border-color":j.cssRules[o].style.borderColor=r,j.cssRules[o].style.borderTopColor=r,j.cssRules[o].style.borderLeftColor=r,j.cssRules[o].style.borderRightColor=r,j.cssRules[o].style.borderBottomColor=r;break;case"border-style":j.cssRules[o].style.borderStyle=r,j.cssRules[o].style.borderTopStyle=r,j.cssRules[o].style.borderLeftStyle=r,j.cssRules[o].style.borderRightStyle=r,j.cssRules[o].style.borderBottomStyle=r,j.cssRules[o].style.borderTop=j.cssRules[o].style.borderTopWidth+" "+r+" "+j.cssRules[o].style.borderTopColor,j.cssRules[o].style.borderLeft=j.cssRules[o].style.borderLeftWidth+" "+r+" "+j.cssRules[o].style.borderLeftColor,j.cssRules[o].style.borderRight=j.cssRules[o].style.borderRightWidth+" "+r+" "+j.cssRules[o].style.borderRightColor,j.cssRules[o].style.borderBottom=j.cssRules[o].style.borderBottomWidth+" "+r+" "+j.cssRules[o].style.borderBottomColor;break;case"border-radius":j.cssRules[o].style.borderRadius=r,j.cssRules[o].style.borderTopLeftRadius=r,j.cssRules[o].style.borderTopRightRadius=r,j.cssRules[o].style.borderBottomLeftRadius=r,j.cssRules[o].style.borderBottomRightRadius=r,j.cssRules[o].style.webkitBorderRadius=r,j.cssRules[o].style.webkitBorderTopLeftRadius=r,j.cssRules[o].style.webkitBorderTopRightRadius=r,j.cssRules[o].style.webkitBorderBottomLeftRadius=r,j.cssRules[o].style.webkitBorderBottomRightRadius=r;break;case"background-color":j.cssRules[o].style.backgroundColor=r}break}}function u(t,e,r,o){for(var a='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-form .'+e,c='[data-rex-element-id="'+t+'"].rex-element-wrapper .wpcf7-form',l=0;l<j.cssRules.length;l++)if(j.cssRules[l].selectorText==a||j.cssRules[l].selectorText==c){switch(r){case"text-color":j.cssRules[l].style.color=o;break;case"border-color":j.cssRules[l].style.borderColor=o;break;case"font-size":j.cssRules[l].style.fontSize=o}break}}function b(t,e,r){for(var o='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-form .wpcf7-column',a='[data-rex-element-id="'+t+'"].rex-element-wrapper .wpcf7-form .wpcf7-column',c=0;c<j.cssRules.length;c++)if(j.cssRules[c].selectorText==o||j.cssRules[c].selectorText==a){switch(e){case"padding-top":j.cssRules[c].style.paddingTop=r;break;case"padding-left":j.cssRules[c].style.paddingLeft=r;break;case"padding-right":j.cssRules[c].style.paddingRight=r;break;case"padding-bottom":j.cssRules[c].style.paddingBottom=r}break}}function p(t,e,r,o,a,c){for(var l=0;l<j.cssRules.length;l++)if(j.cssRules[l].selectorText=='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-row[wpcf7-row-number="'+e+'"] .wpcf7-column[wpcf7-column-number="'+r+'"] .'+o||j.cssRules[l].selectorText=='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-row[wpcf7-row-number="'+e+'"] .wpcf7-column[wpcf7-column-number="'+r+'"] .'+o){switch(a){case"float":j.cssRules[l].style["float"]=c;break;case"width":j.cssRules[l].style.width=c;break;case"height":j.cssRules[l].style.height=c;break;case"text-color":j.cssRules[l].style.color=c;break;case"font-size":j.cssRules[l].style.fontSize=c;break;case"margin-top":j.cssRules[l].style.marginTop=c;break;case"margin-bottom":j.cssRules[l].style.marginBottom=c;break;case"margin-left":j.cssRules[l].style.marginLeft=c;break;case"margin-right":j.cssRules[l].style.marginRight=c;break;case"padding-top":j.cssRules[l].style.paddingTop=c;break;case"padding-bottom":j.cssRules[l].style.paddingBottom=c;break;case"padding-left":j.cssRules[l].style.paddingLeft=c;break;case"padding-right":j.cssRules[l].style.paddingRight=c;break;case"border-width":j.cssRules[l].style.borderWidth=c,j.cssRules[l].style.borderTopWidth=c,j.cssRules[l].style.borderLeftWidth=c,j.cssRules[l].style.borderRightWidth=c,j.cssRules[l].style.borderBottomWidth=c,j.cssRules[l].style.borderTop=c+" "+j.cssRules[l].style.borderTopStyle+" "+j.cssRules[l].style.borderTopColor,j.cssRules[l].style.borderLeft=c+" "+j.cssRules[l].style.borderLeftStyle+" "+j.cssRules[l].style.borderLeftColor,j.cssRules[l].style.borderRight=c+" "+j.cssRules[l].style.borderRightStyle+" "+j.cssRules[l].style.borderRightColor,j.cssRules[l].style.borderBottom=c+" "+j.cssRules[l].style.borderBottomStyle+" "+j.cssRules[l].style.borderBottomColor;break;case"border-color":j.cssRules[l].style.borderColor=c,j.cssRules[l].style.borderTopColor=c,j.cssRules[l].style.borderLeftColor=c,j.cssRules[l].style.borderRightColor=c,j.cssRules[l].style.borderBottomColor=c;break;case"border-top-color":j.cssRules[l].style.borderTopColor=c;break;case"border-right-color":j.cssRules[l].style.borderRightColor=c;break;case"border-bottom-color":j.cssRules[l].style.borderBottomColor=c;break;case"border-left-color":j.cssRules[l].style.borderLeftColor=c;break;case"border-style":j.cssRules[l].style.borderStyle=c,j.cssRules[l].style.borderTopStyle=c,j.cssRules[l].style.borderLeftStyle=c,j.cssRules[l].style.borderRightStyle=c,j.cssRules[l].style.borderBottomStyle=c,j.cssRules[l].style.borderTop=j.cssRules[l].style.borderTopWidth+" "+c+" "+j.cssRules[l].style.borderTopColor,j.cssRules[l].style.borderLeft=j.cssRules[l].style.borderLeftWidth+" "+c+" "+j.cssRules[l].style.borderLeftColor,j.cssRules[l].style.borderRight=j.cssRules[l].style.borderRightWidth+" "+c+" "+j.cssRules[l].style.borderRightColor,j.cssRules[l].style.borderBottom=j.cssRules[l].style.borderBottomWidth+" "+c+" "+j.cssRules[l].style.borderBottomColor;break;case"border-radius":j.cssRules[l].style.borderRadius=c,j.cssRules[l].style.borderTopLeftRadius=c,j.cssRules[l].style.borderTopRightRadius=c,j.cssRules[l].style.borderBottomLeftRadius=c,j.cssRules[l].style.borderBottomRightRadius=c,j.cssRules[l].style.webkitBorderRadius=c,j.cssRules[l].style.webkitBorderTopLeftRadius=c,j.cssRules[l].style.webkitBorderTopRightRadius=c,j.cssRules[l].style.webkitBorderBottomLeftRadius=c,j.cssRules[l].style.webkitBorderBottomRightRadius=c;break;case"background-color":j.cssRules[l].style.backgroundColor=c}break}}function _(t,e,r,o,a,c){for(var l=0;l<j.cssRules.length;l++)if(j.cssRules[l].selectorText=='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-row[wpcf7-row-number="'+e+'"] .wpcf7-column[wpcf7-column-number="'+r+'"] .'+o+":focus"||j.cssRules[l].selectorText=='[data-rex-element-id="'+t+'"].rex-element-wrapper .'+o+":focus"){switch(a){case"text-color":j.cssRules[l].style.color=c}break}}function g(t,e,r,o,a,c){for(var l=0;l<j.cssRules.length;l++)if(j.cssRules[l].selectorText=='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-row[wpcf7-row-number="'+e+'"] .wpcf7-column[wpcf7-column-number="'+r+'"] .'+o+":hover"||j.cssRules[l].selectorText=='[data-rex-element-id="'+t+'"].rex-element-wrapper .'+o+":hover"){switch(a){case"text-color":j.cssRules[l].style.color=c;break;case"background-color":j.cssRules[l].style.backgroundColor=c;break;case"border-color":j.cssRules[l].style.borderColor=c}break}}function w(t,e,r,o,a,c){for(var l=0;l<j.cssRules.length;l++)if(j.cssRules[l].selectorText=='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-row[wpcf7-row-number="'+e+'"] .wpcf7-column[wpcf7-column-number="'+r+'"] .'+o+":hover::placeholder"||j.cssRules[l].selectorText=='[data-rex-element-id="'+t+'"].rex-element-wrapper .'+o+":hover::placeholder"){switch(a){case"text-color":j.cssRules[l].style.color=c;break;case"background-color":j.cssRules[l].style.backgroundColor=c;break;case"border-color":j.cssRules[l].style.borderColor=c}break}}function m(t){for(var e='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-form',r=0;r<j.cssRules.length;r++)if(j.cssRules[r].selectorText==e){j.deleteRule(r);break}}function h(t,e,r,o){for(var a='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-row[wpcf7-row-number="'+e+'"] .wpcf7-column[wpcf7-column-number="'+r+'"] .'+o,c=0;c<j.cssRules.length;c++)if(j.cssRules[c].selectorText==a){j.deleteRule(c);break}}function x(t,e,r,o){for(var a=0;a<j.cssRules.length;a++)if(j.cssRules[a].selectorText=='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-row[wpcf7-row-number="'+e+'"] .wpcf7-column[wpcf7-column-number="'+r+'"] .'+o+":hover"){j.deleteRule(a);break}}function R(t,e,r,o){for(var a=0;a<j.cssRules.length;a++)if(j.cssRules[a].selectorText=='.rex-element-wrapper[data-rex-element-id="'+t+'"] .wpcf7-row[wpcf7-row-number="'+e+'"] .wpcf7-column[wpcf7-column-number="'+r+'"] .'+o+":focus"){j.deleteRule(a);break}}function v(t){var e=t.elementData.wpcf7_data,r=t.elementData.element_target.element_id;f(r,"background-color",e.background_color),f(r,"border-color",e.border_color),f(r,"border-width",e.border_width),f(r,"margin-top",e.margin_top),f(r,"margin-left",e.margin_left),f(r,"margin-right",e.margin_right),f(r,"margin-bottom",e.margin_bottom),G.forEach(function(t){u(r,t,"text-color",e.error_message_color),u(r,t,"border-color",e.error_message_color),u(r,t,"font-size",e.error_message_font_size)}),Q.forEach(function(t){u(r,t,"text-color",e.send_message_color),u(r,t,"border-color",e.send_message_color),u(r,t,"font-size",e.send_message_font_size)}),b(r,"padding-top",e.columns.padding_top),b(r,"padding-left",e.columns.padding_left),b(r,"padding-right",e.columns.padding_right),b(r,"padding-bottom",e.columns.padding_bottom),y(t.elementData);var o=Rexbuilder_Util.$rexContainer.find('.rex-element-wrapper[data-rex-element-id="'+r+'"]');P(o,e)}function y(e){var r=e,o=r.element_target.element_id,a=r.wpcf7_data.options_different,c=Rexbuilder_Util.$rexContainer.find('.rex-element-wrapper[data-rex-element-id="'+o+'"] .wpcf7-column').not(".with-button");c.each(function(e,o){var c=t(o),l=0!==c.find(".rex-wpcf7-column-content-data").length,n=T(c,l),i=n.input_type;"file"!=i&&"radio"!=i&&"acceptance"!=i&&(n.background_color=r.wpcf7_data.content.background_color,n.background_color_hover=r.wpcf7_data.content.background_color_hover,n.border_color=r.wpcf7_data.content.border_color,n.border_color_hover=r.wpcf7_data.content.border_color_hover,n.border_width=r.wpcf7_data.content.border_width,n.border_radius=r.wpcf7_data.content.border_radius),a.width||(n.input_width=r.wpcf7_data.content.width),a.height||(n.input_height=r.wpcf7_data.content.height),a.font_size||(n.font_size=r.wpcf7_data.content.font_size),a.text_color||(n.text_color=r.wpcf7_data.content.text_color),n.text_color_hover=r.wpcf7_data.content.text_color_hover;var s={columnContentData:n};z(s)})}function k(t,e){E(t),C(t,e)}function C(t,e){e="undefined"!=typeof e&&e;var r=t.parents(".rex-element-wrapper"),o=0!==r.find(".rex-element-data").length;if(o){var a=Rexbuilder_Rexelement.generateElementData(r),c=a.element_target.element_id,l=a.wpcf7_data;W(c,l),e&&v({elementData:{element_target:a.element_target,synchronize:a.synchronize,wpcf7_data:a.wpcf7_data}})}}function A(t){O(t),S(t)}function S(t){if(t.get(0).querySelector(".rex-wpcf7-column-content-data")){var e=T(t,!0),r=e.target.element_id;F(r,e)}}function z(t){var e,r=t.columnContentData,o=r.target.element_id,a=r.target.row_number,c=r.target.column_number,l=r.input_type,n=r.field_class,i=r.wpcf7_button.height,s=r.wpcf7_button.width,d=r.wpcf7_button.border_width,f=r.wpcf7_button.border_radius,u=r.wpcf7_button.margin_top,b=r.wpcf7_button.margin_right,m=r.wpcf7_button.margin_bottom,h=r.wpcf7_button.margin_left,x=r.wpcf7_button.padding_top,R=r.wpcf7_button.padding_right,v=r.wpcf7_button.padding_bottom,y=r.wpcf7_button.padding_left,k=r.wpcf7_button.font_size,C=r.background_color,A=r.background_color_hover,S=r.text_color,z=r.text_color_hover,T=r.text_color_focus,q=r.palceholder_color,B=r.palceholder_color_hover,L=r.border_color,U=r.border_color_hover,W=r.wpcf7_button.text_color,F=r.wpcf7_button.text_color_hover,E=r.wpcf7_button.background_color,O=r.wpcf7_button.background_color_hover,P=r.wpcf7_button.border_color,N=r.wpcf7_button.border_color_hover;switch(l){case"text":case"email":case"number":case"textarea":case"select":e="wpcf7-"+l;break;case"acceptance":e="wpcf7-form-control-wrap";break;case"submit":case"file":e=n;break;case"radio":e="wpcf7-form-control-wrap."+n}"radio"===l&&p(o,a,c,e+" .wpcf7-radio-label","font-size",r.font_size),"acceptance"===l&&(p(o,a,c,e+" .wpcf7-list-item-label","font-size",r.font_size),p(o,a,c,e+" :not(:checked) ~ .wpcf7-list-item-label::before","border-color",r.text_color),p(o,a,c,e+" :checked ~ .wpcf7-list-item-label::before","border-bottom-color",r.text_color),p(o,a,c,e+" :checked ~ .wpcf7-list-item-label::before","border-right-color",r.text_color)),"text"!=l&&"email"!=l&&"number"!=l&&"textarea"!=l||(p(o,a,c,e+"::placeholder","text-color",q),w(o,a,c,e,"text-color",B)),"submit"!=l?(_(o,a,c,e,"text-color",T),g(o,a,c,e,"color",z),g(o,a,c,e,"background-color",A),g(o,a,c,e,"border-color",U),p(o,a,c,e,"width",M(l,o,a,c,r.input_width)),"acceptance"!==l&&p(o,a,c,e,"height",r.input_height),p(o,a,c,e,"font-size",r.font_size),p(o,a,c,e,"border-width",r.border_width),p(o,a,c,e,"border-radius",r.border_radius),p(o,a,c,e,"text-color",S),p(o,a,c,e,"background-color",C),p(o,a,c,e,"border-color",L),"file"==l&&(p(o,a,c,e+" label","height",i),p(o,a,c,e+" label","width",s),p(o,a,c,e+" label","border-width",d),p(o,a,c,e+" label","border-radius",f),p(o,a,c,e+" label","margin-top",u),p(o,a,c,e+" label","margin-right",b),p(o,a,c,e+" label","margin-bottom",m),p(o,a,c,e+" label","margin-left",h),p(o,a,c,e+" label","padding-top",x),p(o,a,c,e+" label","padding-right",R),p(o,a,c,e+" label","padding-bottom",v),p(o,a,c,e+" label","padding-left",y),p(o,a,c,e+" label","font-size",k),p(o,a,c,e+" label","text-color",W),p(o,a,c,e+" label","background-color",E),p(o,a,c,e+" label","border-color",P),g(o,a,c,e+" label","text-color",F),g(o,a,c,e+" label","background-color",O),g(o,a,c,e+" label","border-color",N))):(p(o,a,c,e,"height",i),p(o,a,c,e,"width",s),p(o,a,c,e,"border-width",d),p(o,a,c,e,"border-radius",f),p(o,a,c,e,"margin-top",u),p(o,a,c,e,"margin-right",b),p(o,a,c,e,"margin-bottom",m),p(o,a,c,e,"margin-left",h),p(o,a,c,e,"padding-top",x),p(o,a,c,e,"padding-right",R),p(o,a,c,e,"padding-bottom",v),p(o,a,c,e,"padding-left",y),p(o,a,c,e,"font-size",k),p(o,a,c,e,"text-color",W),p(o,a,c,e,"background-color",E),p(o,a,c,e,"border-color",P),g(o,a,c,e,"text-color",F),g(o,a,c,e,"background-color",O),g(o,a,c,e,"border-color",N)),D(o,r)}function T(t,e){var r={wpcf7_required_field:"",wpcf7_email:"",wpcf7_only_numbers:"",wpcf7_default_check:"",wpcf7_placeholder:"",wpcf7_list_fields:[],wpcf7_file_max_dimensions:"",wpcf7_button:{text:"",font_size:"",height:"",width:"",border_width:"",border_radius:"",margin_top:"",margin_right:"",margin_bottom:"",margin_left:"",padding_top:"",padding_right:"",padding_bottom:"",padding_left:"",text_color:"",text_color_hover:"",background_color:"",background_color_hover:"",border_color:"",border_color_hover:""},input_width:"",input_height:"",font_size:"",border_width:"",border_radius:"",background_color:"",background_color_hover:"",border_color:"",border_color_hover:"",placeholder_color:"",placeholder_hover_color:"",select_color_after_selection:"",text_color:"",text_color_hover:"",text_color_focus:"",label_text:"",text:"",type:"",field_class:"",input_type:"",target:{element_id:"",row_number:"",column_number:""}};r.target.element_id=t.parents(".rex-element-wrapper").attr("data-rex-element-id"),r.target.row_number=t.parents(".wpcf7-row").attr("wpcf7-row-number"),r.target.column_number=t.attr("wpcf7-column-number");var o,a=/([a-z]+\-[\d]+)(-rexclone-([\d]+))?/,c=t.find(".wpcf7-form-control");if(r.field_class=null,0!==c.length){if(o=c.get(0).className.match(a),!o){var l=t.find(".wpcf7-form-control-wrap").get(0).className;if(o=l.match(a),!o){var n=t.find("[type=checkbox]").get(0).className;o=n.match(a)}}r.field_class=o[0]}r.input_type=/[a-z]+/.exec(r.field_class)[0],r.input_type="menu"==r.input_type?"select":r.input_type;var i,s=r.input_type;switch(s){case"text":case"email":case"number":case"textarea":case"select":i="wpcf7-"+s;break;case"acceptance":i="wpcf7-form-control-wrap";break;case"submit":case"file":i=r.field_class;break;case"radio":i="wpcf7-form-control-wrap."+r.field_class}-1!==["text","email","number","textarea"].indexOf(s)&&(r.label_text=t.find(".wpcf7-label-text__paragraph").html()),"acceptance"==s&&(r.text=t.find(".wpcf7-list-item-label").html()),"file"==s&&(r.text=t.find(".wpcf7-file-caption").html());var d=t.find(".wpcf7-select").eq(0).find("option");if(0!=d.length&&d.each(function(t,e){""===e.value||e.getAttribute("disabled")||r.wpcf7_list_fields.push(e.textContent)}),0!==t.find(".wpcf7-radio").length){var f=t.find(".wpcf7-radio").eq(0).find(".wpcf7-radio-label");0===f.length&&(f=t.find(".wpcf7-radio").eq(0).find(".wpcf7-list-item-label")),f.each(function(t,e){r.wpcf7_list_fields.push(e.textContent)})}if(e){var u=t.find(".rex-wpcf7-column-content-data").eq(0),b=u[0],p=0!==t.find(".wpcf7-validates-as-required").length;if(!p){var _=0!==t.find(".wpcf7-acceptance").length;_&&(p=0===t.find(".wpcf7-acceptance.optional"))}r.wpcf7_required_field=b.getAttribute("data-wpcf7-required-field")?"true"===b.getAttribute("data-wpcf7-required-field"):p;var g=0!==t.find(".wpcf7-validates-as-email").length;r.wpcf7_email=b.getAttribute("data-wpcf7-email")?"true"===b.getAttribute("data-wpcf7-email").toString():g;var w=0!==t.find(".wpcf7-validates-as-number").length;r.wpcf7_only_numbers=b.getAttribute("data-wpcf7-only-numbers")?"true"===b.getAttribute("data-wpcf7-only-numbers").toString():w;var m=void 0!==t.find(".wpcf7-acceptance [type=checkbox]").prop("checked");if(r.wpcf7_default_check=b.getAttribute("data-wpcf7-default-check")?"true"===b.getAttribute("data-wpcf7-default-check").toString():m,-1!==["text","email","number","textarea"].indexOf(s)?b.hasAttribute("data-wpcf7-placeholder")&&b.getAttribute("data-wpcf7-placeholder")?r.wpcf7_placeholder=b.getAttribute("data-wpcf7-placeholder"):r.wpcf7_placeholder=t.find(".wpcf7-form-control").attr("placeholder")||"":-1!==["select"].indexOf(s)&&(b.getAttribute("data-wpcf7-placeholder")?r.wpcf7_placeholder=b.getAttribute("data-wpcf7-placeholder"):r.wpcf7_placeholder=t.find(".wpcf7-form-control [disabled]").text()||""),r.wpcf7_file_max_dimensions=b.getAttribute("data-wpcf7-file-max-dimensions")?b.getAttribute("data-wpcf7-file-max-dimensions").toString():I.wpcf7_file_max_dimensions,"file"===s)if(b.getAttribute("data-wpcf7-file-types"))r.wpcf7_list_fields=b.getAttribute("data-wpcf7-file-types").toString().split(",");else{for(var h=t.find("[type=file]").attr("accept").toString().split(","),x=0;x<h.length;x++)h[x]=h[x].replace(".","");r.wpcf7_list_fields=h}r.input_width=b.getAttribute("data-wpcf7-input-width")?b.getAttribute("data-wpcf7-input-width").toString():t.find("."+i).css("width"),r.input_height=b.getAttribute("data-wpcf7-input-height")?b.getAttribute("data-wpcf7-input-height").toString():t.find("."+i).css("height"),r.font_size=b.getAttribute("data-wpcf7-font-size")?b.getAttribute("data-wpcf7-font-size").toString():t.find("."+i).css("font-size"),r.background_color=b.getAttribute("data-background-color")?b.getAttribute("data-background-color").toString():t.find("."+i).css("background-color"),r.text_color=b.getAttribute("data-text-color")?b.getAttribute("data-text-color").toString():t.find("."+i).css("color"),r.text_color_focus=b.getAttribute("data-text-color-focus")?b.getAttribute("data-text-color-focus").toString():I.text_color_focus,r.select_color_after_selection=b.getAttribute("data-select-color-after-selection")?b.getAttribute("data-select-color-after-selection").toString():"",r.placeholder_color=b.getAttribute("data-placeholder-color")?b.getAttribute("data-placeholder-color").toString():I.placeholder_color,r.placeholder_hover_color=b.getAttribute("data-placeholder-hover-color")?b.getAttribute("data-placeholder-hover-color").toString():I.placeholder_hover_color,r.border_width=b.getAttribute("data-wpcf7-border-width")?b.getAttribute("data-wpcf7-border-width").toString():t.find("."+i).css("border-width"),r.border_radius=b.getAttribute("data-wpcf7-border-radius")?b.getAttribute("data-wpcf7-border-radius").toString():t.find("."+i).css("border-radius"),r.background_color_hover=b.getAttribute("data-background-color-hover")?b.getAttribute("data-background-color-hover").toString():"",r.text_color_hover=b.getAttribute("data-text-color-hover")?b.getAttribute("data-text-color-hover").toString():"",r.border_color=b.getAttribute("data-border-color")?b.getAttribute("data-border-color").toString():t.find("."+i).css("border-color"),r.border_color_hover=b.getAttribute("data-border-color-hover")?b.getAttribute("data-border-color-hover").toString():"",b.getAttribute("data-button-text")?r.wpcf7_button.text=b.getAttribute("data-button-text").toString():"file"==s?r.wpcf7_button.text="Choose a file":"submit"==s&&(r.wpcf7_button.text=t.find("[type=submit]").val()),b.getAttribute("data-button-text-font-size")?r.wpcf7_button.font_size=b.getAttribute("data-button-text-font-size").toString():"file"==s?r.wpcf7_button.font_size=t.find("."+r.field_class+" label").eq(0).css("font-size"):"submit"==s&&(r.wpcf7_button.font_size=t.find("."+i).css("font-size")),/\d+\.\d+/.test(r.wpcf7_button.font_size)&&(r.wpcf7_button.font_size=/\d+/.exec(r.wpcf7_button.font_size)[0]+"px"),b.getAttribute("data-button-height")?r.wpcf7_button.height=b.getAttribute("data-button-height").toString():"file"==s?r.wpcf7_button.height=t.find("."+r.field_class+" label").eq(0).css("height"):"submit"==s&&(r.wpcf7_button.height=t.find("."+i).css("height")),b.getAttribute("data-button-width")?r.wpcf7_button.width=b.getAttribute("data-button-width").toString():"file"==s?r.wpcf7_button.width=t.find("."+r.field_class+" label").eq(0).css("width"):"submit"==s&&(r.wpcf7_button.width=t.find("."+i).css("width")),b.getAttribute("data-button-border-width")?r.wpcf7_button.border_width=b.getAttribute("data-button-border-width").toString():"file"==s?r.wpcf7_button.border_width=t.find("."+r.field_class+" label").eq(0).css("border-width"):"submit"==s&&(r.wpcf7_button.border_width=t.find("."+i).css("border-width")),b.getAttribute("data-button-border-radius")?r.wpcf7_button.border_radius=b.getAttribute("data-button-border-radius").toString():"file"==s?r.wpcf7_button.border_radius=t.find("."+r.field_class+" label").eq(0).css("border-radius"):"submit"==s&&(r.wpcf7_button.border_radius=t.find("."+i).css("border-radius")),b.getAttribute("data-button-margin-top")?r.wpcf7_button.margin_top=b.getAttribute("data-button-margin-top").toString():"file"==s?r.wpcf7_button.margin_top=t.find("."+r.field_class+" label").eq(0).css("margin-top"):"submit"==s&&(r.wpcf7_button.margin_top=t.find("."+i).css("margin-top")),b.getAttribute("data-button-margin-right")?r.wpcf7_button.margin_right=b.getAttribute("data-button-margin-right").toString():"file"==s?r.wpcf7_button.margin_right=t.find("."+r.field_class+" label").eq(0).css("margin-right"):"submit"==s&&(r.wpcf7_button.margin_right=t.find("."+i).css("margin-right")),b.getAttribute("data-button-margin-bottom")?r.wpcf7_button.margin_bottom=b.getAttribute("data-button-margin-bottom").toString():"file"==s?r.wpcf7_button.margin_bottom=t.find("."+r.field_class+" label").eq(0).css("margin-bottom"):"submit"==s&&(r.wpcf7_button.margin_bottom=t.find("."+i).css("margin-bottom")),b.getAttribute("data-button-margin-left")?r.wpcf7_button.margin_left=b.getAttribute("data-button-margin-left").toString():"file"==s?r.wpcf7_button.margin_left=t.find("."+r.field_class+" label").eq(0).css("margin-left"):"submit"==s&&(r.wpcf7_button.margin_left=t.find("."+i).css("margin-left")),b.getAttribute("data-button-padding-top")?r.wpcf7_button.padding_top=b.getAttribute("data-button-padding-top").toString():"file"==s?r.wpcf7_button.padding_top=t.find("."+r.field_class+" label").eq(0).css("padding-top"):"submit"==s&&(r.wpcf7_button.padding_top=t.find("."+i).css("padding-top")),b.getAttribute("data-button-padding-right")?r.wpcf7_button.padding_right=b.getAttribute("data-button-padding-right").toString():"file"==s?r.wpcf7_button.padding_right=t.find("."+r.field_class+" label").eq(0).css("padding-right"):"submit"==s&&(r.wpcf7_button.padding_right=t.find("."+i).css("padding-right")),b.getAttribute("data-button-padding-bottom")?r.wpcf7_button.padding_bottom=b.getAttribute("data-button-padding-bottom").toString():"file"==s?r.wpcf7_button.padding_bottom=t.find("."+r.field_class+" label").eq(0).css("padding-bottom"):"submit"==s&&(r.wpcf7_button.padding_bottom=t.find("."+i).css("padding-bottom")),b.getAttribute("data-button-padding-left")?r.wpcf7_button.padding_left=b.getAttribute("data-button-padding-left").toString():"file"==s?r.wpcf7_button.padding_left=t.find("."+r.field_class+" label").eq(0).css("padding-left"):"submit"==s&&(r.wpcf7_button.padding_left=t.find("."+i).css("padding-left")),b.getAttribute("data-button-text-color")?r.wpcf7_button.text_color=b.getAttribute("data-button-text-color").toString():"file"==s?r.wpcf7_button.text_color=t.find("."+r.field_class+" label").eq(0).css("color"):"submit"==s&&(r.wpcf7_button.text_color=t.find("."+i).css("color")),r.wpcf7_button.text_color_hover=b.getAttribute("data-button-text-color-hover")?b.getAttribute("data-button-text-color-hover").toString():I.wpcf7_button.text_color_hover,b.getAttribute("data-button-background-color")?r.wpcf7_button.background_color=b.getAttribute("data-button-background-color").toString():"file"==s?r.wpcf7_button.background_color=t.find("."+r.field_class+" label").eq(0).css("background-color"):"submit"==s&&(r.wpcf7_button.background_color=t.find("."+i).css("background-color")),r.wpcf7_button.background_color_hover=b.getAttribute("data-button-background-color-hover")?b.getAttribute("data-button-background-color-hover").toString():I.wpcf7_button.background_color_hover,b.getAttribute("data-button-border-color")?r.wpcf7_button.border_color=b.getAttribute("data-button-border-color").toString():"file"==s?r.wpcf7_button.border_color=t.find("."+r.field_class+" label").eq(0).css("border-color"):"submit"==s&&(r.wpcf7_button.border_color=t.find("."+i).css("border-color")),r.wpcf7_button.border_color_hover=b.getAttribute("data-button-border-color-hover")?b.getAttribute("data-button-border-color-hover").toString():I.wpcf7_button.border_color_hover}else r.wpcf7_required_field=I.wpcf7_required_field,r.wpcf7_only_numbers=I.wpcf7_only_numbers,r.wpcf7_default_check=I.wpcf7_default_check,r.wpcf7_placeholder=I.wpcf7_placeholder,r.wpcf7_file_max_dimensions=I.wpcf7_file_max_dimensions,"file"==s&&(r.wpcf7_list_fields=["png","jpg","jpeg","pdf"]),r.input_width=t.find("."+i).css("width"),r.input_height=t.find("."+i).css("height"),r.font_size=I.font_size,r.background_color=t.find("."+i).css("background-color"),r.text_color=t.find("."+i).css("color"),r.text_color_focus=I.text_color_focus,"file"==s?r.wpcf7_button.text="Choose a file":"submit"==s&&(r.wpcf7_button.text="Send"),"file"==s?r.wpcf7_button.font_size=t.find("."+r.field_class+" label").eq(0).css("font-size"):"submit"==s&&(r.wpcf7_button.font_size=t.find("."+i).css("font-size")),"file"==s?r.wpcf7_button.height=t.find("."+r.field_class+" label").eq(0).css("height"):"submit"==s&&(r.wpcf7_button.height=t.find("."+i).css("height")),"file"==s?r.wpcf7_button.width=t.find("."+r.field_class+" label").eq(0).css("width"):"submit"==s&&(r.wpcf7_button.width=t.find("."+i).css("width")),"file"==s?r.wpcf7_button.border_width=t.find("."+r.field_class+" label").eq(0).css("border-width"):"submit"==s&&(r.wpcf7_button.border_width=t.find("."+i).css("border-width")),"file"==s?r.wpcf7_button.border_radius=t.find("."+r.field_class+" label").eq(0).css("border-radius"):"submit"==s&&(r.wpcf7_button.border_radius=t.find("."+i).css("border-radius")),"file"==s?r.wpcf7_button.margin_top=t.find("."+r.field_class+" label").eq(0).css("margin-top"):"submit"==s&&(r.wpcf7_button.margin_top=t.find("."+i).css("margin-top")),"file"==s?r.wpcf7_button.margin_right=t.find("."+r.field_class+" label").eq(0).css("margin-right"):"submit"==s&&(r.wpcf7_button.margin_right=t.find("."+i).css("margin-right")),"file"==s?r.wpcf7_button.margin_bottom=t.find("."+r.field_class+" label").eq(0).css("margin-bottom"):"submit"==s&&(r.wpcf7_button.margin_bottom=t.find("."+i).css("margin-bottom")),
"file"==s?r.wpcf7_button.margin_left=t.find("."+r.field_class+" label").eq(0).css("margin-left"):"submit"==s&&(r.wpcf7_button.margin_left=t.find("."+i).css("margin-left")),"file"==s?r.wpcf7_button.padding_top=t.find("."+r.field_class+" label").eq(0).css("padding-top"):"submit"==s&&(r.wpcf7_button.padding_top=t.find("."+i).css("padding-top")),"file"==s?r.wpcf7_button.padding_right=t.find("."+r.field_class+" label").eq(0).css("padding-right"):"submit"==s&&(r.wpcf7_button.padding_right=t.find("."+i).css("padding-right")),"file"==s?r.wpcf7_button.padding_bottom=t.find("."+r.field_class+" label").eq(0).css("padding-bottom"):"submit"==s&&(r.wpcf7_button.padding_bottom=t.find("."+i).css("padding-bottom")),"file"==s?r.wpcf7_button.padding_left=t.find("."+r.field_class+" label").eq(0).css("padding-left"):"submit"==s&&(r.wpcf7_button.padding_left=t.find("."+i).css("padding-left")),"file"==s?r.wpcf7_button.text_color=t.find("."+r.field_class+" label").eq(0).css("color"):"submit"==s&&(r.wpcf7_button.text_color=t.find("."+i).css("color")),r.wpcf7_button.text_color_hover=I.wpcf7_button.text_color_hover,"file"==s?r.wpcf7_button.background_color=t.find("."+r.field_class+" label").eq(0).css("background-color"):"submit"==s&&(r.wpcf7_button.background_color=t.find("."+i).css("background-color")),r.wpcf7_button.background_color_hover=I.wpcf7_button.background_color_hover,"file"==s?r.wpcf7_button.border_color=t.find("."+r.field_class+" label").eq(0).css("border-color"):"submit"==s&&(r.wpcf7_button.border_color=t.find("."+i).css("border-color")),r.wpcf7_button.border_color_hover=I.wpcf7_button.border_color_hover;return r}function q(){Rexbuilder_Util.$rexContainer.find(".wpcf7-form:not(.no-builder-form) .wpcf7-column").each(function(e,r){var o=t(r),a={text:0!=o.find("[type=text]").length,email:0!=o.find(".wpcf7-email").length,number:0!=o.find(".wpcf7-number").length,textarea:0!=o.find(".wpcf7-textarea").length,select:0!=o.find(".wpcf7-select").length,radio:0!=o.find(".wpcf7-radio").length,acceptance:0!=o.find(".wpcf7-acceptance").length,file:0!=o.find(".wpcf7-file").length,submit:0!=o.find(".wpcf7-submit").length},c="";for(var l in a)if(1==a[l]){c=l;break}var n=null;switch(c){case"text":case"email":case"number":case"textarea":n=o.find(".wpcf7-"+c),n.attr("size",""),B(n);break;case"select":n=o.find(".wpcf7-select");var i="";if(""==n.find("option").eq(0).val()){var s=n.find("option").eq(0);s.attr("disabled",""),s.attr("selected",""),i=s.parents(".wpcf7-column").find(".rex-wpcf7-column-content-data").attr("data-wpcf7-placeholder"),s.text(i),""===s.text()&&(s.text("Select something"),n.parents(".wpcf7-column").find(".rex-wpcf7-column-content-data").attr("data-wpcf7-placeholder","Select something"))}else{var d=t("<option value disabled selected></option>");n.prepend(d),i=n.parents(".wpcf7-column").find(".rex-wpcf7-column-content-data").attr("data-wpcf7-placeholder"),d.text(i),""===d.text()&&(d.text("Select something"),n.parents(".wpcf7-column").find(".rex-wpcf7-column-content-data").attr("data-wpcf7-placeholder","Select something"))}n.on("change",function(){var t=n.parents(".wpcf7-column").find(".rex-wpcf7-column-content-data").attr("data-select-color-after-selection");n.css("color",t)});break;case"radio":case"acceptance":case"file":case"submit":}}),L(),U()}function B(t){var e=t.parents(".wpcf7-column-content").children("label");if(0!==e.length)1===e.length&&e.addClass("wpcf7-label-text");else{var r=Rexbuilder_Public_Templates.getTemplate("label-text-paragraph"),o=t.parents(".wpcf7-form-control-wrap").get(0),a=document.createElement("label");if(Rexbuilder_Util.addClass(a,"wpcf7-label-text"),a.insertAdjacentHTML("afterbegin",r),o.parentNode.insertBefore(a,o),a.appendChild(o),Rexbuilder_Util.editorMode){var r=Rexbuilder_Public_Templates.getTemplate("label-text-paragraph"),c=t.parents(".rex-element-wrapper").attr("data-rex-element-id"),l=t.parents(".wpcf7-row").attr("wpcf7-row-number"),n=t.parents(".wpcf7-column").attr("wpcf7-column-number"),i=Rexbuilder_Rexwpcf7_Editor.retrieveFormsInPage()[c].find('[wpcf7-row-number="'+l+'"] [wpcf7-column-number="'+n+'"] .wpcf7-column-content').get(0);i.innerHTML='<label class="wpcf7-label-text">'+r+i.textContent+"</label>"}}}function L(){if(Rexbuilder_Util.rexContainer&&"undefined"!=typeof Rexbuilder_Util.rexContainer){for(var e,r,o=Rexbuilder_Util.rexContainer.querySelectorAll(".wpcf7-radio"),a=o.length,c=0;c<a;c++)if(e=o[c],r=e.className.match(/radio-\d+/)){r=r[0],Rexbuilder_Util.removeClass(e,r);var l=e.querySelector("[type=radio]").name,n=e.parentNode;Rexbuilder_Util.addClass(n,r),Rexbuilder_Util.removeClass(n,l)}Rexbuilder_Util.$rexContainer.find('.wpcf7 input[type="radio"]').each(function(e,r){var o=t(r);o.addClass("with-gap"),o.attr("id","wpcf7-radio-"+(e+1));var a=o.siblings(".wpcf7-list-item-label");if(0!==a.length){var c=a.text();a.empty();var l=t(document.createElement("label"));l.addClass("wpcf7-radio-label"),l.attr("for",o.attr("id")),l.text(c),l.insertAfter(a),a.removeClass("wpcf7-list-item-label")}else o.siblings(".wpcf7-radio-label").attr("for","wpcf7-radio-"+(e+1))})}}function U(){Rexbuilder_Util.$rexContainer.find(".rexpansive_section:not(.removing_section) .grid-stack-item:not(.removing_block) .wpcf7 .wpcf7-form-control-wrap").has(".wpcf7-file").each(function(e,r){var o=t(r);0===o.find(".wpcf7-file-caption").length&&o.siblings(".wpcf7-file-caption").detach().appendTo(o);var a=o.find("[type=file]"),c=/file-\w+/gm,l=a.get(0).className,n=c.exec(l);n&&(n=n[0],a.removeClass(n),a.parents(".wpcf7-form-control-wrap").addClass(n)),a.attr("id","wpcf7-file-"+(e+1)),a.siblings("label").remove();var i=t('<label for="'+a.attr("id")+'"></label>');if(i.insertAfter(a),"undefined"!=typeof o.parents(".wpcf7-column").find(".rex-wpcf7-column-content-data").attr("data-button-text")){var s=o.parents(".wpcf7-column").find(".rex-wpcf7-column-content-data").attr("data-button-text");i.text(s)}else i.text("Choose a file"),o.parents(".wpcf7-column").find(".rex-wpcf7-column-content-data").attr("data-button-text","Choose a file");var d=a.parents(".wpcf7-column"),f=T(d,!0);D(f.target.element_id,f),A(d)})}function W(t,e){var r="";r+="background-color: "+e.background_color+";",r+="border-style: solid;",r+="border-color: "+e.border_color+";",r+="border-width: "+e.border_width+";",r+="margin-top: "+e.margin_top+";",r+="margin-left: "+e.margin_left+";",r+="margin-right: "+e.margin_right+";",r+="margin-bottom: "+e.margin_bottom+";",a(t,r);var o="";o+="color:"+e.error_message_color+";",o+="font-size:"+e.error_message_font_size+";",G.forEach(function(e){c(t,e,o)});var n="";n+="color:"+e.send_message_color+";",n+="font-size:"+e.send_message_font_size+";",Q.forEach(function(e){c(t,e,n)});var i="";i+="padding-top: "+e.columns.padding_top+";",i+="padding-left: "+e.columns.padding_left+";",i+="padding-right: "+e.columns.padding_right+";",i+="padding-bottom: "+e.columns.padding_bottom+";",l(t,i)}function F(t,e){var r,o=e.target.row_number,a=e.target.column_number,c=e.field_class,l=e.input_type;switch(l){case"text":case"email":case"number":case"textarea":case"select":r="wpcf7-"+l;break;case"acceptance":r="wpcf7-form-control-wrap";break;case"file":case"submit":r=c;break;case"radio":r="wpcf7-form-control-wrap."+c}var f="";if(-1===["select","submit"].indexOf(l)&&(f+="color: "+e.text_color_focus+";",i(t,o,a,r,f)),"file"==l){var u="";u+="font-size: "+e.wpcf7_button.font_size+";",u+="height: "+e.wpcf7_button.height+";",u+="width: "+e.wpcf7_button.width+";",u+="border-width: "+e.wpcf7_button.border_width+";",u+="border-radius: "+e.wpcf7_button.border_radius+";",u+="border-style: solid;",u+="margin-top: "+e.wpcf7_button.margin_top+";",u+="margin-right: "+e.wpcf7_button.margin_right+";",u+="margin-bottom: "+e.wpcf7_button.margin_bottom+";",u+="margin-left: "+e.wpcf7_button.margin_left+";",u+="padding-top: "+e.wpcf7_button.padding_top+";",u+="padding-right: "+e.wpcf7_button.padding_right+";",u+="padding-bottom: "+e.wpcf7_button.padding_bottom+";",u+="padding-left: "+e.wpcf7_button.padding_left+";",u+="color: "+e.wpcf7_button.text_color+";",u+="background-color: "+e.wpcf7_button.background_color+";",u+="border-color: "+e.wpcf7_button.border_color+";";var b="";b+="color: "+e.wpcf7_button.text_color_hover+";",b+="background-color: "+e.wpcf7_button.background_color_hover+";",b+="border-color: "+e.wpcf7_button.border_color_hover+";",n(t,o,a,r+" label",u),s(t,o,a,r+" label",b)}if("submit"==l){var p="";p+="font-size: "+e.wpcf7_button.font_size+";",p+="height: "+e.wpcf7_button.height+";",p+="width: "+e.wpcf7_button.width+";",p+="border-width: "+e.wpcf7_button.border_width+";",p+="border-radius: "+e.wpcf7_button.border_radius+";",p+="border-style: solid;",p+="margin-top: "+e.wpcf7_button.margin_top+";",p+="margin-right: "+e.wpcf7_button.margin_right+";",p+="margin-bottom: "+e.wpcf7_button.margin_bottom+";",p+="margin-left: "+e.wpcf7_button.margin_left+";",p+="padding-top: "+e.wpcf7_button.padding_top+";",p+="padding-right: "+e.wpcf7_button.padding_right+";",p+="padding-bottom: "+e.wpcf7_button.padding_bottom+";",p+="padding-left: "+e.wpcf7_button.padding_left+";",p+="color: "+e.wpcf7_button.text_color+";",p+="background-color: "+e.wpcf7_button.background_color+";",p+="border-color: "+e.wpcf7_button.border_color+";";var _="";_+="color: "+e.wpcf7_button.text_color_hover+";",_+="background-color: "+e.wpcf7_button.background_color_hover+";",_+="border-color: "+e.wpcf7_button.border_color_hover+";",n(t,o,a,r,p),s(t,o,a,r,_)}else{var g="",w="";"file"===l?g+="display: block;":(g+="background-color: "+e.background_color+";",g+="border-color: "+e.border_color+";",g+="border-width: "+e.border_width+";",g+="border-radius: "+e.border_radius+";",w+="background-color: "+e.background_color_hover+";",w+="border-color: "+e.border_color_hover+";",-1===["radio","acceptance"].indexOf(l)&&(g+="border-style: solid;"));var m="";if("radio"===l&&(m+="font-size: "+e.font_size+";",m+="cursor:pointer;",n(t,o,a,r+" .wpcf7-radio-label",m)),"acceptance"===l){m+="font-size: "+e.font_size+";",m+="cursor:pointer;",n(t,o,a,r+" .wpcf7-list-item-label",m),n(t,o,a,r+" :not(:checked) ~ .wpcf7-list-item-label::before","border-color:"+e.text_color+";");var h="border-bottom-color:"+e.text_color+";";h+="border-right-color:"+e.text_color+";",n(t,o,a,r+" :checked ~ .wpcf7-list-item-label::before",h)}if(g+="color: "+e.text_color+";",g+="width: "+M(l,t,o,a,e.input_width)+";","acceptance"!==l&&(g+="height: "+e.input_height+";"),g+="font-size: "+e.font_size+";",n(t,o,a,r,g),w+="color: "+e.text_color_hover+";",s(t,o,a,r,w),"text"==l||"email"==l||"number"==l||"textarea"==l){var x="";x+="color:"+e.placeholder_color+";",n(t,o,a,r+"::placeholder",x);var R="";R+="color:"+e.placeholder_hover_color+";",d(t,o,a,r,R)}}}function E(t){}function O(t){var e=t.parents(".rex-element-wrapper").attr("data-rex-element-id"),r=t.parents(".wpcf7-row").attr("wpcf7-row-number"),o=t.attr("wpcf7-column-number"),a=0===t.find(".wpcf7-add-new-form-content").length&&0==t.parents("#rex-wpcf7-tools").length;if(a){var c=/[a-z]+\-[0-9]+/.exec(t.find(".wpcf7-form-control").get(0).classList);null===c?(c=/[a-z]+\-[0-9]+/.exec(t.find(".wpcf7-form-control-wrap").get(0).classList),c=null===c?/[a-z]+\-[0-9]+/.exec(t.find("[type=checkbox]").get(0).classList)[0]:c[0]):c=c[0];var l=/[a-z]+/.exec(c)[0];l="menu"==l?"select":l;var n;switch(l){case"text":case"email":case"number":case"textarea":case"select":n="wpcf7-"+l;break;case"acceptance":n="wpcf7-form-control-wrap";break;case"submit":n=c;break;case"file":n=c,h(e,r,o,n+" label"),x(e,r,o,n+" label");break;case"radio":n="wpcf7-form-control-wrap."+c}h(e,r,o,n),x(e,r,o,n),R(e,r,o,n)}}function P(e,r){e.each(function(){var e=t(this).find(".rex-element-data").eq(0);e.attr("data-wpcf7-background-color",r.background_color),e.attr("data-wpcf7-border-color",r.border_color),e.attr("data-wpcf7-border-width",r.border_width),e.attr("data-wpcf7-margin-top",r.margin_top),e.attr("data-wpcf7-margin-left",r.margin_left),e.attr("data-wpcf7-margin-right",r.margin_right),e.attr("data-wpcf7-margin-bottom",r.margin_bottom),e.attr("data-wpcf7-error-message-color",r.error_message_color),e.attr("data-wpcf7-error-message-font-size",r.error_message_font_size),e.attr("data-wpcf7-send-message-color",r.send_message_color),e.attr("data-wpcf7-send-message-font-size",r.send_message_font_size),e.attr("data-wpcf7-columns-padding-top",r.columns.padding_top),e.attr("data-wpcf7-columns-padding-left",r.columns.padding_left),e.attr("data-wpcf7-columns-padding-right",r.columns.padding_right),e.attr("data-wpcf7-columns-padding-bottom",r.columns.padding_bottom),e.attr("data-wpcf7-content-width",r.content.width),e.attr("data-wpcf7-content-height",r.content.height),e.attr("data-wpcf7-content-font-size",r.content.font_size),e.attr("data-wpcf7-content-border-width",r.content.border_width),e.attr("data-wpcf7-content-border-radius",r.content.border_radius),e.attr("data-wpcf7-content-text-color",r.content.text_color),e.attr("data-wpcf7-content-text-color-hover",r.content.text_color_hover),e.attr("data-wpcf7-content-background-color",r.content.background_color),e.attr("data-wpcf7-content-background-color-hover",r.content.background_color_hover),e.attr("data-wpcf7-content-border-color",r.content.border_color),e.attr("data-wpcf7-content-border-color-hover",r.content.border_color_hover)})}function D(e,r){var o=Rexbuilder_Util.$rexContainer.find('.rex-element-wrapper[data-rex-element-id="'+e+'"]').find(".wpcf7-form"),a=r.target.row_number,c=r.target.column_number,l=r.input_type;o.each(function(){var e=t(this).find('.wpcf7-row[wpcf7-row-number="'+a+'"]').find('.wpcf7-column[wpcf7-column-number="'+c+'"]').find(".rex-wpcf7-column-content-data");"submit"!==l&&"radio"!==l&&e.attr("data-wpcf7-required-field",r.wpcf7_required_field),"text"!==l&&"email"!==l&&"number"!==l||(e.attr("data-wpcf7-email",r.wpcf7_email),e.attr("data-wpcf7-only-numbers",r.wpcf7_only_numbers)),"acceptance"===l&&e.attr("data-wpcf7-default-check",r.wpcf7_default_check),"text"!==l&&"email"!==l&&"number"!==l&&"textarea"!==l&&"select"!==l||e.attr("data-wpcf7-placeholder",r.wpcf7_placeholder),"file"===l&&(e.attr("data-wpcf7-file-max-dimensions",r.wpcf7_file_max_dimensions),e.attr("data-wpcf7-file-types",r.wpcf7_list_fields)),"file"!=l&&"radio"!=l&&"acceptance"!=l&&(e.attr("data-wpcf7-border-width",r.border_width),e.attr("data-wpcf7-border-radius",r.border_radius),e.attr("data-background-color",r.background_color),e.attr("data-background-color-hover",r.background_color_hover),e.attr("data-border-color",r.border_color),e.attr("data-border-color-hover",r.border_color_hover)),e.attr("data-wpcf7-input-width",r.input_width),e.attr("data-wpcf7-input-height",r.input_height),e.attr("data-wpcf7-font-size",r.font_size),e.attr("data-text-color",r.text_color),e.attr("data-text-color-hover",r.text_color_hover),e.attr("data-text-color-focus",r.text_color_focus),"select"===l&&e.attr("data-select-color-after-selection",r.select_color_after_selection),"text"!==l&&"email"!==l&&"number"!==l&&"textarea"!==l||(e.attr("data-placeholder-color",r.placeholder_color),e.attr("data-placeholder-hover-color",r.placeholder_hover_color)),"file"!==l&&"submit"!==l||(e.attr("data-button-text",r.wpcf7_button.text),e.attr("data-button-text-font-size",r.wpcf7_button.font_size),e.attr("data-button-height",r.wpcf7_button.height),e.attr("data-button-width",r.wpcf7_button.width),e.attr("data-button-border-width",r.wpcf7_button.border_width),e.attr("data-button-border-radius",r.wpcf7_button.border_radius),e.attr("data-button-margin-top",r.wpcf7_button.margin_top),e.attr("data-button-margin-right",r.wpcf7_button.margin_right),e.attr("data-button-margin-bottom",r.wpcf7_button.margin_bottom),e.attr("data-button-margin-left",r.wpcf7_button.margin_left),e.attr("data-button-padding-top",r.wpcf7_button.padding_top),e.attr("data-button-padding-right",r.wpcf7_button.padding_right),e.attr("data-button-padding-bottom",r.wpcf7_button.padding_bottom),e.attr("data-button-padding-left",r.wpcf7_button.padding_left),e.attr("data-button-text-color",r.wpcf7_button.text_color),e.attr("data-button-text-color-hover",r.wpcf7_button.text_color_hover),e.attr("data-button-background-color",r.wpcf7_button.background_color),e.attr("data-button-background-color-hover",r.wpcf7_button.background_color_hover),e.attr("data-button-border-color",r.wpcf7_button.border_color),e.attr("data-button-border-color-hover",r.wpcf7_button.border_color_hover))}),Rexbuilder_Util.editorMode&&Rexbuilder_Rexwpcf7_Editor.updateSpanDataInDB(e,r)}function N(){t(".wpcf7-column.with-button").each(function(t,e){Rexbuilder_Util.removeClass(e,"with-button"),Rexbuilder_Util.addClass(e,"column-empty"),e.innerHTML=""})}function M(t,e,r,o,a){var c=-1!==["text","email","number","textarea","select"].indexOf(t)&&/\%/.test(a),l=Array.prototype.slice.call(Rexbuilder_Util.rexContainer.querySelectorAll('.rex-element-wrapper[data-rex-element-id="'+e+'"] .wpcf7-row[wpcf7-row-number="'+r+'"] .wpcf7-column[wpcf7-column-number="'+o+'"] .wpcf7-form-control-wrap'));return l.forEach(function(t){t.style.width=c?a:""}),c?"100%":a}function $(){Rexbuilder_Util.$rexContainer.find(".wpcf7-form:not(.no-builder-form) .wpcf7-radio").each(function(e,r){t(r).find(".wpcf7-list-item").click(function(e){e.preventDefault();var o=t(e.target).parents(".wpcf7-list-item");o.hasClass("selected")||(t(r).find(".wpcf7-list-item").each(function(e,o){t(o).removeClass("selected"),t(r).find("input").prop("checked",!1)}),o.addClass("selected"),o.find("input").prop("checked",!0))})}),Rexbuilder_Util.editorMode||document.addEventListener("wpcf7submit",function(e){var r=e.target,o=t(r).parents(".perfect-grid-gallery");if(0!==o.length){var a=RexGrid.data(o.get(0));setTimeout(function(){a.endResize()},200)}})}function H(){this.$rexFormsStyle=t("#rexpansive-builder-rexwpcf7-style-inline-css"),e(),Rexbuilder_Util.editorMode||q(),Rexbuilder_Rexelement.addStyles(),$(),Rexbuilder_Util.editorMode||N()}var j=null,I={wpcf7_required_field:!1,wpcf7_email:!1,wpcf7_only_numbers:!1,wpcf7_default_check:!1,wpcf7_placeholder:"Placeholder",wpcf7_file_max_dimensions:"25mb",wpcf7_button:{text_color_hover:"rgba(255,255,255,1)",background_color_hover:"rgba(86,86,86,1)",border_color_hover:"rgba(255,255,255,1)"},placeholder_color:"rgba(0,0,0,1)",placeholder_hover_color:"rgba(0,0,0,1)",text_color_focus:"rgba(0,0,0,1)"},G=["wpcf7-validation-errors","wpcf7-aborted","wpcf7-acceptance-missing","wpcf7-spam-blocked","wpcf7-mail-sent-ng"],Q=["wpcf7-mail-sent-ok"];return{init:H,guessWidthToSet:M,addFormStyle:C,refreshFormStyle:k,addColumnContentStyle:S,removeColumnContentStyle:O,refreshColumnContentStyle:A,fixInputs:q,fixWpcf7RadioButtons:L,fixWpcf7Files:U,generateColumnContentData:T,updateForm:v,updateFormContent:y,updateColumnContent:z,addFormRule:a,addFormMessageRule:c,addFormColumnsRule:l,addColumnContentRule:n,addColumnContentFocusRule:i,addColumnContentHoverRule:s,addColumnContentPlaceholderHoverRule:d,updateFormRule:f,updateFormMessageRule:u,updateFormColumnsRule:b,updateColumnContentRule:p,updateColumnContentFocusRule:_,updateColumnContentHoverRule:g,updateColumnContentPlaceholderHoverRule:w,removeFormRule:m,removeColumnContentRule:h,removeColumnContentHoverRule:x,removeColumnContentFocusRule:R}}(jQuery);
void function(t,e){"use strict";t.RexGrid=e(t)}("undefined"!=typeof window?window:this,function(t){function e(t){this.el=t.el,this.blockData=this.el.querySelector(".rexbuilder-block-data"),this.id=t.id,this.w=t.w,this.h=t.h,this.x=t.x,this.y=t.y,this.start_x=this.x,this.start_y=this.y,this.start_h=parseInt(this.blockData.getAttribute("data-gs_start_h")),this.hide=t.hide,this.domIndex=this.x+12*this.y,this.toCheck=t.toCheck,this.setHeight=!0,this.setTop=!0}function s(){this.element=null,this.gridBlocks=[],this.gridBlocksTotal=0,this.section=null,this.sectionData=null,arguments[0]&&(this.element=arguments[0],this.section=H.parents(this.element,".rexpansive_section"),this.sectionData=this.section.querySelector(".section-data"));var t={gutter:20,columns:12};arguments[1]&&"object"==typeof arguments[1]?this.options=H.extendDefaults(t,arguments[1]):this.options=t,this.properties={id:"",gridWidth:0,layout:"fixed",oneColumnModeActive:!1,noMobileLayoutSaved:!1,fullHeight:!1,gridHeightSettable:!0,singleWidth:0,singleHeight:0,halfSeparator:0,halfSeparatorTop:0,halfSeparatorRight:0,halfSeparatorBottom:0,halfSeparatorLeft:0,halfSeparatorBlockTop:0,halfSeparatorBlockRight:0,halfSeparatorBlockBottom:0,halfSeparatorBlockLeft:0,gridTopSeparator:null,gridRightSeparator:null,gridBottomSeparator:null,gridLeftSeparator:null,setMobilePadding:!1,setDesktopPadding:!1,editedFromBackend:!1,filterRule:!1,filterCoords:[]},r.call(this)}function r(){d.call(this),c.call(this),g.call(this),u.call(this),f.call(this),o.call(this),a.call(this),l.call(this),k.call(this),this.calcAllBlocksHeights(),this.calcAllBlocksTops(),p.call(this),C.push(this)}function o(){this.properties.gridWidth=this.element.offsetWidth,this.properties.singleWidth=this.properties.gridWidth/this.options.columns,"fixed"===this.properties.layout?this.properties.singleHeight=this.properties.singleWidth:"masonry"===this.properties.layout&&(this.properties.singleHeight=5)}function l(){if(this.properties.fullHeight){var t=n.call(this),e=this.properties.gridTopSeparator-this.properties.halfSeparatorTop,i=this.properties.gridBottomSeparator-this.properties.halfSeparatorBottom;0!==t&&(this.properties.singleHeight=(T.height+this.properties.fullHeightOffset-(e+i))/t)}}function a(){var t,i=Array.prototype.slice.call(this.element.getElementsByClassName("perfect-grid-item")),s=0;for(s=0;s<i.length;s++)H.hasClass(i[s],"rex-block--no-flow")||(t=new e({el:i[s],id:i[s].getAttribute("data-rexbuilder-block-id"),w:parseInt(i[s].getAttribute("data-gs-width")),h:parseInt(i[s].getAttribute("data-gs-height")),x:parseInt(i[s].getAttribute("data-gs-x")),y:parseInt(i[s].getAttribute("data-gs-y")),hide:H.hasClass(i[s],"rex-hide-element"),toCheck:!1}),m.call(this,t),this.gridBlocks.push(t));this.gridBlocksTotal=this.gridBlocks.length,this.sortBlocks(),this.properties.id=this.element.dataset.rexGridId}function h(t){var e=t.querySelector(".text-wrap"),i=0;if(!e)return i;var s=H.hasClass(t,"block-has-slider"),r=0!==e.textContent.trim().length,o=0!==e.childElementCount;return s||!r&&!o||(i=e.offsetHeight),i}function p(t){if(this.properties.gridHeightSettable){var e=n.call(this,t);this.element.style.height=e*this.properties.singleHeight+"px"}}function n(t){t="undefined"!=typeof t?t:this.gridBlocks;var e,i=0,s=0,r=t.length;for(s=0;s<r;s++)t[s].hide||(e=t[s].h+t[s].y,e>i&&(i=e));return i}function d(){"true"!=this.sectionData.getAttribute("data-row_edited_live")&&(this.properties.editedFromBackend=!0),this.properties.layout=this.element.getAttribute("data-layout"),this.properties.noMobileLayoutSaved="true"===this.sectionData.getAttribute("data-no-mobile-layout"),this.properties.oneColumnModeActive="true"===this.sectionData.getAttribute("data-collapse-grid"),this.properties.fullHeight="true"===this.element.getAttribute("data-full-height");var t=parseInt(this.element.dataset.fullHeightOffset);this.properties.fullHeightOffset=isNaN(t)?0:t}function c(){this.element.getAttribute("data-separator")&&(this.options.gutter=parseInt(this.element.getAttribute("data-separator"))),this.properties.gridTopSeparator=this.element.getAttribute("data-row-separator-top")?parseInt(this.element.getAttribute("data-row-separator-top")):null,this.properties.gridRightSeparator=this.element.getAttribute("data-row-separator-right")?parseInt(this.element.getAttribute("data-row-separator-right")):null,this.properties.gridBottomSeparator=this.element.getAttribute("data-row-separator-bottom")?parseInt(this.element.getAttribute("data-row-separator-bottom")):null,this.properties.gridLeftSeparator=this.element.getAttribute("data-row-separator-left")?parseInt(this.element.getAttribute("data-row-separator-left")):null}function g(){H.isEven(this.options.gutter)?(this.properties.halfSeparatorTop=this.options.gutter/2,this.properties.halfSeparatorRight=this.options.gutter/2,this.properties.halfSeparatorBottom=this.options.gutter/2,this.properties.halfSeparatorLeft=this.options.gutter/2):(this.properties.halfSeparatorTop=Math.floor(this.options.gutter/2),this.properties.halfSeparatorRight=Math.floor(this.options.gutter/2),this.properties.halfSeparatorBottom=Math.ceil(this.options.gutter/2),this.properties.halfSeparatorLeft=Math.ceil(this.options.gutter/2))}function u(){H.isEven(this.options.gutter)?(this.properties.halfSeparatorBlockTop=this.options.gutter/2,this.properties.halfSeparatorBlockRight=this.options.gutter/2,this.properties.halfSeparatorBlockBottom=this.options.gutter/2,this.properties.halfSeparatorBlockLeft=this.options.gutter/2):(this.properties.halfSeparatorBlockTop=Math.floor(this.options.gutter/2),this.properties.halfSeparatorBlockRight=Math.floor(this.options.gutter/2),this.properties.halfSeparatorBlockBottom=Math.ceil(this.options.gutter/2),this.properties.halfSeparatorBlockLeft=Math.ceil(this.options.gutter/2))}function f(){this.properties.setDesktopPadding&&(this.properties.setDesktopPadding||this.properties.setMobilePadding||"true"!=this.section.getAttribute("data-rex-collapse-grid"))||(this.properties.setDesktopPadding=!0,"true"==this.section.getAttribute("data-rex-collapse-grid")?this.properties.setMobilePadding=!0:this.properties.setMobilePadding=!1,null!==this.properties.gridTopSeparator?this.element.style.marginTop=this.properties.gridTopSeparator-this.properties.halfSeparatorTop+"px":this.element.style.marginTop=this.properties.halfSeparatorTop+"px",null!==this.properties.gridBottomSeparator?this.element.style.marginBottom=this.properties.gridBottomSeparator-this.properties.halfSeparatorBottom+"px":this.element.style.marginBottom=this.properties.halfSeparatorBottom+"px",null!==this.properties.gridLeftSeparator?this.element.style.marginLeft=this.properties.gridLeftSeparator-this.properties.halfSeparatorLeft+"px":this.element.style.marginLeft=this.properties.halfSeparatorLeft+"px",null!==this.properties.gridRightSeparator?this.element.style.marginRight=this.properties.gridRightSeparator-this.properties.halfSeparatorRight+"px":this.element.style.marginRight=this.properties.halfSeparatorRight+"px")}function k(){var t,e=0;for(e=0;e<this.gridBlocksTotal;e++)t=this.gridBlocks[e].el.querySelector(".grid-stack-item-content"),t.style.paddingTop=this.properties.halfSeparatorBlockTop+"px",t.style.paddingRight=this.properties.halfSeparatorBlockRight+"px",t.style.paddingBottom=this.properties.halfSeparatorBlockBottom+"px",t.style.paddingLeft=this.properties.halfSeparatorBlockLeft+"px"}function y(){var t=0,e=0;for(t=0;t<this.gridBlocksTotal;t++)if(this.gridBlocks[t].toCheck&&!this.gridBlocks[t].hide){for(e=0;e<this.gridBlocksTotal;e++)if(this.gridBlocks[t].el!==this.gridBlocks[e].el&&this.gridBlocks[t].x<this.gridBlocks[e].x+this.gridBlocks[e].w&&this.gridBlocks[t].x+this.gridBlocks[t].w>this.gridBlocks[e].x&&this.gridBlocks[t].y<this.gridBlocks[e].y+this.gridBlocks[e].h&&this.gridBlocks[t].y+this.gridBlocks[t].h>this.gridBlocks[e].y){var i=this.gridBlocks[t].y+this.gridBlocks[t].h-this.gridBlocks[e].y,s=this.gridBlocks[e].y+i;this.gridBlocks[e].el.setAttribute("data-gs-y",s),this.gridBlocks[e].blockData.setAttribute("data-gs-y",s),this.gridBlocks[e].setTop&&(this.gridBlocks[e].el.style.top=s*this.properties.singleHeight+"px"),this.gridBlocks[e].y=s,this.gridBlocks[e].domIndex=this.gridBlocks[e].x+this.gridBlocks[e].y*this.options.columns,this.gridBlocks[e].toCheck=!0}this.gridBlocks[t].toCheck=!1}}function B(){var t=0;for(t=0;t<this.gridBlocksTotal;t++)this.gridBlocks[t].el.setAttribute("data-gs-y",0),this.gridBlocks[t].blockData.setAttribute("data-gs-y",0),this.gridBlocks[t].setTop&&(this.gridBlocks[t].el.style.top="0px"),this.gridBlocks[t].y=0,this.gridBlocks[t].toCheck=!0}function m(t){var e=t.el,i=e.querySelector(".natural-image-background");if(null!==i){var s=e.querySelector(".grid-item-content");if(null===s)return void console.warn("No .grid-item-content Element found in function fixNaturalImage!");var r=parseInt(s.getAttribute("data-background_image_width")),o=this.properties.singleWidth*t.w-this.options.gutter;r>o&&H.addClass(i,"small-width")}}function b(t,e){"masonry"===this.properties.layout?t.setAttribute("data-block_height_masonry",e):t.setAttribute("data-block_height_fixed",e),t.setAttribute("data-gs_height",e),t.setAttribute("data-block_height_calculated",e)}function x(t){var e,i,s=t.el,r=t.blockData,o=t.start_h,l=this.properties.singleWidth,a=this.options.gutter,p=t.w,n=t.start_h*this.properties.singleHeight-a,d=parseInt(r.getAttribute("data-element_real_fluid")),c=0,g=0,u=0,f=0,k=!1,y=r.getAttribute("data-type_bg_block"),B=H.hasClass(s,"fit-natural-bg-image"),m=s.querySelector(".grid-item-content"),b=null,x=!1,v=!1,A=!1,S=!1,w=!1;if(m&&(v=-1!==m.className.indexOf("empty-content"),b=m.querySelector(".rex-image-wrapper"),x=-1!==s.className.indexOf("block-has-slider"),A=-1!==m.className.indexOf("youtube-player"),S=-1!==m.className.indexOf("mp4-player"),w=-1!==m.className.indexOf("vimeo-player")),x)return null;var C=h.call(this,s);if(this.properties.oneColumnModeActive&&(p=this.options.columns),0===C){if(null!==b){var T=parseInt(m.getAttribute("data-background_image_width")),_=parseInt(m.getAttribute("data-background_image_height")),I=this.properties.singleWidth*t.w;c=B?_*I/T-a:I<T?_*(p*l-a)/T:_}(A||S||w)&&(g=t.start_h*this.properties.singleHeight),x&&(f=t.start_h*this.properties.singleHeight),0==g&&0==c&&0==f&&(v||x)&&(u=this.properties.editedFromBackend&&"masonry"==this.properties.layout?Math.round(l*o):o*this.properties.singleHeight)}x||0!=c||0!=g||0!=C||(k=!0),x||A||w||S||!("full"===y&&0===C||""===y&&0===C)?(o=0,e=Math.max(o,c,g,u,C,f)):e=o*this.properties.singleHeight-a;var M=!0,N=!1;return 0!==C?("fixed"===this.properties.layout||1!==d&&"masonry"===this.properties.layout)&&e<=n&&(t.h>t.start_h?N=!0:M=!1):0!==c?"fixed"===this.properties.layout?M=!1:"masonry"===this.properties.layout&&("natural"===y&&1!==d||"full"===y)&&e<=n&&(M=!1):0!==g&&"masonry"===this.properties.layout&&(M=!1),N?t.start_h:M?i="fixed"==this.properties.layout&&(k||A||S||w)?Math.round((e+a)/this.properties.singleHeight):Math.ceil((e+a)/this.properties.singleHeight):null}function v(t){var e=t.el,i=e.querySelector(".rexbuilder-block-data"),s=e.querySelector(".text-wrap"),r=e.querySelector(".rex-image-wrapper"),o=e.querySelector(".grid-item-content"),l=-1!==e.className.indexOf("block-has-slider"),a=-1!==o.className.indexOf("youtube-player"),p=0!==[].slice.call(e.getElementsByClassName("rex-video-wrap")).length,n=-1!==o.className.indexOf("vimeo-player"),d=0,c=!1,g=null,u=t.h*this.properties.singleHeight;if(d=Math.round(u/this.properties.singleHeight),s){var f=h.call(this,t.el);c=0!==f,g=f+this.options.gutter}if(!c&&r){var k=parseInt(o.getAttribute("data-background_image_width")),y=parseInt(o.getAttribute("data-background_image_height")),B=this.properties.singleWidth*t.w-this.options.gutter;B<k?(g=y*(t.w*this.properties.singleWidth-this.options.gutter)/k,H.addClass(r,"small-width")):(g=y+this.options.gutter,H.removeClass(r,"small-width"))}var m=.75;!c&&(a||p||n)&&(g=Math.round(t.w*this.properties.singleWidth*m));var b=parseFloat(i.getAttribute("data-slider_ratio"));return l&&!isNaN(b)&&(g=isNaN(b)?t.w*this.properties.singleWidth*m:t.w*this.properties.singleWidth*b),d=Math.round(g/this.properties.singleHeight)}function A(t){if(0!==t.length){var e=new IndexedGrid(this.options.columns);t[0].x=0,t[0].y=0,e.setGrid(0,0,t[0].w,t[0].h);var s,r;for(i=1;i<t.length;i++)s=e.willFit(t[i].w,t[i].h),s&&(r=H.getCoord(s,this.options.columns),e.setGrid(r.x,r.y,t[i].w,t[i].h),t[i].x=r.x,t[i].y=r.y)}}function S(e,i){if(i="undefined"==typeof i?null:i,t.CustomEvent&&"function"==typeof t.CustomEvent)var s=new CustomEvent(e,{detail:i});else{var s=document.createEvent("CustomEvent");s.initCustomEvent(e,!0,!0,i)}this.element.dispatchEvent(s)}function w(t,e){t.h=e,t.setHeight&&(t.el.style.height=t.h*this.properties.singleHeight+"px"),t.el.setAttribute("data-gs-height",t.h),t.el.setAttribute("data-height",t.h),t.toCheck=!0}var C=[],H={viewport:function(){var e=t,i="inner";return"innerWidth"in t||(i="client",e=document.documentElement||document.body),{width:e[i+"Width"],height:e[i+"Height"]}},extendDefaults:function(t,e){var i;for(i in e)e.hasOwnProperty(i)&&(t[i]=e[i]);return t},matches:function(t,e){return(t.matches||t.matchesSelector||t.msMatchesSelector||t.mozMatchesSelector||t.webkitMatchesSelector||t.oMatchesSelector).call(t,e)},parents:function(t,e){for(;t.parentNode;){if(H.matches(t,e))return t;t=t.parentNode}return null},isEven:function(t){if("string"==typeof t&&(t=parseInt(t)),isNaN(t))throw new Error("The value passed is not a Number or a String representing a Number");return t%2===0},toggleClass:function(t,e){hasClass(t,e)?H.removeClass(t,e):H.addClass(t,e)},getCoord:function(t,e){return{x:t%e,y:Math.floor(t/e)}}};"classList"in document.documentElement?(H.hasClass=function(t,e){return t.classList.contains(e)},H.addClass=function(t,e){t.classList.add(e)},H.removeClass=function(t,e){t.classList.remove(e)}):(H.hasClass=function(t,e){return new RegExp("\\b"+e+"\\b").test(t.className)},H.addClass=function(t,e){hasClass(t,e)||(t.className+=" "+e)},H.removeClass=function(t,e){t.className=t.className.replace(new RegExp("\\b"+e+"\\b","g"),"")});var T=H.viewport();return e.prototype.refreshProperties=function(){this.refreshCoords(),this.refreshHide(),this.refreshDOMIndex()},e.prototype.refreshCoords=function(){this.w=parseInt(this.el.getAttribute("data-gs-width")),this.h=parseInt(this.el.getAttribute("data-gs-height")),this.x=parseInt(this.el.getAttribute("data-gs-x")),this.y=parseInt(this.el.getAttribute("data-gs-y")),this.start_h=parseInt(this.blockData.getAttribute("data-gs_start_h")),this.start_x=this.x,this.start_y=this.y},e.prototype.refreshHide=function(){this.hide=H.hasClass(this.el,"rex-hide-element")},e.prototype.refreshDOMIndex=function(){this.domIndex=this.x+12*this.y},e.prototype.destroy=function(){this.el.style.top="",this.el.style.height=""},s.prototype.isMasonry=function(){return"masonry"===this.properties.layout},s.prototype.isFixed=function(){return"fixed"===this.properties.layout},s.prototype.calcAllBlocksHeights=function(){var t=0;for(t=0;t<this.gridBlocksTotal;t++)this.gridBlocks[t].setHeight&&this.calcAndSetBlockHeight(this.gridBlocks[t])},s.prototype.calcAndSetBlockHeight=function(t){t.el.style.height=this.properties.singleHeight*t.h+"px"},s.prototype.fixAllBlocksHeights=function(){var t=0;for(t=0;t<this.gridBlocksTotal;t++)this.gridBlocks[t].hide||this.fixBlockHeight(this.gridBlocks[t])},s.prototype.fixBlockHeight=function(t){var e;e=this.properties.oneColumnModeActive?v.call(this,t):x.call(this,t),t.toCheck=!0,null===e||isNaN(e)||(b.call(this,t.blockData,e),w.call(this,t,e))},s.prototype.fixAllBlockPositions=function(){switch(this.properties.layout){case"masonry":B.call(this);default:y.call(this)}},s.prototype.calcAllBlocksTops=function(){var t,e=0,i=0;for(e=0;e<this.gridBlocksTotal;e++)t=this.gridBlocks[e].el,"fixed"===this.properties.layout&&(this.gridBlocks[e].y=this.gridBlocks[e].start_y),this.gridBlocks[e].setTop&&(i=this.properties.singleHeight*this.gridBlocks[e].y,t.style.top=i+"px")},s.prototype.fixAfterLoad=function(){this.fixAllBlocksHeights(),this.fixAllBlockPositions(),p.call(this)},s.prototype.updateGridBlocks=function(){var t=0;for(t=0;t<this.gridBlocksTotal;t++)this.gridBlocks[t].refreshProperties()},s.prototype.sortBlocks=function(){this.gridBlocks.sort(function(t,e){return t.domIndex-e.domIndex})},s.prototype.endChangeLayout=function(){if(d.call(this),c.call(this),g.call(this),u.call(this),this.properties.setDesktopPadding=!1,f.call(this),l.call(this),k.call(this),this.properties.noMobileLayoutSaved){var t,e,i=Array.prototype.slice.call(this.element.getElementsByClassName("perfect-grid-item")),s=i.length,r=[];for(t=0;t<s;t++)for(e=0;e<this.gridBlocksTotal;e++)i[t]===this.gridBlocks[e].el&&(r[t]=this.gridBlocks[e]);this.gridBlocks=r}this.updateGridBlocks(),this.sortBlocks()},s.prototype.endResize=function(){if(o.call(this),l.call(this),this.isFiltered()){this.calcAllBlocksHeights(),this.fixAllBlocksHeights(),this.fixAllBlockPositions();for(var t=0;t<this.gridBlocksTotal;t++)for(var e=0;e<this.properties.filterCoords.length;e++)if(this.properties.filterCoords[e].el===this.gridBlocks[t].el){this.properties.filterCoords[e].w=this.gridBlocks[t].w,this.properties.filterCoords[e].h=this.gridBlocks[t].h,this.properties.filterCoords[e].x=this.gridBlocks[t].x,this.properties.filterCoords[e].y=this.gridBlocks[t].y;break}A.call(this,this.properties.filterCoords);for(var t=0;t<this.properties.filterCoords.length;t++)this.properties.filterCoords[t].el.style.left=this.properties.filterCoords[t].x*this.properties.singleWidth+"px",this.properties.filterCoords[t].el.style.top=this.properties.filterCoords[t].y*this.properties.singleHeight+"px";p.call(this,this.properties.filterCoords)}else{if("*"===this.properties.filterRule)for(var t=0;t<this.gridBlocksTotal;t++)this.gridBlocks[t].el.style.left="";this.calcAllBlocksHeights(),this.calcAllBlocksTops(),this.fixAllBlocksHeights(),this.fixAllBlockPositions(),p.call(this)}},s.prototype.getRexBlockInstance=function(t){var e=0;for(e=0;e<this.gridBlocksTotal;e++)if(t===this.gridBlocks[e].el)return this.gridBlocks[e];return null},s.prototype.reCalcBlockHeight=function(t){var e=this.getRexBlockInstance(t),i=h.call(this,t),s=Math.ceil((i+this.options.gutter)/this.properties.singleHeight);b.call(this,e.blockData,s),w.call(this,e,s),this.fixAllBlockPositions(),p.call(this)},s.prototype.isFiltered=function(){return"string"==typeof this.properties.filterRule&&"*"!==this.properties.filterRule},s.prototype.filter=function(t){var e,i=[],s=[],r=[];if(this.properties.filterRule=t,"*"==t)for(e=0;e<this.gridBlocksTotal;e++)i.push(this.gridBlocks[e].el),s.push({x:this.gridBlocks[e].x,y:this.gridBlocks[e].y,w:this.gridBlocks[e].w,h:this.gridBlocks[e].h}),this.gridBlocks[e].hide=!1;else for(e=0;e<this.gridBlocksTotal;e++)H.hasClass(this.gridBlocks[e].el,t)?(i.push(this.gridBlocks[e].el),s.push({el:this.gridBlocks[e].el,x:0,y:0,w:this.gridBlocks[e].w,h:this.gridBlocks[e].h}),this.gridBlocks[e].hide=!1):(this.gridBlocks[e].hide=!0,r.push(this.gridBlocks[e].el));A.call(this,s),this.properties.filterCoords=s;var o=this,l=anime.timeline({duration:200,easing:"easeInOutQuad",begin:function(t){},complete:function(t){p.call(o,s),S.call(o,"rex-grid-filter-end")}});l.add({targets:i,scale:1,opacity:1,left:function(t,e){return s[e].x*o.properties.singleWidth+"px"},top:function(t,e){return s[e].y*o.properties.singleHeight+"px"},begin:function(t){t.animatables.forEach(function(t){H.removeClass(t.target,"rex-block--filtered")})}}).add({targets:r,scale:0,opacity:0,complete:function(t){t.animatables.forEach(function(t){H.addClass(t.target,"rex-block--filtered")})}},"-=200")},s.prototype.addGridBlock=function(t,i,s,r,o){"undefined"!=typeof i?(i=parseInt(i),t.setAttribute("data-gs-width",i)):i=parseInt(t.getAttribute("data-gs-width")),"undefined"!=typeof s?(s=parseInt(s),t.setAttribute("data-gs-height",s)):s=parseInt(t.getAttribute("data-gs-height")),"undefined"!=typeof r?(r=parseInt(r),t.setAttribute("data-gs-x",r)):r=parseInt(t.getAttribute("data-gs-x")),"undefined"!=typeof o?(o=parseInt(o),t.setAttribute("data-gs-y",o)):o=parseInt(t.getAttribute("data-gs-y"));var l=t.querySelector(".rexbuilder-block-data");l.setAttribute("data-gs_width",i),l.setAttribute("data-gs_height",s),l.setAttribute("data-gs_x",r),l.setAttribute("data-gs_y",o),l.setAttribute("data-gs_start_h",s);var a=new e({el:t,id:t.getAttribute("data-rexbuilder-block-id"),w:i,h:s,x:r,y:o,hide:H.hasClass(t,"rex-hide-element"),toCheck:!1}),h=t.querySelector(".grid-stack-item-content");h.style.paddingTop=this.properties.halfSeparatorBlockTop+"px",h.style.paddingRight=this.properties.halfSeparatorBlockRight+"px",h.style.paddingBottom=this.properties.halfSeparatorBlockBottom+"px",h.style.paddingLeft=this.properties.halfSeparatorBlockLeft+"px",this.gridBlocks.push(a),this.gridBlocksTotal=this.gridBlocks.length},s.prototype.addGridBlocksAccordingToLayoutData=function(t,e){if(Array.isArray(t)||(t=Array.prototype.slice.call(t)),!Array.isArray(e))throw new Error("Layout data passed is not an array!");for(var i=0;i<t.length;i++){var s=t[i],r=s.getAttribute("data-rexbuilder-block-id"),o=e.filter(function(t){return r===t.name});o=o[0];0!==o.props.length;if(!o)throw new Error("Block with ID "+r+" is not in the archive data!");this.addGridBlock(s,o.props.gs_width,o.props.gs_height,o.props.gs_x,o.props.gs_y)}},s.prototype.removeGridBlock=function(t,e){e="undefined"!=typeof e?e:{removeFromDOM:!0};for(var i=null,s=0;s<this.gridBlocksTotal;s++)if(this.gridBlocks[s].el===t){i=s;break}null!==i&&(e.removeFromDOM&&this.gridBlocks[i].el.parentNode.removeChild(this.gridBlocks[i].el),this.gridBlocks.splice(i,1),this.gridBlocksTotal=this.gridBlocks.length)},s.prototype.removeGridBlocks=function(t,e){Array.isArray(t)||(t=Array.prototype.slice.call(t));var i=this.removeGridBlock.bind(this);t.forEach(function(t){i(t,e)})},s.prototype.removeAllGridBlocks=function(){var t;for(t=0;t<this.gridBlocksTotal;t++)this.gridBlocks[t].el.parentNode&&this.gridBlocks[t].el.parentNode.removeChild(this.gridBlocks[t].el);this.gridBlocks=[],this.gridBlocksTotal=0},s.prototype.destroy=function(){function t(t){return t.element!==this.element}this.element.style.height="";var e;for(e=0;e<this.gridBlocksTotal;e++)this.gridBlocks[e].destroy();C=C.filter(t.bind(this))},s.prototype.setFullHeightOffset=function(t){return t?("string"==typeof t&&(t=parseInt(t)),"number"!=typeof t||isNaN(t)?void console.error("The offset passed must be either a String or a Number"):(this.element.dataset.fullHeightOffset=t,void(this.properties.fullHeightOffset=t))):void console.error("An offset must be passed!")},s.destroyAll=function(){C.forEach(function(t){t.destroy()})},s.data=function(t){var e=0,i=C.length;for(e=0;e<i;e++)if(t===C[e].element)return C[e];return null},s.updateViewportSize=function(){T=H.viewport()},s});
var Rex_Navigator=function(e){"use strict";function t(){d=Rexbuilder_Util.$rexContainer.children(".rexpansive_section"),c=d.get(),u=c.length,v=c.filter(function(e){return e.getAttribute("id")&&""!==e.getAttribute("id")}),s=v.length}function i(){r();for(var e=document.getElementById("vertical-nav-label"),t=Array.prototype.slice.call(document.querySelectorAll(".vertical-nav-link[href]")),i=0;i<t.length;i++)t[i].addEventListener("mouseenter",function(t){var i=t.target.getAttribute("href"),r=t.target.getAttribute("data-section_nav_label");r?e.innerHTML=r:e.innerText=i.replace("#","").replace(/\-/g," "),e.style.display="inline",e.style.opacity="1",e.style.top=R[i].top+R[i].height/2-e.offsetHeight/2+"px",e.style.right=1.5*R[i].width+"px"}),t[i].addEventListener("mouseleave",function(t){e.style.display="none",e.style.opacity="0"})}function r(){for(var e=Array.prototype.slice.call(document.querySelectorAll(".vertical-nav-link[href]")),t=0;t<e.length;t++){var i=e[t].getAttribute("href"),r=e[t].getBoundingClientRect();R[i]=r}}function n(){var e=Rexbuilder_Util.$document.find('nav[class*="vertical-nav"]');0!=e.length&&e.hasClass("nav-editor-mode-disable")&&f(e),a=document.querySelector(".vertical-nav"),a&&(Rexbuilder_Util.$window.on("scroll",function(){h()}),_()),x(),i()}var a,l,o,d,c,u,v,s,f=function(t){var i=Rexbuilder_Util.$rexContainer.children(".rexpansive_section");i.each(function(i,r){var n=e(r),a=n.attr("data-rexlive-section-name");if(""!=a){var l=a.replace(/ /gm,"");tmpl.arg="navigator";var o=tmpl("tmpl-navigator-item",{sectionName:a,sectionID:l,number:i+1});t.children("ul").append(o)}})},h=function(){var t,i,r;d.each(function(){t=e(this),null!==this.getAttribute("id")&&""!=this.getAttribute("id")&&(i=document.querySelector('.vertical-nav a[href="#'+this.getAttribute("id")+'"]'),i&&(r=i.getAttribute("data-number")-1,t.offset().top-Rexbuilder_Util.globalViewport.height/2<Rexbuilder_Util.$window.scrollTop()&&t.offset().top+t.height()-Rexbuilder_Util.globalViewport.height/2>Rexbuilder_Util.$window.scrollTop()?o.eq(r).addClass("is-selected"):o.eq(r).removeClass("is-selected")))})},g=function(){o=Rexbuilder_Util.$document.find(".vertical-nav a")},p=function(){l=Rexbuilder_Util.$document.find(".touch .vertical-nav a")},b=function(e){if(void 0!=e.attr("id")&&""!=e.attr("id")){var t=e.attr("id"),i=Rexbuilder_Util.$document.find('nav[class*="vertical-nav"]'),r=i.find('li a[href="#'+t+'"]').parent(),n=e,a="";do if(n=n.next(),a=n.attr("id"),""!=a)break;while(0!=n.length);""==a||void 0==a?i.children("ul").append(r[0]):r.insertBefore(i.find('li a[href="#'+a+'"]').parent())}},m=function(t,i,r){var n=Rexbuilder_Util.$document.find('nav[class*="vertical-nav"]');if(""!=i){if(""==t.attr("id")){var a=Rexbuilder_Util.$rexContainer.children(".rexpansive_section").length,l=Rexbuilder_Util.$rexContainer.children('.rexpansive_section[id=""]').length,o=t,d="";do if(o=o.next(),d=o.attr("id"),""!=d)break;while(0!=o.length);var c=a-l+1;tmpl.arg="navigator";var u=tmpl("tmpl-navigator-item",{sectionName:r,sectionID:i,number:c});""==d||void 0==d?n.children("ul").append(u):e(u).insertBefore(n.find('li a[href="#'+d+'"]').parent())}else{var v=t.attr("id"),s=n.find('li a[href="#'+v+'"]');s.attr("href","#"+i),s.find(".label").text(r)}t.attr("id",i),t.attr("href","#"+i)}else if(""!=t.attr("id")){var v=t.attr("id"),s=n.find('li a[href="#'+v+'"]').parent();s.remove(),t.attr("id",""),t.removeAttr("href")}x()},x=function(){t(),g(),p(),a&&h()},_=function(){Rexbuilder_Util.$document.on("click",".vertical-nav a",function(t){t.preventDefault();var i=e(t.target);i.is("a")||(i=i.parents("a"));var r=i.attr("href"),n=Rexbuilder_Util.$rexContainer.children(r);Rexbuilder_Util.smoothScroll(n)}),Rexbuilder_Util.$document.on("click",".touch .vertical-nav a",function(){l.find(".rex-label").removeClass("fadeInAndOut"),e(this).find(".rex-label").addClass("fadeInAndOut"),Rexbuilder_Util.$document.find(".touch .vertical-nav").removeClass("open")})},R={};return{init:n,updateNavigator:x,updateNavigatorItem:m,fixNavigatorItemOrder:b,getNavigationDotsPosition:r}}(jQuery);
/*!
 * Flickity PACKAGED v2.2.0
 * Touch, responsive, flickable carousels
 *
 * Licensed GPLv3 for open source use
 * or Flickity Commercial License for commercial use
 *
 * https://flickity.metafizzy.co
 * Copyright 2015-2018 Metafizzy
 */
!function(t,e){"function"==typeof define&&define.amd?define("jquery-bridget/jquery-bridget",["jquery"],function(i){return e(t,i)}):"object"==typeof module&&module.exports?module.exports=e(t,require("jquery")):t.jQueryBridget=e(t,t.jQuery)}(window,function(t,e){"use strict";function i(i,o,a){(a=a||e||t.jQuery)&&(o.prototype.option||(o.prototype.option=function(t){a.isPlainObject(t)&&(this.options=a.extend(!0,this.options,t))}),a.fn[i]=function(t){if("string"!=typeof t)return d=t,this.each(function(t,e){var n=a.data(e,i);n?(n.option(d),n._init()):(n=new o(e,d),a.data(e,i,n))}),this;var e,n,l,h,c,d,u=s.call(arguments,1);return l=u,c="$()."+i+'("'+(n=t)+'")',(e=this).each(function(t,e){var s=a.data(e,i);if(s){var o=s[n];if(o&&"_"!=n.charAt(0)){var d=o.apply(s,l);h=void 0===h?d:h}else r(c+" is not a valid method")}else r(i+" not initialized. Cannot call methods, i.e. "+c)}),void 0!==h?h:e},n(a))}function n(t){!t||t&&t.bridget||(t.bridget=i)}var s=Array.prototype.slice,o=t.console,r=void 0===o?function(){}:function(t){o.error(t)};return n(e||t.jQuery),i}),function(t,e){"function"==typeof define&&define.amd?define("ev-emitter/ev-emitter",e):"object"==typeof module&&module.exports?module.exports=e():t.EvEmitter=e()}("undefined"!=typeof window?window:this,function(){function t(){}var e=t.prototype;return e.on=function(t,e){if(t&&e){var i=this._events=this._events||{},n=i[t]=i[t]||[];return-1==n.indexOf(e)&&n.push(e),this}},e.once=function(t,e){if(t&&e){this.on(t,e);var i=this._onceEvents=this._onceEvents||{};return(i[t]=i[t]||{})[e]=!0,this}},e.off=function(t,e){var i=this._events&&this._events[t];if(i&&i.length){var n=i.indexOf(e);return-1!=n&&i.splice(n,1),this}},e.emitEvent=function(t,e){var i=this._events&&this._events[t];if(i&&i.length){i=i.slice(0),e=e||[];for(var n=this._onceEvents&&this._onceEvents[t],s=0;s<i.length;s++){var o=i[s];n&&n[o]&&(this.off(t,o),delete n[o]),o.apply(this,e)}return this}},e.allOff=function(){delete this._events,delete this._onceEvents},t}),function(t,e){"function"==typeof define&&define.amd?define("get-size/get-size",e):"object"==typeof module&&module.exports?module.exports=e():t.getSize=e()}(window,function(){"use strict";function t(t){var e=parseFloat(t);return-1==t.indexOf("%")&&!isNaN(e)&&e}function e(t){var e=getComputedStyle(t);return e||s("Style returned "+e+". Are you running this code in a hidden iframe on Firefox? See https://bit.ly/getsizebug1"),e}function i(s){if(function(){if(!a){a=!0;var s=document.createElement("div");s.style.width="200px",s.style.padding="1px 2px 3px 4px",s.style.borderStyle="solid",s.style.borderWidth="1px 2px 3px 4px",s.style.boxSizing="border-box";var o=document.body||document.documentElement;o.appendChild(s);var r=e(s);n=200==Math.round(t(r.width)),i.isBoxSizeOuter=n,o.removeChild(s)}}(),"string"==typeof s&&(s=document.querySelector(s)),s&&"object"==typeof s&&s.nodeType){var l=e(s);if("none"==l.display)return function(){for(var t={width:0,height:0,innerWidth:0,innerHeight:0,outerWidth:0,outerHeight:0},e=0;e<r;e++)t[o[e]]=0;return t}();var h={};h.width=s.offsetWidth,h.height=s.offsetHeight;for(var c=h.isBorderBox="border-box"==l.boxSizing,d=0;d<r;d++){var u=o[d],f=l[u],p=parseFloat(f);h[u]=isNaN(p)?0:p}var g=h.paddingLeft+h.paddingRight,v=h.paddingTop+h.paddingBottom,m=h.marginLeft+h.marginRight,y=h.marginTop+h.marginBottom,b=h.borderLeftWidth+h.borderRightWidth,E=h.borderTopWidth+h.borderBottomWidth,S=c&&n,C=t(l.width);!1!==C&&(h.width=C+(S?0:g+b));var x=t(l.height);return!1!==x&&(h.height=x+(S?0:v+E)),h.innerWidth=h.width-(g+b),h.innerHeight=h.height-(v+E),h.outerWidth=h.width+m,h.outerHeight=h.height+y,h}}var n,s="undefined"==typeof console?function(){}:function(t){console.error(t)},o=["paddingLeft","paddingRight","paddingTop","paddingBottom","marginLeft","marginRight","marginTop","marginBottom","borderLeftWidth","borderRightWidth","borderTopWidth","borderBottomWidth"],r=o.length,a=!1;return i}),function(t,e){"use strict";"function"==typeof define&&define.amd?define("desandro-matches-selector/matches-selector",e):"object"==typeof module&&module.exports?module.exports=e():t.matchesSelector=e()}(window,function(){"use strict";var t=function(){var t=window.Element.prototype;if(t.matches)return"matches";if(t.matchesSelector)return"matchesSelector";for(var e=["webkit","moz","ms","o"],i=0;i<e.length;i++){var n=e[i]+"MatchesSelector";if(t[n])return n}}();return function(e,i){return e[t](i)}}),function(t,e){"function"==typeof define&&define.amd?define("fizzy-ui-utils/utils",["desandro-matches-selector/matches-selector"],function(i){return e(t,i)}):"object"==typeof module&&module.exports?module.exports=e(t,require("desandro-matches-selector")):t.fizzyUIUtils=e(t,t.matchesSelector)}(window,function(t,e){var i={extend:function(t,e){for(var i in e)t[i]=e[i];return t},modulo:function(t,e){return(t%e+e)%e}},n=Array.prototype.slice;i.makeArray=function(t){return Array.isArray(t)?t:null==t?[]:"object"==typeof t&&"number"==typeof t.length?n.call(t):[t]},i.removeFrom=function(t,e){var i=t.indexOf(e);-1!=i&&t.splice(i,1)},i.getParent=function(t,i){for(;t.parentNode&&t!=document.body;)if(t=t.parentNode,e(t,i))return t},i.getQueryElement=function(t){return"string"==typeof t?document.querySelector(t):t},i.handleEvent=function(t){var e="on"+t.type;this[e]&&this[e](t)},i.filterFindElements=function(t,n){t=i.makeArray(t);var s=[];return t.forEach(function(t){if(t instanceof HTMLElement)if(n){e(t,n)&&s.push(t);for(var i=t.querySelectorAll(n),o=0;o<i.length;o++)s.push(i[o])}else s.push(t)}),s},i.debounceMethod=function(t,e,i){i=i||100;var n=t.prototype[e],s=e+"Timeout";t.prototype[e]=function(){var t=this[s];clearTimeout(t);var e=arguments,o=this;this[s]=setTimeout(function(){n.apply(o,e),delete o[s]},i)}},i.docReady=function(t){var e=document.readyState;"complete"==e||"interactive"==e?setTimeout(t):document.addEventListener("DOMContentLoaded",t)},i.toDashed=function(t){return t.replace(/(.)([A-Z])/g,function(t,e,i){return e+"-"+i}).toLowerCase()};var s=t.console;return i.htmlInit=function(e,n){i.docReady(function(){var o=i.toDashed(n),r="data-"+o,a=document.querySelectorAll("["+r+"]"),l=document.querySelectorAll(".js-"+o),h=i.makeArray(a).concat(i.makeArray(l)),c=r+"-options",d=t.jQuery;h.forEach(function(t){var i,o=t.getAttribute(r)||t.getAttribute(c);try{i=o&&JSON.parse(o)}catch(i){return void(s&&s.error("Error parsing "+r+" on "+t.className+": "+i))}var a=new e(t,i);d&&d.data(t,n,a)})})},i}),function(t,e){"function"==typeof define&&define.amd?define("flickity/js/cell",["get-size/get-size"],function(i){return e(t,i)}):"object"==typeof module&&module.exports?module.exports=e(t,require("get-size")):(t.Flickity=t.Flickity||{},t.Flickity.Cell=e(t,t.getSize))}(window,function(t,e){function i(t,e){this.element=t,this.parent=e,this.create()}var n=i.prototype;return n.create=function(){this.element.style.position="absolute",this.element.setAttribute("aria-hidden","true"),this.x=0,this.shift=0},n.destroy=function(){this.unselect(),this.element.style.position="";var t=this.parent.originSide;this.element.style[t]=""},n.getSize=function(){this.size=e(this.element)},n.setPosition=function(t){this.x=t,this.updateTarget(),this.renderPosition(t)},n.updateTarget=n.setDefaultTarget=function(){var t="left"==this.parent.originSide?"marginLeft":"marginRight";this.target=this.x+this.size[t]+this.size.width*this.parent.cellAlign},n.renderPosition=function(t){var e=this.parent.originSide;this.element.style[e]=this.parent.getPositionValue(t)},n.select=function(){this.element.classList.add("is-selected"),this.element.removeAttribute("aria-hidden")},n.unselect=function(){this.element.classList.remove("is-selected"),this.element.setAttribute("aria-hidden","true")},n.wrapShift=function(t){this.shift=t,this.renderPosition(this.x+this.parent.slideableWidth*t)},n.remove=function(){this.element.parentNode.removeChild(this.element)},i}),function(t,e){"function"==typeof define&&define.amd?define("flickity/js/slide",e):"object"==typeof module&&module.exports?module.exports=e():(t.Flickity=t.Flickity||{},t.Flickity.Slide=e())}(window,function(){"use strict";function t(t){this.parent=t,this.isOriginLeft="left"==t.originSide,this.cells=[],this.outerWidth=0,this.height=0}var e=t.prototype;return e.addCell=function(t){if(this.cells.push(t),this.outerWidth+=t.size.outerWidth,this.height=Math.max(t.size.outerHeight,this.height),1==this.cells.length){this.x=t.x;var e=this.isOriginLeft?"marginLeft":"marginRight";this.firstMargin=t.size[e]}},e.updateTarget=function(){var t=this.isOriginLeft?"marginRight":"marginLeft",e=this.getLastCell(),i=e?e.size[t]:0,n=this.outerWidth-(this.firstMargin+i);this.target=this.x+this.firstMargin+n*this.parent.cellAlign},e.getLastCell=function(){return this.cells[this.cells.length-1]},e.select=function(){this.cells.forEach(function(t){t.select()})},e.unselect=function(){this.cells.forEach(function(t){t.unselect()})},e.getCellElements=function(){return this.cells.map(function(t){return t.element})},t}),function(t,e){"function"==typeof define&&define.amd?define("flickity/js/animate",["fizzy-ui-utils/utils"],function(i){return e(t,i)}):"object"==typeof module&&module.exports?module.exports=e(t,require("fizzy-ui-utils")):(t.Flickity=t.Flickity||{},t.Flickity.animatePrototype=e(t,t.fizzyUIUtils))}(window,function(t,e){var i={startAnimation:function(){this.isAnimating||(this.isAnimating=!0,this.restingFrames=0,this.animate())},animate:function(){this.applyDragForce(),this.applySelectedAttraction();var t=this.x;if(this.integratePhysics(),this.positionSlider(),this.settle(t),this.isAnimating){var e=this;requestAnimationFrame(function(){e.animate()})}},positionSlider:function(){var t=this.x;this.options.wrapAround&&1<this.cells.length&&(t=e.modulo(t,this.slideableWidth),t-=this.slideableWidth,this.shiftWrapCells(t)),this.setTranslateX(t,this.isAnimating),this.dispatchScrollEvent()},setTranslateX:function(t,e){t+=this.cursorPosition,t=this.options.rightToLeft?-t:t;var i=this.getPositionValue(t);this.slider.style.transform=e?"translate3d("+i+",0,0)":"translateX("+i+")"},dispatchScrollEvent:function(){var t=this.slides[0];if(t){var e=-this.x-t.target,i=e/this.slidesWidth;this.dispatchEvent("scroll",null,[i,e])}},positionSliderAtSelected:function(){this.cells.length&&(this.x=-this.selectedSlide.target,this.velocity=0,this.positionSlider())},getPositionValue:function(t){return this.options.percentPosition?.01*Math.round(t/this.size.innerWidth*1e4)+"%":Math.round(t)+"px"},settle:function(t){this.isPointerDown||Math.round(100*this.x)!=Math.round(100*t)||this.restingFrames++,2<this.restingFrames&&(this.isAnimating=!1,delete this.isFreeScrolling,this.positionSlider(),this.dispatchEvent("settle",null,[this.selectedIndex]))},shiftWrapCells:function(t){var e=this.cursorPosition+t;this._shiftCells(this.beforeShiftCells,e,-1);var i=this.size.innerWidth-(t+this.slideableWidth+this.cursorPosition);this._shiftCells(this.afterShiftCells,i,1)},_shiftCells:function(t,e,i){for(var n=0;n<t.length;n++){var s=t[n],o=0<e?i:0;s.wrapShift(o),e-=s.size.outerWidth}},_unshiftCells:function(t){if(t&&t.length)for(var e=0;e<t.length;e++)t[e].wrapShift(0)},integratePhysics:function(){this.x+=this.velocity,this.velocity*=this.getFrictionFactor()},applyForce:function(t){this.velocity+=t},getFrictionFactor:function(){return 1-this.options[this.isFreeScrolling?"freeScrollFriction":"friction"]},getRestingPosition:function(){return this.x+this.velocity/(1-this.getFrictionFactor())},applyDragForce:function(){if(this.isDraggable&&this.isPointerDown){var t=this.dragX-this.x-this.velocity;this.applyForce(t)}},applySelectedAttraction:function(){if((!this.isDraggable||!this.isPointerDown)&&!this.isFreeScrolling&&this.slides.length){var t=(-1*this.selectedSlide.target-this.x)*this.options.selectedAttraction;this.applyForce(t)}}};return i}),function(t,e){if("function"==typeof define&&define.amd)define("flickity/js/flickity",["ev-emitter/ev-emitter","get-size/get-size","fizzy-ui-utils/utils","./cell","./slide","./animate"],function(i,n,s,o,r,a){return e(t,i,n,s,o,r,a)});else if("object"==typeof module&&module.exports)module.exports=e(t,require("ev-emitter"),require("get-size"),require("fizzy-ui-utils"),require("./cell"),require("./slide"),require("./animate"));else{var i=t.Flickity;t.Flickity=e(t,t.EvEmitter,t.getSize,t.fizzyUIUtils,i.Cell,i.Slide,i.animatePrototype)}}(window,function(t,e,i,n,s,o,r){function a(t,e){for(t=n.makeArray(t);t.length;)e.appendChild(t.shift())}function l(t,e){var i=n.getQueryElement(t);if(i){if(this.element=i,this.element.flickityGUID){var s=f[this.element.flickityGUID];return s.option(e),s}h&&(this.$element=h(this.element)),this.options=n.extend({},this.constructor.defaults),this.option(e),this._create()}else d&&d.error("Bad element for Flickity: "+(i||t))}var h=t.jQuery,c=t.getComputedStyle,d=t.console,u=0,f={};l.defaults={accessibility:!0,cellAlign:"center",freeScrollFriction:.075,friction:.28,namespaceJQueryEvents:!0,percentPosition:!0,resize:!0,selectedAttraction:.025,setGallerySize:!0},l.createMethods=[];var p=l.prototype;n.extend(p,e.prototype),p._create=function(){var e=this.guid=++u;for(var i in this.element.flickityGUID=e,(f[e]=this).selectedIndex=0,this.restingFrames=0,this.x=0,this.velocity=0,this.originSide=this.options.rightToLeft?"right":"left",this.viewport=document.createElement("div"),this.viewport.className="flickity-viewport",this._createSlider(),(this.options.resize||this.options.watchCSS)&&t.addEventListener("resize",this),this.options.on){var n=this.options.on[i];this.on(i,n)}l.createMethods.forEach(function(t){this[t]()},this),this.options.watchCSS?this.watchCSS():this.activate()},p.option=function(t){n.extend(this.options,t)},p.activate=function(){this.isActive||(this.isActive=!0,this.element.classList.add("flickity-enabled"),this.options.rightToLeft&&this.element.classList.add("flickity-rtl"),this.getSize(),a(this._filterFindCellElements(this.element.children),this.slider),this.viewport.appendChild(this.slider),this.element.appendChild(this.viewport),this.reloadCells(),this.options.accessibility&&(this.element.tabIndex=0,this.element.addEventListener("keydown",this)),this.emitEvent("activate"),this.selectInitialIndex(),this.isInitActivated=!0,this.dispatchEvent("ready"))},p._createSlider=function(){var t=document.createElement("div");t.className="flickity-slider",t.style[this.originSide]=0,this.slider=t},p._filterFindCellElements=function(t){return n.filterFindElements(t,this.options.cellSelector)},p.reloadCells=function(){this.cells=this._makeCells(this.slider.children),this.positionCells(),this._getWrapShiftCells(),this.setGallerySize()},p._makeCells=function(t){return this._filterFindCellElements(t).map(function(t){return new s(t,this)},this)},p.getLastCell=function(){return this.cells[this.cells.length-1]},p.getLastSlide=function(){return this.slides[this.slides.length-1]},p.positionCells=function(){this._sizeCells(this.cells),this._positionCells(0)},p._positionCells=function(t){t=t||0,this.maxCellHeight=t&&this.maxCellHeight||0;var e=0;if(0<t){var i=this.cells[t-1];e=i.x+i.size.outerWidth}for(var n=this.cells.length,s=t;s<n;s++){var o=this.cells[s];o.setPosition(e),e+=o.size.outerWidth,this.maxCellHeight=Math.max(o.size.outerHeight,this.maxCellHeight)}this.slideableWidth=e,this.updateSlides(),this._containSlides(),this.slidesWidth=n?this.getLastSlide().target-this.slides[0].target:0},p._sizeCells=function(t){t.forEach(function(t){t.getSize()})},p.updateSlides=function(){if(this.slides=[],this.cells.length){var t=new o(this);this.slides.push(t);var e="left"==this.originSide?"marginRight":"marginLeft",i=this._getCanCellFit();this.cells.forEach(function(n,s){if(t.cells.length){var r=t.outerWidth-t.firstMargin+(n.size.outerWidth-n.size[e]);i.call(this,s,r)||(t.updateTarget(),t=new o(this),this.slides.push(t)),t.addCell(n)}else t.addCell(n)},this),t.updateTarget(),this.updateSelectedSlide()}},p._getCanCellFit=function(){var t=this.options.groupCells;if(!t)return function(){return!1};if("number"==typeof t){var e=parseInt(t,10);return function(t){return t%e!=0}}var i="string"==typeof t&&t.match(/^(\d+)%$/),n=i?parseInt(i[1],10)/100:1;return function(t,e){return e<=(this.size.innerWidth+1)*n}},p._init=p.reposition=function(){this.positionCells(),this.positionSliderAtSelected()},p.getSize=function(){this.size=i(this.element),this.setCellAlign(),this.cursorPosition=this.size.innerWidth*this.cellAlign};var g={center:{left:.5,right:.5},left:{left:0,right:1},right:{right:0,left:1}};return p.setCellAlign=function(){var t=g[this.options.cellAlign];this.cellAlign=t?t[this.originSide]:this.options.cellAlign},p.setGallerySize=function(){if(this.options.setGallerySize){var t=this.options.adaptiveHeight&&this.selectedSlide?this.selectedSlide.height:this.maxCellHeight;this.viewport.style.height=t+"px"}},p._getWrapShiftCells=function(){if(this.options.wrapAround){this._unshiftCells(this.beforeShiftCells),this._unshiftCells(this.afterShiftCells);var t=this.cursorPosition,e=this.cells.length-1;this.beforeShiftCells=this._getGapCells(t,e,-1),t=this.size.innerWidth-this.cursorPosition,this.afterShiftCells=this._getGapCells(t,0,1)}},p._getGapCells=function(t,e,i){for(var n=[];0<t;){var s=this.cells[e];if(!s)break;n.push(s),e+=i,t-=s.size.outerWidth}return n},p._containSlides=function(){if(this.options.contain&&!this.options.wrapAround&&this.cells.length){var t=this.options.rightToLeft,e=t?"marginRight":"marginLeft",i=t?"marginLeft":"marginRight",n=this.slideableWidth-this.getLastCell().size[i],s=n<this.size.innerWidth,o=this.cursorPosition+this.cells[0].size[e],r=n-this.size.innerWidth*(1-this.cellAlign);this.slides.forEach(function(t){t.target=s?n*this.cellAlign:(t.target=Math.max(t.target,o),Math.min(t.target,r))},this)}},p.dispatchEvent=function(t,e,i){var n=e?[e].concat(i):i;if(this.emitEvent(t,n),h&&this.$element){var s=t+=this.options.namespaceJQueryEvents?".flickity":"";if(e){var o=h.Event(e);o.type=t,s=o}this.$element.trigger(s,i)}},p.select=function(t,e,i){if(this.isActive&&(t=parseInt(t,10),this._wrapSelect(t),(this.options.wrapAround||e)&&(t=n.modulo(t,this.slides.length)),this.slides[t])){var s=this.selectedIndex;this.selectedIndex=t,this.updateSelectedSlide(),i?this.positionSliderAtSelected():this.startAnimation(),this.options.adaptiveHeight&&this.setGallerySize(),this.dispatchEvent("select",null,[t]),t!=s&&this.dispatchEvent("change",null,[t]),this.dispatchEvent("cellSelect")}},p._wrapSelect=function(t){var e=this.slides.length;if(!(this.options.wrapAround&&1<e))return t;var i=n.modulo(t,e),s=Math.abs(i-this.selectedIndex),o=Math.abs(i+e-this.selectedIndex),r=Math.abs(i-e-this.selectedIndex);!this.isDragSelect&&o<s?t+=e:!this.isDragSelect&&r<s&&(t-=e),t<0?this.x-=this.slideableWidth:e<=t&&(this.x+=this.slideableWidth)},p.previous=function(t,e){this.select(this.selectedIndex-1,t,e)},p.next=function(t,e){this.select(this.selectedIndex+1,t,e)},p.updateSelectedSlide=function(){var t=this.slides[this.selectedIndex];t&&(this.unselectSelectedSlide(),(this.selectedSlide=t).select(),this.selectedCells=t.cells,this.selectedElements=t.getCellElements(),this.selectedCell=t.cells[0],this.selectedElement=this.selectedElements[0])},p.unselectSelectedSlide=function(){this.selectedSlide&&this.selectedSlide.unselect()},p.selectInitialIndex=function(){var t=this.options.initialIndex;if(this.isInitActivated)this.select(this.selectedIndex,!1,!0);else{if(t&&"string"==typeof t&&this.queryCell(t))return void this.selectCell(t,!1,!0);var e=0;t&&this.slides[t]&&(e=t),this.select(e,!1,!0)}},p.selectCell=function(t,e,i){var n=this.queryCell(t);if(n){var s=this.getCellSlideIndex(n);this.select(s,e,i)}},p.getCellSlideIndex=function(t){for(var e=0;e<this.slides.length;e++)if(-1!=this.slides[e].cells.indexOf(t))return e},p.getCell=function(t){for(var e=0;e<this.cells.length;e++){var i=this.cells[e];if(i.element==t)return i}},p.getCells=function(t){t=n.makeArray(t);var e=[];return t.forEach(function(t){var i=this.getCell(t);i&&e.push(i)},this),e},p.getCellElements=function(){return this.cells.map(function(t){return t.element})},p.getParentCell=function(t){var e=this.getCell(t);return e||(t=n.getParent(t,".flickity-slider > *"),this.getCell(t))},p.getAdjacentCellElements=function(t,e){if(!t)return this.selectedSlide.getCellElements();e=void 0===e?this.selectedIndex:e;var i=this.slides.length;if(i<=1+2*t)return this.getCellElements();for(var s=[],o=e-t;o<=e+t;o++){var r=this.options.wrapAround?n.modulo(o,i):o,a=this.slides[r];a&&(s=s.concat(a.getCellElements()))}return s},p.queryCell=function(t){if("number"==typeof t)return this.cells[t];if("string"==typeof t){if(t.match(/^[#\.]?[\d\/]/))return;t=this.element.querySelector(t)}return this.getCell(t)},p.uiChange=function(){this.emitEvent("uiChange")},p.childUIPointerDown=function(t){"touchstart"!=t.type&&t.preventDefault(),this.focus()},p.onresize=function(){this.watchCSS(),this.resize()},n.debounceMethod(l,"onresize",150),p.resize=function(){if(this.isActive){this.getSize(),this.options.wrapAround&&(this.x=n.modulo(this.x,this.slideableWidth)),this.positionCells(),this._getWrapShiftCells(),this.setGallerySize(),this.emitEvent("resize");var t=this.selectedElements&&this.selectedElements[0];this.selectCell(t,!1,!0)}},p.watchCSS=function(){this.options.watchCSS&&(-1!=c(this.element,":after").content.indexOf("flickity")?this.activate():this.deactivate())},p.onkeydown=function(t){var e=document.activeElement&&document.activeElement!=this.element;if(this.options.accessibility&&!e){var i=l.keyboardHandlers[t.keyCode];i&&i.call(this)}},l.keyboardHandlers={37:function(){var t=this.options.rightToLeft?"next":"previous";this.uiChange(),this[t]()},39:function(){var t=this.options.rightToLeft?"previous":"next";this.uiChange(),this[t]()}},p.focus=function(){var e=t.pageYOffset;this.element.focus({preventScroll:!0}),t.pageYOffset!=e&&t.scrollTo(t.pageXOffset,e)},p.deactivate=function(){this.isActive&&(this.element.classList.remove("flickity-enabled"),this.element.classList.remove("flickity-rtl"),this.unselectSelectedSlide(),this.cells.forEach(function(t){t.destroy()}),this.element.removeChild(this.viewport),a(this.slider.children,this.element),this.options.accessibility&&(this.element.removeAttribute("tabIndex"),this.element.removeEventListener("keydown",this)),this.isActive=!1,this.emitEvent("deactivate"))},p.destroy=function(){this.deactivate(),t.removeEventListener("resize",this),this.allOff(),this.emitEvent("destroy"),h&&this.$element&&h.removeData(this.element,"flickity"),delete this.element.flickityGUID,delete f[this.guid]},n.extend(p,r),l.data=function(t){var e=(t=n.getQueryElement(t))&&t.flickityGUID;return e&&f[e]},n.htmlInit(l,"flickity"),h&&h.bridget&&h.bridget("flickity",l),l.setJQuery=function(t){h=t},l.Cell=s,l.Slide=o,l}),function(t,e){"function"==typeof define&&define.amd?define("unipointer/unipointer",["ev-emitter/ev-emitter"],function(i){return e(t,i)}):"object"==typeof module&&module.exports?module.exports=e(t,require("ev-emitter")):t.Unipointer=e(t,t.EvEmitter)}(window,function(t,e){function i(){}var n=i.prototype=Object.create(e.prototype);n.bindStartEvent=function(t){this._bindStartEvent(t,!0)},n.unbindStartEvent=function(t){this._bindStartEvent(t,!1)},n._bindStartEvent=function(e,i){var n=(i=void 0===i||i)?"addEventListener":"removeEventListener",s="mousedown";t.PointerEvent?s="pointerdown":"ontouchstart"in t&&(s="touchstart"),e[n](s,this)},n.handleEvent=function(t){var e="on"+t.type;this[e]&&this[e](t)},n.getTouch=function(t){for(var e=0;e<t.length;e++){var i=t[e];if(i.identifier==this.pointerIdentifier)return i}},n.onmousedown=function(t){var e=t.button;e&&0!==e&&1!==e||this._pointerDown(t,t)},n.ontouchstart=function(t){this._pointerDown(t,t.changedTouches[0])},n.onpointerdown=function(t){this._pointerDown(t,t)},n._pointerDown=function(t,e){t.button||this.isPointerDown||(this.isPointerDown=!0,this.pointerIdentifier=void 0!==e.pointerId?e.pointerId:e.identifier,this.pointerDown(t,e))},n.pointerDown=function(t,e){this._bindPostStartEvents(t),this.emitEvent("pointerDown",[t,e])};var s={mousedown:["mousemove","mouseup"],touchstart:["touchmove","touchend","touchcancel"],pointerdown:["pointermove","pointerup","pointercancel"]};return n._bindPostStartEvents=function(e){if(e){var i=s[e.type];i.forEach(function(e){t.addEventListener(e,this)},this),this._boundPointerEvents=i}},n._unbindPostStartEvents=function(){this._boundPointerEvents&&(this._boundPointerEvents.forEach(function(e){t.removeEventListener(e,this)},this),delete this._boundPointerEvents)},n.onmousemove=function(t){this._pointerMove(t,t)},n.onpointermove=function(t){t.pointerId==this.pointerIdentifier&&this._pointerMove(t,t)},n.ontouchmove=function(t){var e=this.getTouch(t.changedTouches);e&&this._pointerMove(t,e)},n._pointerMove=function(t,e){this.pointerMove(t,e)},n.pointerMove=function(t,e){this.emitEvent("pointerMove",[t,e])},n.onmouseup=function(t){this._pointerUp(t,t)},n.onpointerup=function(t){t.pointerId==this.pointerIdentifier&&this._pointerUp(t,t)},n.ontouchend=function(t){var e=this.getTouch(t.changedTouches);e&&this._pointerUp(t,e)},n._pointerUp=function(t,e){this._pointerDone(),this.pointerUp(t,e)},n.pointerUp=function(t,e){this.emitEvent("pointerUp",[t,e])},n._pointerDone=function(){this._pointerReset(),this._unbindPostStartEvents(),this.pointerDone()},n._pointerReset=function(){this.isPointerDown=!1,delete this.pointerIdentifier},n.pointerDone=function(){},n.onpointercancel=function(t){t.pointerId==this.pointerIdentifier&&this._pointerCancel(t,t)},n.ontouchcancel=function(t){var e=this.getTouch(t.changedTouches);e&&this._pointerCancel(t,e)},n._pointerCancel=function(t,e){this._pointerDone(),this.pointerCancel(t,e)},n.pointerCancel=function(t,e){this.emitEvent("pointerCancel",[t,e])},i.getPointerPoint=function(t){return{x:t.pageX,y:t.pageY}},i}),function(t,e){"function"==typeof define&&define.amd?define("unidragger/unidragger",["unipointer/unipointer"],function(i){return e(t,i)}):"object"==typeof module&&module.exports?module.exports=e(t,require("unipointer")):t.Unidragger=e(t,t.Unipointer)}(window,function(t,e){function i(){}var n=i.prototype=Object.create(e.prototype);n.bindHandles=function(){this._bindHandles(!0)},n.unbindHandles=function(){this._bindHandles(!1)},n._bindHandles=function(e){for(var i=(e=void 0===e||e)?"addEventListener":"removeEventListener",n=e?this._touchActionValue:"",s=0;s<this.handles.length;s++){var o=this.handles[s];this._bindStartEvent(o,e),o[i]("click",this),t.PointerEvent&&(o.style.touchAction=n)}},n._touchActionValue="none",n.pointerDown=function(t,e){this.okayPointerDown(t)&&(this.pointerDownPointer=e,t.preventDefault(),this.pointerDownBlur(),this._bindPostStartEvents(t),this.emitEvent("pointerDown",[t,e]))};var s={TEXTAREA:!0,INPUT:!0,SELECT:!0,OPTION:!0},o={radio:!0,checkbox:!0,button:!0,submit:!0,image:!0,file:!0};return n.okayPointerDown=function(t){var e=s[t.target.nodeName],i=o[t.target.type],n=!e||i;return n||this._pointerReset(),n},n.pointerDownBlur=function(){var t=document.activeElement;t&&t.blur&&t!=document.body&&t.blur()},n.pointerMove=function(t,e){var i=this._dragPointerMove(t,e);this.emitEvent("pointerMove",[t,e,i]),this._dragMove(t,e,i)},n._dragPointerMove=function(t,e){var i={x:e.pageX-this.pointerDownPointer.pageX,y:e.pageY-this.pointerDownPointer.pageY};return!this.isDragging&&this.hasDragStarted(i)&&this._dragStart(t,e),i},n.hasDragStarted=function(t){return 3<Math.abs(t.x)||3<Math.abs(t.y)},n.pointerUp=function(t,e){this.emitEvent("pointerUp",[t,e]),this._dragPointerUp(t,e)},n._dragPointerUp=function(t,e){this.isDragging?this._dragEnd(t,e):this._staticClick(t,e)},n._dragStart=function(t,e){this.isDragging=!0,this.isPreventingClicks=!0,this.dragStart(t,e)},n.dragStart=function(t,e){this.emitEvent("dragStart",[t,e])},n._dragMove=function(t,e,i){this.isDragging&&this.dragMove(t,e,i)},n.dragMove=function(t,e,i){t.preventDefault(),this.emitEvent("dragMove",[t,e,i])},n._dragEnd=function(t,e){this.isDragging=!1,setTimeout(function(){delete this.isPreventingClicks}.bind(this)),this.dragEnd(t,e)},n.dragEnd=function(t,e){this.emitEvent("dragEnd",[t,e])},n.onclick=function(t){this.isPreventingClicks&&t.preventDefault()},n._staticClick=function(t,e){this.isIgnoringMouseUp&&"mouseup"==t.type||(this.staticClick(t,e),"mouseup"!=t.type&&(this.isIgnoringMouseUp=!0,setTimeout(function(){delete this.isIgnoringMouseUp}.bind(this),400)))},n.staticClick=function(t,e){this.emitEvent("staticClick",[t,e])},i.getPointerPoint=e.getPointerPoint,i}),function(t,e){"function"==typeof define&&define.amd?define("flickity/js/drag",["./flickity","unidragger/unidragger","fizzy-ui-utils/utils"],function(i,n,s){return e(t,i,n,s)}):"object"==typeof module&&module.exports?module.exports=e(t,require("./flickity"),require("unidragger"),require("fizzy-ui-utils")):t.Flickity=e(t,t.Flickity,t.Unidragger,t.fizzyUIUtils)}(window,function(t,e,i,n){function s(){return{x:t.pageXOffset,y:t.pageYOffset}}n.extend(e.defaults,{draggable:">1",dragThreshold:3}),e.createMethods.push("_createDrag");var o=e.prototype;n.extend(o,i.prototype),o._touchActionValue="pan-y";var r="createTouch"in document,a=!1;o._createDrag=function(){this.on("activate",this.onActivateDrag),this.on("uiChange",this._uiChangeDrag),this.on("deactivate",this.onDeactivateDrag),this.on("cellChange",this.updateDraggable),r&&!a&&(t.addEventListener("touchmove",function(){}),a=!0)},o.onActivateDrag=function(){this.handles=[this.viewport],this.bindHandles(),this.updateDraggable()},o.onDeactivateDrag=function(){this.unbindHandles(),this.element.classList.remove("is-draggable")},o.updateDraggable=function(){">1"==this.options.draggable?this.isDraggable=1<this.slides.length:this.isDraggable=this.options.draggable,this.isDraggable?this.element.classList.add("is-draggable"):this.element.classList.remove("is-draggable")},o.bindDrag=function(){this.options.draggable=!0,this.updateDraggable()},o.unbindDrag=function(){this.options.draggable=!1,this.updateDraggable()},o._uiChangeDrag=function(){delete this.isFreeScrolling},o.pointerDown=function(e,i){this.isDraggable?this.okayPointerDown(e)&&(this._pointerDownPreventDefault(e),this.pointerDownFocus(e),document.activeElement!=this.element&&this.pointerDownBlur(),this.dragX=this.x,this.viewport.classList.add("is-pointer-down"),this.pointerDownScroll=s(),t.addEventListener("scroll",this),this._pointerDownDefault(e,i)):this._pointerDownDefault(e,i)},o._pointerDownDefault=function(t,e){this.pointerDownPointer={pageX:e.pageX,pageY:e.pageY},this._bindPostStartEvents(t),this.dispatchEvent("pointerDown",t,[e])};var l={INPUT:!0,TEXTAREA:!0,SELECT:!0};return o.pointerDownFocus=function(t){l[t.target.nodeName]||this.focus()},o._pointerDownPreventDefault=function(t){var e="touchstart"==t.type,i="touch"==t.pointerType,n=l[t.target.nodeName];e||i||n||t.preventDefault()},o.hasDragStarted=function(t){return Math.abs(t.x)>this.options.dragThreshold},o.pointerUp=function(t,e){delete this.isTouchScrolling,this.viewport.classList.remove("is-pointer-down"),this.dispatchEvent("pointerUp",t,[e]),this._dragPointerUp(t,e)},o.pointerDone=function(){t.removeEventListener("scroll",this),delete this.pointerDownScroll},o.dragStart=function(e,i){this.isDraggable&&(this.dragStartPosition=this.x,this.startAnimation(),t.removeEventListener("scroll",this),this.dispatchEvent("dragStart",e,[i]))},o.pointerMove=function(t,e){var i=this._dragPointerMove(t,e);this.dispatchEvent("pointerMove",t,[e,i]),this._dragMove(t,e,i)},o.dragMove=function(t,e,i){if(this.isDraggable){t.preventDefault(),this.previousDragX=this.dragX;var n=this.options.rightToLeft?-1:1;this.options.wrapAround&&(i.x=i.x%this.slideableWidth);var s=this.dragStartPosition+i.x*n;if(!this.options.wrapAround&&this.slides.length){var o=Math.max(-this.slides[0].target,this.dragStartPosition);s=o<s?.5*(s+o):s;var r=Math.min(-this.getLastSlide().target,this.dragStartPosition);s=s<r?.5*(s+r):s}this.dragX=s,this.dragMoveTime=new Date,this.dispatchEvent("dragMove",t,[e,i]);
}},o.dragEnd=function(t,e){if(this.isDraggable){this.options.freeScroll&&(this.isFreeScrolling=!0);var i=this.dragEndRestingSelect();if(this.options.freeScroll&&!this.options.wrapAround){var n=this.getRestingPosition();this.isFreeScrolling=-n>this.slides[0].target&&-n<this.getLastSlide().target}else this.options.freeScroll||i!=this.selectedIndex||(i+=this.dragEndBoostSelect());delete this.previousDragX,this.isDragSelect=this.options.wrapAround,this.select(i),delete this.isDragSelect,this.dispatchEvent("dragEnd",t,[e])}},o.dragEndRestingSelect=function(){var t=this.getRestingPosition(),e=Math.abs(this.getSlideDistance(-t,this.selectedIndex)),i=this._getClosestResting(t,e,1),n=this._getClosestResting(t,e,-1);return i.distance<n.distance?i.index:n.index},o._getClosestResting=function(t,e,i){for(var n=this.selectedIndex,s=1/0,o=this.options.contain&&!this.options.wrapAround?function(t,e){return t<=e}:function(t,e){return t<e};o(e,s)&&(n+=i,s=e,null!==(e=this.getSlideDistance(-t,n)));)e=Math.abs(e);return{distance:s,index:n-i}},o.getSlideDistance=function(t,e){var i=this.slides.length,s=this.options.wrapAround&&1<i,o=s?n.modulo(e,i):e,r=this.slides[o];if(!r)return null;var a=s?this.slideableWidth*Math.floor(e/i):0;return t-(r.target+a)},o.dragEndBoostSelect=function(){if(void 0===this.previousDragX||!this.dragMoveTime||100<new Date-this.dragMoveTime)return 0;var t=this.getSlideDistance(-this.dragX,this.selectedIndex),e=this.previousDragX-this.dragX;return 0<t&&0<e?1:t<0&&e<0?-1:0},o.staticClick=function(t,e){var i=this.getParentCell(t.target),n=i&&i.element,s=i&&this.cells.indexOf(i);this.dispatchEvent("staticClick",t,[e,n,s])},o.onscroll=function(){var t=s(),e=this.pointerDownScroll.x-t.x,i=this.pointerDownScroll.y-t.y;(3<Math.abs(e)||3<Math.abs(i))&&this._pointerDone()},e}),function(t,e){"function"==typeof define&&define.amd?define("flickity/js/prev-next-button",["./flickity","unipointer/unipointer","fizzy-ui-utils/utils"],function(i,n,s){return e(t,i,n,s)}):"object"==typeof module&&module.exports?module.exports=e(t,require("./flickity"),require("unipointer"),require("fizzy-ui-utils")):e(t,t.Flickity,t.Unipointer,t.fizzyUIUtils)}(window,function(t,e,i,n){"use strict";function s(t,e){this.direction=t,this.parent=e,this._create()}var o="http://www.w3.org/2000/svg";(s.prototype=Object.create(i.prototype))._create=function(){this.isEnabled=!0,this.isPrevious=-1==this.direction;var t=this.parent.options.rightToLeft?1:-1;this.isLeft=this.direction==t;var e=this.element=document.createElement("button");e.className="flickity-button flickity-prev-next-button",e.className+=this.isPrevious?" previous":" next",e.setAttribute("type","button"),this.disable(),e.setAttribute("aria-label",this.isPrevious?"Previous":"Next");var i=this.createSVG();e.appendChild(i),this.parent.on("select",this.update.bind(this)),this.on("pointerDown",this.parent.childUIPointerDown.bind(this.parent))},s.prototype.activate=function(){this.bindStartEvent(this.element),this.element.addEventListener("click",this),this.parent.element.appendChild(this.element)},s.prototype.deactivate=function(){this.parent.element.removeChild(this.element),this.unbindStartEvent(this.element),this.element.removeEventListener("click",this)},s.prototype.createSVG=function(){var t=document.createElementNS(o,"svg");t.setAttribute("class","flickity-button-icon"),t.setAttribute("viewBox","0 0 100 100");var e,i=document.createElementNS(o,"path"),n="string"!=typeof(e=this.parent.options.arrowShape)?"M "+e.x0+",50 L "+e.x1+","+(e.y1+50)+" L "+e.x2+","+(e.y2+50)+" L "+e.x3+",50  L "+e.x2+","+(50-e.y2)+" L "+e.x1+","+(50-e.y1)+" Z":e;return i.setAttribute("d",n),i.setAttribute("class","arrow"),this.isLeft||i.setAttribute("transform","translate(100, 100) rotate(180) "),t.appendChild(i),t},s.prototype.handleEvent=n.handleEvent,s.prototype.onclick=function(){if(this.isEnabled){this.parent.uiChange();var t=this.isPrevious?"previous":"next";this.parent[t]()}},s.prototype.enable=function(){this.isEnabled||(this.element.disabled=!1,this.isEnabled=!0)},s.prototype.disable=function(){this.isEnabled&&(this.element.disabled=!0,this.isEnabled=!1)},s.prototype.update=function(){var t=this.parent.slides;if(this.parent.options.wrapAround&&1<t.length)this.enable();else{var e=t.length?t.length-1:0,i=this.isPrevious?0:e;this[this.parent.selectedIndex==i?"disable":"enable"]()}},s.prototype.destroy=function(){this.deactivate(),this.allOff()},n.extend(e.defaults,{prevNextButtons:!0,arrowShape:{x0:10,x1:60,y1:50,x2:70,y2:40,x3:30}}),e.createMethods.push("_createPrevNextButtons");var r=e.prototype;return r._createPrevNextButtons=function(){this.options.prevNextButtons&&(this.prevButton=new s((-1),this),this.nextButton=new s(1,this),this.on("activate",this.activatePrevNextButtons))},r.activatePrevNextButtons=function(){this.prevButton.activate(),this.nextButton.activate(),this.on("deactivate",this.deactivatePrevNextButtons)},r.deactivatePrevNextButtons=function(){this.prevButton.deactivate(),this.nextButton.deactivate(),this.off("deactivate",this.deactivatePrevNextButtons)},e.PrevNextButton=s,e}),function(t,e){"function"==typeof define&&define.amd?define("flickity/js/page-dots",["./flickity","unipointer/unipointer","fizzy-ui-utils/utils"],function(i,n,s){return e(t,i,n,s)}):"object"==typeof module&&module.exports?module.exports=e(t,require("./flickity"),require("unipointer"),require("fizzy-ui-utils")):e(t,t.Flickity,t.Unipointer,t.fizzyUIUtils)}(window,function(t,e,i,n){function s(t){this.parent=t,this._create()}(s.prototype=Object.create(i.prototype))._create=function(){this.holder=document.createElement("ol"),this.holder.className="flickity-page-dots",this.dots=[],this.handleClick=this.onClick.bind(this),this.on("pointerDown",this.parent.childUIPointerDown.bind(this.parent))},s.prototype.activate=function(){this.setDots(),this.holder.addEventListener("click",this.handleClick),this.bindStartEvent(this.holder),this.parent.element.appendChild(this.holder)},s.prototype.deactivate=function(){this.holder.removeEventListener("click",this.handleClick),this.unbindStartEvent(this.holder),this.parent.element.removeChild(this.holder)},s.prototype.setDots=function(){var t=this.parent.slides.length-this.dots.length;0<t?this.addDots(t):t<0&&this.removeDots(-t)},s.prototype.addDots=function(t){for(var e=document.createDocumentFragment(),i=[],n=this.dots.length,s=n+t,o=n;o<s;o++){var r=document.createElement("li");r.className="dot",r.setAttribute("aria-label","Page dot "+(o+1)),e.appendChild(r),i.push(r)}this.holder.appendChild(e),this.dots=this.dots.concat(i)},s.prototype.removeDots=function(t){this.dots.splice(this.dots.length-t,t).forEach(function(t){this.holder.removeChild(t)},this)},s.prototype.updateSelected=function(){this.selectedDot&&(this.selectedDot.className="dot",this.selectedDot.removeAttribute("aria-current")),this.dots.length&&(this.selectedDot=this.dots[this.parent.selectedIndex],this.selectedDot.className="dot is-selected",this.selectedDot.setAttribute("aria-current","step"))},s.prototype.onTap=s.prototype.onClick=function(t){var e=t.target;if("LI"==e.nodeName){this.parent.uiChange();var i=this.dots.indexOf(e);this.parent.select(i)}},s.prototype.destroy=function(){this.deactivate(),this.allOff()},e.PageDots=s,n.extend(e.defaults,{pageDots:!0}),e.createMethods.push("_createPageDots");var o=e.prototype;return o._createPageDots=function(){this.options.pageDots&&(this.pageDots=new s(this),this.on("activate",this.activatePageDots),this.on("select",this.updateSelectedPageDots),this.on("cellChange",this.updatePageDots),this.on("resize",this.updatePageDots),this.on("deactivate",this.deactivatePageDots))},o.activatePageDots=function(){this.pageDots.activate()},o.updateSelectedPageDots=function(){this.pageDots.updateSelected()},o.updatePageDots=function(){this.pageDots.setDots()},o.deactivatePageDots=function(){this.pageDots.deactivate()},e.PageDots=s,e}),function(t,e){"function"==typeof define&&define.amd?define("flickity/js/player",["ev-emitter/ev-emitter","fizzy-ui-utils/utils","./flickity"],function(t,i,n){return e(t,i,n)}):"object"==typeof module&&module.exports?module.exports=e(require("ev-emitter"),require("fizzy-ui-utils"),require("./flickity")):e(t.EvEmitter,t.fizzyUIUtils,t.Flickity)}(window,function(t,e,i){function n(t){this.parent=t,this.state="stopped",this.onVisibilityChange=this.visibilityChange.bind(this),this.onVisibilityPlay=this.visibilityPlay.bind(this)}(n.prototype=Object.create(t.prototype)).play=function(){"playing"!=this.state&&(document.hidden?document.addEventListener("visibilitychange",this.onVisibilityPlay):(this.state="playing",document.addEventListener("visibilitychange",this.onVisibilityChange),this.tick()))},n.prototype.tick=function(){if("playing"==this.state){var t=this.parent.options.autoPlay;t="number"==typeof t?t:3e3;var e=this;this.clear(),this.timeout=setTimeout(function(){e.parent.next(!0),e.tick()},t)}},n.prototype.stop=function(){this.state="stopped",this.clear(),document.removeEventListener("visibilitychange",this.onVisibilityChange)},n.prototype.clear=function(){clearTimeout(this.timeout)},n.prototype.pause=function(){"playing"==this.state&&(this.state="paused",this.clear())},n.prototype.unpause=function(){"paused"==this.state&&this.play()},n.prototype.visibilityChange=function(){this[document.hidden?"pause":"unpause"]()},n.prototype.visibilityPlay=function(){this.play(),document.removeEventListener("visibilitychange",this.onVisibilityPlay)},e.extend(i.defaults,{pauseAutoPlayOnHover:!0}),i.createMethods.push("_createPlayer");var s=i.prototype;return s._createPlayer=function(){this.player=new n(this),this.on("activate",this.activatePlayer),this.on("uiChange",this.stopPlayer),this.on("pointerDown",this.stopPlayer),this.on("deactivate",this.deactivatePlayer)},s.activatePlayer=function(){this.options.autoPlay&&(this.player.play(),this.element.addEventListener("mouseenter",this))},s.playPlayer=function(){this.player.play()},s.stopPlayer=function(){this.player.stop()},s.pausePlayer=function(){this.player.pause()},s.unpausePlayer=function(){this.player.unpause()},s.deactivatePlayer=function(){this.player.stop(),this.element.removeEventListener("mouseenter",this)},s.onmouseenter=function(){this.options.pauseAutoPlayOnHover&&(this.player.pause(),this.element.addEventListener("mouseleave",this))},s.onmouseleave=function(){this.player.unpause(),this.element.removeEventListener("mouseleave",this)},i.Player=n,i}),function(t,e){"function"==typeof define&&define.amd?define("flickity/js/add-remove-cell",["./flickity","fizzy-ui-utils/utils"],function(i,n){return e(t,i,n)}):"object"==typeof module&&module.exports?module.exports=e(t,require("./flickity"),require("fizzy-ui-utils")):e(t,t.Flickity,t.fizzyUIUtils)}(window,function(t,e,i){var n=e.prototype;return n.insert=function(t,e){var i=this._makeCells(t);if(i&&i.length){var n=this.cells.length;e=void 0===e?n:e;var s,o,r=(s=i,o=document.createDocumentFragment(),s.forEach(function(t){o.appendChild(t.element)}),o),a=e==n;if(a)this.slider.appendChild(r);else{var l=this.cells[e].element;this.slider.insertBefore(r,l)}if(0===e)this.cells=i.concat(this.cells);else if(a)this.cells=this.cells.concat(i);else{var h=this.cells.splice(e,n-e);this.cells=this.cells.concat(i).concat(h)}this._sizeCells(i),this.cellChange(e,!0)}},n.append=function(t){this.insert(t,this.cells.length)},n.prepend=function(t){this.insert(t,0)},n.remove=function(t){var e=this.getCells(t);if(e&&e.length){var n=this.cells.length-1;e.forEach(function(t){t.remove();var e=this.cells.indexOf(t);n=Math.min(e,n),i.removeFrom(this.cells,t)},this),this.cellChange(n,!0)}},n.cellSizeChange=function(t){var e=this.getCell(t);if(e){e.getSize();var i=this.cells.indexOf(e);this.cellChange(i)}},n.cellChange=function(t,e){var i=this.selectedElement;this._positionCells(t),this._getWrapShiftCells(),this.setGallerySize();var n=this.getCell(i);n&&(this.selectedIndex=this.getCellSlideIndex(n)),this.selectedIndex=Math.min(this.slides.length-1,this.selectedIndex),this.emitEvent("cellChange",[t]),this.select(this.selectedIndex),e&&this.positionSliderAtSelected()},e}),function(t,e){"function"==typeof define&&define.amd?define("flickity/js/lazyload",["./flickity","fizzy-ui-utils/utils"],function(i,n){return e(t,i,n)}):"object"==typeof module&&module.exports?module.exports=e(t,require("./flickity"),require("fizzy-ui-utils")):e(t,t.Flickity,t.fizzyUIUtils)}(window,function(t,e,i){"use strict";function n(t,e){this.img=t,this.flickity=e,this.load()}e.createMethods.push("_createLazyload");var s=e.prototype;return s._createLazyload=function(){this.on("select",this.lazyLoad)},s.lazyLoad=function(){var t=this.options.lazyLoad;if(t){var e="number"==typeof t?t:0,s=this.getAdjacentCellElements(e),o=[];s.forEach(function(t){var e=function(t){if("IMG"==t.nodeName){var e=t.getAttribute("data-flickity-lazyload"),n=t.getAttribute("data-flickity-lazyload-src"),s=t.getAttribute("data-flickity-lazyload-srcset");if(e||n||s)return[t]}var o=t.querySelectorAll("img[data-flickity-lazyload], img[data-flickity-lazyload-src], img[data-flickity-lazyload-srcset]");return i.makeArray(o)}(t);o=o.concat(e)}),o.forEach(function(t){new n(t,this)},this)}},n.prototype.handleEvent=i.handleEvent,n.prototype.load=function(){this.img.addEventListener("load",this),this.img.addEventListener("error",this);var t=this.img.getAttribute("data-flickity-lazyload")||this.img.getAttribute("data-flickity-lazyload-src"),e=this.img.getAttribute("data-flickity-lazyload-srcset");this.img.src=t,e&&this.img.setAttribute("srcset",e),this.img.removeAttribute("data-flickity-lazyload"),this.img.removeAttribute("data-flickity-lazyload-src"),this.img.removeAttribute("data-flickity-lazyload-srcset")},n.prototype.onload=function(t){this.complete(t,"flickity-lazyloaded")},n.prototype.onerror=function(t){this.complete(t,"flickity-lazyerror")},n.prototype.complete=function(t,e){this.img.removeEventListener("load",this),this.img.removeEventListener("error",this);var i=this.flickity.getParentCell(this.img),n=i&&i.element;this.flickity.cellSizeChange(n),this.img.classList.add(e),this.flickity.dispatchEvent("lazyLoad",t,n)},e.LazyLoader=n,e}),function(t,e){"function"==typeof define&&define.amd?define("flickity/js/index",["./flickity","./drag","./prev-next-button","./page-dots","./player","./add-remove-cell","./lazyload"],e):"object"==typeof module&&module.exports&&(module.exports=e(require("./flickity"),require("./drag"),require("./prev-next-button"),require("./page-dots"),require("./player"),require("./add-remove-cell"),require("./lazyload")))}(window,function(t){return t}),function(t,e){"function"==typeof define&&define.amd?define("flickity-as-nav-for/as-nav-for",["flickity/js/index","fizzy-ui-utils/utils"],e):"object"==typeof module&&module.exports?module.exports=e(require("flickity"),require("fizzy-ui-utils")):t.Flickity=e(t.Flickity,t.fizzyUIUtils)}(window,function(t,e){t.createMethods.push("_createAsNavFor");var i=t.prototype;return i._createAsNavFor=function(){this.on("activate",this.activateAsNavFor),this.on("deactivate",this.deactivateAsNavFor),this.on("destroy",this.destroyAsNavFor);var t=this.options.asNavFor;if(t){var e=this;setTimeout(function(){e.setNavCompanion(t)})}},i.setNavCompanion=function(i){i=e.getQueryElement(i);var n=t.data(i);if(n&&n!=this){this.navCompanion=n;var s=this;this.onNavCompanionSelect=function(){s.navCompanionSelect()},n.on("select",this.onNavCompanionSelect),this.on("staticClick",this.onNavStaticClick),this.navCompanionSelect(!0)}},i.navCompanionSelect=function(t){if(this.navCompanion){var e,i,n,s=this.navCompanion.selectedCells[0],o=this.navCompanion.cells.indexOf(s),r=o+this.navCompanion.selectedCells.length-1,a=Math.floor((e=o,i=r,n=this.navCompanion.cellAlign,(i-e)*n+e));if(this.selectCell(a,!1,t),this.removeNavSelectedElements(),!(a>=this.cells.length)){var l=this.cells.slice(o,r+1);this.navSelectedElements=l.map(function(t){return t.element}),this.changeNavSelectedClass("add")}}},i.changeNavSelectedClass=function(t){this.navSelectedElements.forEach(function(e){e.classList[t]("is-nav-selected")})},i.activateAsNavFor=function(){this.navCompanionSelect(!0)},i.removeNavSelectedElements=function(){this.navSelectedElements&&(this.changeNavSelectedClass("remove"),delete this.navSelectedElements)},i.onNavStaticClick=function(t,e,i,n){"number"==typeof n&&this.navCompanion.selectCell(n)},i.deactivateAsNavFor=function(){this.removeNavSelectedElements()},i.destroyAsNavFor=function(){this.navCompanion&&(this.navCompanion.off("select",this.onNavCompanionSelect),this.off("staticClick",this.onNavStaticClick),delete this.navCompanion)},t}),function(t,e){"use strict";"function"==typeof define&&define.amd?define("imagesloaded/imagesloaded",["ev-emitter/ev-emitter"],function(i){return e(t,i)}):"object"==typeof module&&module.exports?module.exports=e(t,require("ev-emitter")):t.imagesLoaded=e(t,t.EvEmitter)}("undefined"!=typeof window?window:this,function(t,e){function i(t,e){for(var i in e)t[i]=e[i];return t}function n(t,e,s){if(!(this instanceof n))return new n(t,e,s);var o,h=t;"string"==typeof t&&(h=document.querySelectorAll(t)),h?(this.elements=(o=h,Array.isArray(o)?o:"object"==typeof o&&"number"==typeof o.length?l.call(o):[o]),this.options=i({},this.options),"function"==typeof e?s=e:i(this.options,e),s&&this.on("always",s),this.getImages(),r&&(this.jqDeferred=new r.Deferred),setTimeout(this.check.bind(this))):a.error("Bad element for imagesLoaded "+(h||t))}function s(t){this.img=t}function o(t,e){this.url=t,this.element=e,this.img=new Image}var r=t.jQuery,a=t.console,l=Array.prototype.slice;(n.prototype=Object.create(e.prototype)).options={},n.prototype.getImages=function(){this.images=[],this.elements.forEach(this.addElementImages,this)},n.prototype.addElementImages=function(t){"IMG"==t.nodeName&&this.addImage(t),!0===this.options.background&&this.addElementBackgroundImages(t);var e=t.nodeType;if(e&&h[e]){for(var i=t.querySelectorAll("img"),n=0;n<i.length;n++){var s=i[n];this.addImage(s)}if("string"==typeof this.options.background){var o=t.querySelectorAll(this.options.background);for(n=0;n<o.length;n++){var r=o[n];this.addElementBackgroundImages(r)}}}};var h={1:!0,9:!0,11:!0};return n.prototype.addElementBackgroundImages=function(t){var e=getComputedStyle(t);if(e)for(var i=/url\((['"])?(.*?)\1\)/gi,n=i.exec(e.backgroundImage);null!==n;){var s=n&&n[2];s&&this.addBackground(s,t),n=i.exec(e.backgroundImage)}},n.prototype.addImage=function(t){var e=new s(t);this.images.push(e)},n.prototype.addBackground=function(t,e){var i=new o(t,e);this.images.push(i)},n.prototype.check=function(){function t(t,i,n){setTimeout(function(){e.progress(t,i,n)})}var e=this;this.progressedCount=0,this.hasAnyBroken=!1,this.images.length?this.images.forEach(function(e){e.once("progress",t),e.check()}):this.complete()},n.prototype.progress=function(t,e,i){this.progressedCount++,this.hasAnyBroken=this.hasAnyBroken||!t.isLoaded,this.emitEvent("progress",[this,t,e]),this.jqDeferred&&this.jqDeferred.notify&&this.jqDeferred.notify(this,t),this.progressedCount==this.images.length&&this.complete(),this.options.debug&&a&&a.log("progress: "+i,t,e)},n.prototype.complete=function(){var t=this.hasAnyBroken?"fail":"done";if(this.isComplete=!0,this.emitEvent(t,[this]),this.emitEvent("always",[this]),this.jqDeferred){var e=this.hasAnyBroken?"reject":"resolve";this.jqDeferred[e](this)}},(s.prototype=Object.create(e.prototype)).check=function(){this.getIsImageComplete()?this.confirm(0!==this.img.naturalWidth,"naturalWidth"):(this.proxyImage=new Image,this.proxyImage.addEventListener("load",this),this.proxyImage.addEventListener("error",this),this.img.addEventListener("load",this),this.img.addEventListener("error",this),this.proxyImage.src=this.img.src)},s.prototype.getIsImageComplete=function(){return this.img.complete&&this.img.naturalWidth},s.prototype.confirm=function(t,e){this.isLoaded=t,this.emitEvent("progress",[this,this.img,e])},s.prototype.handleEvent=function(t){var e="on"+t.type;this[e]&&this[e](t)},s.prototype.onload=function(){this.confirm(!0,"onload"),this.unbindEvents()},s.prototype.onerror=function(){this.confirm(!1,"onerror"),this.unbindEvents()},s.prototype.unbindEvents=function(){this.proxyImage.removeEventListener("load",this),this.proxyImage.removeEventListener("error",this),this.img.removeEventListener("load",this),this.img.removeEventListener("error",this)},(o.prototype=Object.create(s.prototype)).check=function(){this.img.addEventListener("load",this),this.img.addEventListener("error",this),this.img.src=this.url,this.getIsImageComplete()&&(this.confirm(0!==this.img.naturalWidth,"naturalWidth"),this.unbindEvents())},o.prototype.unbindEvents=function(){this.img.removeEventListener("load",this),this.img.removeEventListener("error",this)},o.prototype.confirm=function(t,e){this.isLoaded=t,this.emitEvent("progress",[this,this.element,e])},n.makeJQueryPlugin=function(e){(e=e||t.jQuery)&&((r=e).fn.imagesLoaded=function(t,e){return new n(this,t,e).jqDeferred.promise(r(this))})},n.makeJQueryPlugin(),n}),function(t,e){"function"==typeof define&&define.amd?define(["flickity/js/index","imagesloaded/imagesloaded"],function(i,n){return e(t,i,n)}):"object"==typeof module&&module.exports?module.exports=e(t,require("flickity"),require("imagesloaded")):t.Flickity=e(t,t.Flickity,t.imagesLoaded)}(window,function(t,e,i){"use strict";e.createMethods.push("_createImagesLoaded");var n=e.prototype;return n._createImagesLoaded=function(){this.on("activate",this.imagesLoaded)},n.imagesLoaded=function(){if(this.options.imagesLoaded){var t=this;i(this.slider).on("progress",function(e,i){var n=t.getParentCell(i.img);t.cellSizeChange(n&&n.element),t.options.freeScroll||t.positionSliderAtSelected()})}},e});
/**
 * Flickity background lazyload v1.0.1
 * lazyload background cell images
 */
!function(t,e){"function"==typeof define&&define.amd?define(["flickity/js/index","fizzy-ui-utils/utils"],e):"object"==typeof module&&module.exports?module.exports=e(require("flickity"),require("fizzy-ui-utils")):e(t.Flickity,t.fizzyUIUtils)}(window,function(t,e){"use strict";function i(t,e,i){this.element=t,this.url=e,this.img=new Image,this.flickity=i,this.load()}t.createMethods.push("_createBgLazyLoad");var o=t.prototype;return o._createBgLazyLoad=function(){this.on("select",this.bgLazyLoad)},o.bgLazyLoad=function(){var t=this.options.bgLazyLoad;if(t)for(var e="number"==typeof t?t:0,i=this.getAdjacentCellElements(e),o=0;o<i.length;o++){var a=i[o];this.bgLazyLoadElem(a);for(var l=a.querySelectorAll("[data-flickity-bg-lazyload]"),n=0;n<l.length;n++)this.bgLazyLoadElem(l[n])}},o.bgLazyLoadElem=function(t){var e=t.getAttribute("data-flickity-bg-lazyload");e&&new i(t,e,this)},i.prototype.handleEvent=e.handleEvent,i.prototype.load=function(){this.img.addEventListener("load",this),this.img.addEventListener("error",this),this.img.src=this.url,this.element.removeAttribute("data-flickity-bg-lazyload")},i.prototype.onload=function(t){this.element.style.backgroundImage='url("'+this.url+'")',this.complete(t,"flickity-bg-lazyloaded")},i.prototype.onerror=function(t){this.complete(t,"flickity-bg-lazyerror")},i.prototype.complete=function(t,e){this.img.removeEventListener("load",this),this.img.removeEventListener("error",this),this.element.classList.add(e),this.flickity.dispatchEvent("bgLazyLoad",t,this.element)},t.BgLazyLoader=i,t});
var RexSlider=function(e){"use strict";function t(e){var t=this,i=this.element.getAttribute("data-custom-autoplay-timer")?this.element.getAttribute("data-custom-autoplay-timer"):9e3;t.customAutoplayInterval&&t.customAutoplayInterval.clear(),t.customAutoplayInterval=Rexbuilder_Util.rtimeOut(function(){t.playPlayer()},i),t.pausePlayer()}var i=".rex-slider-wrap",a=".rex-slider-element",r=".flickity-page-dots.rex-slider__custom-nav",l=".flickity-page-dots.rex-slider__custom-nav__preview-slide",n=".rexpansive_section",d=".rex-box-slider-wrap",s=".rex-box-slider-element",o=function(i){function n(){Rexbuilder_Util.addClass(this,"is-dragging")}function d(){Rexbuilder_Util.removeClass(this,"is-dragging")}function s(t,i){for(var a=0;a<x.length;a++)Rexbuilder_Util.pauseVideo(e(x[a].querySelector(".rex-slider-video-wrapper")));var r=Rexbuilder_Util.hasClass(Flickity.data(t.target).selectedCell.element,"rex-slide--video");r&&Rexbuilder_Util.playVideo(e(t.target.querySelector(".rex-slider-video-wrapper")))}var o=i.get(0),c={cellAlign:"left",prevNextButtons:!1,pageDots:!1,cellSelector:a,selectedAttraction:.018,friction:.3,wrapAround:!0,arrowShape:_plugin_frontend_settings.slider.arrowShape},u=i.parents(".block-has-slider");c.setGallerySize="undefined"!=typeof i.attr("data-set-gallery-size")&&JSON.parse(i.attr("data-set-gallery-size")),c.wrapAround="undefined"==typeof i.attr("data-wrap-around")||JSON.parse(i.attr("data-wrap-around"));var f=i.attr("data-rex-slider-animation");"undefined"!=typeof f&&"true"==f.toString()?c.autoPlay=!0:c.autoPlay=!1;var y=i.attr("data-rex-slider-prev-next");"undefined"!=typeof y&&"1"==y.toString()&&(c.prevNextButtons=!0);var p=i.attr("data-rex-slider-dots");"undefined"!=typeof p&&"1"==p.toString()&&(c.pageDots=!0);var g=i.attr("data-rexlider-lazyload");"undefined"!=typeof g&&"1"==g.toString()&&(c.bgLazyLoad=1,c.lazyLoad=1),i.hasClass("rex-slider--bottom-interface")&&u.addClass("block-has-slider--navigator"),i.find(".rex-slider-element").each(function(t,i){var a=e(i).find(".rex-slider-video-wrapper");Rexbuilder_Util.startVideoPlugin(a)}),1==c.setGallerySize&&(c.on={ready:function(e){var t=this.$element.parents(".rexpansive_section").eq(0);if(t.length>0){var i=Rexbuilder_Util.getGalleryInstance(t);"undefined"!==i&&i.updateElementHeight(this.$element.parents(".grid-stack-item").get(0))}}});var v=!!c.autoPlay;c.prevNextButtons&&v&&(c.pauseAutoPlayOnHover=!1),i.flickity(c),i.flickity("stopPlayer");var x=Array.prototype.slice.call(o.getElementsByClassName("rex-slide--video"));if(i.on("dragStart.flickity",n),i.on("dragEnd.flickity",d),0!==x.length&&i.on("select.flickity",s),c.autoPlay&&i.flickity("playPlayer"),v){var m=i.data("flickity");if(m.customAutoplayInterval=null,c.prevNextButtons&&(m.prevButton.element.addEventListener("click",t.bind(m)),m.nextButton.element.addEventListener("click",t.bind(m))),c.pageDots)for(var h=0;h<m.pageDots.dots.length;h++)m.pageDots.dots[h].addEventListener("click",t.bind(m));m.$element.on("dragEnd.flickity",t.bind(m))}i.attr("data-rex-slider-active",!0),i.find(r).children().first().addClass("is-selected"),i.find(r).on("click",".dot",function(t){var a=e(this),r=a.index();a.addClass("is-selected").siblings(".dot").removeClass("is-selected"),i.flickity("select",r)}),i.find(l).find(".rex-slider__b-label-image--item").hover(function(e){var t=parseInt(e.currentTarget.getAttribute("data-nav-index"));i.flickity("select",t)})},c=function(t){var i=e(t),a={cellAlign:"center",prevNextButtons:!0,pageDots:!0,cellSelector:s,selectedAttraction:.018,friction:.3,initialIndex:null!==t.getAttribute("data-rex-box-slider-initialIndex")?parseInt(t.getAttribute("data-rex-box-slider-initialIndex")):0,setGallerySize:!1,arrowShape:"m 38.79662,40.087413 0,0 c -0.387529,0 -0.757576,-0.154429 -1.031468,-0.425408 L 1.2470862,3.1322842 c -0.56818177,-0.5681815 -0.56818177,-1.4918411 0,-2.060023 0.5681819,-0.56818197 1.4918415,-0.56818197 2.0600234,0 L 38.793706,36.570513 74.294872,1.0722612 c 0.568182,-0.56818197 1.491842,-0.56818197 2.060023,0 0.568182,0.5681819 0.568182,1.4918415 0,2.060023 L 39.825175,39.659091 c -0.273893,0.273893 -0.641026,0.428322 -1.028555,0.428322 l 0,0 0,0 z"},r=t.getAttribute("data-rex-slider-animation");null!==r&&"true"==r&&(a.autoPlay=!0),i.flickity(a),i.flickity("stopPlayer"),i.on("dragStart.flickity",function(){e(this).addClass("is-dragging")}),i.on("dragEnd.flickity",function(){e(this).removeClass("is-dragging")})},u=function(){e(i,n).length>0&&e(i,n).each(function(t,i){RexSlider.initSlider(e(i)),e(i).attr("data-rex-slider-number",t),Rexbuilder_Dom_Util.lastSliderNumber=t}),e(d,n).length>0&&e(d,n).each(function(e,t){c(t)})},f=function(t){"undefined"!=typeof t.data("flickity")&&t.flickity("destroy"),t.find(".rex-slider-video-wrapper").each(function(t,i){Rexbuilder_Util.destroyVideo(e(i),!1)})},y=function(){e(i,n).length>0&&e(i,n).each(function(t,i){f(e(i))}),e(d,n).length>0&&e(d,n).each(function(t,i){f(e(i))})},p=function(){e(i,n).length&&e(i,n).each(function(e,t){var i=Flickity.data(t);i&&i.autoPlay&&i.playPlayer()})},g=function(){u()};return{init:g,initSlider:o,startAutoPlay:p,destroy:y,destroySliderPlugins:f}}(jQuery);
/*
 *  TextFill
 */
!function(t,e,i,s){"use strict";function r(e,i){this.element=e,this.$element=t(e),this.settings=t.extend({},a,i),this._defaults=a,this._name=n,this.properties={canvas:null,text:"",ctx:null,img:null,background:null,lines:null,wrap:null},this.init()}var n="textFill",a={maxFontSize:100,textAlignment:"center",fontFamily:"sans-serif",fontWeight:"bold",relative:!1,relativeWrap:""};t.extend(r.prototype,{init:function(){this._defineSettings(),this._defineProperties(),this._attachImage();var i=this;t(e).on("resize",function(){i._resizeCanvas(),i._drawText()})},_defineSettings:function(){this.settings.maxFontSize=parseInt(this.element.dataset.maxFontSize||this.element.getAttribute("data-max-font-size")||this.settings.maxFontSize),this.settings.textAlignment=this.element.getElementsByClassName("text-fill-canvas-background")[0].dataset.textAlign||this.element.getElementsByClassName("text-fill-canvas-background")[0].getAttribute("data-text-align")||this.settings.textAlignment,this.settings.relativeWrap=this.element.getAttribute("data-relative-wrap")||this.settings.relativeWrap},_defineProperties:function(){this.properties.canvas=this.element.getElementsByClassName("text-fill-canvas")[0],this.properties.text=this.properties.canvas.textContent,this.properties.ctx=this.properties.canvas.getContext("2d"),this.properties.img=i.createElement("img"),this.properties.background=this.element.getElementsByClassName("text-fill-canvas-background")[0].dataset.backSrc||this.element.getElementsByClassName("text-fill-canvas-background")[0].getAttribute("data-back-src"),this.settings.relative&&""!==this.settings.relativeWrap&&(this.properties.wrap=t(this.element).parents(this.settings.relativeWrap)[0],"undefined"==typeof this.properties.wrap&&(this.settings.relative=!1))},_attachImage:function(){this.properties.img.src=this.properties.background;var t=this;this.properties.img.onload=function(){t._resizeCanvas(),t._drawText(),t.$element.trigger("textfill-render-complete")}},_drawText:function(){var t=this._calcFontSize(this.settings.maxFontSize);this.properties.ctx.font=this.settings.fontWeight+" "+t+"px "+this.settings.fontFamily,this.properties.rows=this._numRows(this.properties.ctx,this.properties.text,(this.properties.relative?this.properties.wrap.offsetWidth:this.element.offsetWidth)-20),this.properties.canvas.height=this.properties.ctx.height=this.properties.rows*t,this.properties.ctx.clearRect(0,0,this.properties.canvas.width,this.properties.canvas.height),this.properties.ctx.font=this.settings.fontWeight+" "+t+"px "+this.settings.fontFamily,this.properties.ctx.fillStyle=this.properties.ctx.createPattern(this.properties.img,"repeat"),this.properties.ctx.textAlign=this.settings.textAlignment,this.properties.ctx.textBaseline="middle";var e;switch(this.settings.textAlignment){case"left":e=0;break;case"right":e=this.properties.canvas.width;break;case"center":e=this.properties.canvas.width/2;break;default:e=this.properties.canvas.width/2}var i=t/2;this._wrapText(this.properties.ctx,this.properties.text,e,i,(this.properties.relative?this.properties.wrap.offsetWidth:this.element.offsetWidth)-20,t)},_calcFontSize:function(t){var e=this.settings.maxFontSize/1e3,i=this.properties.relative?this.properties.wrap.offsetWidth*e:this.element.offsetWidth*e,s=i;return s},_wrapText:function(t,e,i,s,r,n){for(var a=e.split(" "),h=(t.measureText(a).width,""),p=0;p<a.length;p++){var o=h+a[p]+" ",l=t.measureText(o),c=l.width;c>r&&p>0?(t.fillText(h,i,s),h=a[p]+" ",s+=n):h=o}h=h.trim(),t.fillText(h,i,s)},_numRows:function(t,e,i){for(var s,r=new Array,n=" ",a=e.split(" "),h=1,p=0;p<a.length;p++)r.unshift(n),r.unshift(a[p]),s=this._partialTextLenght(t,r),s>i&&(r.splice(1,r.length),h++);return h<=a.length?h:a.length},_partialTextLenght:function(t,e){for(var i=0,s=0;s<e.length;s++)i+=t.measureText(e[s]).width;return i},_resizeCanvas:function(){this.properties.canvas.width=this.properties.ctx.canvas.width=Math.floor(this.properties.relative?this.properties.wrap.offsetWidth:this.element.offsetWidth),this.properties.canvas.height=this.properties.ctx.canvas.height=this._calcFontSize(this.settings.maxFontSize+50)},_calcSlope:function(t,e){var i=(e[1]-t[1])/(e[0]-t[0]);return i}}),t.fn[n]=function(e){var i=arguments;if(e===s||"object"==typeof e)return this.each(function(){t.data(this,"plugin_"+n)||t.data(this,"plugin_"+n,new r(this,e))});if("string"==typeof e&&"_"!==e[0]&&"init"!==e){var a;return this.each(function(){var s=t.data(this,"plugin_"+n);s instanceof r&&"function"==typeof s[e]&&(a=s[e].apply(s,Array.prototype.slice.call(i,1))),"destroy"===e&&t.data(this,"plugin_"+n,null)}),a!==s?a:this}}}(jQuery,window,document);
var VimeoVideo=function(e){"use strict";var i=null,o=null,n=function(){i=Rexbuilder_Util.$rexContainer.find(".rex-video-vimeo-wrap--section"),o=Rexbuilder_Util.$rexContainer.find(".rex-video-vimeo-wrap--block")},t=function(){i.length>0&&i.each(function(i,o){var n=e(o).find("iframe")[0];if("undefined"!=typeof Vimeo){var t=new Vimeo.Player(n);t.ready().then(function(){t.setVolume(0)})}})},r=function(i){var n=i;o.length>0&&o.each(function(i,o){var t=e(o).attr("data-vimeo-video-mute"),r=e(o).find("iframe")[0];"undefined"!=typeof Vimeo&&n.addPlayer(t,r)})},l=function(e,i,o){if("undefined"!=typeof this.blockVideos){var n;n="undefined"!=typeof o?new Vimeo.Player(i,o):new Vimeo.Player(i),"1"==e&&n.ready().then(function(){n.setVolume(0)});var t={el:i,player:n};this.blockVideos.push(t)}},d=function(e){if(void 0!==this.blockVideos)for(var i=0,o=this.blockVideos.length;i<o;i++)if(this.blockVideos[i].el===e)return this.blockVideos[i].player;return null},a=function(e){var i,o=!1,n=this.blockVideos.length;for(i=0;i<n;i++)if(this.blockVideos[i].el===e){this.blockVideos[i].player.destroy().then(function(){})["catch"](function(e){}),o=!0;break}o&&this.blockVideos.splice(i,1)},f=function(){this.blockVideos=[],n(),t(),r(this)};return{init:f,findVideo:d,initBlockVideos:r,addPlayer:l,removePlayer:a}}(jQuery);
/*
 *  rexScrolled - v0.1
 *
 *  Made by NEWEB di Simone Forgiarini
 */
!function(t,e,i,n){"use strict";function s(t){u[t]=null;for(var i=0;i<u.length;i++)if(null!==u[i])return;e.removeEventListener("scroll",d)}function l(){g=a()}function r(){return e.pageYOffset||i.documentElement.scrollTop}function o(t,n){n="undefined"!=typeof n?n:e.pageYOffset||i.documentElement.scrollTop;var s=t.getBoundingClientRect();return s.top+n}function a(){var t=e,n="inner";return"innerWidth"in e||(n="client",t=i.documentElement||i.body),{width:t[n+"Width"],height:t[n+"Height"]}}function c(e,i){this.element=e,this.$element=t(e),this.settings=t.extend({},f,i),this._defaults=f,this._name=h,this.properties={launched:!1},this.settings.offset=parseInt(this.element.getAttribute("data-rs-animation-offset")||this.settings.offset),this.settings.force_launch=this.element.getAttribute("data-rs-animation-force-launch")||this.settings.force_launch,this.settings.visiblePercentage=(parseInt(this.element.getAttribute("data-rs-animation-visible-percentage"))||this.settings.visiblePercentage)/100,this.init()}var h="rexScrolled",f={offset:0,mobile:!0,force_launch:!1,callback:null,visiblePercentage:50},u=[],d=function(){for(var t=0;t<u.length;t++)null!==u[t]&&u[t].call()};e.addEventListener("scroll",d);var g=a();e.addEventListener("resize",l),t.extend(c.prototype,{init:function(){this.instance_index=u.length,u.push(this.has_scrolled.bind(this)),this.has_scrolled(!1)},has_scrolled:function(t){if(t="undefined"==typeof t||t,g.width<=767&&!this.settings.mobile)this.properties.launched=!0,t&&this.removeScrollHandler();else{if(this.properties.launched)return void(t&&this.removeScrollHandler());var e=this,i=g.height,n=r(),s=o(this.element,n),l=this.element.offsetHeight,a=s+l,c=i*(this.settings.offset/100);(s>=n+c&&a<=n+i-c||s+l*this.settings.visiblePercentage<=n+i-c&&a>=n+i-c||s+l*this.settings.visiblePercentage>=n+c&&s<=n+c)&&(e.properties.launched=!0,e.$element.trigger("rs-scrolled-complete"),this.settings.callback&&"function"==typeof this.settings.callback&&this.settings.callback(this.element),t&&this.removeScrollHandler())}},removeScrollHandler:function(){s(this.instance_index)}}),t.fn[h]=function(e){var i=arguments;if(e===n||"object"==typeof e)return this.each(function(){t.data(this,"plugin_"+h)||t.data(this,"plugin_"+h,new c(this,e))});if("string"==typeof e&&"_"!==e[0]&&"init"!==e){var s;return this.each(function(){var n=t.data(this,"plugin_"+h);n instanceof c&&"function"==typeof n[e]&&(s=n[e].apply(n,Array.prototype.slice.call(i,1))),"destroy"===e&&t.data(this,"plugin_"+h,null)}),s!==n?s:this}}}(jQuery,window,document);
/*
 *  rexAccordion - v1.0.0
 *
 *  Made by NEWEB di Simone Forgiarini
 */
!function(t,e,s,n){"use strict";function o(e,s){this.element=e,this.$element=t(e),this.settings=t.extend({},l,s),this._defaults=l,this._name=i,null==this.settings.durationOpen&&(this.settings.durationOpen=this.settings.duration),null==this.settings.durationClose&&(this.settings.durationClose=this.settings.duration);var n=this.$element.find(this.settings.selectors.toggle),o=this.$element.find(this.settings.selectors.content),c=this,r=[];n.each(function(e,s){t(s).closest(c.settings.selectors.self).is(c.$element)&&r.push(s)});var a=[];o.each(function(e,s){t(s).closest(c.settings.selectors.self).is(c.$element)&&a.push(s)}),this.properties={$toggle:t(r),$content:t(a)},this.init()}var i="rexAccordion",l={selectors:{self:".rex-accordion",toggle:".rex-accordion--toggle",content:".rex-accordion--content"},duration:150,durationOpen:null,durationClose:null,noToggleClass:"no-toggle"};t.extend(o.prototype,{init:function(){var e=this;"function"==typeof this.settings.onSetup&&this.settings.onSetup.call(this),this.updateState(),this.properties.$toggle.each(function(s,n){t(n).on("click",function(n){t(n.target).hasClass(e.settings.noToggleClass)||0!==t(n.target).parents("."+e.settings.noToggleClass).length||e._handle_click(s)})})},updateState:function(){this.$element.hasClass("close")&&this.close_all(),this.$element.hasClass("open")&&this.open_all()},_handle_click:function(t){var e=this;1==this.properties.$toggle.length?this.$element.hasClass("open")?(this.$element.addClass("close").removeClass("open"),this.properties.$content.slideUp({duration:this.settings.durationClose,start:function(s){"function"==typeof e.settings.close.startClbk&&e.settings.close.startClbk.call(this,e,t)},progress:function(s,n,o){"function"==typeof e.settings.close.progressClbk&&e.settings.close.progressClbk.call(this,e,n,t)},complete:function(){"function"==typeof e.settings.close.completeClbk&&e.settings.close.completeClbk.call(this,e,t),e.$element.trigger("rex_accordion:close")}}).attr("data-item-status","close")):this.$element.hasClass("close")&&(this.$element.addClass("open").removeClass("close"),this.properties.$content.slideDown({duration:this.settings.durationOpen,start:function(s){"function"==typeof e.settings.open.startClbk&&e.settings.open.startClbk.call(this,e,t)},progress:function(s,n,o){"function"==typeof e.settings.open.progressClbk&&e.settings.open.progressClbk.call(this,e,n,t)},complete:function(){"function"==typeof e.settings.open.completeClbk&&e.settings.open.completeClbk.call(this,e,t),e.$element.trigger("rex_accordion:open")}}).attr("data-item-status","open")):1<this.properties.$toggle.length&&(this.$element.hasClass("open")?"open"==this.properties.$content.eq(t).attr("data-item-status")?(this.$element.addClass("close").removeClass("open"),this.properties.$content.eq(t).slideUp({duration:this.settings.durationClose,start:function(s){"function"==typeof e.settings.close.startClbk&&e.settings.close.startClbk.call(this,e,t)},progress:function(s,n,o){"function"==typeof e.settings.close.progressClbk&&e.settings.close.progressClbk.call(this,e,n,t)},complete:function(){"function"==typeof e.settings.close.completeClbk&&e.settings.close.completeClbk.call(this,e,t),e.$element.trigger("rex_accordion:close")}}).attr("data-item-status","close")):(this.$element.addClass("close").removeClass("close"),this.properties.$content.not(t).slideUp({duration:this.settings.durationClose,start:function(s){"function"==typeof e.settings.close.startClbk&&e.settings.close.startClbk.call(this,e,t)},progress:function(s,n,o){"function"==typeof e.settings.close.progressClbk&&e.settings.close.progressClbk.call(this,e,n,t)},complete:function(){"function"==typeof e.settings.close.completeClbk&&e.settings.close.completeClbk.call(this,e,t),e.$element.trigger("rex_accordion:close")}}).attr("data-item-status","close"),this.properties.$content.eq(t).slideDown({duration:this.settings.durationOpen,start:function(s){"function"==typeof e.settings.open.startClbk&&e.settings.open.startClbk.call(this,e,t)},progress:function(s,n,o){"function"==typeof e.settings.open.progressClbk&&e.settings.open.progressClbk.call(this,e,n,t)},complete:function(){"function"==typeof e.settings.open.completeClbk&&e.settings.open.completeClbk.call(this,e,t),e.$element.trigger("rex_accordion:open")}}).attr("data-item-status","open")):this.$element.hasClass("close")&&("close"==this.properties.$content.eq(t).attr("data-item-status")?(this.$element.addClass("open").removeClass("close"),this.properties.$content.eq(t).slideDown({duration:this.settings.durationOpen,start:function(s){"function"==typeof e.settings.open.startClbk&&e.settings.open.startClbk.call(this,e,t)},progress:function(s,n,o){"function"==typeof e.settings.open.progressClbk&&e.settings.open.progressClbk.call(this,e,n,t)},complete:function(){"function"==typeof e.settings.open.completeClbk&&e.settings.open.completeClbk.call(this,e,t),e.$element.trigger("rex_accordion:open")}}).attr("data-item-status","open")):(this.$element.addClass("close").removeClass("open"),this.properties.$content.eq(t).slideUp({duration:this.settings.duration,start:function(s){"function"==typeof e.settings.close.startClbk&&e.settings.close.startClbk.call(this,e,t)},progress:function(s,n,o){"function"==typeof e.settings.close.progressClbk&&e.settings.close.progressClbk.call(this,e,n,t)},complete:function(){"function"==typeof e.settings.close.completeClbk&&e.settings.close.completeClbk.call(this,e,t),e.$element.trigger("rex_accordion:close")}}).attr("data-item-status","close"),this.properties.$content.not(t).slideDown({duration:this.settings.durationOpen,start:function(s){"function"==typeof e.settings.open.startClbk&&e.settings.open.startClbk.call(this,e,t)},progress:function(s,n,o){"function"==typeof e.settings.open.progressClbk&&e.settings.open.progressClbk.call(this,e,n,t)},complete:function(){"function"==typeof e.settings.open.completeClbk&&e.settings.open.completeClbk.call(this,e,t),e.$element.trigger("rex_accordion:open")}}).attr("data-item-status","open"))))},open_all:function(){this.properties.$content.attr("data-item-status","open"),this.properties.$content.css("display","block"),this.$element.hasClass("close")&&this.$element.addClass("open").removeClass("close")},close_all:function(){this.properties.$content.attr("data-item-status","close"),this.properties.$content.css("display","none"),this.$element.hasClass("open")&&this.$element.addClass("close").removeClass("open")},getState:function(){return this.properties.$content.attr("data-item-status")}}),t.fn[i]=function(e){var s=arguments;if(e===n||"object"==typeof e)return this.each(function(){t.data(this,"plugin_"+i)||t.data(this,"plugin_"+i,new o(this,e))});if("string"==typeof e&&"_"!==e[0]&&"init"!==e){var l;return this.each(function(){var n=t.data(this,"plugin_"+i);n instanceof o&&"function"==typeof n[e]&&(l=n[e].apply(n,Array.prototype.slice.call(s,1))),"destroy"===e&&t.data(this,"plugin_"+i,null)}),l!==n?l:this}}}(jQuery,window,document);
/*
 *  rexIndicator
 * @version 1.0.0
 *
 *  Made by NEWEB - Digital Agency
 */
!function(t,e,i,s){"use strict";function o(){var t=e,s="inner";return"innerWidth"in e||(s="client",t=i.documentElement||i.body),{width:t[s+"Width"],height:t[s+"Height"]}}function n(e,i){this.element=e,this.$element=t(e),this.settings=t.extend({},r,i),this._defaults=r,this._name=h,this.settings.from=this.$element.find(this.settings.indicator).attr("data-ri-from")||this.settings.from,this.settings.to=this.$element.find(this.settings.indicator).attr("data-ri-to")||this.settings.to,this.settings.relative_to=this.$element.find(this.settings.indicator).attr("data-ri-relative-to")||this.settings.relative_to,this.settings.relative_to_parent_position=this.$element.find(this.settings.indicator).attr("data-ri-relative-to-parent-position")||this.settings.relative_to_parent_position,this.settings.relative_to_parent_position=parseInt(this.settings.relative_to_parent_position)/100,this.$line_ref=this.$element.children(this.settings.indicator),this.$block_ref=this.$element.parents(this.settings.block_parent),this.$after_ref=this.$element.parents(this.settings.after),this.init()}var h="rexIndicator",r={indicator:".rex-indicator__wrap--absolute",block_parent:".perfect-grid-item",after:".rexpansive_section"};t.extend(n.prototype,{init:function(){this.move_indicator(),this.place_indicator();var t=this;this.$after_ref.on("relayoutComplete",function(){t.place_indicator()})},move_indicator:function(){this.$after_ref.after(this.$line_ref)},place_indicator:function(){var t={top:0,left:0};switch(this.settings.relative_to){case"block":t=o().width>=parseInt(_plugin_frontend_settings.collapse_dimension)?this._get_position_desktop_block_relative():this._get_position_mobile();break;case"start":t=o().width>=parseInt(_plugin_frontend_settings.collapse_dimension)?this._get_position_desktop_start_relative():this._get_position_mobile();break;case"parent":t=o().width>=parseInt(_plugin_frontend_settings.collapse_dimension)?this._get_position_desktop_parent_relative():this._get_position_mobile()}this.$line_ref.offset(t)},_get_position_desktop_block_relative:function(){var t={top:0,left:0},e=this.$block_ref.offset();return"left"==this.settings.to||"right"==this.settings.to?t.top=e.top+this.$block_ref.outerHeight()/2:"top"==this.settings.to?t.top=e.top-this.$line_ref.height()/2:"bottom"==this.settings.to&&(t.top=e.top+this.$block_ref.outerHeight()-this.$line_ref.height()/2),"top"==this.settings.to||"bottom"==this.settings.to?t.left=e.left+this.$block_ref.outerWidth()/2-this.$line_ref.width()/2:"left"==this.settings.to?t.left=e.left-this.$line_ref.width()/2:"right"==this.settings.to&&(t.left=e.left+this.$block_ref.outerWidth()-this.$line_ref.width()/2),t},_get_position_desktop_start_relative:function(){var t={top:0,left:0},e=this.$block_ref.offset(),i=this.$element.offset();return"left"==this.settings.to||"right"==this.settings.to?t.top=i.top+this.$element.outerHeight(!0)/2-parseInt(this.$element.css("marginTop"))-this.$line_ref.height()/2:"top"==this.settings.to?t.top=e.top-this.$line_ref.height()/2:"bottom"==this.settings.to&&(t.top=e.top+this.$block_ref.outerHeight()-this.$line_ref.height()/2),"top"==this.settings.to||"bottom"==this.settings.to?t.left=i.left+this.$line_ref.width()/2:"left"==this.settings.to?t.left=e.left-this.$line_ref.width()/2:"right"==this.settings.to&&(t.left=e.left+this.$block_ref.outerWidth()-this.$line_ref.width()/2),t},_get_position_desktop_parent_relative:function(){var t={top:0,left:0},e=this.$block_ref.offset(),i=this.$element.parent().offset();return"left"==this.settings.to||"right"==this.settings.to?t.top=i.top+this.$element.parent().outerHeight(!0)*this.settings.relative_to_parent_position-parseInt(this.$element.parent().css("marginTop"))-this.$line_ref.height()/2:"top"==this.settings.to?t.top=e.top-this.$line_ref.height()/2:"bottom"==this.settings.to&&(t.top=e.top+this.$block_ref.outerHeight()-this.$line_ref.height()/2),"top"==this.settings.to||"bottom"==this.settings.to?t.left=i.left+this.$line_ref.width()/2:"left"==this.settings.to?t.left=e.left-this.$line_ref.width()/2:"right"==this.settings.to&&(t.left=e.left+this.$block_ref.outerWidth()-this.$line_ref.width()/2),t},_get_position_mobile:function(){var t={top:0,left:0},e=this.$block_ref.offset();switch(this.settings.to){case"left":t.top=e.top-this.$line_ref.width()/2,t.left=e.left+this.$block_ref.outerWidth()/2-this.$line_ref.height()/2;break;case"top":t.top=e.top-this.$line_ref.height()/2,t.left=e.left+this.$block_ref.outerWidth()/2-this.$line_ref.width()/2;break;case"right":t.top=e.top+this.$block_ref.outerHeight()-this.$line_ref.width()/2,t.left=e.left+this.$block_ref.outerWidth()/2-this.$line_ref.height()/2;break;case"bottom":t.top=e.top+this.$block_ref.outerHeight()-this.$line_ref.height()/2,t.left=e.left+this.$block_ref.outerWidth()/2-this.$line_ref.width()/2}return t}}),t.fn[h]=function(e){var i=arguments;if(e===s||"object"==typeof e)return this.each(function(){t.data(this,"plugin_"+h)||t.data(this,"plugin_"+h,new n(this,e))});if("string"==typeof e&&"_"!==e[0]&&"init"!==e){var o;return this.each(function(){var s=t.data(this,"plugin_"+h);s instanceof n&&"function"==typeof s[e]&&(o=s[e].apply(s,Array.prototype.slice.call(i,1))),"destroy"===e&&t.data(this,"plugin_"+h,null)}),o!==s?o:this}}}(jQuery,window,document);
!function(e){"use strict";e.fn.reverse=[].reverse}(jQuery);
/*
 * anime.js v3.1.0
 * (c) 2019 Julian Garnier
 * Released under the MIT license
 * animejs.com
 */
!function(n,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):n.anime=e()}(this,function(){"use strict";function n(n,e,t){return Math.min(Math.max(n,e),t)}function e(n,e){return n.indexOf(e)>-1}function t(n,e){return n.apply(null,e)}function r(n){var e=/\(([^)]+)\)/.exec(n);return e?e[1].split(",").map(function(n){return parseFloat(n)}):[]}function a(e,t){function a(n){var e=t?t*n/1e3:n;return e=l<1?Math.exp(-e*l*f)*(p*Math.cos(d*e)+h*Math.sin(d*e)):(p+h*e)*Math.exp(-e*f),0===n||1===n?n:1-e}var o=r(e),u=n(J.und(o[0])?1:o[0],.1,100),i=n(J.und(o[1])?100:o[1],.1,100),c=n(J.und(o[2])?10:o[2],.1,100),s=n(J.und(o[3])?0:o[3],.1,100),f=Math.sqrt(i/u),l=c/(2*Math.sqrt(i*u)),d=l<1?f*Math.sqrt(1-l*l):0,p=1,h=l<1?(l*f-s)/d:-s+f;return t?a:function(){var n=W.springs[e];if(n)return n;for(var t=0,r=0;;)if(1===a(t+=1/6)){if(++r>=16)break}else r=0;var o=t*(1/6)*1e3;return W.springs[e]=o,o}}function o(n){return void 0===n&&(n=10),function(e){return Math.round(e*n)*(1/n)}}function u(n,e){if(J.fnc(n))return n;var u=n.split("(")[0],i=U[u],c=r(n);switch(u){case"spring":return a(n,e);case"cubicBezier":return t(K,c);case"steps":return t(o,c);default:return t(i,c)}}function i(n){try{return document.querySelectorAll(n)}catch(n){return}}function c(n,e){for(var t=n.length,r=arguments.length>=2?arguments[1]:void 0,a=[],o=0;o<t;o++)if(o in n){var u=n[o];e.call(r,u,o,n)&&a.push(u)}return a}function s(n){return n.reduce(function(n,e){return n.concat(J.arr(e)?s(e):e)},[])}function f(n){return J.arr(n)?n:(J.str(n)&&(n=i(n)||n),n instanceof NodeList||n instanceof HTMLCollection?[].slice.call(n):[n])}function l(n,e){return n.some(function(n){return n===e})}function d(n){var e={};for(var t in n)e[t]=n[t];return e}function p(n,e){var t=d(n);for(var r in n)t[r]=e.hasOwnProperty(r)?e[r]:n[r];return t}function h(n,e){var t=d(n);for(var r in e)t[r]=J.und(n[r])?e[r]:n[r];return t}function v(n){return J.rgb(n)?(t=/rgb\((\d+,\s*[\d]+,\s*[\d]+)\)/g.exec(e=n))?"rgba("+t[1]+",1)":e:J.hex(n)?(r=n.replace(/^#?([a-f\d])([a-f\d])([a-f\d])$/i,function(n,e,t,r){return e+e+t+t+r+r}),a=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(r),"rgba("+parseInt(a[1],16)+","+parseInt(a[2],16)+","+parseInt(a[3],16)+",1)"):J.hsl(n)?function(n){function e(n,e,t){return t<0&&(t+=1),t>1&&(t-=1),t<1/6?n+6*(e-n)*t:t<.5?e:t<2/3?n+(e-n)*(2/3-t)*6:n}var t,r,a,o=/hsl\((\d+),\s*([\d.]+)%,\s*([\d.]+)%\)/g.exec(n)||/hsla\((\d+),\s*([\d.]+)%,\s*([\d.]+)%,\s*([\d.]+)\)/g.exec(n),u=parseInt(o[1],10)/360,i=parseInt(o[2],10)/100,c=parseInt(o[3],10)/100,s=o[4]||1;if(0==i)t=r=a=c;else{var f=c<.5?c*(1+i):c+i-c*i,l=2*c-f;t=e(l,f,u+1/3),r=e(l,f,u),a=e(l,f,u-1/3)}return"rgba("+255*t+","+255*r+","+255*a+","+s+")"}(n):void 0;var e,t,r,a}function g(n){var e=/[+-]?\d*\.?\d+(?:\.\d+)?(?:[eE][+-]?\d+)?(%|px|pt|em|rem|in|cm|mm|ex|ch|pc|vw|vh|vmin|vmax|deg|rad|turn)?$/.exec(n);if(e)return e[1]}function m(n,e){return J.fnc(n)?n(e.target,e.id,e.total):n}function y(n,e){return n.getAttribute(e)}function b(n,e,t){if(l([t,"deg","rad","turn"],g(e)))return e;var r=W.CSS[e+t];if(!J.und(r))return r;var a=document.createElement(n.tagName),o=n.parentNode&&n.parentNode!==document?n.parentNode:document.body;o.appendChild(a),a.style.position="absolute",a.style.width=100+t;var u=100/a.offsetWidth;o.removeChild(a);var i=u*parseFloat(e);return W.CSS[e+t]=i,i}function M(n,e,t){if(e in n.style){var r=e.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase(),a=n.style[e]||getComputedStyle(n).getPropertyValue(r)||"0";return t?b(n,a,t):a}}function x(n,e){return J.dom(n)&&!J.inp(n)&&(y(n,e)||J.svg(n)&&n[e])?"attribute":J.dom(n)&&l(R,e)?"transform":J.dom(n)&&"transform"!==e&&M(n,e)?"css":null!=n[e]?"object":void 0}function w(n){if(J.dom(n)){for(var e,t=n.style.transform||"",r=/(\w+)\(([^)]*)\)/g,a=new Map;e=r.exec(t);)a.set(e[1],e[2]);return a}}function k(n,t,r,a){var o,u=e(t,"scale")?1:0+(e(o=t,"translate")||"perspective"===o?"px":e(o,"rotate")||e(o,"skew")?"deg":void 0),i=w(n).get(t)||u;return r&&(r.transforms.list.set(t,i),r.transforms.last=t),a?b(n,i,a):i}function O(n,e,t,r){switch(x(n,e)){case"transform":return k(n,e,r,t);case"css":return M(n,e,t);case"attribute":return y(n,e);default:return n[e]||0}}function C(n,e){var t=/^(\*=|\+=|-=)/.exec(n);if(!t)return n;var r=g(n)||0,a=parseFloat(e),o=parseFloat(n.replace(t[0],""));switch(t[0][0]){case"+":return a+o+r;case"-":return a-o+r;case"*":return a*o+r}}function B(n,e){if(J.col(n))return v(n);if(/\s/g.test(n))return n;var t=g(n),r=t?n.substr(0,n.length-t.length):n;return e?r+e:r}function P(n,e){return Math.sqrt(Math.pow(e.x-n.x,2)+Math.pow(e.y-n.y,2))}function I(n){for(var e,t=n.points,r=0,a=0;a<t.numberOfItems;a++){var o=t.getItem(a);a>0&&(r+=P(e,o)),e=o}return r}function T(n){if(n.getTotalLength)return n.getTotalLength();switch(n.tagName.toLowerCase()){case"circle":return o=n,2*Math.PI*y(o,"r");case"rect":return 2*y(a=n,"width")+2*y(a,"height");case"line":return P({x:y(r=n,"x1"),y:y(r,"y1")},{x:y(r,"x2"),y:y(r,"y2")});case"polyline":return I(n);case"polygon":return t=(e=n).points,I(e)+P(t.getItem(t.numberOfItems-1),t.getItem(0))}var e,t,r,a,o}function D(n,e){var t=e||{},r=t.el||function(n){for(var e=n.parentNode;J.svg(e)&&J.svg(e.parentNode);)e=e.parentNode;return e}(n),a=r.getBoundingClientRect(),o=y(r,"viewBox"),u=a.width,i=a.height,c=t.viewBox||(o?o.split(" "):[0,0,u,i]);return{el:r,viewBox:c,x:c[0]/1,y:c[1]/1,w:u/c[2],h:i/c[3]}}function E(n,e){function t(t){void 0===t&&(t=0);var r=e+t>=1?e+t:0;return n.el.getPointAtLength(r)}var r=D(n.el,n.svg),a=t(),o=t(-1),u=t(1);switch(n.property){case"x":return(a.x-r.x)*r.w;case"y":return(a.y-r.y)*r.h;case"angle":return 180*Math.atan2(u.y-o.y,u.x-o.x)/Math.PI}}function F(n,e){var t=/[+-]?\d*\.?\d+(?:\.\d+)?(?:[eE][+-]?\d+)?/g,r=B(J.pth(n)?n.totalLength:n,e)+"";return{original:r,numbers:r.match(t)?r.match(t).map(Number):[0],strings:J.str(n)||e?r.split(t):[]}}function N(n){return c(n?s(J.arr(n)?n.map(f):f(n)):[],function(n,e,t){return t.indexOf(n)===e})}function A(n){var e=N(n);return e.map(function(n,t){return{target:n,id:t,total:e.length,transforms:{list:w(n)}}})}function L(n,e){var t=d(e);if(/^spring/.test(t.easing)&&(t.duration=a(t.easing)),J.arr(n)){var r=n.length;2!==r||J.obj(n[0])?J.fnc(e.duration)||(t.duration=e.duration/r):n={value:n}}var o=J.arr(n)?n:[n];return o.map(function(n,t){var r=J.obj(n)&&!J.pth(n)?n:{value:n};return J.und(r.delay)&&(r.delay=t?0:e.delay),J.und(r.endDelay)&&(r.endDelay=t===o.length-1?e.endDelay:0),r}).map(function(n){return h(n,t)})}function j(n,e){var t=[],r=e.keyframes;for(var a in r&&(e=h(function(n){for(var e=c(s(n.map(function(n){return Object.keys(n)})),function(n){return J.key(n)}).reduce(function(n,e){return n.indexOf(e)<0&&n.push(e),n},[]),t={},r=function(r){var a=e[r];t[a]=n.map(function(n){var e={};for(var t in n)J.key(t)?t==a&&(e.value=n[t]):e[t]=n[t];return e})},a=0;a<e.length;a++)r(a);return t}(r),e)),e)J.key(a)&&t.push({name:a,tweens:L(e[a],n)});return t}function S(n,e){var t;return n.tweens.map(function(r){var a=function(n,e){var t={};for(var r in n){var a=m(n[r],e);J.arr(a)&&1===(a=a.map(function(n){return m(n,e)})).length&&(a=a[0]),t[r]=a}return t.duration=parseFloat(t.duration),t.delay=parseFloat(t.delay),t}(r,e),o=a.value,i=J.arr(o)?o[1]:o,c=g(i),s=O(e.target,n.name,c,e),f=t?t.to.original:s,l=J.arr(o)?o[0]:f,d=g(l)||g(s),p=c||d;return J.und(i)&&(i=f),a.from=F(l,p),a.to=F(C(i,l),p),a.start=t?t.end:0,a.end=a.start+a.delay+a.duration+a.endDelay,a.easing=u(a.easing,a.duration),a.isPath=J.pth(o),a.isColor=J.col(a.from.original),a.isColor&&(a.round=1),t=a,a})}function q(n,e){A(n).forEach(function(n){for(var t in e){var r=m(e[t],n),a=n.target,o=g(r),u=O(a,t,o,n),i=C(B(r,o||g(u)),u),c=x(a,t);_[c](a,t,i,n.transforms,!0)}})}function $(n,e){return c(s(n.map(function(n){return e.map(function(e){return function(n,e){var t=x(n.target,e.name);if(t){var r=S(e,n),a=r[r.length-1];return{type:t,property:e.name,animatable:n,tweens:r,duration:a.end,delay:r[0].delay,endDelay:a.endDelay}}}(n,e)})})),function(n){return!J.und(n)})}function X(n,e){var t=n.length,r=function(n){return n.timelineOffset?n.timelineOffset:0},a={};return a.duration=t?Math.max.apply(Math,n.map(function(n){return r(n)+n.duration})):e.duration,a.delay=t?Math.min.apply(Math,n.map(function(n){return r(n)+n.delay})):e.delay,a.endDelay=t?a.duration-Math.max.apply(Math,n.map(function(n){return r(n)+n.duration-n.endDelay})):e.endDelay,a}function Y(e){function t(n){var e=window.Promise&&new Promise(function(n){return B=n});return n.finished=e,e}function r(){var n=P.direction;"alternate"!==n&&(P.direction="normal"!==n?"normal":"reverse"),P.reversed=!P.reversed,l.forEach(function(n){return n.reversed=P.reversed})}function a(n){return P.reversed?P.duration-n:n}function o(){w=0,k=a(P.currentTime)*(1/Y.speed)}function u(n,e){e&&e.seek(n-e.timelineOffset)}function i(e){for(var t=0,r=P.animations,a=r.length;t<a;){var o=r[t],u=o.animatable,i=o.tweens,s=i.length-1,f=i[s];s&&(f=c(i,function(n){return e<n.end})[0]||f);for(var l=n(e-f.start-f.delay,0,f.duration)/f.duration,d=isNaN(l)?1:f.easing(l),p=f.to.strings,h=f.round,v=[],g=f.to.numbers.length,m=void 0,y=0;y<g;y++){var b=void 0,M=f.to.numbers[y],x=f.from.numbers[y]||0;b=f.isPath?E(f.value,d*M):x+d*(M-x),h&&(f.isColor&&y>2||(b=Math.round(b*h)/h)),v.push(b)}var w=p.length;if(w){m=p[0];for(var k=0;k<w;k++){p[k];var O=p[k+1],C=v[k];isNaN(C)||(m+=O?C+O:C+" ")}}else m=v[0];_[o.type](u.target,o.property,m,u.transforms),o.currentValue=m,t++}}function s(n){P[n]&&!P.passThrough&&P[n](P)}function f(e){var o=P.duration,c=P.delay,f=o-P.endDelay,d=a(e);P.progress=n(d/o*100,0,100),P.reversePlayback=d<P.currentTime,l&&function(n){if(P.reversePlayback)for(var e=C;e--;)u(n,l[e]);else for(var t=0;t<C;t++)u(n,l[t])}(d),!P.began&&P.currentTime>0&&(P.began=!0,s("begin")),!P.loopBegan&&P.currentTime>0&&(P.loopBegan=!0,s("loopBegin")),d<=c&&0!==P.currentTime&&i(0),(d>=f&&P.currentTime!==o||!o)&&i(o),d>c&&d<f?(P.changeBegan||(P.changeBegan=!0,P.changeCompleted=!1,s("changeBegin")),s("change"),i(d)):P.changeBegan&&(P.changeCompleted=!0,P.changeBegan=!1,s("changeComplete")),P.currentTime=n(d,0,o),P.began&&s("update"),e>=o&&(k=0,P.remaining&&!0!==P.remaining&&P.remaining--,P.remaining?(w=O,s("loopComplete"),P.loopBegan=!1,"alternate"===P.direction&&r()):(P.paused=!0,P.completed||(P.completed=!0,s("loopComplete"),s("complete"),!P.passThrough&&"Promise"in window&&(B(),t(P)))))}void 0===e&&(e={});var l,d,v,g,m,y,b,M,x,w=0,k=0,O=0,C=0,B=null,P=(v=p(H,d=e),g=p(G,d),m=j(g,d),y=A(d.targets),b=$(y,m),M=X(b,g),x=nn,nn++,h(v,{id:x,children:[],animatables:y,animations:b,duration:M.duration,delay:M.delay,endDelay:M.endDelay}));return t(P),P.reset=function(){var n=P.direction;P.passThrough=!1,P.currentTime=0,P.progress=0,P.paused=!0,P.began=!1,P.loopBegan=!1,P.changeBegan=!1,P.completed=!1,P.changeCompleted=!1,P.reversePlayback=!1,P.reversed="reverse"===n,P.remaining=P.loop,l=P.children;for(var e=C=l.length;e--;)P.children[e].reset();(P.reversed&&!0!==P.loop||"alternate"===n&&1===P.loop)&&P.remaining++,i(P.reversed?P.duration:0)},P.set=function(n,e){return q(n,e),P},P.tick=function(n){O=n,w||(w=O),f((O+(k-w))*Y.speed)},P.seek=function(n){f(a(n))},P.pause=function(){P.paused=!0,o()},P.play=function(){P.paused&&(P.completed&&P.reset(),P.paused=!1,en.push(P),o(),z||rn())},P.reverse=function(){r(),o()},P.restart=function(){P.reset(),P.play()},P.reset(),P.autoplay&&P.play(),P}function Z(n,e){for(var t=e.length;t--;)l(n,e[t].animatable.target)&&e.splice(t,1)}var Q,V,z,H={update:null,begin:null,loopBegin:null,changeBegin:null,change:null,changeComplete:null,loopComplete:null,complete:null,loop:1,direction:"normal",autoplay:!0,timelineOffset:0},G={duration:1e3,delay:0,endDelay:0,easing:"easeOutElastic(1, .5)",round:0},R=["translateX","translateY","translateZ","rotate","rotateX","rotateY","rotateZ","scale","scaleX","scaleY","scaleZ","skew","skewX","skewY","perspective"],W={CSS:{},springs:{}},J={arr:function(n){return Array.isArray(n)},obj:function(n){return e(Object.prototype.toString.call(n),"Object")},pth:function(n){return J.obj(n)&&n.hasOwnProperty("totalLength")},svg:function(n){return n instanceof SVGElement},inp:function(n){return n instanceof HTMLInputElement},dom:function(n){return n.nodeType||J.svg(n)},str:function(n){return"string"==typeof n},fnc:function(n){return"function"==typeof n},und:function(n){return void 0===n},hex:function(n){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(n)},rgb:function(n){return/^rgb/.test(n)},hsl:function(n){return/^hsl/.test(n)},col:function(n){return J.hex(n)||J.rgb(n)||J.hsl(n)},key:function(n){return!H.hasOwnProperty(n)&&!G.hasOwnProperty(n)&&"targets"!==n&&"keyframes"!==n}},K=function(){function n(n,e){return 1-3*e+3*n}function e(n,e){return 3*e-6*n}function t(n){return 3*n}function r(r,a,o){return((n(a,o)*r+e(a,o))*r+t(a))*r}function a(r,a,o){return 3*n(a,o)*r*r+2*e(a,o)*r+t(a)}var o=11,u=1/(o-1);return function(n,e,t,i){function c(e){for(var i=0,c=1,f=o-1;c!==f&&s[c]<=e;++c)i+=u;var l=i+(e-s[--c])/(s[c+1]-s[c])*u,d=a(l,n,t);return d>=.001?function(n,e,t,o){for(var u=0;u<4;++u){var i=a(e,t,o);if(0===i)return e;e-=(r(e,t,o)-n)/i}return e}(e,l,n,t):0===d?l:function(n,e,t,a,o){for(var u,i,c=0;(u=r(i=e+(t-e)/2,a,o)-n)>0?t=i:e=i,Math.abs(u)>1e-7&&++c<10;);return i}(e,i,i+u,n,t)}if(0<=n&&n<=1&&0<=t&&t<=1){var s=new Float32Array(o);if(n!==e||t!==i)for(var f=0;f<o;++f)s[f]=r(f*u,n,t);return function(a){return n===e&&t===i?a:0===a||1===a?a:r(c(a),e,i)}}}}(),U=(Q={linear:function(){return function(n){return n}}},V={Sine:function(){return function(n){return 1-Math.cos(n*Math.PI/2)}},Circ:function(){return function(n){return 1-Math.sqrt(1-n*n)}},Back:function(){return function(n){return n*n*(3*n-2)}},Bounce:function(){return function(n){for(var e,t=4;n<((e=Math.pow(2,--t))-1)/11;);return 1/Math.pow(4,3-t)-7.5625*Math.pow((3*e-2)/22-n,2)}},Elastic:function(e,t){void 0===e&&(e=1),void 0===t&&(t=.5);var r=n(e,1,10),a=n(t,.1,2);return function(n){return 0===n||1===n?n:-r*Math.pow(2,10*(n-1))*Math.sin((n-1-a/(2*Math.PI)*Math.asin(1/r))*(2*Math.PI)/a)}}},["Quad","Cubic","Quart","Quint","Expo"].forEach(function(n,e){V[n]=function(){return function(n){return Math.pow(n,e+2)}}}),Object.keys(V).forEach(function(n){var e=V[n];Q["easeIn"+n]=e,Q["easeOut"+n]=function(n,t){return function(r){return 1-e(n,t)(1-r)}},Q["easeInOut"+n]=function(n,t){return function(r){return r<.5?e(n,t)(2*r)/2:1-e(n,t)(-2*r+2)/2}}}),Q),_={css:function(n,e,t){return n.style[e]=t},attribute:function(n,e,t){return n.setAttribute(e,t)},object:function(n,e,t){return n[e]=t},transform:function(n,e,t,r,a){if(r.list.set(e,t),e===r.last||a){var o="";r.list.forEach(function(n,e){o+=e+"("+n+") "}),n.style.transform=o}}},nn=0,en=[],tn=[],rn=function(){function n(){z=requestAnimationFrame(e)}function e(e){var t=en.length;if(t){for(var r=0;r<t;){var a=en[r];if(a.paused){var o=en.indexOf(a);o>-1&&(en.splice(o,1),t=en.length)}else a.tick(e);r++}n()}else z=cancelAnimationFrame(z)}return n}();return"undefined"!=typeof document&&document.addEventListener("visibilitychange",function(){document.hidden?(en.forEach(function(n){return n.pause()}),tn=en.slice(0),Y.running=en=[]):tn.forEach(function(n){return n.play()})}),Y.version="3.1.0",Y.speed=1,Y.running=en,Y.remove=function(n){for(var e=N(n),t=en.length;t--;){var r=en[t],a=r.animations,o=r.children;Z(e,a);for(var u=o.length;u--;){var i=o[u],c=i.animations;Z(e,c),c.length||i.children.length||o.splice(u,1)}a.length||o.length||r.pause()}},Y.get=O,Y.set=q,Y.convertPx=b,Y.path=function(n,e){var t=J.str(n)?i(n)[0]:n,r=e||100;return function(n){return{property:n,el:t,svg:D(t),totalLength:T(t)*(r/100)}}},Y.setDashoffset=function(n){var e=T(n);return n.setAttribute("stroke-dasharray",e),e},Y.stagger=function(n,e){void 0===e&&(e={});var t=e.direction||"normal",r=e.easing?u(e.easing):null,a=e.grid,o=e.axis,i=e.from||0,c="first"===i,s="center"===i,f="last"===i,l=J.arr(n),d=l?parseFloat(n[0]):parseFloat(n),p=l?parseFloat(n[1]):0,h=g(l?n[1]:n)||0,v=e.start||0+(l?d:0),m=[],y=0;return function(n,e,u){if(c&&(i=0),s&&(i=(u-1)/2),f&&(i=u-1),!m.length){for(var g=0;g<u;g++){if(a){var b=s?(a[0]-1)/2:i%a[0],M=s?(a[1]-1)/2:Math.floor(i/a[0]),x=b-g%a[0],w=M-Math.floor(g/a[0]),k=Math.sqrt(x*x+w*w);"x"===o&&(k=-x),"y"===o&&(k=-w),m.push(k)}else m.push(Math.abs(i-g));y=Math.max.apply(Math,m)}r&&(m=m.map(function(n){return r(n/y)*y})),"reverse"===t&&(m=m.map(function(n){return o?n<0?-1*n:-n:Math.abs(y-n)}))}return v+(l?(p-d)/y:d)*(Math.round(100*m[e])/100)+h}},Y.timeline=function(n){void 0===n&&(n={});var e=Y(n);return e.duration=0,e.add=function(t,r){function a(n){n.passThrough=!0}var o=en.indexOf(e),u=e.children;o>-1&&en.splice(o,1);for(var i=0;i<u.length;i++)a(u[i]);var c=h(t,p(G,n));c.targets=c.targets||n.targets;var s=e.duration;c.autoplay=!1,c.direction=e.direction,c.timelineOffset=J.und(r)?s:C(r,s),a(e),e.seek(c.timelineOffset);var f=Y(c);a(f),u.push(f);var l=X(u,n);return e.delay=l.delay,e.endDelay=l.endDelay,e.duration=l.duration,e.seek(0),e.reset(),e.autoplay&&e.play(),e},e},Y.easing=u,Y.penner=U,Y.random=function(n,e){return Math.floor(Math.random()*(e-n+1))+n},Y});
/*
 *  rexScrollify - v0.1
 *
 *  Made by NEWEB di Simone Forgiarini
 */
!function(t,e,i,n){"use strict";function s(){g=r()}function a(){return e.pageYOffset||i.documentElement.scrollTop}function o(t,n){n="undefined"!=typeof n?n:e.pageYOffset||i.documentElement.scrollTop;var s=t.getBoundingClientRect();return s.top+n}function r(){var t=e,n="inner";return"innerWidth"in e||(n="client",t=i.documentElement||i.body),{width:t[n+"Width"],height:t[n+"Height"]}}function l(){var t,e=i.createElement("fakeelement"),s={transition:"transitionend",OTransition:"oTransitionEnd",MozTransition:"transitionend",WebkitTransition:"webkitTransitionEnd"};for(t in s)if(e.style[t]!==n)return s[t]}function h(){var t,e=i.createElement("fakeelement"),s={animation:"animationend",OAnimation:"oAnimationEnd",MozAnimation:"animationend",WebkitAnimation:"webkitAnimationEnd"};for(t in s)if(e.style[t]!==n)return s[t]}function d(){if(g.width<=767&&!this.settings.mobile)this.$element.css("opacity",1),this.properties.launched=!0,this.removeScrollHandler();else{if(this.properties.launched)return;var t,e,i=g.height,n=a(),s=o(this.element,n),r=this.element.offsetHeight;0===this.settings.offset?(t=.7*i,e=.2*i):this.settings.offset>0?(t=i-this.settings.offset,e=.2*i):this.settings.offset<0&&(t=.7*i,e=i+this.settings.offset),(s-t<n&&s+r-e>n||this.settings.force_launch)&&(this.settings.delay&&(this.properties.launched=!0),this.launchAnimation())}}function c(e,i){this.element=e,this.$element=t(e),this.settings=t.extend({},u,i),this._defaults=u,this._name=f,this.properties={launched:!1},this.settings.animation=this.element.getAttribute("data-rs-animation")||this.settings.animation,this.settings.duration=this.element.getAttribute("data-rs-animation-duration")||this.settings.duration,this.settings.offset=parseInt(this.element.getAttribute("data-rs-animation-offset")||this.settings.offset),this.settings.delay=parseInt(this.element.getAttribute("data-rs-animation-delay")||this.settings.delay),this.settings.stagger=parseInt(this.element.getAttribute("data-rs-animation-stagger")||this.settings.stagger),this.settings.force_launch=this.element.getAttribute("data-rs-animation-force-launch")||this.settings.force_launch,this.bindedScrollHandler=null,this.init()}var f="rexScrollify",u={animation:"rexSlideUpBigIn",duration:"500",offset:0,delay:0,stagger:0,mobile:!0,force_launch:!1,context:null},g=r();e.addEventListener("resize",s);var m=(l(),h());t.extend(c.prototype,{init:function(){d.call(this),this.bindedScrollHandler=d.bind(this),this.settings.context?this.settings.context.addEventListener("scroll",this.bindedScrollHandler):e.addEventListener("scroll",this.bindedScrollHandler)},launchAnimation:function(){var t=this;this.$element.one(m,function(e){t.element.style.opacity=1,t.$element.trigger("rs-animation-complete"),t.removeScrollHandler()}),this.properties.launched=!0,this.$element.addClass(this.settings.animation)},removeScrollHandler:function(){this.settings.context?this.settings.context.removeEventListener("scroll",this.bindedScrollHandler):e.removeEventListener("scroll",this.bindedScrollHandler)}}),t.fn[f]=function(e){var i=arguments;if(e===n||"object"==typeof e)return this.each(function(){t.data(this,"plugin_"+f)||t.data(this,"plugin_"+f,new c(this,e))});if("string"==typeof e&&"_"!==e[0]&&"init"!==e){var s;return this.each(function(){var n=t.data(this,"plugin_"+f);n instanceof c&&"function"==typeof n[e]&&(s=n[e].apply(n,Array.prototype.slice.call(i,1))),"destroy"===e&&t.data(this,"plugin_"+f,null)}),s!==n?s:this}}}(jQuery,window,document);
// var lodash = _.noConflict();
var Rexbuilder_App=function(e){"use strict";function t(){function t(){Rexbuilder_Util.$window.resize()}var i=e(".text-fill-container-canvas");0!==i.length&&(i.textFill({relative:!0,relativeWrap:".perfect-grid-item",fontFamily:_plugin_frontend_settings.textFill.font_family,fontWeight:_plugin_frontend_settings.textFill.font_weight}),i.on("textfill-render-complete",t))}function i(e){"undefined"!=typeof rexIndicator&&e.find(".rex-indicator__placeholder").rexIndicator()}function n(){e(".rex-effect-distortion").each(function(t,i){var n=e(i);1==_plugin_frontend_settings.animations?n.one("rs-animation-complete",function(){n.rexEffect({effect:{name:"distortion",properties:{startDelay:2500}}})}):n.rexEffect({effect:{name:"distortion",properties:{startDelay:2500}}})}),e(".rex-effect-distortion-section").each(function(t,i){var n=e(i);1==_plugin_frontend_settings.animations?n.one("rs-scrolled-complete",function(){n.rexEffect({effect:{name:"distortion-section",properties:{startDelay:2500}}})}):n.rexEffect({effect:{name:"distortion-section",properties:{startDelay:2500}}})})}function r(){e("[class*=border-space-animated-]").each(function(t,i){var n=e(i);n.addClass("border-space-animated"),1==_plugin_frontend_settings.animations&&Rexbuilder_Util.globalViewport.width>768?n.one("rs-animation-complete",function(){n.addClass("border-active")}):n.parents(".rexpansive_section").one("rs-scrolled-complete",function(){n.addClass("border-active")})})}function l(t){function i(e){Rexbuilder_Util.removeClass(this,"rex-element--animated"),this.removeEventListener(Rexbuilder_Util._transitionEvent,i)}var n=e(document.getElementsByClassName("rex-element--animated"));n.rexScrolled({callback:function(e){e.addEventListener(Rexbuilder_Util._transitionEvent,i),Rexbuilder_Util.addClass(e,"run-animation")}})}function o(){var t=e(document.querySelectorAll(".rs-animation:not(.deactivate-rexpansive-animation)"));t.rexScrollify({mobile:!1})}function a(){if($){var e,t=!(Rexbuilder_Util.cssPropertyValueSupported("position","sticky")||Rexbuilder_Util.cssPropertyValueSupported("position","-webkit-sticky")),i=Array.prototype.slice.call(document.getElementsByClassName("sticky-section")),n=i.length,r=0,l="",o=!1;for(StickySection.destroyHandlers(),r=0;r<n;r++)if(e=i[r],null!==StickySection.data(e)&&StickySection.data(e).destroy(),Rexbuilder_Util.hasClass(e,"mp4-player")?l=".rex-video-wrap":(""!==e.style.backgroundImage||Rexbuilder_Util.hasClass(e,"section-w-image"))&&(l=".sticky-background-simulator"),o="true"===e.querySelector(".section-data").getAttribute("data-row_overlay_active"),new StickySection(e,{borderAnimation:!0,stickyJS:t,stickyElementSelector:l,overlayAnimation:o}),"undefined"!=typeof RevealOpacityOnScroll&&_plugin_frontend_settings.stickySection.revealContentOnScroll)for(var a=RexGrid.data(e.querySelector(".perfect-grid-gallery")),s=0;s<a.gridBlocksTotal;s++){Rexbuilder_Util.removeClass(a.gridBlocks[s].el,"has-rs-animation"),Rexbuilder_Util.removeClass(a.gridBlocks[s].el,"rs-animation");var d=a.gridBlocks[s].el.querySelector(".text-wrap");new RevealOpacityOnScroll(d,{offset:1,transition:!1})}}}function s(){function e(){var e;for(e=0;e<l.length;e++)l[e].options.autoPlay&&l[e].pausePlayer()}function t(){var e;for(e=0;e<l.length;e++)l[e].options.autoPlay&&l[e].unpausePlayer()}if("undefined"!=typeof PopUpContent&&!Rexbuilder_Util.isIframe){window.addEventListener("message",d,!1),document.addEventListener("popUpContent:open",e),document.addEventListener("popUpContent:close",t);var i,n=Array.prototype.slice.call(document.getElementsByClassName("rex-slider-wrap")),r=n.length,l=[];for(i=0;i<r;i++){var o=Flickity.data(n[i]);o&&l.push(o)}}}function d(e){if(e.data.rexliveEvent)switch(e.data.eventName){case"popUpContent:pswpOpened":Rexbuilder_Util.addClass(document.body,"popup-content--active--pswp-open");break;case"popUpContent:pswpClosed":Rexbuilder_Util.removeClass(document.body,"popup-content--active--pswp-open");break;case"popUpContent:changePage":""!==e.data.href&&(window.location=e.data.href)}}function c(){if("undefined"!=typeof PopUpVideo){var e=[].slice.call(document.getElementsByClassName("popup-video-button")),t=e.length,i=0;for(i=0;i<t;i++)""!==e[i].href&&new PopUpVideo(e[i],{closeOnEnd:_plugin_frontend_settings.popUpVideo.closeOnEnd})}}function u(){var e,t,i=this.element.querySelector(".perfect-grid-gallery"),n=S(i);if(n.instance){for(p(this,n.instance),f(this,n.instance),e=0;e<this.totScrollEls;e++)this.scrollEls[e].style.height="";for(e=0;e<this.totOpacityEls;e++)this.opacityEls[e].style.top="";for(e=0;e<n.instance.gridBlocksTotal;e++){for(t=0;t<this.totScrollEls;t++)if(this.scrollEls[t]===n.instance.gridBlocks[e].el){n.instance.gridBlocks[e].setHeight=!1;break}for(t=0;t<this.totOpacityEls;t++)if(this.opacityEls[t]===n.instance.gridBlocks[e].el){n.instance.gridBlocks[e].setTop=!1;break}}i.style.height="",n.instance.properties.gridHeightSettable=!1}}function p(e,t){e.scrollEls=t.gridBlocks.filter(function(t){return Rexbuilder_Util.hasClass(t.el,e.options.scrollElsClass)}).map(function(e){return e.el}),e.scrollElsToWatch=t.gridBlocks.filter(function(t){return Rexbuilder_Util.hasClass(t.el,e.options.scrollElsClass)}).map(function(t){return t.el.querySelector("."+e.options.scrollElsToWatchClass)});for(var i=0,n=0,r=0;i<t.gridBlocksTotal;i++)for(n=0;n<e.totScrollEls;n++)if(e.scrollEls[n]===t.gridBlocks[i].el){e.scrollEls[n].style.WebKitBoxOrdinalGroup=r+1,e.scrollEls[n].style.MozFlexOrder=r,e.scrollEls[n].style.OOrder=r,e.scrollEls[n].style.MSOrder=r,e.scrollEls[n].style.order=r,e.scrollElsToWatch[n].setAttribute("data-scroll-el-index",r),r++;break}}function f(e,t){e.opacityEls=t.gridBlocks.filter(function(t){return Rexbuilder_Util.hasClass(t.el,e.options.opacityElsClass)}).map(function(e){return e.el})}function g(){if(L&&!(Rexbuilder_Util.globalViewport.width<_plugin_frontend_settings.splitScrollable.minViewportWidth)){var e,t=Array.prototype.slice.call(document.getElementsByClassName("split-scrollable")),i=t.length;for(e=0;e<i;e++)null===SplitScrollable.data(t[e])&&new SplitScrollable(t[e],{scrollElsToWatchClass:"text-wrap",initializeComplete:u})}}function x(){if("undefined"!=typeof ParticleSwarm){var e,t=Array.prototype.slice.call(document.getElementsByClassName("particle-swarm")),i=t.length;for(e=0;e<i;e++){var n=document.createElement("canvas");t[e].insertBefore(n,t[e].firstChild),new ParticleSwarm(n)}}}function _(){var t,i=Array.prototype.slice.call(document.getElementsByClassName("disable-grid")),n=i.length;for(t=0;t<n;t++){var r,l=i[t].querySelector(".perfect-grid-gallery"),o=Array.prototype.slice.call(i[t].getElementsByClassName("grid-stack-item")),a=o.length,s=[];for(r=0;r<a;r++)s.push(o[r].style.height);for(B(l),Rexbuilder_Util.addClass(i[t],"disabled"),e(l).find(".rex-animate-lazy-loaded-resource .rex-image-wrapper").addClass("rex-image-wrapper--lazy-show"),r=0;r<a;r++)o[r].style.height=s[r]}}function m(){var e=Rexbuilder_Util.$rexContainer.find(".inline-pswp-gallery");e.on("click",Rexbuilder_Photoswipe.init_inline_pswp)}function h(){var t,i=[].slice.call(document.getElementsByClassName("rex-num-spin")),n=i.length;for(t=0;t<n;t++){var r=W(i[t]);r&&(I.push(r),Rexbuilder_Util.hasClass(i[t],"rex-num-spin__block-scrolled")?e(i[t]).parents(".perfect-grid-item").one("rs-scrolled-complete",{el:i[t]},function(e){e.data.el.innerHTML=e.data.el.getAttribute("data-final-value")}):Rexbuilder_Util.hasClass(i[t],"rex-num-spin__stopped")||e(i[t]).rexScrolled({callback:function(e){e.innerHTML=e.getAttribute("data-final-value")}}))}}function b(){F=Rexbuilder_Util.$rexContainer.find(".rex-accordion"),N=Rexbuilder_Util.$document.find(".rex-accordion").not(F),D={onSetup:function(){if(!Rexbuilder_Util.editorMode){var t=this.$element.parents(".perfect-grid-gallery"),i=t.find(".perfect-grid-item"),n=t.get(0),r=this.$element.parents(".perfect-grid-item").get(0),l=S(n);this.caching={$grid:t,grid:n,$blocks:i,block:r,$block:e(r),rexGridInstance:l}}}},Rexbuilder_Util.editorMode?(D.open={progressClbk:function(e){var t=e.properties.$content.parents(".grid-stack-item")[0],i=e.properties.$content.parents(".grid-stack").data("gridstack");i.resize(t,null,Math.round(e.element.parentElement.offsetHeight/i.opts.cellHeight))}},D.close={progressClbk:function(e){var t=e.properties.$content.parents(".grid-stack-item")[0],i=t.children[0].getAttribute("data-gs_start_h"),n=e.properties.$content.parents(".grid-stack").data("gridstack");n.resize(t,null,Math.round(parseInt(i)))}}):(D.open={startClbk:function(e){e.caching.$blocks.addClass("accordion-animate-block")},progressClbk:function(e){e.caching.rexGridInstance&&e.caching.rexGridInstance.instance.reCalcBlockHeight(e.caching.block)}},D.close={progressClbk:function(e){e.caching.rexGridInstance&&e.caching.rexGridInstance.instance.reCalcBlockHeight(e.caching.block)},completeClbk:function(e){e.caching.$block.one(Rexbuilder_Util._transitionEvent,function(){e.caching.$blocks.removeClass("accordion-animate-block")})}}),F.rexAccordion(D),N.rexAccordion({open:{},close:{}})}function y(){for(var e=0;e<O.length;e++)Rexbuilder_Util.removeClass(O[e].section,"empty-section"),0===O[e].gridBlocksTotal?Rexbuilder_Util.addClass(O[e].section,"empty-section"):O[e].section.getElementsByClassName("rex-hide-element").length===O[e].gridBlocksTotal&&Rexbuilder_Util.addClass(O[e].section,"empty-section")}function v(){Rexbuilder_Util.editorMode||(_(),Rexbuilder_Photoswipe.init(".photoswipe-gallery"),m(),n(),r(),a(),l(V),1==_plugin_frontend_settings.animations&&o(),q(),Y(),c(),g(),x(),s())}function R(){var e=performance.getEntriesByType("navigation")[0],t=e.type;if("navigate"!==t&&"prerender"!==t){var i=store.get("scrollPosition");"undefined"!=typeof i&&setTimeout(function(){window.scrollTo(0,i)},0)}}function U(){if(0!==M.length)if(Rexbuilder_Util.editorMode)M.perfectGridGalleryEditor({editorMode:Rexbuilder_Util.editorMode});else{var e=Rexbuilder_Util.chooseLayout();Rexbuilder_Util.handleLayoutChange(e);var t=Array.prototype.slice.call(document.getElementsByClassName("perfect-grid-gallery")),i=t.length,n=0;for(n=0;n<i;n++){var r=new RexGrid(t[n]);O.push(r)}for(n=0;n<i;n++)$&&Rexbuilder_Util.hasClass(O[n].section,"sticky-section")&&StickySection.prepare(O[n].section);window.FastLoad.init()}}function C(e,t){"undefined"==typeof j[e]&&(j[e]=[]),j[e].push(t)}function k(e){"undefined"!=typeof j[e]&&j[e].forEach(function(e){e.call()})}function w(){function t(t){if(!(Rexbuilder_Util.editorMode&&t.currentTarget.matches(".rex-button-container")||location.pathname.replace(/^\//,"")!=this.pathname.replace(/^\//,"")||location.hostname!=this.hostname)){var i=e(this.hash);if(i=i.length?i:Rexbuilder_Util.$rexContainer.find("[name="+this.hash.slice(1)+"]"),i.length)return Rexbuilder_Util.smoothScroll(i),!1}}if(Rexbuilder_Util.init(),Rexbuilder_Dom_Util.init(),V=Rexbuilder_Util.$rexContainer.find(".rexpansive_section"),M=Rexbuilder_Util.$rexContainer.find(".grid-stack-row"),k("builder_before_launch_grids"),U(),Rexbuilder_Rexbutton.init(),Rexbuilder_Rexelement.init(),Rexbuilder_Rexwpcf7.init(),Rexbuilder_Util.editorMode?(Rex_Save_Listeners.init(),Rexbuilder_Rexelement_Editor.init(),Rexbuilder_Rexwpcf7_Editor.init(),Rexbuilder_CreateBlocks.init(),Rexbuilder_Util_Editor.init(),Rexbuilder_Color_Palette.init(),Rexbuilder_Overlay_Palette.init(),Rexbuilder_Section.init(),Rexbuilder_Section_Editor.init(),Rexbuilder_Block.init(),Rexbuilder_Block_Editor.init(),Rexbuilder_Live_Utilities.addBuilderListeners(),TextEditor.init(),Rexbuilder_Section_Editor.triggerRowDataChange()):G(),Rex_Navigator.init(),Rexbuilder_Util.editorMode&&M.each(function(e,t){TextEditor.launchTextEditors(t)}),Rexbuilder_Util.editorMode&&Rexbuilder_Util.launchEditDomLayout(),!Rexbuilder_Util.editorMode){V.each(function(e,t){var i=t.getElementsByClassName("pswp-figure");0===i.length&&Rexbuilder_Util.removeClass(t,"photoswipe-gallery")}),h();var i=Rexbuilder_Util.$body.find(".rex-slideshow");i.length>0&&i.rexSlideshow()}if(1==_plugin_frontend_settings.native_scroll_animation){for(var n=['[href="#"]',".no-smoothing",".vertical-nav-link",".rex-vertical-nav-link",".woocommerce-review-link",".distance-accordion-toggle"],r=Rexbuilder_Util.$body.find('a[href*="#"]'),l=0,o=n.length;l<o;l++)r=r.not(n[l]);r=r.not(a),r.on("click",t);var a=function(t){return 0!=e(this).parents(".woocommerce-tabs").length}}z(),Rexbuilder_Util.editorMode&&(Rexbuilder_Util.$document.on("rexlive:editDomLayoutEnd",RexSlider.init),Rexbuilder_Util.launchVideoPlugins(),Rexbuilder_Util.playAllVideos(),b())}function E(){if(Rexbuilder_Util.editorMode)TextEditor.load(),Rexbuilder_Util_Editor.load(),Rexbuilder_Live_Utilities.load();else{for(var e=O.length,n=0;n<e;n++)O[n].fixAfterLoad();RexSlider.init(),Rexbuilder_Util.launchVideoPlugins(),Rexbuilder_Util.playAllVideos(),b()}t(),RexSlider.startAutoPlay(),M&&i(M),y(),v(),Rexbuilder_Util.galleryPluginActive=!0,A&&!Rexbuilder_Util.editorMode&&R()}function S(e){var t=e.getAttribute("data-rex-grid-id"),i=0,n=O.length;for(i=0;i<n;i++)if(t===O[i].properties.id&&e===O[i].element)return{instance:O[i],index:i};return null}function B(e){var t=S(e);null!==t&&(t.instance.destroy(),O.splice(t.index,1))}function P(){Rexbuilder_Util_Editor.elementIsResizing||(Rexbuilder_Util.windowIsResizing=!0,Rexbuilder_Util.loadWidth!==Rexbuilder_Util.globalViewport.width&&Rexbuilder_Util.doneResizing())}function T(){var e=Rexbuilder_Util.findFrontLayout(),t=O.length;if(Rexbuilder_Util.startFrontLayout!=e&&(Rexbuilder_Util.changedFrontLayout=!0,Rexbuilder_Util.startFrontLayout=e),Rexbuilder_Util.changedFrontLayout){k("builder_before_layout_change");var i=Rexbuilder_Util.chooseLayout();Rexbuilder_Util.handleLayoutChange(i)}RexGrid.updateViewportSize();for(var n=0,r=0,l=null;n<t;n++){if(L&&(l=SplitScrollable.data(O[n].section)),l&&Rexbuilder_Util.changedFrontLayout&&Rexbuilder_Util.globalViewport.width<_plugin_frontend_settings.splitScrollable.minViewportWidth)for(l.destroy(),l=null,O[n].properties.gridHeightSettable=!0,r=0;r<O[n].gridBlocksTotal;r++)O[n].gridBlocks[r].setHeight=!0,O[n].gridBlocks[r].setTop=!0;if(Rexbuilder_Util.changedFrontLayout&&O[n].endChangeLayout(),O[n].endResize(),l&&(Rexbuilder_Util.changedFrontLayout&&(p(l,O[n]),f(l,O[n]),l.refreshScrollableIndex()),l.callFixStickyHeight()),$&&Rexbuilder_Util.changedFrontLayout){var o=StickySection.data(O[n].section);o&&StickySection.prepare(O[n].section)}}Rexbuilder_Util.changedFrontLayout&&(window.FastLoad.destroy(),window.FastLoad.init(),y(),v()),Rex_Navigator.getNavigationDotsPosition(),Rexbuilder_Util.changedFrontLayout=!1}var A=/Chrome/.test(navigator.userAgent)&&/Google Inc/.test(navigator.vendor),L="undefined"!=typeof SplitScrollable,$="undefined"!=typeof StickySection,V=null,M=null,F=null,N=null,I=[],D={},O=[],G=function(){var e=[].slice.call(document.getElementsByClassName("rex-button-wrapper")),t=e.length,i=0;for(i=0;i<t;i++){var n=e[i].querySelector(".rex-button-container");if(!n){var r=document.createElement("span");r.className="rex-button-container";var l=e[i].querySelector(".rex-button-background");l.parentNode.insertBefore(r,l),r.appendChild(l)}}},z=function(){function t(t){var i=e(t.target),n=i.parents(".youtube-player").eq(0).children(".rex-video-toggle-audio"),r=i.YTPGetPlayer();void 0!==r&&(i.optimizeDisplay(),0==n.length||n.hasClass("user-has-muted")?(r.mute(),r.isMute=!0,r.setVolume(0)):i.YTPUnmute())}function i(t){var i=e(t.target).parents(".rex-youtube-wrap");if(i.length>0){var n=i[0].state;1==n?i.YTPPause():i.YTPPlay()}}function n(t){var i=e(this).find(".grid-item-content"),n=i.children(".rex-youtube-wrap"),r=i.children(".rex-video-vimeo-wrap--block"),l=i.children(".rex-video-wrap");if(n.length>0){var o=n[0].state;1==o?n.YTPPause():n.YTPPlay()}if(r.length>0){var a=VimeoVideo.findVideo(r.find("iframe")[0]);a&&a.getPaused().then(function(e){e?a.play():a.pause()})["catch"](function(e){})}if(l.length>0){var s=l.find(".rex-video-container").get(0);s.paused?s.play():s.pause()}}function r(t){t.stopPropagation();var i=e(this),n=i.parents(".youtube-player").eq(0).children(".rex-youtube-wrap"),r=i.parents(".mp4-player").eq(0).find(".rex-video-container"),l=i.parents(".vimeo-player").eq(0).find(".rex-video-vimeo-wrap--block");if(n.length>0){var o=n.get(0).player.isMuted();o?(n.YTPUnmute(),i.removeClass("user-has-muted")):(n.YTPMute(),i.addClass("user-has-muted"))}if(r.length>0&&(r.prop("muted")?(r.prop("muted",!1),i.removeClass("user-has-muted")):(r.prop("muted",!0),i.addClass("user-has-muted"))),l.length>0){var a=VimeoVideo.findVideo(l.find("iframe")[0]);a&&a.getVolume().then(function(e){0==e?(a.setVolume(1),i.removeClass("user-has-muted")):(a.setVolume(0),i.addClass("user-has-muted"))})["catch"](function(e){})}}function l(t){var i=e(t.currentTarget),n=i.parent().children(".play"),r=i.parents(".rexpansive_section");i.removeClass("video-tool--view"),n.addClass("video-tool--view"),Rexbuilder_Util.pauseVideo(r)}function o(t){var i=e(t.currentTarget),n=i.parent().children(".pause"),r=i.parents(".rexpansive_section");i.removeClass("video-tool--view"),n.addClass("video-tool--view"),Rexbuilder_Util.playVideo(r)}function a(t){var i=e(t.currentTarget).parent().find(".video-tool--view");i.click()}Rexbuilder_Util.$document.on("YTPStart",t),Rexbuilder_Util.$document.on("click",".YTPOverlay",i),Rexbuilder_Util.$document.on("click",".block-has-slider",n),Rexbuilder_Util.$document.on("click",".rex-video-toggle-audio",r),Rexbuilder_Util.$document.on("click",".rex-video__controls .pause",l),Rexbuilder_Util.$document.on("click",".rex-video__controls .play",o),Rexbuilder_Util.$document.on("click",".sticky-video-controls",a)},q=function(){if("undefined"!=typeof DistanceAccordion)for(var e=document.getElementsByClassName("distance-accordion-toggle"),t=0,i=e.length;t<i;t++){new DistanceAccordion(e[t])}},H=function(){var e=this.iframeContainer.contentDocument.querySelector(".rexbuilder-live-content");e.parentElement.removeChild(e),this.iframeContainer.contentDocument.body.insertBefore(e,this.iframeContainer.contentDocument.body.firstChild)},Y=function(){if("undefined"!=typeof PopUpContent){var e=[].slice.call(document.getElementsByClassName("popup-content-button")),t=e.length,i=0;for(i=0;i<t;i++)null===PopUpContent.data(e[i])&&new PopUpContent(e[i],{contentRetrieveMethod:"iframe",getPopUpContentComplete:H,ajaxSettings:{type:"GET",dataType:"json",url:_plugin_frontend_settings.rexajax.ajaxurl,data:{action:"rex_get_popup_content",nonce_param:_plugin_frontend_settings.rexajax.rexnonce}}})}},W=function(e){if("undefined"!=typeof Odometer){var t=e.innerText;if(null!==e.getAttribute("data-yearly-inc")&&""!==_plugin_frontend_settings.sitedate){var i=new Date(_plugin_frontend_settings.sitedate),n=new Date,r=n.getFullYear()-i.getFullYear(),l=e.getAttribute("data-yearly-inc");t=parseInt(t)+parseInt(l)*r}if(null!==e.getAttribute("data-montly-inc")&&""!==_plugin_frontend_settings.sitedate){var i=new Date(_plugin_frontend_settings.sitedate),n=new Date,r=n.getMonth()-i.getMonth(),o=e.getAttribute("data-montly-inc");t=parseInt(t)+parseInt(o)*r}e.setAttribute("data-final-value",t);var a=e.getAttribute("data-start-value");if(null==a){a="";for(var s=0,d=e.innerText.length;s<d;s++)a+="1"}var c=new Odometer({el:e,value:a,format:_plugin_frontend_settings.odometer.format,theme:_plugin_frontend_settings.odometer.theme});return c}},j=[];return{init:w,load:E,handleLiveResize:P,handleFrontEndResize:T,addAction:C,getRexGridInstance:S,destroyRexGridInstance:B}}(jQuery);
!function(){"use strict";function e(){var e;return window.matchMedia("(orientation: portrait)").matches&&(e="portrait"),window.matchMedia("(orientation: landscape)").matches&&(e="landscape"),e!=n&&(n=e,!0)}function i(e,i,t){var o;return function(){var a=this,n=arguments,r=function(){o=null,t||e.apply(a,n)},d=t&&!o;clearTimeout(o),o=setTimeout(r,i),d&&e.apply(a,n)}}function t(){Rexbuilder_Util.globalViewport=Rexbuilder_Util.viewport(),Rexbuilder_Util.editorMode?Rexbuilder_App.handleLiveResize():(a&&e()||!a)&&Rexbuilder_App.handleFrontEndResize()}function o(){d&&!Rexbuilder_Util.editorMode&&store.set("scrollPosition",window.pageYOffset||document.documentElement.scrollTop)}var a=!1;(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|ipad|iris|kindle|Android|Silk|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(navigator.userAgent)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(navigator.userAgent.substr(0,4)))&&(a=!0);var n;e(),document.addEventListener("DOMContentLoaded",Rexbuilder_App.init),window.addEventListener("load",Rexbuilder_App.load);var r=Rexbuilder_Util.editorMode?1e3:100;window.addEventListener("resize",i(t,r));var d=/Chrome/.test(navigator.userAgent)&&/Google Inc/.test(navigator.vendor);window.addEventListener("beforeunload",o)}();